/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997-2012 Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Sam Lantinga
    slouken@libsdl.org
*/
module org.libsdl.mouse;

import org.libsdl.stdinc;
import org.libsdl.video;

struct WMcursor {}

struct SDL_Cursor
{
	SDL_Rect area;
	Sint16 hot_x, hot_y;
	Uint8* data;
	Uint8* mask;
	Uint8*[2] save;
	WMcursor* wm_cursor;
}

extern (C)
{
	Uint8 SDL_GetMouseState(int* x, int* y);
	Uint8 SDL_GetRelativeMouseState(int* x, int* y);
	void SDL_WarpMouse(Uint16 x, Uint16 y);
	SDL_Cursor* SDL_CreateCursor(Uint8* data, Uint8* mask, int w, int h, int hot_x, int hot_y);
	void SDL_SetCursor(SDL_Cursor* cursor);
	SDL_Cursor* SDL_GetCursor();
	void SDL_FreeCursor(SDL_Cursor* cursor);
	int SDL_ShowCursor(int toggle);
}

template SDL_BUTTON(int x)
{
	immutable Uint8 SDL_BUTTON = 1 << (x - 1);
}

immutable int SDL_BUTTON_LEFT      = 1;
immutable int SDL_BUTTON_MIDDLE	   = 2;
immutable int SDL_BUTTON_RIGHT	   = 3;
immutable int SDL_BUTTON_WHEELUP   = 4;
immutable int SDL_BUTTON_WHEELDOWN = 5;
immutable int SDL_BUTTON_X1        = 6;
immutable int SDL_BUTTON_X2        = 7;

immutable Uint8 SDL_BUTTON_LMASK  = SDL_BUTTON!(SDL_BUTTON_LEFT);
immutable Uint8 SDL_BUTTON_MMASK  = SDL_BUTTON!(SDL_BUTTON_MIDDLE);
immutable Uint8 SDL_BUTTON_RMASK  = SDL_BUTTON!(SDL_BUTTON_RIGHT);
immutable Uint8 SDL_BUTTON_X1MASK = SDL_BUTTON!(SDL_BUTTON_X1);
immutable Uint8 SDL_BUTTON_X2MASK = SDL_BUTTON!(SDL_BUTTON_X2);
