/*
  SDL - Simple DirectMedia Layer
  Copyright (C) 1997-2012 Sam Lantinga

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

  Sam Lantinga
  slouken@libsdl.org
*/
module org.libsdl.opengl;

import core.stdc.stddef;
import org.libsdl.config;
version(DisablePublicImport)
{
	import org.opengl.gl;
	import org.opengl.glu;
}
else
{
	public import org.opengl.gl;
	public import org.opengl.glu;
}

/*
** License Applicability. Except to the extent portions of this file are
** made subject to an alternative license as permitted in the SGI Free
** Software License B, Version 1.1 (the "License"), the contents of this
** file are subject only to the provisions of the License. You may not use
** this file except in compliance with the License. You may obtain a copy
** of the License at Silicon Graphics, Inc., attn: Legal Services, 1600
** Amphitheatre Parkway, Mountain View, CA 94043-1351, or at:
** 
** http://oss.sgi.com/projects/FreeB
** 
** Note that, as provided in the License, the Software is distributed on an
** "AS IS" basis, with ALL EXPRESS AND IMPLIED WARRANTIES AND CONDITIONS
** DISCLAIMED, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES AND
** CONDITIONS OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A
** PARTICULAR PURPOSE, AND NON-INFRINGEMENT.
** 
** Original Code. The Original Code is: OpenGL Sample Implementation,
** Version 1.2.1, released January 26, 2000, developed by Silicon Graphics,
** Inc. The Original Code is Copyright (c) 1991-2004 Silicon Graphics, Inc.
** Copyright in any portions created by third parties is as indicated
** elsewhere herein. All Rights Reserved.
** 
** Additional Notice Provisions: This software was created using the
** OpenGL(R) version 1.2.1 Sample Implementation published by SGI, but has
** not been independently verified as being compliant with the OpenGL(R)
** version 1.2.1 Specification.
*/

immutable int GL_GLEXT_VERSION = 29;

version (GL_VERSION_1_2)
{
}
else
{
	immutable GLenum GL_UNSIGNED_BYTE_3_3_2           = 0x8032;
	immutable GLenum GL_UNSIGNED_SHORT_4_4_4_4        = 0x8033;
	immutable GLenum GL_UNSIGNED_SHORT_5_5_5_1        = 0x8034;
	immutable GLenum GL_UNSIGNED_INT_8_8_8_8          = 0x8035;
	immutable GLenum GL_UNSIGNED_INT_10_10_10_2       = 0x8036;
	immutable GLenum GL_RESCALE_NORMAL                = 0x803A;
	immutable GLenum GL_TEXTURE_BINDING_3D            = 0x806A;
	immutable GLenum GL_PACK_SKIP_IMAGES              = 0x806B;
	immutable GLenum GL_PACK_IMAGE_HEIGHT             = 0x806C;
	immutable GLenum GL_UNPACK_SKIP_IMAGES            = 0x806D;
	immutable GLenum GL_UNPACK_IMAGE_HEIGHT           = 0x806E;
	immutable GLenum GL_TEXTURE_3D                    = 0x806F;
	immutable GLenum GL_PROXY_TEXTURE_3D              = 0x8070;
	immutable GLenum GL_TEXTURE_DEPTH                 = 0x8071;
	immutable GLenum GL_TEXTURE_WRAP_R                = 0x8072;
	immutable GLenum GL_MAX_3D_TEXTURE_SIZE           = 0x8073;
	immutable GLenum GL_UNSIGNED_BYTE_2_3_3_REV       = 0x8362;
	immutable GLenum GL_UNSIGNED_SHORT_5_6_5          = 0x8363;
	immutable GLenum GL_UNSIGNED_SHORT_5_6_5_REV      = 0x8364;
	immutable GLenum GL_UNSIGNED_SHORT_4_4_4_4_REV    = 0x8365;
	immutable GLenum GL_UNSIGNED_SHORT_1_5_5_5_REV    = 0x8366;
	immutable GLenum GL_UNSIGNED_INT_8_8_8_8_REV      = 0x8367;
	immutable GLenum GL_UNSIGNED_INT_2_10_10_10_REV   = 0x8368;
	immutable GLenum GL_BGR                           = 0x80E0;
	immutable GLenum GL_BGRA                          = 0x80E1;
	immutable GLenum GL_MAX_ELEMENTS_VERTICES         = 0x80E8;
	immutable GLenum GL_MAX_ELEMENTS_INDICES          = 0x80E9;
	immutable GLenum GL_CLAMP_TO_EDGE                 = 0x812F;
	immutable GLenum GL_TEXTURE_MIN_LOD               = 0x813A;
	immutable GLenum GL_TEXTURE_MAX_LOD               = 0x813B;
	immutable GLenum GL_TEXTURE_BASE_LEVEL            = 0x813C;
	immutable GLenum GL_TEXTURE_MAX_LEVEL             = 0x813D;
	immutable GLenum GL_LIGHT_MODEL_COLOR_CONTROL     = 0x81F8;
	immutable GLenum GL_SINGLE_COLOR                  = 0x81F9;
	immutable GLenum GL_SEPARATE_SPECULAR_COLOR       = 0x81FA;
	immutable GLenum GL_SMOOTH_POINT_SIZE_RANGE       = 0x0B12;
	immutable GLenum GL_SMOOTH_POINT_SIZE_GRANULARITY = 0x0B13;
	immutable GLenum GL_SMOOTH_LINE_WIDTH_RANGE       = 0x0B22;
	immutable GLenum GL_SMOOTH_LINE_WIDTH_GRANULARITY = 0x0B23;
	immutable GLenum GL_ALIASED_POINT_SIZE_RANGE      = 0x846D;
	immutable GLenum GL_ALIASED_LINE_WIDTH_RANGE      = 0x846E;
}

version (GL_ARB_imaging)
{
}
else
{
	immutable GLenum GL_CONSTANT_COLOR                      = 0x8001;
	immutable GLenum GL_ONE_MINUS_CONSTANT_COLOR            = 0x8002;
	immutable GLenum GL_CONSTANT_ALPHA                      = 0x8003;
	immutable GLenum GL_ONE_MINUS_CONSTANT_ALPHA            = 0x8004;
	immutable GLenum GL_BLEND_COLOR                         = 0x8005;
	immutable GLenum GL_FUNC_ADD                            = 0x8006;
	immutable GLenum GL_MIN                                 = 0x8007;
	immutable GLenum GL_MAX                                 = 0x8008;
	immutable GLenum GL_BLEND_EQUATION                      = 0x8009;
	immutable GLenum GL_FUNC_SUBTRACT                       = 0x800A;
	immutable GLenum GL_FUNC_REVERSE_SUBTRACT               = 0x800B;
	immutable GLenum GL_CONVOLUTION_1D                      = 0x8010;
	immutable GLenum GL_CONVOLUTION_2D                      = 0x8011;
	immutable GLenum GL_SEPARABLE_2D                        = 0x8012;
	immutable GLenum GL_CONVOLUTION_BORDER_MODE             = 0x8013;
	immutable GLenum GL_CONVOLUTION_FILTER_SCALE            = 0x8014;
	immutable GLenum GL_CONVOLUTION_FILTER_BIAS             = 0x8015;
	immutable GLenum GL_REDUCE                              = 0x8016;
	immutable GLenum GL_CONVOLUTION_FORMAT                  = 0x8017;
	immutable GLenum GL_CONVOLUTION_WIDTH                   = 0x8018;
	immutable GLenum GL_CONVOLUTION_HEIGHT                  = 0x8019;
	immutable GLenum GL_MAX_CONVOLUTION_WIDTH               = 0x801A;
	immutable GLenum GL_MAX_CONVOLUTION_HEIGHT              = 0x801B;
	immutable GLenum GL_POST_CONVOLUTION_RED_SCALE          = 0x801C;
	immutable GLenum GL_POST_CONVOLUTION_GREEN_SCALE        = 0x801D;
	immutable GLenum GL_POST_CONVOLUTION_BLUE_SCALE         = 0x801E;
	immutable GLenum GL_POST_CONVOLUTION_ALPHA_SCALE        = 0x801F;
	immutable GLenum GL_POST_CONVOLUTION_RED_BIAS           = 0x8020;
	immutable GLenum GL_POST_CONVOLUTION_GREEN_BIAS         = 0x8021;
	immutable GLenum GL_POST_CONVOLUTION_BLUE_BIAS          = 0x8022;
	immutable GLenum GL_POST_CONVOLUTION_ALPHA_BIAS         = 0x8023;
	immutable GLenum GL_HISTOGRAM                           = 0x8024;
	immutable GLenum GL_PROXY_HISTOGRAM                     = 0x8025;
	immutable GLenum GL_HISTOGRAM_WIDTH                     = 0x8026;
	immutable GLenum GL_HISTOGRAM_FORMAT                    = 0x8027;
	immutable GLenum GL_HISTOGRAM_RED_SIZE                  = 0x8028;
	immutable GLenum GL_HISTOGRAM_GREEN_SIZE                = 0x8029;
	immutable GLenum GL_HISTOGRAM_BLUE_SIZE                 = 0x802A;
	immutable GLenum GL_HISTOGRAM_ALPHA_SIZE                = 0x802B;
	immutable GLenum GL_HISTOGRAM_LUMINANCE_SIZE            = 0x802C;
	immutable GLenum GL_HISTOGRAM_SINK                      = 0x802D;
	immutable GLenum GL_MINMAX                              = 0x802E;
	immutable GLenum GL_MINMAX_FORMAT                       = 0x802F;
	immutable GLenum GL_MINMAX_SINK                         = 0x8030;
	immutable GLenum GL_TABLE_TOO_LARGE                     = 0x8031;
	immutable GLenum GL_COLOR_MATRIX                        = 0x80B1;
	immutable GLenum GL_COLOR_MATRIX_STACK_DEPTH            = 0x80B2;
	immutable GLenum GL_MAX_COLOR_MATRIX_STACK_DEPTH        = 0x80B3;
	immutable GLenum GL_POST_COLOR_MATRIX_RED_SCALE         = 0x80B4;
	immutable GLenum GL_POST_COLOR_MATRIX_GREEN_SCALE       = 0x80B5;
	immutable GLenum GL_POST_COLOR_MATRIX_BLUE_SCALE        = 0x80B6;
	immutable GLenum GL_POST_COLOR_MATRIX_ALPHA_SCALE       = 0x80B7;
	immutable GLenum GL_POST_COLOR_MATRIX_RED_BIAS          = 0x80B8;
	immutable GLenum GL_POST_COLOR_MATRIX_GREEN_BIAS        = 0x80B9;
	immutable GLenum GL_POST_COLOR_MATRIX_BLUE_BIAS         = 0x80BA;
	immutable GLenum GL_POST_COLOR_MATRIX_ALPHA_BIAS        = 0x80BB;
	immutable GLenum GL_COLOR_TABLE                         = 0x80D0;
	immutable GLenum GL_POST_CONVOLUTION_COLOR_TABLE        = 0x80D1;
	immutable GLenum GL_POST_COLOR_MATRIX_COLOR_TABLE       = 0x80D2;
	immutable GLenum GL_PROXY_COLOR_TABLE                   = 0x80D3;
	immutable GLenum GL_PROXY_POST_CONVOLUTION_COLOR_TABLE  = 0x80D4;
	immutable GLenum GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE = 0x80D5;
	immutable GLenum GL_COLOR_TABLE_SCALE                   = 0x80D6;
	immutable GLenum GL_COLOR_TABLE_BIAS                    = 0x80D7;
	immutable GLenum GL_COLOR_TABLE_FORMAT                  = 0x80D8;
	immutable GLenum GL_COLOR_TABLE_WIDTH                   = 0x80D9;
	immutable GLenum GL_COLOR_TABLE_RED_SIZE                = 0x80DA;
	immutable GLenum GL_COLOR_TABLE_GREEN_SIZE              = 0x80DB;
	immutable GLenum GL_COLOR_TABLE_BLUE_SIZE               = 0x80DC;
	immutable GLenum GL_COLOR_TABLE_ALPHA_SIZE              = 0x80DD;
	immutable GLenum GL_COLOR_TABLE_LUMINANCE_SIZE          = 0x80DE;
	immutable GLenum GL_COLOR_TABLE_INTENSITY_SIZE          = 0x80DF;
	immutable GLenum GL_CONSTANT_BORDER                     = 0x8151;
	immutable GLenum GL_REPLICATE_BORDER                    = 0x8153;
	immutable GLenum GL_CONVOLUTION_BORDER_COLOR            = 0x8154;
}

version (GL_VERSION_1_3)
{
}
else
{
	immutable GLbitfield GL_MULTISAMPLE_BIT = 0x20000000;
	immutable GLenum GL_TEXTURE0                       = 0x84C0;
	immutable GLenum GL_TEXTURE1                       = 0x84C1;
	immutable GLenum GL_TEXTURE2                       = 0x84C2;
	immutable GLenum GL_TEXTURE3                       = 0x84C3;
	immutable GLenum GL_TEXTURE4                       = 0x84C4;
	immutable GLenum GL_TEXTURE5                       = 0x84C5;
	immutable GLenum GL_TEXTURE6                       = 0x84C6;
	immutable GLenum GL_TEXTURE7                       = 0x84C7;
	immutable GLenum GL_TEXTURE8                       = 0x84C8;
	immutable GLenum GL_TEXTURE9                       = 0x84C9;
	immutable GLenum GL_TEXTURE10                      = 0x84CA;
	immutable GLenum GL_TEXTURE11                      = 0x84CB;
	immutable GLenum GL_TEXTURE12                      = 0x84CC;
	immutable GLenum GL_TEXTURE13                      = 0x84CD;
	immutable GLenum GL_TEXTURE14                      = 0x84CE;
	immutable GLenum GL_TEXTURE15                      = 0x84CF;
	immutable GLenum GL_TEXTURE16                      = 0x84D0;
	immutable GLenum GL_TEXTURE17                      = 0x84D1;
	immutable GLenum GL_TEXTURE18                      = 0x84D2;
	immutable GLenum GL_TEXTURE19                      = 0x84D3;
	immutable GLenum GL_TEXTURE20                      = 0x84D4;
	immutable GLenum GL_TEXTURE21                      = 0x84D5;
	immutable GLenum GL_TEXTURE22                      = 0x84D6;
	immutable GLenum GL_TEXTURE23                      = 0x84D7;
	immutable GLenum GL_TEXTURE24                      = 0x84D8;
	immutable GLenum GL_TEXTURE25                      = 0x84D9;
	immutable GLenum GL_TEXTURE26                      = 0x84DA;
	immutable GLenum GL_TEXTURE27                      = 0x84DB;
	immutable GLenum GL_TEXTURE28                      = 0x84DC;
	immutable GLenum GL_TEXTURE29                      = 0x84DD;
	immutable GLenum GL_TEXTURE30                      = 0x84DE;
	immutable GLenum GL_TEXTURE31                      = 0x84DF;
	immutable GLenum GL_ACTIVE_TEXTURE                 = 0x84E0;
	immutable GLenum GL_CLIENT_ACTIVE_TEXTURE          = 0x84E1;
	immutable GLenum GL_MAX_TEXTURE_UNITS              = 0x84E2;
	immutable GLenum GL_TRANSPOSE_MODELVIEW_MATRIX     = 0x84E3;
	immutable GLenum GL_TRANSPOSE_PROJECTION_MATRIX    = 0x84E4;
	immutable GLenum GL_TRANSPOSE_TEXTURE_MATRIX       = 0x84E5;
	immutable GLenum GL_TRANSPOSE_COLOR_MATRIX         = 0x84E6;
	immutable GLenum GL_MULTISAMPLE                    = 0x809D;
	immutable GLenum GL_SAMPLE_ALPHA_TO_COVERAGE       = 0x809E;
	immutable GLenum GL_SAMPLE_ALPHA_TO_ONE            = 0x809F;
	immutable GLenum GL_SAMPLE_COVERAGE                = 0x80A0;
	immutable GLenum GL_SAMPLE_BUFFERS                 = 0x80A8;
	immutable GLenum GL_SAMPLES                        = 0x80A9;
	immutable GLenum GL_SAMPLE_COVERAGE_VALUE          = 0x80AA;
	immutable GLenum GL_SAMPLE_COVERAGE_INVERT         = 0x80AB;
	immutable GLenum GL_NORMAL_MAP                     = 0x8511;
	immutable GLenum GL_REFLECTION_MAP                 = 0x8512;
	immutable GLenum GL_TEXTURE_CUBE_MAP               = 0x8513;
	immutable GLenum GL_TEXTURE_BINDING_CUBE_MAP       = 0x8514;
	immutable GLenum GL_TEXTURE_CUBE_MAP_POSITIVE_X    = 0x8515;
	immutable GLenum GL_TEXTURE_CUBE_MAP_NEGATIVE_X    = 0x8516;
	immutable GLenum GL_TEXTURE_CUBE_MAP_POSITIVE_Y    = 0x8517;
	immutable GLenum GL_TEXTURE_CUBE_MAP_NEGATIVE_Y    = 0x8518;
	immutable GLenum GL_TEXTURE_CUBE_MAP_POSITIVE_Z    = 0x8519;
	immutable GLenum GL_TEXTURE_CUBE_MAP_NEGATIVE_Z    = 0x851A;
	immutable GLenum GL_PROXY_TEXTURE_CUBE_MAP         = 0x851B;
	immutable GLenum GL_MAX_CUBE_MAP_TEXTURE_SIZE      = 0x851C;
	immutable GLenum GL_COMPRESSED_ALPHA               = 0x84E9;
	immutable GLenum GL_COMPRESSED_LUMINANCE           = 0x84EA;
	immutable GLenum GL_COMPRESSED_LUMINANCE_ALPHA     = 0x84EB;
	immutable GLenum GL_COMPRESSED_INTENSITY           = 0x84EC;
	immutable GLenum GL_COMPRESSED_RGB                 = 0x84ED;
	immutable GLenum GL_COMPRESSED_RGBA                = 0x84EE;
	immutable GLenum GL_TEXTURE_COMPRESSION_HINT       = 0x84EF;
	immutable GLenum GL_TEXTURE_COMPRESSED_IMAGE_SIZE  = 0x86A0;
	immutable GLenum GL_TEXTURE_COMPRESSED             = 0x86A1;
	immutable GLenum GL_NUM_COMPRESSED_TEXTURE_FORMATS = 0x86A2;
	immutable GLenum GL_COMPRESSED_TEXTURE_FORMATS     = 0x86A3;
	immutable GLenum GL_CLAMP_TO_BORDER                = 0x812D;
	immutable GLenum GL_COMBINE                        = 0x8570;
	immutable GLenum GL_COMBINE_RGB                    = 0x8571;
	immutable GLenum GL_COMBINE_ALPHA                  = 0x8572;
	immutable GLenum GL_SOURCE0_RGB                    = 0x8580;
	immutable GLenum GL_SOURCE1_RGB                    = 0x8581;
	immutable GLenum GL_SOURCE2_RGB                    = 0x8582;
	immutable GLenum GL_SOURCE0_ALPHA                  = 0x8588;
	immutable GLenum GL_SOURCE1_ALPHA                  = 0x8589;
	immutable GLenum GL_SOURCE2_ALPHA                  = 0x858A;
	immutable GLenum GL_OPERAND0_RGB                   = 0x8590;
	immutable GLenum GL_OPERAND1_RGB                   = 0x8591;
	immutable GLenum GL_OPERAND2_RGB                   = 0x8592;
	immutable GLenum GL_OPERAND0_ALPHA                 = 0x8598;
	immutable GLenum GL_OPERAND1_ALPHA                 = 0x8599;
	immutable GLenum GL_OPERAND2_ALPHA                 = 0x859A;
	immutable GLenum GL_RGB_SCALE                      = 0x8573;
	immutable GLenum GL_ADD_SIGNED                     = 0x8574;
	immutable GLenum GL_INTERPOLATE                    = 0x8575;
	immutable GLenum GL_SUBTRACT                       = 0x84E7;
	immutable GLenum GL_CONSTANT                       = 0x8576;
	immutable GLenum GL_PRIMARY_COLOR                  = 0x8577;
	immutable GLenum GL_PREVIOUS                       = 0x8578;
	immutable GLenum GL_DOT3_RGB                       = 0x86AE;
	immutable GLenum GL_DOT3_RGBA                      = 0x86AF;
}

version (GL_VERSION_1_4)
{
}
else
{
	immutable GLenum GL_BLEND_DST_RGB                 = 0x80C8;
	immutable GLenum GL_BLEND_SRC_RGB                 = 0x80C9;
	immutable GLenum GL_BLEND_DST_ALPHA               = 0x80CA;
	immutable GLenum GL_BLEND_SRC_ALPHA               = 0x80CB;
	immutable GLenum GL_POINT_SIZE_MIN                = 0x8126;
	immutable GLenum GL_POINT_SIZE_MAX                = 0x8127;
	immutable GLenum GL_POINT_FADE_THRESHOLD_SIZE     = 0x8128;
	immutable GLenum GL_POINT_DISTANCE_ATTENUATION    = 0x8129;
	immutable GLenum GL_GENERATE_MIPMAP               = 0x8191;
	immutable GLenum GL_GENERATE_MIPMAP_HINT          = 0x8192;
	immutable GLenum GL_DEPTH_COMPONENT16             = 0x81A5;
	immutable GLenum GL_DEPTH_COMPONENT24             = 0x81A6;
	immutable GLenum GL_DEPTH_COMPONENT32             = 0x81A7;
	immutable GLenum GL_MIRRORED_REPEAT               = 0x8370;
	immutable GLenum GL_FOG_COORDINATE_SOURCE         = 0x8450;
	immutable GLenum GL_FOG_COORDINATE                = 0x8451;
	immutable GLenum GL_FRAGMENT_DEPTH                = 0x8452;
	immutable GLenum GL_CURRENT_FOG_COORDINATE        = 0x8453;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_TYPE     = 0x8454;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_STRIDE   = 0x8455;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_POINTER  = 0x8456;
	immutable GLenum GL_FOG_COORDINATE_ARRAY          = 0x8457;
	immutable GLenum GL_COLOR_SUM                     = 0x8458;
	immutable GLenum GL_CURRENT_SECONDARY_COLOR       = 0x8459;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_SIZE    = 0x845A;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_TYPE    = 0x845B;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_STRIDE  = 0x845C;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_POINTER = 0x845D;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY         = 0x845E;
	immutable GLenum GL_MAX_TEXTURE_LOD_BIAS          = 0x84FD;
	immutable GLenum GL_TEXTURE_FILTER_CONTROL        = 0x8500;
	immutable GLenum GL_TEXTURE_LOD_BIAS              = 0x8501;
	immutable GLenum GL_INCR_WRAP                     = 0x8507;
	immutable GLenum GL_DECR_WRAP                     = 0x8508;
	immutable GLenum GL_TEXTURE_DEPTH_SIZE            = 0x884A;
	immutable GLenum GL_DEPTH_TEXTURE_MODE            = 0x884B;
	immutable GLenum GL_TEXTURE_COMPARE_MODE          = 0x884C;
	immutable GLenum GL_TEXTURE_COMPARE_FUNC          = 0x884D;
	immutable GLenum GL_COMPARE_R_TO_TEXTURE          = 0x884E;
}

version (GL_VERSION_1_5)
{
}
else
{
	immutable GLenum GL_BUFFER_SIZE                          = 0x8764;
	immutable GLenum GL_BUFFER_USAGE                         = 0x8765;
	immutable GLenum GL_QUERY_COUNTER_BITS                   = 0x8864;
	immutable GLenum GL_CURRENT_QUERY                        = 0x8865;
	immutable GLenum GL_QUERY_RESULT                         = 0x8866;
	immutable GLenum GL_QUERY_RESULT_AVAILABLE               = 0x8867;
	immutable GLenum GL_ARRAY_BUFFER                         = 0x8892;
	immutable GLenum GL_ELEMENT_ARRAY_BUFFER                 = 0x8893;
	immutable GLenum GL_ARRAY_BUFFER_BINDING                 = 0x8894;
	immutable GLenum GL_ELEMENT_ARRAY_BUFFER_BINDING         = 0x8895;
	immutable GLenum GL_VERTEX_ARRAY_BUFFER_BINDING          = 0x8896;
	immutable GLenum GL_NORMAL_ARRAY_BUFFER_BINDING          = 0x8897;
	immutable GLenum GL_COLOR_ARRAY_BUFFER_BINDING           = 0x8898;
	immutable GLenum GL_INDEX_ARRAY_BUFFER_BINDING           = 0x8899;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING   = 0x889A;
	immutable GLenum GL_EDGE_FLAG_ARRAY_BUFFER_BINDING       = 0x889B;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING = 0x889C;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING  = 0x889D;
	immutable GLenum GL_WEIGHT_ARRAY_BUFFER_BINDING          = 0x889E;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING   = 0x889F;
	immutable GLenum GL_READ_ONLY                            = 0x88B8;
	immutable GLenum GL_WRITE_ONLY                           = 0x88B9;
	immutable GLenum GL_READ_WRITE                           = 0x88BA;
	immutable GLenum GL_BUFFER_ACCESS                        = 0x88BB;
	immutable GLenum GL_BUFFER_MAPPED                        = 0x88BC;
	immutable GLenum GL_BUFFER_MAP_POINTER                   = 0x88BD;
	immutable GLenum GL_STREAM_DRAW                          = 0x88E0;
	immutable GLenum GL_STREAM_READ                          = 0x88E1;
	immutable GLenum GL_STREAM_COPY                          = 0x88E2;
	immutable GLenum GL_STATIC_DRAW                          = 0x88E4;
	immutable GLenum GL_STATIC_READ                          = 0x88E5;
	immutable GLenum GL_STATIC_COPY                          = 0x88E6;
	immutable GLenum GL_DYNAMIC_DRAW                         = 0x88E8;
	immutable GLenum GL_DYNAMIC_READ                         = 0x88E9;
	immutable GLenum GL_DYNAMIC_COPY                         = 0x88EA;
	immutable GLenum GL_SAMPLES_PASSED                       = 0x8914;
	immutable GLenum GL_FOG_COORD_SRC                        = GL_FOG_COORDINATE_SOURCE;
	immutable GLenum GL_FOG_COORD                            = GL_FOG_COORDINATE;
	immutable GLenum GL_CURRENT_FOG_COORD                    = GL_CURRENT_FOG_COORDINATE;
	immutable GLenum GL_FOG_COORD_ARRAY_TYPE                 = GL_FOG_COORDINATE_ARRAY_TYPE;
	immutable GLenum GL_FOG_COORD_ARRAY_STRIDE               = GL_FOG_COORDINATE_ARRAY_STRIDE;
	immutable GLenum GL_FOG_COORD_ARRAY_POINTER              = GL_FOG_COORDINATE_ARRAY_POINTER;
	immutable GLenum GL_FOG_COORD_ARRAY                      = GL_FOG_COORDINATE_ARRAY;
	immutable GLenum GL_FOG_COORD_ARRAY_BUFFER_BINDING       = GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING;
	immutable GLenum GL_SRC0_RGB                             = GL_SOURCE0_RGB;
	immutable GLenum GL_SRC1_RGB                             = GL_SOURCE1_RGB;
	immutable GLenum GL_SRC2_RGB                             = GL_SOURCE2_RGB;
	immutable GLenum GL_SRC0_ALPHA                           = GL_SOURCE0_ALPHA;
	immutable GLenum GL_SRC1_ALPHA                           = GL_SOURCE1_ALPHA;
	immutable GLenum GL_SRC2_ALPHA                           = GL_SOURCE2_ALPHA;
}

version (GL_VERSION_2_0)
{
}
else
{
	immutable GLenum GL_BLEND_EQUATION_RGB               = GL_BLEND_EQUATION;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_ENABLED      = 0x8622;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_SIZE         = 0x8623;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_STRIDE       = 0x8624;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_TYPE         = 0x8625;
	immutable GLenum GL_CURRENT_VERTEX_ATTRIB            = 0x8626;
	immutable GLenum GL_VERTEX_PROGRAM_POINT_SIZE        = 0x8642;
	immutable GLenum GL_VERTEX_PROGRAM_TWO_SIDE          = 0x8643;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_POINTER      = 0x8645;
	immutable GLenum GL_STENCIL_BACK_FUNC                = 0x8800;
	immutable GLenum GL_STENCIL_BACK_FAIL                = 0x8801;
	immutable GLenum GL_STENCIL_BACK_PASS_DEPTH_FAIL     = 0x8802;
	immutable GLenum GL_STENCIL_BACK_PASS_DEPTH_PASS     = 0x8803;
	immutable GLenum GL_MAX_DRAW_BUFFERS                 = 0x8824;
	immutable GLenum GL_DRAW_BUFFER0                     = 0x8825;
	immutable GLenum GL_DRAW_BUFFER1                     = 0x8826;
	immutable GLenum GL_DRAW_BUFFER2                     = 0x8827;
	immutable GLenum GL_DRAW_BUFFER3                     = 0x8828;
	immutable GLenum GL_DRAW_BUFFER4                     = 0x8829;
	immutable GLenum GL_DRAW_BUFFER5                     = 0x882A;
	immutable GLenum GL_DRAW_BUFFER6                     = 0x882B;
	immutable GLenum GL_DRAW_BUFFER7                     = 0x882C;
	immutable GLenum GL_DRAW_BUFFER8                     = 0x882D;
	immutable GLenum GL_DRAW_BUFFER9                     = 0x882E;
	immutable GLenum GL_DRAW_BUFFER10                    = 0x882F;
	immutable GLenum GL_DRAW_BUFFER11                    = 0x8830;
	immutable GLenum GL_DRAW_BUFFER12                    = 0x8831;
	immutable GLenum GL_DRAW_BUFFER13                    = 0x8832;
	immutable GLenum GL_DRAW_BUFFER14                    = 0x8833;
	immutable GLenum GL_DRAW_BUFFER15                    = 0x8834;
	immutable GLenum GL_BLEND_EQUATION_ALPHA             = 0x883D;
	immutable GLenum GL_POINT_SPRITE                     = 0x8861;
	immutable GLenum GL_COORD_REPLACE                    = 0x8862;
	immutable GLenum GL_MAX_VERTEX_ATTRIBS               = 0x8869;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_NORMALIZED   = 0x886A;
	immutable GLenum GL_MAX_TEXTURE_COORDS               = 0x8871;
	immutable GLenum GL_MAX_TEXTURE_IMAGE_UNITS          = 0x8872;
	immutable GLenum GL_FRAGMENT_SHADER                  = 0x8B30;
	immutable GLenum GL_VERTEX_SHADER                    = 0x8B31;
	immutable GLenum GL_MAX_FRAGMENT_UNIFORM_COMPONENTS  = 0x8B49;
	immutable GLenum GL_MAX_VERTEX_UNIFORM_COMPONENTS    = 0x8B4A;
	immutable GLenum GL_MAX_VARYING_FLOATS               = 0x8B4B;
	immutable GLenum GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS   = 0x8B4C;
	immutable GLenum GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS = 0x8B4D;
	immutable GLenum GL_SHADER_TYPE                      = 0x8B4F;
	immutable GLenum GL_FLOAT_VEC2                       = 0x8B50;
	immutable GLenum GL_FLOAT_VEC3                       = 0x8B51;
	immutable GLenum GL_FLOAT_VEC4                       = 0x8B52;
	immutable GLenum GL_INT_VEC2                         = 0x8B53;
	immutable GLenum GL_INT_VEC3                         = 0x8B54;
	immutable GLenum GL_INT_VEC4                         = 0x8B55;
	immutable GLenum GL_BOOL                             = 0x8B56;
	immutable GLenum GL_BOOL_VEC2                        = 0x8B57;
	immutable GLenum GL_BOOL_VEC3                        = 0x8B58;
	immutable GLenum GL_BOOL_VEC4                        = 0x8B59;
	immutable GLenum GL_FLOAT_MAT2                       = 0x8B5A;
	immutable GLenum GL_FLOAT_MAT3                       = 0x8B5B;
	immutable GLenum GL_FLOAT_MAT4                       = 0x8B5C;
	immutable GLenum GL_SAMPLER_1D                       = 0x8B5D;
	immutable GLenum GL_SAMPLER_2D                       = 0x8B5E;
	immutable GLenum GL_SAMPLER_3D                       = 0x8B5F;
	immutable GLenum GL_SAMPLER_CUBE                     = 0x8B60;
	immutable GLenum GL_SAMPLER_1D_SHADOW                = 0x8B61;
	immutable GLenum GL_SAMPLER_2D_SHADOW                = 0x8B62;
	immutable GLenum GL_DELETE_STATUS                    = 0x8B80;
	immutable GLenum GL_COMPILE_STATUS                   = 0x8B81;
	immutable GLenum GL_LINK_STATUS                      = 0x8B82;
	immutable GLenum GL_VALIDATE_STATUS                  = 0x8B83;
	immutable GLenum GL_INFO_LOG_LENGTH                  = 0x8B84;
	immutable GLenum GL_ATTACHED_SHADERS                 = 0x8B85;
	immutable GLenum GL_ACTIVE_UNIFORMS                  = 0x8B86;
	immutable GLenum GL_ACTIVE_UNIFORM_MAX_LENGTH        = 0x8B87;
	immutable GLenum GL_SHADER_SOURCE_LENGTH             = 0x8B88;
	immutable GLenum GL_ACTIVE_ATTRIBUTES                = 0x8B89;
	immutable GLenum GL_ACTIVE_ATTRIBUTE_MAX_LENGTH      = 0x8B8A;
	immutable GLenum GL_FRAGMENT_SHADER_DERIVATIVE_HINT  = 0x8B8B;
	immutable GLenum GL_SHADING_LANGUAGE_VERSION         = 0x8B8C;
	immutable GLenum GL_CURRENT_PROGRAM                  = 0x8B8D;
	immutable GLenum GL_POINT_SPRITE_COORD_ORIGIN        = 0x8CA0;
	immutable GLenum GL_LOWER_LEFT                       = 0x8CA1;
	immutable GLenum GL_UPPER_LEFT                       = 0x8CA2;
	immutable GLenum GL_STENCIL_BACK_REF                 = 0x8CA3;
	immutable GLenum GL_STENCIL_BACK_VALUE_MASK          = 0x8CA4;
	immutable GLenum GL_STENCIL_BACK_WRITEMASK           = 0x8CA5;
}

version (GL_ARB_multitexture)
{
}
else
{
	immutable GLenum GL_TEXTURE0_ARB              = 0x84C0;
	immutable GLenum GL_TEXTURE1_ARB              = 0x84C1;
	immutable GLenum GL_TEXTURE2_ARB              = 0x84C2;
	immutable GLenum GL_TEXTURE3_ARB              = 0x84C3;
	immutable GLenum GL_TEXTURE4_ARB              = 0x84C4;
	immutable GLenum GL_TEXTURE5_ARB              = 0x84C5;
	immutable GLenum GL_TEXTURE6_ARB              = 0x84C6;
	immutable GLenum GL_TEXTURE7_ARB              = 0x84C7;
	immutable GLenum GL_TEXTURE8_ARB              = 0x84C8;
	immutable GLenum GL_TEXTURE9_ARB              = 0x84C9;
	immutable GLenum GL_TEXTURE10_ARB             = 0x84CA;
	immutable GLenum GL_TEXTURE11_ARB             = 0x84CB;
	immutable GLenum GL_TEXTURE12_ARB             = 0x84CC;
	immutable GLenum GL_TEXTURE13_ARB             = 0x84CD;
	immutable GLenum GL_TEXTURE14_ARB             = 0x84CE;
	immutable GLenum GL_TEXTURE15_ARB             = 0x84CF;
	immutable GLenum GL_TEXTURE16_ARB             = 0x84D0;
	immutable GLenum GL_TEXTURE17_ARB             = 0x84D1;
	immutable GLenum GL_TEXTURE18_ARB             = 0x84D2;
	immutable GLenum GL_TEXTURE19_ARB             = 0x84D3;
	immutable GLenum GL_TEXTURE20_ARB             = 0x84D4;
	immutable GLenum GL_TEXTURE21_ARB             = 0x84D5;
	immutable GLenum GL_TEXTURE22_ARB             = 0x84D6;
	immutable GLenum GL_TEXTURE23_ARB             = 0x84D7;
	immutable GLenum GL_TEXTURE24_ARB             = 0x84D8;
	immutable GLenum GL_TEXTURE25_ARB             = 0x84D9;
	immutable GLenum GL_TEXTURE26_ARB             = 0x84DA;
	immutable GLenum GL_TEXTURE27_ARB             = 0x84DB;
	immutable GLenum GL_TEXTURE28_ARB             = 0x84DC;
	immutable GLenum GL_TEXTURE29_ARB             = 0x84DD;
	immutable GLenum GL_TEXTURE30_ARB             = 0x84DE;
	immutable GLenum GL_TEXTURE31_ARB             = 0x84DF;
	immutable GLenum GL_ACTIVE_TEXTURE_ARB        = 0x84E0;
	immutable GLenum GL_CLIENT_ACTIVE_TEXTURE_ARB = 0x84E1;
	immutable GLenum GL_MAX_TEXTURE_UNITS_ARB     = 0x84E2;
}

version (GL_ARB_transpose_matrix)
{
}
else
{
	immutable GLenum GL_TRANSPOSE_MODELVIEW_MATRIX_ARB  = 0x84E3;
	immutable GLenum GL_TRANSPOSE_PROJECTION_MATRIX_ARB = 0x84E4;
	immutable GLenum GL_TRANSPOSE_TEXTURE_MATRIX_ARB    = 0x84E5;
	immutable GLenum GL_TRANSPOSE_COLOR_MATRIX_ARB      = 0x84E6;
}

version (GL_ARB_multisample)
{
}
else
{
	immutable GLbitfield GL_MULTISAMPLE_BIT_ARB = 0x20000000;
	immutable GLenum GL_MULTISAMPLE_ARB              = 0x809D;
	immutable GLenum GL_SAMPLE_ALPHA_TO_COVERAGE_ARB = 0x809E;
	immutable GLenum GL_SAMPLE_ALPHA_TO_ONE_ARB      = 0x809F;
	immutable GLenum GL_SAMPLE_COVERAGE_ARB          = 0x80A0;
	immutable GLenum GL_SAMPLE_BUFFERS_ARB           = 0x80A8;
	immutable GLenum GL_SAMPLES_ARB                  = 0x80A9;
	immutable GLenum GL_SAMPLE_COVERAGE_VALUE_ARB    = 0x80AA;
	immutable GLenum GL_SAMPLE_COVERAGE_INVERT_ARB   = 0x80AB;
}

version (GL_ARB_texture_env_add)
{
}
else
{
}

version (GL_ARB_texture_cube_map)
{
}
else
{
	immutable GLenum GL_NORMAL_MAP_ARB                  = 0x8511;
	immutable GLenum GL_REFLECTION_MAP_ARB              = 0x8512;
	immutable GLenum GL_TEXTURE_CUBE_MAP_ARB            = 0x8513;
	immutable GLenum GL_TEXTURE_BINDING_CUBE_MAP_ARB    = 0x8514;
	immutable GLenum GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB = 0x8515;
	immutable GLenum GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB = 0x8516;
	immutable GLenum GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB = 0x8517;
	immutable GLenum GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB = 0x8518;
	immutable GLenum GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB = 0x8519;
	immutable GLenum GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB = 0x851A;
	immutable GLenum GL_PROXY_TEXTURE_CUBE_MAP_ARB      = 0x851B;
	immutable GLenum GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB   = 0x851C;
}

version (GL_ARB_texture_compression)
{
}
else
{
	immutable GLenum GL_COMPRESSED_ALPHA_ARB               = 0x84E9;
	immutable GLenum GL_COMPRESSED_LUMINANCE_ARB           = 0x84EA;
	immutable GLenum GL_COMPRESSED_LUMINANCE_ALPHA_ARB     = 0x84EB;
	immutable GLenum GL_COMPRESSED_INTENSITY_ARB           = 0x84EC;
	immutable GLenum GL_COMPRESSED_RGB_ARB                 = 0x84ED;
	immutable GLenum GL_COMPRESSED_RGBA_ARB                = 0x84EE;
	immutable GLenum GL_TEXTURE_COMPRESSION_HINT_ARB       = 0x84EF;
	immutable GLenum GL_TEXTURE_COMPRESSED_IMAGE_SIZE_ARB  = 0x86A0;
	immutable GLenum GL_TEXTURE_COMPRESSED_ARB             = 0x86A1;
	immutable GLenum GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB = 0x86A2;
	immutable GLenum GL_COMPRESSED_TEXTURE_FORMATS_ARB     = 0x86A3;
}

version (GL_ARB_texture_border_clamp)
{
}
else
{
	immutable GLenum GL_CLAMP_TO_BORDER_ARB = 0x812D;
}

version (GL_ARB_point_parameters)
{
}
else
{
	immutable GLenum GL_POINT_SIZE_MIN_ARB             = 0x8126;
	immutable GLenum GL_POINT_SIZE_MAX_ARB             = 0x8127;
	immutable GLenum GL_POINT_FADE_THRESHOLD_SIZE_ARB  = 0x8128;
	immutable GLenum GL_POINT_DISTANCE_ATTENUATION_ARB = 0x8129;
}

version (GL_ARB_vertex_blend)
{
}
else
{
	immutable GLenum GL_MAX_VERTEX_UNITS_ARB     = 0x86A4;
	immutable GLenum GL_ACTIVE_VERTEX_UNITS_ARB  = 0x86A5;
	immutable GLenum GL_WEIGHT_SUM_UNITY_ARB     = 0x86A6;
	immutable GLenum GL_VERTEX_BLEND_ARB         = 0x86A7;
	immutable GLenum GL_CURRENT_WEIGHT_ARB       = 0x86A8;
	immutable GLenum GL_WEIGHT_ARRAY_TYPE_ARB    = 0x86A9;
	immutable GLenum GL_WEIGHT_ARRAY_STRIDE_ARB  = 0x86AA;
	immutable GLenum GL_WEIGHT_ARRAY_SIZE_ARB    = 0x86AB;
	immutable GLenum GL_WEIGHT_ARRAY_POINTER_ARB = 0x86AC;
	immutable GLenum GL_WEIGHT_ARRAY_ARB         = 0x86AD;
	immutable GLenum GL_MODELVIEW0_ARB           = 0x1700;
	immutable GLenum GL_MODELVIEW1_ARB           = 0x850A;
	immutable GLenum GL_MODELVIEW2_ARB           = 0x8722;
	immutable GLenum GL_MODELVIEW3_ARB           = 0x8723;
	immutable GLenum GL_MODELVIEW4_ARB           = 0x8724;
	immutable GLenum GL_MODELVIEW5_ARB           = 0x8725;
	immutable GLenum GL_MODELVIEW6_ARB           = 0x8726;
	immutable GLenum GL_MODELVIEW7_ARB           = 0x8727;
	immutable GLenum GL_MODELVIEW8_ARB           = 0x8728;
	immutable GLenum GL_MODELVIEW9_ARB           = 0x8729;
	immutable GLenum GL_MODELVIEW10_ARB          = 0x872A;
	immutable GLenum GL_MODELVIEW11_ARB          = 0x872B;
	immutable GLenum GL_MODELVIEW12_ARB          = 0x872C;
	immutable GLenum GL_MODELVIEW13_ARB          = 0x872D;
	immutable GLenum GL_MODELVIEW14_ARB          = 0x872E;
	immutable GLenum GL_MODELVIEW15_ARB          = 0x872F;
	immutable GLenum GL_MODELVIEW16_ARB          = 0x8730;
	immutable GLenum GL_MODELVIEW17_ARB          = 0x8731;
	immutable GLenum GL_MODELVIEW18_ARB          = 0x8732;
	immutable GLenum GL_MODELVIEW19_ARB          = 0x8733;
	immutable GLenum GL_MODELVIEW20_ARB          = 0x8734;
	immutable GLenum GL_MODELVIEW21_ARB          = 0x8735;
	immutable GLenum GL_MODELVIEW22_ARB          = 0x8736;
	immutable GLenum GL_MODELVIEW23_ARB          = 0x8737;
	immutable GLenum GL_MODELVIEW24_ARB          = 0x8738;
	immutable GLenum GL_MODELVIEW25_ARB          = 0x8739;
	immutable GLenum GL_MODELVIEW26_ARB          = 0x873A;
	immutable GLenum GL_MODELVIEW27_ARB          = 0x873B;
	immutable GLenum GL_MODELVIEW28_ARB          = 0x873C;
	immutable GLenum GL_MODELVIEW29_ARB          = 0x873D;
	immutable GLenum GL_MODELVIEW30_ARB          = 0x873E;
	immutable GLenum GL_MODELVIEW31_ARB          = 0x873F;
}

version (GL_ARB_matrix_palette)
{
}
else
{
	immutable GLenum GL_MATRIX_PALETTE_ARB                 = 0x8840;
	immutable GLenum GL_MAX_MATRIX_PALETTE_STACK_DEPTH_ARB = 0x8841;
	immutable GLenum GL_MAX_PALETTE_MATRICES_ARB           = 0x8842;
	immutable GLenum GL_CURRENT_PALETTE_MATRIX_ARB         = 0x8843;
	immutable GLenum GL_MATRIX_INDEX_ARRAY_ARB             = 0x8844;
	immutable GLenum GL_CURRENT_MATRIX_INDEX_ARB           = 0x8845;
	immutable GLenum GL_MATRIX_INDEX_ARRAY_SIZE_ARB        = 0x8846;
	immutable GLenum GL_MATRIX_INDEX_ARRAY_TYPE_ARB        = 0x8847;
	immutable GLenum GL_MATRIX_INDEX_ARRAY_STRIDE_ARB      = 0x8848;
	immutable GLenum GL_MATRIX_INDEX_ARRAY_POINTER_ARB     = 0x8849;
}

version (GL_ARB_texture_env_combine)
{
}
else
{
	immutable GLenum GL_COMBINE_ARB        = 0x8570;
	immutable GLenum GL_COMBINE_RGB_ARB    = 0x8571;
	immutable GLenum GL_COMBINE_ALPHA_ARB  = 0x8572;
	immutable GLenum GL_SOURCE0_RGB_ARB    = 0x8580;
	immutable GLenum GL_SOURCE1_RGB_ARB    = 0x8581;
	immutable GLenum GL_SOURCE2_RGB_ARB    = 0x8582;
	immutable GLenum GL_SOURCE0_ALPHA_ARB  = 0x8588;
	immutable GLenum GL_SOURCE1_ALPHA_ARB  = 0x8589;
	immutable GLenum GL_SOURCE2_ALPHA_ARB  = 0x858A;
	immutable GLenum GL_OPERAND0_RGB_ARB   = 0x8590;
	immutable GLenum GL_OPERAND1_RGB_ARB   = 0x8591;
	immutable GLenum GL_OPERAND2_RGB_ARB   = 0x8592;
	immutable GLenum GL_OPERAND0_ALPHA_ARB = 0x8598;
	immutable GLenum GL_OPERAND1_ALPHA_ARB = 0x8599;
	immutable GLenum GL_OPERAND2_ALPHA_ARB = 0x859A;
	immutable GLenum GL_RGB_SCALE_ARB      = 0x8573;
	immutable GLenum GL_ADD_SIGNED_ARB     = 0x8574;
	immutable GLenum GL_INTERPOLATE_ARB    = 0x8575;
	immutable GLenum GL_SUBTRACT_ARB       = 0x84E7;
	immutable GLenum GL_CONSTANT_ARB       = 0x8576;
	immutable GLenum GL_PRIMARY_COLOR_ARB  = 0x8577;
	immutable GLenum GL_PREVIOUS_ARB       = 0x8578;
}

version (GL_ARB_texture_env_crossbar)
{
}
else
{
}

version (GL_ARB_texture_env_dot3)
{
}
else
{
	immutable GLenum GL_DOT3_RGB_ARB  = 0x86AE;
	immutable GLenum GL_DOT3_RGBA_ARB = 0x86AF;
}

version (GL_ARB_texture_mirrored_repeat)
{
}
else
{
	immutable GLenum GL_MIRRORED_REPEAT_ARB = 0x8370;
}

version (GL_ARB_depth_texture)
{
}
else
{
	immutable GLenum GL_DEPTH_COMPONENT16_ARB  = 0x81A5;
	immutable GLenum GL_DEPTH_COMPONENT24_ARB  = 0x81A6;
	immutable GLenum GL_DEPTH_COMPONENT32_ARB  = 0x81A7;
	immutable GLenum GL_TEXTURE_DEPTH_SIZE_ARB = 0x884A;
	immutable GLenum GL_DEPTH_TEXTURE_MODE_ARB = 0x884B;
}

version (GL_ARB_shadow)
{
}
else
{
	immutable GLenum GL_TEXTURE_COMPARE_MODE_ARB = 0x884C;
	immutable GLenum GL_TEXTURE_COMPARE_FUNC_ARB = 0x884D;
	immutable GLenum GL_COMPARE_R_TO_TEXTURE_ARB = 0x884E;
}

version (GL_ARB_shadow_ambient)
{
}
else
{
	immutable GLenum GL_TEXTURE_COMPARE_FAIL_VALUE_ARB = 0x80BF;
}

version (GL_ARB_window_pos)
{
}
else
{
}

version (GL_ARB_vertex_program)
{
}
else
{
	immutable GLenum GL_COLOR_SUM_ARB                            = 0x8458;
	immutable GLenum GL_VERTEX_PROGRAM_ARB                       = 0x8620;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_ENABLED_ARB          = 0x8622;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_SIZE_ARB             = 0x8623;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_STRIDE_ARB           = 0x8624;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_TYPE_ARB             = 0x8625;
	immutable GLenum GL_CURRENT_VERTEX_ATTRIB_ARB                = 0x8626;
	immutable GLenum GL_PROGRAM_LENGTH_ARB                       = 0x8627;
	immutable GLenum GL_PROGRAM_STRING_ARB                       = 0x8628;
	immutable GLenum GL_MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB       = 0x862E;
	immutable GLenum GL_MAX_PROGRAM_MATRICES_ARB                 = 0x862F;
	immutable GLenum GL_CURRENT_MATRIX_STACK_DEPTH_ARB           = 0x8640;
	immutable GLenum GL_CURRENT_MATRIX_ARB                       = 0x8641;
	immutable GLenum GL_VERTEX_PROGRAM_POINT_SIZE_ARB            = 0x8642;
	immutable GLenum GL_VERTEX_PROGRAM_TWO_SIDE_ARB              = 0x8643;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_POINTER_ARB          = 0x8645;
	immutable GLenum GL_PROGRAM_ERROR_POSITION_ARB               = 0x864B;
	immutable GLenum GL_PROGRAM_BINDING_ARB                      = 0x8677;
	immutable GLenum GL_MAX_VERTEX_ATTRIBS_ARB                   = 0x8869;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB       = 0x886A;
	immutable GLenum GL_PROGRAM_ERROR_STRING_ARB                 = 0x8874;
	immutable GLenum GL_PROGRAM_FORMAT_ASCII_ARB                 = 0x8875;
	immutable GLenum GL_PROGRAM_FORMAT_ARB                       = 0x8876;
	immutable GLenum GL_PROGRAM_INSTRUCTIONS_ARB                 = 0x88A0;
	immutable GLenum GL_MAX_PROGRAM_INSTRUCTIONS_ARB             = 0x88A1;
	immutable GLenum GL_PROGRAM_NATIVE_INSTRUCTIONS_ARB          = 0x88A2;
	immutable GLenum GL_MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB      = 0x88A3;
	immutable GLenum GL_PROGRAM_TEMPORARIES_ARB                  = 0x88A4;
	immutable GLenum GL_MAX_PROGRAM_TEMPORARIES_ARB              = 0x88A5;
	immutable GLenum GL_PROGRAM_NATIVE_TEMPORARIES_ARB           = 0x88A6;
	immutable GLenum GL_MAX_PROGRAM_NATIVE_TEMPORARIES_ARB       = 0x88A7;
	immutable GLenum GL_PROGRAM_PARAMETERS_ARB                   = 0x88A8;
	immutable GLenum GL_MAX_PROGRAM_PARAMETERS_ARB               = 0x88A9;
	immutable GLenum GL_PROGRAM_NATIVE_PARAMETERS_ARB            = 0x88AA;
	immutable GLenum GL_MAX_PROGRAM_NATIVE_PARAMETERS_ARB        = 0x88AB;
	immutable GLenum GL_PROGRAM_ATTRIBS_ARB                      = 0x88AC;
	immutable GLenum GL_MAX_PROGRAM_ATTRIBS_ARB                  = 0x88AD;
	immutable GLenum GL_PROGRAM_NATIVE_ATTRIBS_ARB               = 0x88AE;
	immutable GLenum GL_MAX_PROGRAM_NATIVE_ATTRIBS_ARB           = 0x88AF;
	immutable GLenum GL_PROGRAM_ADDRESS_REGISTERS_ARB            = 0x88B0;
	immutable GLenum GL_MAX_PROGRAM_ADDRESS_REGISTERS_ARB        = 0x88B1;
	immutable GLenum GL_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB     = 0x88B2;
	immutable GLenum GL_MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB = 0x88B3;
	immutable GLenum GL_MAX_PROGRAM_LOCAL_PARAMETERS_ARB         = 0x88B4;
	immutable GLenum GL_MAX_PROGRAM_ENV_PARAMETERS_ARB           = 0x88B5;
	immutable GLenum GL_PROGRAM_UNDER_NATIVE_LIMITS_ARB          = 0x88B6;
	immutable GLenum GL_TRANSPOSE_CURRENT_MATRIX_ARB             = 0x88B7;
	immutable GLenum GL_MATRIX0_ARB                              = 0x88C0;
	immutable GLenum GL_MATRIX1_ARB                              = 0x88C1;
	immutable GLenum GL_MATRIX2_ARB                              = 0x88C2;
	immutable GLenum GL_MATRIX3_ARB                              = 0x88C3;
	immutable GLenum GL_MATRIX4_ARB                              = 0x88C4;
	immutable GLenum GL_MATRIX5_ARB                              = 0x88C5;
	immutable GLenum GL_MATRIX6_ARB                              = 0x88C6;
	immutable GLenum GL_MATRIX7_ARB                              = 0x88C7;
	immutable GLenum GL_MATRIX8_ARB                              = 0x88C8;
	immutable GLenum GL_MATRIX9_ARB                              = 0x88C9;
	immutable GLenum GL_MATRIX10_ARB                             = 0x88CA;
	immutable GLenum GL_MATRIX11_ARB                             = 0x88CB;
	immutable GLenum GL_MATRIX12_ARB                             = 0x88CC;
	immutable GLenum GL_MATRIX13_ARB                             = 0x88CD;
	immutable GLenum GL_MATRIX14_ARB                             = 0x88CE;
	immutable GLenum GL_MATRIX15_ARB                             = 0x88CF;
	immutable GLenum GL_MATRIX16_ARB                             = 0x88D0;
	immutable GLenum GL_MATRIX17_ARB                             = 0x88D1;
	immutable GLenum GL_MATRIX18_ARB                             = 0x88D2;
	immutable GLenum GL_MATRIX19_ARB                             = 0x88D3;
	immutable GLenum GL_MATRIX20_ARB                             = 0x88D4;
	immutable GLenum GL_MATRIX21_ARB                             = 0x88D5;
	immutable GLenum GL_MATRIX22_ARB                             = 0x88D6;
	immutable GLenum GL_MATRIX23_ARB                             = 0x88D7;
	immutable GLenum GL_MATRIX24_ARB                             = 0x88D8;
	immutable GLenum GL_MATRIX25_ARB                             = 0x88D9;
	immutable GLenum GL_MATRIX26_ARB                             = 0x88DA;
	immutable GLenum GL_MATRIX27_ARB                             = 0x88DB;
	immutable GLenum GL_MATRIX28_ARB                             = 0x88DC;
	immutable GLenum GL_MATRIX29_ARB                             = 0x88DD;
	immutable GLenum GL_MATRIX30_ARB                             = 0x88DE;
	immutable GLenum GL_MATRIX31_ARB                             = 0x88DF;
}

version (GL_ARB_fragment_program)
{
}
else
{
	immutable GLenum GL_FRAGMENT_PROGRAM_ARB                    = 0x8804;
	immutable GLenum GL_PROGRAM_ALU_INSTRUCTIONS_ARB            = 0x8805;
	immutable GLenum GL_PROGRAM_TEX_INSTRUCTIONS_ARB            = 0x8806;
	immutable GLenum GL_PROGRAM_TEX_INDIRECTIONS_ARB            = 0x8807;
	immutable GLenum GL_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB     = 0x8808;
	immutable GLenum GL_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB     = 0x8809;
	immutable GLenum GL_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB     = 0x880A;
	immutable GLenum GL_MAX_PROGRAM_ALU_INSTRUCTIONS_ARB        = 0x880B;
	immutable GLenum GL_MAX_PROGRAM_TEX_INSTRUCTIONS_ARB        = 0x880C;
	immutable GLenum GL_MAX_PROGRAM_TEX_INDIRECTIONS_ARB        = 0x880D;
	immutable GLenum GL_MAX_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB = 0x880E;
	immutable GLenum GL_MAX_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB = 0x880F;
	immutable GLenum GL_MAX_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB = 0x8810;
	immutable GLenum GL_MAX_TEXTURE_COORDS_ARB                  = 0x8871;
	immutable GLenum GL_MAX_TEXTURE_IMAGE_UNITS_ARB             = 0x8872;
}

version (GL_ARB_vertex_buffer_object)
{
}
else
{
	immutable GLenum GL_BUFFER_SIZE_ARB                          = 0x8764;
	immutable GLenum GL_BUFFER_USAGE_ARB                         = 0x8765;
	immutable GLenum GL_ARRAY_BUFFER_ARB                         = 0x8892;
	immutable GLenum GL_ELEMENT_ARRAY_BUFFER_ARB                 = 0x8893;
	immutable GLenum GL_ARRAY_BUFFER_BINDING_ARB                 = 0x8894;
	immutable GLenum GL_ELEMENT_ARRAY_BUFFER_BINDING_ARB         = 0x8895;
	immutable GLenum GL_VERTEX_ARRAY_BUFFER_BINDING_ARB          = 0x8896;
	immutable GLenum GL_NORMAL_ARRAY_BUFFER_BINDING_ARB          = 0x8897;
	immutable GLenum GL_COLOR_ARRAY_BUFFER_BINDING_ARB           = 0x8898;
	immutable GLenum GL_INDEX_ARRAY_BUFFER_BINDING_ARB           = 0x8899;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB   = 0x889A;
	immutable GLenum GL_EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB       = 0x889B;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB = 0x889C;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB  = 0x889D;
	immutable GLenum GL_WEIGHT_ARRAY_BUFFER_BINDING_ARB          = 0x889E;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB   = 0x889F;
	immutable GLenum GL_READ_ONLY_ARB                            = 0x88B8;
	immutable GLenum GL_WRITE_ONLY_ARB                           = 0x88B9;
	immutable GLenum GL_READ_WRITE_ARB                           = 0x88BA;
	immutable GLenum GL_BUFFER_ACCESS_ARB                        = 0x88BB;
	immutable GLenum GL_BUFFER_MAPPED_ARB                        = 0x88BC;
	immutable GLenum GL_BUFFER_MAP_POINTER_ARB                   = 0x88BD;
	immutable GLenum GL_STREAM_DRAW_ARB                          = 0x88E0;
	immutable GLenum GL_STREAM_READ_ARB                          = 0x88E1;
	immutable GLenum GL_STREAM_COPY_ARB                          = 0x88E2;
	immutable GLenum GL_STATIC_DRAW_ARB                          = 0x88E4;
	immutable GLenum GL_STATIC_READ_ARB                          = 0x88E5;
	immutable GLenum GL_STATIC_COPY_ARB                          = 0x88E6;
	immutable GLenum GL_DYNAMIC_DRAW_ARB                         = 0x88E8;
	immutable GLenum GL_DYNAMIC_READ_ARB                         = 0x88E9;
	immutable GLenum GL_DYNAMIC_COPY_ARB                         = 0x88EA;
}

version (GL_ARB_occlusion_query)
{
}
else
{
	immutable GLenum GL_QUERY_COUNTER_BITS_ARB     = 0x8864;
	immutable GLenum GL_CURRENT_QUERY_ARB          = 0x8865;
	immutable GLenum GL_QUERY_RESULT_ARB           = 0x8866;
	immutable GLenum GL_QUERY_RESULT_AVAILABLE_ARB = 0x8867;
	immutable GLenum GL_SAMPLES_PASSED_ARB         = 0x8914;
}

version (GL_ARB_shader_objects)
{
}
else
{
	immutable GLenum GL_PROGRAM_OBJECT_ARB                   = 0x8B40;
	immutable GLenum GL_SHADER_OBJECT_ARB                    = 0x8B48;
	immutable GLenum GL_OBJECT_TYPE_ARB                      = 0x8B4E;
	immutable GLenum GL_OBJECT_SUBTYPE_ARB                   = 0x8B4F;
	immutable GLenum GL_FLOAT_VEC2_ARB                       = 0x8B50;
	immutable GLenum GL_FLOAT_VEC3_ARB                       = 0x8B51;
	immutable GLenum GL_FLOAT_VEC4_ARB                       = 0x8B52;
	immutable GLenum GL_INT_VEC2_ARB                         = 0x8B53;
	immutable GLenum GL_INT_VEC3_ARB                         = 0x8B54;
	immutable GLenum GL_INT_VEC4_ARB                         = 0x8B55;
	immutable GLenum GL_BOOL_ARB                             = 0x8B56;
	immutable GLenum GL_BOOL_VEC2_ARB                        = 0x8B57;
	immutable GLenum GL_BOOL_VEC3_ARB                        = 0x8B58;
	immutable GLenum GL_BOOL_VEC4_ARB                        = 0x8B59;
	immutable GLenum GL_FLOAT_MAT2_ARB                       = 0x8B5A;
	immutable GLenum GL_FLOAT_MAT3_ARB                       = 0x8B5B;
	immutable GLenum GL_FLOAT_MAT4_ARB                       = 0x8B5C;
	immutable GLenum GL_SAMPLER_1D_ARB                       = 0x8B5D;
	immutable GLenum GL_SAMPLER_2D_ARB                       = 0x8B5E;
	immutable GLenum GL_SAMPLER_3D_ARB                       = 0x8B5F;
	immutable GLenum GL_SAMPLER_CUBE_ARB                     = 0x8B60;
	immutable GLenum GL_SAMPLER_1D_SHADOW_ARB                = 0x8B61;
	immutable GLenum GL_SAMPLER_2D_SHADOW_ARB                = 0x8B62;
	immutable GLenum GL_SAMPLER_2D_RECT_ARB                  = 0x8B63;
	immutable GLenum GL_SAMPLER_2D_RECT_SHADOW_ARB           = 0x8B64;
	immutable GLenum GL_OBJECT_DELETE_STATUS_ARB             = 0x8B80;
	immutable GLenum GL_OBJECT_COMPILE_STATUS_ARB            = 0x8B81;
	immutable GLenum GL_OBJECT_LINK_STATUS_ARB               = 0x8B82;
	immutable GLenum GL_OBJECT_VALIDATE_STATUS_ARB           = 0x8B83;
	immutable GLenum GL_OBJECT_INFO_LOG_LENGTH_ARB           = 0x8B84;
	immutable GLenum GL_OBJECT_ATTACHED_OBJECTS_ARB          = 0x8B85;
	immutable GLenum GL_OBJECT_ACTIVE_UNIFORMS_ARB           = 0x8B86;
	immutable GLenum GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB = 0x8B87;
	immutable GLenum GL_OBJECT_SHADER_SOURCE_LENGTH_ARB      = 0x8B88;
}

version (GL_ARB_vertex_shader)
{
}
else
{
	immutable GLenum GL_VERTEX_SHADER_ARB                      = 0x8B31;
	immutable GLenum GL_MAX_VERTEX_UNIFORM_COMPONENTS_ARB      = 0x8B4A;
	immutable GLenum GL_MAX_VARYING_FLOATS_ARB                 = 0x8B4B;
	immutable GLenum GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB     = 0x8B4C;
	immutable GLenum GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB   = 0x8B4D;
	immutable GLenum GL_OBJECT_ACTIVE_ATTRIBUTES_ARB           = 0x8B89;
	immutable GLenum GL_OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB = 0x8B8A;
}

version (GL_ARB_fragment_shader)
{
}
else
{
	immutable GLenum GL_FRAGMENT_SHADER_ARB                 = 0x8B30;
	immutable GLenum GL_MAX_FRAGMENT_UNIFORM_COMPONENTS_ARB = 0x8B49;
	immutable GLenum GL_FRAGMENT_SHADER_DERIVATIVE_HINT_ARB = 0x8B8B;
}

version (GL_ARB_shading_language_100)
{
}
else
{
	immutable GLenum GL_SHADING_LANGUAGE_VERSION_ARB = 0x8B8C;
}

version (GL_ARB_texture_non_power_of_two)
{
}
else
{
}

version (GL_ARB_point_sprite)
{
}
else
{
	immutable GLenum GL_POINT_SPRITE_ARB  = 0x8861;
	immutable GLenum GL_COORD_REPLACE_ARB = 0x8862;
}

version (GL_ARB_fragment_program_shadow)
{
}
else
{
}

version (GL_ARB_draw_buffers)
{
}
else
{
	immutable GLenum GL_MAX_DRAW_BUFFERS_ARB = 0x8824;
	immutable GLenum GL_DRAW_BUFFER0_ARB     = 0x8825;
	immutable GLenum GL_DRAW_BUFFER1_ARB     = 0x8826;
	immutable GLenum GL_DRAW_BUFFER2_ARB     = 0x8827;
	immutable GLenum GL_DRAW_BUFFER3_ARB     = 0x8828;
	immutable GLenum GL_DRAW_BUFFER4_ARB     = 0x8829;
	immutable GLenum GL_DRAW_BUFFER5_ARB     = 0x882A;
	immutable GLenum GL_DRAW_BUFFER6_ARB     = 0x882B;
	immutable GLenum GL_DRAW_BUFFER7_ARB     = 0x882C;
	immutable GLenum GL_DRAW_BUFFER8_ARB     = 0x882D;
	immutable GLenum GL_DRAW_BUFFER9_ARB     = 0x882E;
	immutable GLenum GL_DRAW_BUFFER10_ARB    = 0x882F;
	immutable GLenum GL_DRAW_BUFFER11_ARB    = 0x8830;
	immutable GLenum GL_DRAW_BUFFER12_ARB    = 0x8831;
	immutable GLenum GL_DRAW_BUFFER13_ARB    = 0x8832;
	immutable GLenum GL_DRAW_BUFFER14_ARB    = 0x8833;
	immutable GLenum GL_DRAW_BUFFER15_ARB    = 0x8834;
}

version (GL_ARB_texture_rectangle)
{
}
else
{
	immutable GLenum GL_TEXTURE_RECTANGLE_ARB          = 0x84F5;
	immutable GLenum GL_TEXTURE_BINDING_RECTANGLE_ARB  = 0x84F6;
	immutable GLenum GL_PROXY_TEXTURE_RECTANGLE_ARB    = 0x84F7;
	immutable GLenum GL_MAX_RECTANGLE_TEXTURE_SIZE_ARB = 0x84F8;
}

version (GL_ARB_color_buffer_float)
{
}
else
{
	immutable GLenum GL_RGBA_FLOAT_MODE_ARB      = 0x8820;
	immutable GLenum GL_CLAMP_VERTEX_COLOR_ARB   = 0x891A;
	immutable GLenum GL_CLAMP_FRAGMENT_COLOR_ARB = 0x891B;
	immutable GLenum GL_CLAMP_READ_COLOR_ARB     = 0x891C;
	immutable GLenum GL_FIXED_ONLY_ARB           = 0x891D;
}

version (GL_ARB_half_float_pixel)
{
}
else
{
	immutable GLenum GL_HALF_FLOAT_ARB = 0x140B;
}

version (GL_ARB_texture_float)
{
}
else
{
	immutable GLenum GL_TEXTURE_RED_TYPE_ARB       = 0x8C10;
	immutable GLenum GL_TEXTURE_GREEN_TYPE_ARB     = 0x8C11;
	immutable GLenum GL_TEXTURE_BLUE_TYPE_ARB      = 0x8C12;
	immutable GLenum GL_TEXTURE_ALPHA_TYPE_ARB     = 0x8C13;
	immutable GLenum GL_TEXTURE_LUMINANCE_TYPE_ARB = 0x8C14;
	immutable GLenum GL_TEXTURE_INTENSITY_TYPE_ARB = 0x8C15;
	immutable GLenum GL_TEXTURE_DEPTH_TYPE_ARB     = 0x8C16;
	immutable GLenum GL_UNSIGNED_NORMALIZED_ARB    = 0x8C17;
	immutable GLenum GL_RGBA32F_ARB                = 0x8814;
	immutable GLenum GL_RGB32F_ARB                 = 0x8815;
	immutable GLenum GL_ALPHA32F_ARB               = 0x8816;
	immutable GLenum GL_INTENSITY32F_ARB           = 0x8817;
	immutable GLenum GL_LUMINANCE32F_ARB           = 0x8818;
	immutable GLenum GL_LUMINANCE_ALPHA32F_ARB     = 0x8819;
	immutable GLenum GL_RGBA16F_ARB                = 0x881A;
	immutable GLenum GL_RGB16F_ARB                 = 0x881B;
	immutable GLenum GL_ALPHA16F_ARB               = 0x881C;
	immutable GLenum GL_INTENSITY16F_ARB           = 0x881D;
	immutable GLenum GL_LUMINANCE16F_ARB           = 0x881E;
	immutable GLenum GL_LUMINANCE_ALPHA16F_ARB     = 0x881F;
}

version (GL_ARB_pixel_buffer_object)
{
}
else
{
	immutable GLenum GL_PIXEL_PACK_BUFFER_ARB           = 0x88EB;
	immutable GLenum GL_PIXEL_UNPACK_BUFFER_ARB         = 0x88EC;
	immutable GLenum GL_PIXEL_PACK_BUFFER_BINDING_ARB   = 0x88ED;
	immutable GLenum GL_PIXEL_UNPACK_BUFFER_BINDING_ARB = 0x88EF;
}

version (GL_EXT_abgr)
{
}
else
{
	immutable GLenum GL_ABGR_EXT = 0x8000;
}

version (GL_EXT_blend_color)
{
}
else
{
	immutable GLenum GL_CONSTANT_COLOR_EXT           = 0x8001;
	immutable GLenum GL_ONE_MINUS_CONSTANT_COLOR_EXT = 0x8002;
	immutable GLenum GL_CONSTANT_ALPHA_EXT           = 0x8003;
	immutable GLenum GL_ONE_MINUS_CONSTANT_ALPHA_EXT = 0x8004;
	immutable GLenum GL_BLEND_COLOR_EXT              = 0x8005;
}

version (GL_EXT_polygon_offset)
{
}
else
{
	immutable GLenum GL_POLYGON_OFFSET_EXT        = 0x8037;
	immutable GLenum GL_POLYGON_OFFSET_FACTOR_EXT = 0x8038;
	immutable GLenum GL_POLYGON_OFFSET_BIAS_EXT   = 0x8039;
}

version (GL_EXT_texture)
{
}
else
{
	immutable GLenum GL_ALPHA4_EXT                 = 0x803B;
	immutable GLenum GL_ALPHA8_EXT                 = 0x803C;
	immutable GLenum GL_ALPHA12_EXT                = 0x803D;
	immutable GLenum GL_ALPHA16_EXT                = 0x803E;
	immutable GLenum GL_LUMINANCE4_EXT             = 0x803F;
	immutable GLenum GL_LUMINANCE8_EXT             = 0x8040;
	immutable GLenum GL_LUMINANCE12_EXT            = 0x8041;
	immutable GLenum GL_LUMINANCE16_EXT            = 0x8042;
	immutable GLenum GL_LUMINANCE4_ALPHA4_EXT      = 0x8043;
	immutable GLenum GL_LUMINANCE6_ALPHA2_EXT      = 0x8044;
	immutable GLenum GL_LUMINANCE8_ALPHA8_EXT      = 0x8045;
	immutable GLenum GL_LUMINANCE12_ALPHA4_EXT     = 0x8046;
	immutable GLenum GL_LUMINANCE12_ALPHA12_EXT    = 0x8047;
	immutable GLenum GL_LUMINANCE16_ALPHA16_EXT    = 0x8048;
	immutable GLenum GL_INTENSITY_EXT              = 0x8049;
	immutable GLenum GL_INTENSITY4_EXT             = 0x804A;
	immutable GLenum GL_INTENSITY8_EXT             = 0x804B;
	immutable GLenum GL_INTENSITY12_EXT            = 0x804C;
	immutable GLenum GL_INTENSITY16_EXT            = 0x804D;
	immutable GLenum GL_RGB2_EXT                   = 0x804E;
	immutable GLenum GL_RGB4_EXT                   = 0x804F;
	immutable GLenum GL_RGB5_EXT                   = 0x8050;
	immutable GLenum GL_RGB8_EXT                   = 0x8051;
	immutable GLenum GL_RGB10_EXT                  = 0x8052;
	immutable GLenum GL_RGB12_EXT                  = 0x8053;
	immutable GLenum GL_RGB16_EXT                  = 0x8054;
	immutable GLenum GL_RGBA2_EXT                  = 0x8055;
	immutable GLenum GL_RGBA4_EXT                  = 0x8056;
	immutable GLenum GL_RGB5_A1_EXT                = 0x8057;
	immutable GLenum GL_RGBA8_EXT                  = 0x8058;
	immutable GLenum GL_RGB10_A2_EXT               = 0x8059;
	immutable GLenum GL_RGBA12_EXT                 = 0x805A;
	immutable GLenum GL_RGBA16_EXT                 = 0x805B;
	immutable GLenum GL_TEXTURE_RED_SIZE_EXT       = 0x805C;
	immutable GLenum GL_TEXTURE_GREEN_SIZE_EXT     = 0x805D;
	immutable GLenum GL_TEXTURE_BLUE_SIZE_EXT      = 0x805E;
	immutable GLenum GL_TEXTURE_ALPHA_SIZE_EXT     = 0x805F;
	immutable GLenum GL_TEXTURE_LUMINANCE_SIZE_EXT = 0x8060;
	immutable GLenum GL_TEXTURE_INTENSITY_SIZE_EXT = 0x8061;
	immutable GLenum GL_REPLACE_EXT                = 0x8062;
	immutable GLenum GL_PROXY_TEXTURE_1D_EXT       = 0x8063;
	immutable GLenum GL_PROXY_TEXTURE_2D_EXT       = 0x8064;
	immutable GLenum GL_TEXTURE_TOO_LARGE_EXT      = 0x8065;
}

version (GL_EXT_texture3D)
{
}
else
{
	immutable GLenum GL_PACK_SKIP_IMAGES_EXT    = 0x806B;
	immutable GLenum GL_PACK_IMAGE_HEIGHT_EXT   = 0x806C;
	immutable GLenum GL_UNPACK_SKIP_IMAGES_EXT  = 0x806D;
	immutable GLenum GL_UNPACK_IMAGE_HEIGHT_EXT = 0x806E;
	immutable GLenum GL_TEXTURE_3D_EXT          = 0x806F;
	immutable GLenum GL_PROXY_TEXTURE_3D_EXT    = 0x8070;
	immutable GLenum GL_TEXTURE_DEPTH_EXT       = 0x8071;
	immutable GLenum GL_TEXTURE_WRAP_R_EXT      = 0x8072;
	immutable GLenum GL_MAX_3D_TEXTURE_SIZE_EXT = 0x8073;
}

version (GL_SGIS_texture_filter4)
{
}
else
{
	immutable GLenum GL_FILTER4_SGIS              = 0x8146;
	immutable GLenum GL_TEXTURE_FILTER4_SIZE_SGIS = 0x8147;
}

version (GL_EXT_subtexture)
{
}
else
{
}

version (GL_EXT_copy_texture)
{
}
else
{
}

version (GL_EXT_histogram)
{
}
else
{
	immutable GLenum GL_HISTOGRAM_EXT                = 0x8024;
	immutable GLenum GL_PROXY_HISTOGRAM_EXT          = 0x8025;
	immutable GLenum GL_HISTOGRAM_WIDTH_EXT          = 0x8026;
	immutable GLenum GL_HISTOGRAM_FORMAT_EXT         = 0x8027;
	immutable GLenum GL_HISTOGRAM_RED_SIZE_EXT       = 0x8028;
	immutable GLenum GL_HISTOGRAM_GREEN_SIZE_EXT     = 0x8029;
	immutable GLenum GL_HISTOGRAM_BLUE_SIZE_EXT      = 0x802A;
	immutable GLenum GL_HISTOGRAM_ALPHA_SIZE_EXT     = 0x802B;
	immutable GLenum GL_HISTOGRAM_LUMINANCE_SIZE_EXT = 0x802C;
	immutable GLenum GL_HISTOGRAM_SINK_EXT           = 0x802D;
	immutable GLenum GL_MINMAX_EXT                   = 0x802E;
	immutable GLenum GL_MINMAX_FORMAT_EXT            = 0x802F;
	immutable GLenum GL_MINMAX_SINK_EXT              = 0x8030;
	immutable GLenum GL_TABLE_TOO_LARGE_EXT          = 0x8031;
}

version (GL_EXT_convolution)
{
}
else
{
	immutable GLenum GL_CONVOLUTION_1D_EXT               = 0x8010;
	immutable GLenum GL_CONVOLUTION_2D_EXT               = 0x8011;
	immutable GLenum GL_SEPARABLE_2D_EXT                 = 0x8012;
	immutable GLenum GL_CONVOLUTION_BORDER_MODE_EXT      = 0x8013;
	immutable GLenum GL_CONVOLUTION_FILTER_SCALE_EXT     = 0x8014;
	immutable GLenum GL_CONVOLUTION_FILTER_BIAS_EXT      = 0x8015;
	immutable GLenum GL_REDUCE_EXT                       = 0x8016;
	immutable GLenum GL_CONVOLUTION_FORMAT_EXT           = 0x8017;
	immutable GLenum GL_CONVOLUTION_WIDTH_EXT            = 0x8018;
	immutable GLenum GL_CONVOLUTION_HEIGHT_EXT           = 0x8019;
	immutable GLenum GL_MAX_CONVOLUTION_WIDTH_EXT        = 0x801A;
	immutable GLenum GL_MAX_CONVOLUTION_HEIGHT_EXT       = 0x801B;
	immutable GLenum GL_POST_CONVOLUTION_RED_SCALE_EXT   = 0x801C;
	immutable GLenum GL_POST_CONVOLUTION_GREEN_SCALE_EXT = 0x801D;
	immutable GLenum GL_POST_CONVOLUTION_BLUE_SCALE_EXT  = 0x801E;
	immutable GLenum GL_POST_CONVOLUTION_ALPHA_SCALE_EXT = 0x801F;
	immutable GLenum GL_POST_CONVOLUTION_RED_BIAS_EXT    = 0x8020;
	immutable GLenum GL_POST_CONVOLUTION_GREEN_BIAS_EXT  = 0x8021;
	immutable GLenum GL_POST_CONVOLUTION_BLUE_BIAS_EXT   = 0x8022;
	immutable GLenum GL_POST_CONVOLUTION_ALPHA_BIAS_EXT  = 0x8023;
}

version (GL_SGI_color_matrix)
{
}
else
{
	immutable GLenum GL_COLOR_MATRIX_SGI                  = 0x80B1;
	immutable GLenum GL_COLOR_MATRIX_STACK_DEPTH_SGI      = 0x80B2;
	immutable GLenum GL_MAX_COLOR_MATRIX_STACK_DEPTH_SGI  = 0x80B3;
	immutable GLenum GL_POST_COLOR_MATRIX_RED_SCALE_SGI   = 0x80B4;
	immutable GLenum GL_POST_COLOR_MATRIX_GREEN_SCALE_SGI = 0x80B5;
	immutable GLenum GL_POST_COLOR_MATRIX_BLUE_SCALE_SGI  = 0x80B6;
	immutable GLenum GL_POST_COLOR_MATRIX_ALPHA_SCALE_SGI = 0x80B7;
	immutable GLenum GL_POST_COLOR_MATRIX_RED_BIAS_SGI    = 0x80B8;
	immutable GLenum GL_POST_COLOR_MATRIX_GREEN_BIAS_SGI  = 0x80B9;
	immutable GLenum GL_POST_COLOR_MATRIX_BLUE_BIAS_SGI   = 0x80BA;
	immutable GLenum GL_POST_COLOR_MATRIX_ALPHA_BIAS_SGI  = 0x80BB;
}

version (GL_SGI_color_table)
{
}
else
{
	immutable GLenum GL_COLOR_TABLE_SGI                         = 0x80D0;
	immutable GLenum GL_POST_CONVOLUTION_COLOR_TABLE_SGI        = 0x80D1;
	immutable GLenum GL_POST_COLOR_MATRIX_COLOR_TABLE_SGI       = 0x80D2;
	immutable GLenum GL_PROXY_COLOR_TABLE_SGI                   = 0x80D3;
	immutable GLenum GL_PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI  = 0x80D4;
	immutable GLenum GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI = 0x80D5;
	immutable GLenum GL_COLOR_TABLE_SCALE_SGI                   = 0x80D6;
	immutable GLenum GL_COLOR_TABLE_BIAS_SGI                    = 0x80D7;
	immutable GLenum GL_COLOR_TABLE_FORMAT_SGI                  = 0x80D8;
	immutable GLenum GL_COLOR_TABLE_WIDTH_SGI                   = 0x80D9;
	immutable GLenum GL_COLOR_TABLE_RED_SIZE_SGI                = 0x80DA;
	immutable GLenum GL_COLOR_TABLE_GREEN_SIZE_SGI              = 0x80DB;
	immutable GLenum GL_COLOR_TABLE_BLUE_SIZE_SGI               = 0x80DC;
	immutable GLenum GL_COLOR_TABLE_ALPHA_SIZE_SGI              = 0x80DD;
	immutable GLenum GL_COLOR_TABLE_LUMINANCE_SIZE_SGI          = 0x80DE;
	immutable GLenum GL_COLOR_TABLE_INTENSITY_SIZE_SGI          = 0x80DF;
}

version (GL_SGIS_pixel_texture)
{
}
else
{
	immutable GLenum GL_PIXEL_TEXTURE_SGIS               = 0x8353;
	immutable GLenum GL_PIXEL_FRAGMENT_RGB_SOURCE_SGIS   = 0x8354;
	immutable GLenum GL_PIXEL_FRAGMENT_ALPHA_SOURCE_SGIS = 0x8355;
	immutable GLenum GL_PIXEL_GROUP_COLOR_SGIS           = 0x8356;
}

version (GL_SGIX_pixel_texture)
{
}
else
{
	immutable GLenum GL_PIXEL_TEX_GEN_SGIX      = 0x8139;
	immutable GLenum GL_PIXEL_TEX_GEN_MODE_SGIX = 0x832B;
}

version (GL_SGIS_texture4D)
{
}
else
{
	immutable GLenum GL_PACK_SKIP_VOLUMES_SGIS   = 0x8130;
	immutable GLenum GL_PACK_IMAGE_DEPTH_SGIS    = 0x8131;
	immutable GLenum GL_UNPACK_SKIP_VOLUMES_SGIS = 0x8132;
	immutable GLenum GL_UNPACK_IMAGE_DEPTH_SGIS  = 0x8133;
	immutable GLenum GL_TEXTURE_4D_SGIS          = 0x8134;
	immutable GLenum GL_PROXY_TEXTURE_4D_SGIS    = 0x8135;
	immutable GLenum GL_TEXTURE_4DSIZE_SGIS      = 0x8136;
	immutable GLenum GL_TEXTURE_WRAP_Q_SGIS      = 0x8137;
	immutable GLenum GL_MAX_4D_TEXTURE_SIZE_SGIS = 0x8138;
	immutable GLenum GL_TEXTURE_4D_BINDING_SGIS  = 0x814F;
}

version (GL_SGI_texture_color_table)
{
}
else
{
	immutable GLenum GL_TEXTURE_COLOR_TABLE_SGI       = 0x80BC;
	immutable GLenum GL_PROXY_TEXTURE_COLOR_TABLE_SGI = 0x80BD;
}

version (GL_EXT_cmyka)
{
}
else
{
	immutable GLenum GL_CMYK_EXT             = 0x800C;
	immutable GLenum GL_CMYKA_EXT            = 0x800D;
	immutable GLenum GL_PACK_CMYK_HINT_EXT   = 0x800E;
	immutable GLenum GL_UNPACK_CMYK_HINT_EXT = 0x800F;
}

version (GL_EXT_texture_object)
{
}
else
{
	immutable GLenum GL_TEXTURE_PRIORITY_EXT   = 0x8066;
	immutable GLenum GL_TEXTURE_RESIDENT_EXT   = 0x8067;
	immutable GLenum GL_TEXTURE_1D_BINDING_EXT = 0x8068;
	immutable GLenum GL_TEXTURE_2D_BINDING_EXT = 0x8069;
	immutable GLenum GL_TEXTURE_3D_BINDING_EXT = 0x806A;
}

version (GL_SGIS_detail_texture)
{
}
else
{
	immutable GLenum GL_DETAIL_TEXTURE_2D_SGIS          = 0x8095;
	immutable GLenum GL_DETAIL_TEXTURE_2D_BINDING_SGIS  = 0x8096;
	immutable GLenum GL_LINEAR_DETAIL_SGIS              = 0x8097;
	immutable GLenum GL_LINEAR_DETAIL_ALPHA_SGIS        = 0x8098;
	immutable GLenum GL_LINEAR_DETAIL_COLOR_SGIS        = 0x8099;
	immutable GLenum GL_DETAIL_TEXTURE_LEVEL_SGIS       = 0x809A;
	immutable GLenum GL_DETAIL_TEXTURE_MODE_SGIS        = 0x809B;
	immutable GLenum GL_DETAIL_TEXTURE_FUNC_POINTS_SGIS = 0x809C;
}

version (GL_SGIS_sharpen_texture)
{
}
else
{
	immutable GLenum GL_LINEAR_SHARPEN_SGIS              = 0x80AD;
	immutable GLenum GL_LINEAR_SHARPEN_ALPHA_SGIS        = 0x80AE;
	immutable GLenum GL_LINEAR_SHARPEN_COLOR_SGIS        = 0x80AF;
	immutable GLenum GL_SHARPEN_TEXTURE_FUNC_POINTS_SGIS = 0x80B0;
}

version (GL_EXT_packed_pixels)
{
}
else
{
	immutable GLenum GL_UNSIGNED_BYTE_3_3_2_EXT     = 0x8032;
	immutable GLenum GL_UNSIGNED_SHORT_4_4_4_4_EXT  = 0x8033;
	immutable GLenum GL_UNSIGNED_SHORT_5_5_5_1_EXT  = 0x8034;
	immutable GLenum GL_UNSIGNED_INT_8_8_8_8_EXT    = 0x8035;
	immutable GLenum GL_UNSIGNED_INT_10_10_10_2_EXT = 0x8036;
}

version (GL_SGIS_texture_lod)
{
}
else
{
	immutable GLenum GL_TEXTURE_MIN_LOD_SGIS    = 0x813A;
	immutable GLenum GL_TEXTURE_MAX_LOD_SGIS    = 0x813B;
	immutable GLenum GL_TEXTURE_BASE_LEVEL_SGIS = 0x813C;
	immutable GLenum GL_TEXTURE_MAX_LEVEL_SGIS  = 0x813D;
}

version (GL_SGIS_multisample)
{
}
else
{
	immutable GLenum GL_MULTISAMPLE_SGIS          = 0x809D;
	immutable GLenum GL_SAMPLE_ALPHA_TO_MASK_SGIS = 0x809E;
	immutable GLenum GL_SAMPLE_ALPHA_TO_ONE_SGIS  = 0x809F;
	immutable GLenum GL_SAMPLE_MASK_SGIS          = 0x80A0;
	immutable GLenum GL_1PASS_SGIS                = 0x80A1;
	immutable GLenum GL_2PASS_0_SGIS              = 0x80A2;
	immutable GLenum GL_2PASS_1_SGIS              = 0x80A3;
	immutable GLenum GL_4PASS_0_SGIS              = 0x80A4;
	immutable GLenum GL_4PASS_1_SGIS              = 0x80A5;
	immutable GLenum GL_4PASS_2_SGIS              = 0x80A6;
	immutable GLenum GL_4PASS_3_SGIS              = 0x80A7;
	immutable GLenum GL_SAMPLE_BUFFERS_SGIS       = 0x80A8;
	immutable GLenum GL_SAMPLES_SGIS              = 0x80A9;
	immutable GLenum GL_SAMPLE_MASK_VALUE_SGIS    = 0x80AA;
	immutable GLenum GL_SAMPLE_MASK_INVERT_SGIS   = 0x80AB;
	immutable GLenum GL_SAMPLE_PATTERN_SGIS       = 0x80AC;
}

version (GL_EXT_rescale_normal)
{
}
else
{
	immutable GLenum GL_RESCALE_NORMAL_EXT = 0x803A;
}

version (GL_EXT_vertex_array)
{
}
else
{
	immutable GLenum GL_VERTEX_ARRAY_EXT                = 0x8074;
	immutable GLenum GL_NORMAL_ARRAY_EXT                = 0x8075;
	immutable GLenum GL_COLOR_ARRAY_EXT                 = 0x8076;
	immutable GLenum GL_INDEX_ARRAY_EXT                 = 0x8077;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_EXT         = 0x8078;
	immutable GLenum GL_EDGE_FLAG_ARRAY_EXT             = 0x8079;
	immutable GLenum GL_VERTEX_ARRAY_SIZE_EXT           = 0x807A;
	immutable GLenum GL_VERTEX_ARRAY_TYPE_EXT           = 0x807B;
	immutable GLenum GL_VERTEX_ARRAY_STRIDE_EXT         = 0x807C;
	immutable GLenum GL_VERTEX_ARRAY_COUNT_EXT          = 0x807D;
	immutable GLenum GL_NORMAL_ARRAY_TYPE_EXT           = 0x807E;
	immutable GLenum GL_NORMAL_ARRAY_STRIDE_EXT         = 0x807F;
	immutable GLenum GL_NORMAL_ARRAY_COUNT_EXT          = 0x8080;
	immutable GLenum GL_COLOR_ARRAY_SIZE_EXT            = 0x8081;
	immutable GLenum GL_COLOR_ARRAY_TYPE_EXT            = 0x8082;
	immutable GLenum GL_COLOR_ARRAY_STRIDE_EXT          = 0x8083;
	immutable GLenum GL_COLOR_ARRAY_COUNT_EXT           = 0x8084;
	immutable GLenum GL_INDEX_ARRAY_TYPE_EXT            = 0x8085;
	immutable GLenum GL_INDEX_ARRAY_STRIDE_EXT          = 0x8086;
	immutable GLenum GL_INDEX_ARRAY_COUNT_EXT           = 0x8087;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_SIZE_EXT    = 0x8088;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_TYPE_EXT    = 0x8089;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_STRIDE_EXT  = 0x808A;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_COUNT_EXT   = 0x808B;
	immutable GLenum GL_EDGE_FLAG_ARRAY_STRIDE_EXT      = 0x808C;
	immutable GLenum GL_EDGE_FLAG_ARRAY_COUNT_EXT       = 0x808D;
	immutable GLenum GL_VERTEX_ARRAY_POINTER_EXT        = 0x808E;
	immutable GLenum GL_NORMAL_ARRAY_POINTER_EXT        = 0x808F;
	immutable GLenum GL_COLOR_ARRAY_POINTER_EXT         = 0x8090;
	immutable GLenum GL_INDEX_ARRAY_POINTER_EXT         = 0x8091;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_POINTER_EXT = 0x8092;
	immutable GLenum GL_EDGE_FLAG_ARRAY_POINTER_EXT     = 0x8093;
}

version (GL_EXT_misc_attribute)
{
}
else
{
}

version (GL_SGIS_generate_mipmap)
{
}
else
{
	immutable GLenum GL_GENERATE_MIPMAP_SGIS      = 0x8191;
	immutable GLenum GL_GENERATE_MIPMAP_HINT_SGIS = 0x8192;
}

version (GL_SGIX_clipmap)
{
}
else
{
	immutable GLenum GL_LINEAR_CLIPMAP_LINEAR_SGIX         = 0x8170;
	immutable GLenum GL_TEXTURE_CLIPMAP_CENTER_SGIX        = 0x8171;
	immutable GLenum GL_TEXTURE_CLIPMAP_FRAME_SGIX         = 0x8172;
	immutable GLenum GL_TEXTURE_CLIPMAP_OFFSET_SGIX        = 0x8173;
	immutable GLenum GL_TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX = 0x8174;
	immutable GLenum GL_TEXTURE_CLIPMAP_LOD_OFFSET_SGIX    = 0x8175;
	immutable GLenum GL_TEXTURE_CLIPMAP_DEPTH_SGIX         = 0x8176;
	immutable GLenum GL_MAX_CLIPMAP_DEPTH_SGIX             = 0x8177;
	immutable GLenum GL_MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX     = 0x8178;
	immutable GLenum GL_NEAREST_CLIPMAP_NEAREST_SGIX       = 0x844D;
	immutable GLenum GL_NEAREST_CLIPMAP_LINEAR_SGIX        = 0x844E;
	immutable GLenum GL_LINEAR_CLIPMAP_NEAREST_SGIX        = 0x844F;
}

version (GL_SGIX_shadow)
{
}
else
{
	immutable GLenum GL_TEXTURE_COMPARE_SGIX          = 0x819A;
	immutable GLenum GL_TEXTURE_COMPARE_OPERATOR_SGIX = 0x819B;
	immutable GLenum GL_TEXTURE_LEQUAL_R_SGIX         = 0x819C;
	immutable GLenum GL_TEXTURE_GEQUAL_R_SGIX         = 0x819D;
}

version (GL_SGIS_texture_edge_clamp)
{
}
else
{
	immutable GLenum GL_CLAMP_TO_EDGE_SGIS = 0x812F;
}

version (GL_SGIS_texture_border_clamp)
{
}
else
{
	immutable GLenum GL_CLAMP_TO_BORDER_SGIS = 0x812D;
}

version (GL_EXT_blend_minmax)
{
}
else
{
	immutable GLenum GL_FUNC_ADD_EXT       = 0x8006;
	immutable GLenum GL_MIN_EXT            = 0x8007;
	immutable GLenum GL_MAX_EXT            = 0x8008;
	immutable GLenum GL_BLEND_EQUATION_EXT = 0x8009;
}

version (GL_EXT_blend_subtract)
{
}
else
{
	immutable GLenum GL_FUNC_SUBTRACT_EXT         = 0x800A;
	immutable GLenum GL_FUNC_REVERSE_SUBTRACT_EXT = 0x800B;
}

version (GL_EXT_blend_logic_op)
{
}
else
{
}

version (GL_SGIX_interlace)
{
}
else
{
	immutable GLenum GL_INTERLACE_SGIX = 0x8094;
}

version (GL_SGIX_pixel_tiles)
{
}
else
{
	immutable GLenum GL_PIXEL_TILE_BEST_ALIGNMENT_SGIX  = 0x813E;
	immutable GLenum GL_PIXEL_TILE_CACHE_INCREMENT_SGIX = 0x813F;
	immutable GLenum GL_PIXEL_TILE_WIDTH_SGIX           = 0x8140;
	immutable GLenum GL_PIXEL_TILE_HEIGHT_SGIX          = 0x8141;
	immutable GLenum GL_PIXEL_TILE_GRID_WIDTH_SGIX      = 0x8142;
	immutable GLenum GL_PIXEL_TILE_GRID_HEIGHT_SGIX     = 0x8143;
	immutable GLenum GL_PIXEL_TILE_GRID_DEPTH_SGIX      = 0x8144;
	immutable GLenum GL_PIXEL_TILE_CACHE_SIZE_SGIX      = 0x8145;
}

version (GL_SGIS_texture_select)
{
}
else
{
	immutable GLenum GL_DUAL_ALPHA4_SGIS           = 0x8110;
	immutable GLenum GL_DUAL_ALPHA8_SGIS           = 0x8111;
	immutable GLenum GL_DUAL_ALPHA12_SGIS          = 0x8112;
	immutable GLenum GL_DUAL_ALPHA16_SGIS          = 0x8113;
	immutable GLenum GL_DUAL_LUMINANCE4_SGIS       = 0x8114;
	immutable GLenum GL_DUAL_LUMINANCE8_SGIS       = 0x8115;
	immutable GLenum GL_DUAL_LUMINANCE12_SGIS      = 0x8116;
	immutable GLenum GL_DUAL_LUMINANCE16_SGIS      = 0x8117;
	immutable GLenum GL_DUAL_INTENSITY4_SGIS       = 0x8118;
	immutable GLenum GL_DUAL_INTENSITY8_SGIS       = 0x8119;
	immutable GLenum GL_DUAL_INTENSITY12_SGIS      = 0x811A;
	immutable GLenum GL_DUAL_INTENSITY16_SGIS      = 0x811B;
	immutable GLenum GL_DUAL_LUMINANCE_ALPHA4_SGIS = 0x811C;
	immutable GLenum GL_DUAL_LUMINANCE_ALPHA8_SGIS = 0x811D;
	immutable GLenum GL_QUAD_ALPHA4_SGIS           = 0x811E;
	immutable GLenum GL_QUAD_ALPHA8_SGIS           = 0x811F;
	immutable GLenum GL_QUAD_LUMINANCE4_SGIS       = 0x8120;
	immutable GLenum GL_QUAD_LUMINANCE8_SGIS       = 0x8121;
	immutable GLenum GL_QUAD_INTENSITY4_SGIS       = 0x8122;
	immutable GLenum GL_QUAD_INTENSITY8_SGIS       = 0x8123;
	immutable GLenum GL_DUAL_TEXTURE_SELECT_SGIS   = 0x8124;
	immutable GLenum GL_QUAD_TEXTURE_SELECT_SGIS   = 0x8125;
}

version (GL_SGIX_sprite)
{
}
else
{
	immutable GLenum GL_SPRITE_SGIX                = 0x8148;
	immutable GLenum GL_SPRITE_MODE_SGIX           = 0x8149;
	immutable GLenum GL_SPRITE_AXIS_SGIX           = 0x814A;
	immutable GLenum GL_SPRITE_TRANSLATION_SGIX    = 0x814B;
	immutable GLenum GL_SPRITE_AXIAL_SGIX          = 0x814C;
	immutable GLenum GL_SPRITE_OBJECT_ALIGNED_SGIX = 0x814D;
	immutable GLenum GL_SPRITE_EYE_ALIGNED_SGIX    = 0x814E;
}

version (GL_SGIX_texture_multi_buffer)
{
}
else
{
	immutable GLenum GL_TEXTURE_MULTI_BUFFER_HINT_SGIX = 0x812E;
}

version (GL_EXT_point_parameters)
{
}
else
{
	immutable GLenum GL_POINT_SIZE_MIN_EXT            = 0x8126;
	immutable GLenum GL_POINT_SIZE_MAX_EXT            = 0x8127;
	immutable GLenum GL_POINT_FADE_THRESHOLD_SIZE_EXT = 0x8128;
	immutable GLenum GL_DISTANCE_ATTENUATION_EXT      = 0x8129;
}

version (GL_SGIS_point_parameters)
{
}
else
{
	immutable GLenum GL_POINT_SIZE_MIN_SGIS            = 0x8126;
	immutable GLenum GL_POINT_SIZE_MAX_SGIS            = 0x8127;
	immutable GLenum GL_POINT_FADE_THRESHOLD_SIZE_SGIS = 0x8128;
	immutable GLenum GL_DISTANCE_ATTENUATION_SGIS      = 0x8129;
}

version (GL_SGIX_instruments)
{
}
else
{
	immutable GLenum GL_INSTRUMENT_BUFFER_POINTER_SGIX = 0x8180;
	immutable GLenum GL_INSTRUMENT_MEASUREMENTS_SGIX   = 0x8181;
}

version (GL_SGIX_texture_scale_bias)
{
}
else
{
	immutable GLenum GL_POST_TEXTURE_FILTER_BIAS_SGIX        = 0x8179;
	immutable GLenum GL_POST_TEXTURE_FILTER_SCALE_SGIX       = 0x817A;
	immutable GLenum GL_POST_TEXTURE_FILTER_BIAS_RANGE_SGIX  = 0x817B;
	immutable GLenum GL_POST_TEXTURE_FILTER_SCALE_RANGE_SGIX = 0x817C;
}

version (GL_SGIX_framezoom)
{
}
else
{
	immutable GLenum GL_FRAMEZOOM_SGIX            = 0x818B;
	immutable GLenum GL_FRAMEZOOM_FACTOR_SGIX     = 0x818C;
	immutable GLenum GL_MAX_FRAMEZOOM_FACTOR_SGIX = 0x818D;
}

version (GL_SGIX_tag_sample_buffer)
{
}
else
{
}

version (GL_FfdMaskSGIX)
{
}
else
{
	immutable GLbitfield GL_TEXTURE_DEFORMATION_BIT_SGIX  = 0x00000001;
	immutable GLbitfield GL_GEOMETRY_DEFORMATION_BIT_SGIX = 0x00000002;
}

version (GL_SGIX_polynomial_ffd)
{
}
else
{
	immutable GLenum GL_GEOMETRY_DEFORMATION_SGIX  = 0x8194;
	immutable GLenum GL_TEXTURE_DEFORMATION_SGIX   = 0x8195;
	immutable GLenum GL_DEFORMATIONS_MASK_SGIX     = 0x8196;
	immutable GLenum GL_MAX_DEFORMATION_ORDER_SGIX = 0x8197;
}

version (GL_SGIX_reference_plane)
{
}
else
{
	immutable GLenum GL_REFERENCE_PLANE_SGIX          = 0x817D;
	immutable GLenum GL_REFERENCE_PLANE_EQUATION_SGIX = 0x817E;
}

version (GL_SGIX_flush_raster)
{
}
else
{
}

version (GL_SGIX_depth_texture)
{
}
else
{
	immutable GLenum GL_DEPTH_COMPONENT16_SGIX = 0x81A5;
	immutable GLenum GL_DEPTH_COMPONENT24_SGIX = 0x81A6;
	immutable GLenum GL_DEPTH_COMPONENT32_SGIX = 0x81A7;
}

version (GL_SGIS_fog_function)
{
}
else
{
	immutable GLenum GL_FOG_FUNC_SGIS            = 0x812A;
	immutable GLenum GL_FOG_FUNC_POINTS_SGIS     = 0x812B;
	immutable GLenum GL_MAX_FOG_FUNC_POINTS_SGIS = 0x812C;
}

version (GL_SGIX_fog_offset)
{
}
else
{
	immutable GLenum GL_FOG_OFFSET_SGIX       = 0x8198;
	immutable GLenum GL_FOG_OFFSET_VALUE_SGIX = 0x8199;
}

version (GL_HP_image_transform)
{
}
else
{
	immutable GLenum GL_IMAGE_SCALE_X_HP                          = 0x8155;
	immutable GLenum GL_IMAGE_SCALE_Y_HP                          = 0x8156;
	immutable GLenum GL_IMAGE_TRANSLATE_X_HP                      = 0x8157;
	immutable GLenum GL_IMAGE_TRANSLATE_Y_HP                      = 0x8158;
	immutable GLenum GL_IMAGE_ROTATE_ANGLE_HP                     = 0x8159;
	immutable GLenum GL_IMAGE_ROTATE_ORIGIN_X_HP                  = 0x815A;
	immutable GLenum GL_IMAGE_ROTATE_ORIGIN_Y_HP                  = 0x815B;
	immutable GLenum GL_IMAGE_MAG_FILTER_HP                       = 0x815C;
	immutable GLenum GL_IMAGE_MIN_FILTER_HP                       = 0x815D;
	immutable GLenum GL_IMAGE_CUBIC_WEIGHT_HP                     = 0x815E;
	immutable GLenum GL_CUBIC_HP                                  = 0x815F;
	immutable GLenum GL_AVERAGE_HP                                = 0x8160;
	immutable GLenum GL_IMAGE_TRANSFORM_2D_HP                     = 0x8161;
	immutable GLenum GL_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP       = 0x8162;
	immutable GLenum GL_PROXY_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP = 0x8163;
}

version (GL_HP_convolution_border_modes)
{
}
else
{
	immutable GLenum GL_IGNORE_BORDER_HP            = 0x8150;
	immutable GLenum GL_CONSTANT_BORDER_HP          = 0x8151;
	immutable GLenum GL_REPLICATE_BORDER_HP         = 0x8153;
	immutable GLenum GL_CONVOLUTION_BORDER_COLOR_HP = 0x8154;
}

version (GL_INGR_palette_buffer)
{
}
else
{
}

version (GL_SGIX_texture_add_env)
{
}
else
{
	immutable GLenum GL_TEXTURE_ENV_BIAS_SGIX = 0x80BE;
}

version (GL_EXT_color_subtable)
{
}
else
{
}

version (GL_PGI_vertex_hints)
{
}
else
{
	immutable GLbitfield GL_COLOR3_BIT_PGI                  = 0x00010000;
	immutable GLbitfield GL_COLOR4_BIT_PGI                  = 0x00020000;
	immutable GLbitfield GL_EDGEFLAG_BIT_PGI                = 0x00040000;
	immutable GLbitfield GL_INDEX_BIT_PGI                   = 0x00080000;
	immutable GLbitfield GL_MAT_AMBIENT_BIT_PGI             = 0x00100000;
	immutable GLbitfield GL_MAT_AMBIENT_AND_DIFFUSE_BIT_PGI = 0x00200000;
	immutable GLbitfield GL_MAT_DIFFUSE_BIT_PGI             = 0x00400000;
	immutable GLbitfield GL_MAT_EMISSION_BIT_PGI            = 0x00800000;
	immutable GLbitfield GL_MAT_COLOR_INDEXES_BIT_PGI       = 0x01000000;
	immutable GLbitfield GL_MAT_SHININESS_BIT_PGI           = 0x02000000;
	immutable GLbitfield GL_MAT_SPECULAR_BIT_PGI            = 0x04000000;
	immutable GLbitfield GL_NORMAL_BIT_PGI                  = 0x08000000;
	immutable GLbitfield GL_TEXCOORD1_BIT_PGI               = 0x10000000;
	immutable GLbitfield GL_TEXCOORD2_BIT_PGI               = 0x20000000;
	immutable GLbitfield GL_TEXCOORD3_BIT_PGI               = 0x40000000;
	immutable GLbitfield GL_TEXCOORD4_BIT_PGI               = 0x80000000;
	immutable GLbitfield GL_VERTEX23_BIT_PGI                = 0x00000004;
	immutable GLbitfield GL_VERTEX4_BIT_PGI                 = 0x00000008;
	immutable GLenum GL_VERTEX_DATA_HINT_PGI            = 0x1A22;
	immutable GLenum GL_VERTEX_CONSISTENT_HINT_PGI      = 0x1A22;
	immutable GLenum GL_MATERIAL_SIDE_HINT_PGI          = 0x1A22;
	immutable GLenum GL_MAX_VERTEX_HINT_PGI             = 0x1A22;
}

version (GL_PGI_misc_hints)
{
}
else
{
	immutable GLenum GL_PREFER_DOUBLEBUFFER_HINT_PGI   = 0x1A1F;
	immutable GLenum GL_CONSERVE_MEMORY_HINT_PGI       = 0x1A1F;
	immutable GLenum GL_RECLAIM_MEMORY_HINT_PGI        = 0x1A1F;
	immutable GLenum GL_NATIVE_GRAPHICS_HANDLE_PGI     = 0x1A20;
	immutable GLenum GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI = 0x1A20;
	immutable GLenum GL_NATIVE_GRAPHICS_END_HINT_PGI   = 0x1A20;
	immutable GLenum GL_ALWAYS_FAST_HINT_PGI           = 0x1A20;
	immutable GLenum GL_ALWAYS_SOFT_HINT_PGI           = 0x1A20;
	immutable GLenum GL_ALLOW_DRAW_OBJ_HINT_PGI        = 0x1A20;
	immutable GLenum GL_ALLOW_DRAW_WIN_HINT_PGI        = 0x1A20;
	immutable GLenum GL_ALLOW_DRAW_FRG_HINT_PGI        = 0x1A21;
	immutable GLenum GL_ALLOW_DRAW_MEM_HINT_PGI        = 0x1A21;
	immutable GLenum GL_STRICT_DEPTHFUNC_HINT_PGI      = 0x1A21;
	immutable GLenum GL_STRICT_LIGHTING_HINT_PGI       = 0x1A21;
	immutable GLenum GL_STRICT_SCISSOR_HINT_PGI        = 0x1A21;
	immutable GLenum GL_FULL_STIPPLE_HINT_PGI          = 0x1A21;
	immutable GLenum GL_CLIP_NEAR_HINT_PGI             = 0x1A22;
	immutable GLenum GL_CLIP_FAR_HINT_PGI              = 0x1A22;
	immutable GLenum GL_WIDE_LINE_HINT_PGI             = 0x1A22;
	immutable GLenum GL_BACK_NORMALS_HINT_PGI          = 0x1A22;
}

version (GL_EXT_paletted_texture)
{
}
else
{
	immutable GLenum GL_COLOR_INDEX1_EXT       = 0x80E2;
	immutable GLenum GL_COLOR_INDEX2_EXT       = 0x80E3;
	immutable GLenum GL_COLOR_INDEX4_EXT       = 0x80E4;
	immutable GLenum GL_COLOR_INDEX8_EXT       = 0x80E5;
	immutable GLenum GL_COLOR_INDEX12_EXT      = 0x80E6;
	immutable GLenum GL_COLOR_INDEX16_EXT      = 0x80E7;
	immutable GLenum GL_TEXTURE_INDEX_SIZE_EXT = 0x80ED;
}

version (GL_EXT_clip_volume_hint)
{
}
else
{
	immutable GLenum GL_CLIP_VOLUME_CLIPPING_HINT_EXT = 0x80F0;
}

version (GL_SGIX_list_priority)
{
}
else
{
	immutable GLenum GL_LIST_PRIORITY_SGIX = 0x8182;
}

version (GL_SGIX_ir_instrument1)
{
}
else
{
	immutable GLenum GL_IR_INSTRUMENT1_SGIX = 0x817F;
}

version (GL_SGIX_calligraphic_fragment)
{
}
else
{
	immutable GLenum GL_CALLIGRAPHIC_FRAGMENT_SGIX = 0x8183;
}

version (GL_SGIX_texture_lod_bias)
{
}
else
{
	immutable GLenum GL_TEXTURE_LOD_BIAS_S_SGIX = 0x818E;
	immutable GLenum GL_TEXTURE_LOD_BIAS_T_SGIX = 0x818F;
	immutable GLenum GL_TEXTURE_LOD_BIAS_R_SGIX = 0x8190;
}

version (GL_SGIX_shadow_ambient)
{
}
else
{
	immutable GLenum GL_SHADOW_AMBIENT_SGIX = 0x80BF;
}

version (GL_EXT_index_texture)
{
}
else
{
}

version (GL_EXT_index_material)
{
}
else
{
	immutable GLenum GL_INDEX_MATERIAL_EXT           = 0x81B8;
	immutable GLenum GL_INDEX_MATERIAL_PARAMETER_EXT = 0x81B9;
	immutable GLenum GL_INDEX_MATERIAL_FACE_EXT      = 0x81BA;
}

version (GL_EXT_index_func)
{
}
else
{
	immutable GLenum GL_INDEX_TEST_EXT      = 0x81B5;
	immutable GLenum GL_INDEX_TEST_FUNC_EXT = 0x81B6;
	immutable GLenum GL_INDEX_TEST_REF_EXT  = 0x81B7;
}

version (GL_EXT_index_array_formats)
{
}
else
{
	immutable GLenum GL_IUI_V2F_EXT         = 0x81AD;
	immutable GLenum GL_IUI_V3F_EXT         = 0x81AE;
	immutable GLenum GL_IUI_N3F_V2F_EXT     = 0x81AF;
	immutable GLenum GL_IUI_N3F_V3F_EXT     = 0x81B0;
	immutable GLenum GL_T2F_IUI_V2F_EXT     = 0x81B1;
	immutable GLenum GL_T2F_IUI_V3F_EXT     = 0x81B2;
	immutable GLenum GL_T2F_IUI_N3F_V2F_EXT = 0x81B3;
	immutable GLenum GL_T2F_IUI_N3F_V3F_EXT = 0x81B4;
}

version (GL_EXT_compiled_vertex_array)
{
}
else
{
	immutable GLenum GL_ARRAY_ELEMENT_LOCK_FIRST_EXT = 0x81A8;
	immutable GLenum GL_ARRAY_ELEMENT_LOCK_COUNT_EXT = 0x81A9;
}

version (GL_EXT_cull_vertex)
{
}
else
{
	immutable GLenum GL_CULL_VERTEX_EXT                 = 0x81AA;
	immutable GLenum GL_CULL_VERTEX_EYE_POSITION_EXT    = 0x81AB;
	immutable GLenum GL_CULL_VERTEX_OBJECT_POSITION_EXT = 0x81AC;
}

version (GL_SGIX_ycrcb)
{
}
else
{
	immutable GLenum GL_YCRCB_422_SGIX = 0x81BB;
	immutable GLenum GL_YCRCB_444_SGIX = 0x81BC;
}

version (GL_SGIX_fragment_lighting)
{
}
else
{
	immutable GLenum GL_FRAGMENT_LIGHTING_SGIX                         = 0x8400;
	immutable GLenum GL_FRAGMENT_COLOR_MATERIAL_SGIX                   = 0x8401;
	immutable GLenum GL_FRAGMENT_COLOR_MATERIAL_FACE_SGIX              = 0x8402;
	immutable GLenum GL_FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX         = 0x8403;
	immutable GLenum GL_MAX_FRAGMENT_LIGHTS_SGIX                       = 0x8404;
	immutable GLenum GL_MAX_ACTIVE_LIGHTS_SGIX                         = 0x8405;
	immutable GLenum GL_CURRENT_RASTER_NORMAL_SGIX                     = 0x8406;
	immutable GLenum GL_LIGHT_ENV_MODE_SGIX                            = 0x8407;
	immutable GLenum GL_FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX         = 0x8408;
	immutable GLenum GL_FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX             = 0x8409;
	immutable GLenum GL_FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX              = 0x840A;
	immutable GLenum GL_FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX = 0x840B;
	immutable GLenum GL_FRAGMENT_LIGHT0_SGIX                           = 0x840C;
	immutable GLenum GL_FRAGMENT_LIGHT1_SGIX                           = 0x840D;
	immutable GLenum GL_FRAGMENT_LIGHT2_SGIX                           = 0x840E;
	immutable GLenum GL_FRAGMENT_LIGHT3_SGIX                           = 0x840F;
	immutable GLenum GL_FRAGMENT_LIGHT4_SGIX                           = 0x8410;
	immutable GLenum GL_FRAGMENT_LIGHT5_SGIX                           = 0x8411;
	immutable GLenum GL_FRAGMENT_LIGHT6_SGIX                           = 0x8412;
	immutable GLenum GL_FRAGMENT_LIGHT7_SGIX                           = 0x8413;
}

version (GL_IBM_rasterpos_clip)
{
}
else
{
	immutable GLenum GL_RASTER_POSITION_UNCLIPPED_IBM = 0x1926;
}

version (GL_HP_texture_lighting)
{
}
else
{
	immutable GLenum GL_TEXTURE_LIGHTING_MODE_HP = 0x8167;
	immutable GLenum GL_TEXTURE_POST_SPECULAR_HP = 0x8168;
	immutable GLenum GL_TEXTURE_PRE_SPECULAR_HP  = 0x8169;
}

version (GL_EXT_draw_range_elements)
{
}
else
{
	immutable GLenum GL_MAX_ELEMENTS_VERTICES_EXT = 0x80E8;
	immutable GLenum GL_MAX_ELEMENTS_INDICES_EXT  = 0x80E9;
}

version (GL_WIN_phong_shading)
{
}
else
{
	immutable GLenum GL_PHONG_WIN      = 0x80EA;
	immutable GLenum GL_PHONG_HINT_WIN = 0x80EB;
}

version (GL_WIN_specular_fog)
{
}
else
{
	immutable GLenum GL_FOG_SPECULAR_TEXTURE_WIN = 0x80EC;
}

version (GL_EXT_light_texture)
{
}
else
{
	immutable GLenum GL_FRAGMENT_MATERIAL_EXT          = 0x8349;
	immutable GLenum GL_FRAGMENT_NORMAL_EXT            = 0x834A;
	immutable GLenum GL_FRAGMENT_COLOR_EXT             = 0x834C;
	immutable GLenum GL_ATTENUATION_EXT                = 0x834D;
	immutable GLenum GL_SHADOW_ATTENUATION_EXT         = 0x834E;
	immutable GLenum GL_TEXTURE_APPLICATION_MODE_EXT   = 0x834F;
	immutable GLenum GL_TEXTURE_LIGHT_EXT              = 0x8350;
	immutable GLenum GL_TEXTURE_MATERIAL_FACE_EXT      = 0x8351;
	immutable GLenum GL_TEXTURE_MATERIAL_PARAMETER_EXT = 0x8352;
}

version (GL_SGIX_blend_alpha_minmax)
{
}
else
{
	immutable GLenum GL_ALPHA_MIN_SGIX = 0x8320;
	immutable GLenum GL_ALPHA_MAX_SGIX = 0x8321;
}

version (GL_SGIX_impact_pixel_texture)
{
}
else
{
	immutable GLenum GL_PIXEL_TEX_GEN_Q_CEILING_SGIX        = 0x8184;
	immutable GLenum GL_PIXEL_TEX_GEN_Q_ROUND_SGIX          = 0x8185;
	immutable GLenum GL_PIXEL_TEX_GEN_Q_FLOOR_SGIX          = 0x8186;
	immutable GLenum GL_PIXEL_TEX_GEN_ALPHA_REPLACE_SGIX    = 0x8187;
	immutable GLenum GL_PIXEL_TEX_GEN_ALPHA_NO_REPLACE_SGIX = 0x8188;
	immutable GLenum GL_PIXEL_TEX_GEN_ALPHA_LS_SGIX         = 0x8189;
	immutable GLenum GL_PIXEL_TEX_GEN_ALPHA_MS_SGIX         = 0x818A;
}

version (GL_EXT_bgra)
{
}
else
{
	immutable GLenum GL_BGR_EXT  = 0x80E0;
	immutable GLenum GL_BGRA_EXT = 0x80E1;
}

version (GL_SGIX_async)
{
}
else
{
	immutable GLenum GL_ASYNC_MARKER_SGIX = 0x8329;
}

version (GL_SGIX_async_pixel)
{
}
else
{
	immutable GLenum GL_ASYNC_TEX_IMAGE_SGIX       = 0x835C;
	immutable GLenum GL_ASYNC_DRAW_PIXELS_SGIX     = 0x835D;
	immutable GLenum GL_ASYNC_READ_PIXELS_SGIX     = 0x835E;
	immutable GLenum GL_MAX_ASYNC_TEX_IMAGE_SGIX   = 0x835F;
	immutable GLenum GL_MAX_ASYNC_DRAW_PIXELS_SGIX = 0x8360;
	immutable GLenum GL_MAX_ASYNC_READ_PIXELS_SGIX = 0x8361;
}

version (GL_SGIX_async_histogram)
{
}
else
{
	immutable GLenum GL_ASYNC_HISTOGRAM_SGIX     = 0x832C;
	immutable GLenum GL_MAX_ASYNC_HISTOGRAM_SGIX = 0x832D;
}

version (GL_INTEL_texture_scissor)
{
}
else
{
}

version (GL_INTEL_parallel_arrays)
{
}
else
{
	immutable GLenum GL_PARALLEL_ARRAYS_INTEL                       = 0x83F4;
	immutable GLenum GL_VERTEX_ARRAY_PARALLEL_POINTERS_INTEL        = 0x83F5;
	immutable GLenum GL_NORMAL_ARRAY_PARALLEL_POINTERS_INTEL        = 0x83F6;
	immutable GLenum GL_COLOR_ARRAY_PARALLEL_POINTERS_INTEL         = 0x83F7;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_PARALLEL_POINTERS_INTEL = 0x83F8;
}

version (GL_HP_occlusion_test)
{
}
else
{
	immutable GLenum GL_OCCLUSION_TEST_HP        = 0x8165;
	immutable GLenum GL_OCCLUSION_TEST_RESULT_HP = 0x8166;
}

version (GL_EXT_pixel_transform)
{
}
else
{
	immutable GLenum GL_PIXEL_TRANSFORM_2D_EXT                 = 0x8330;
	immutable GLenum GL_PIXEL_MAG_FILTER_EXT                   = 0x8331;
	immutable GLenum GL_PIXEL_MIN_FILTER_EXT                   = 0x8332;
	immutable GLenum GL_PIXEL_CUBIC_WEIGHT_EXT                 = 0x8333;
	immutable GLenum GL_CUBIC_EXT                              = 0x8334;
	immutable GLenum GL_AVERAGE_EXT                            = 0x8335;
	immutable GLenum GL_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT     = 0x8336;
	immutable GLenum GL_MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT = 0x8337;
	immutable GLenum GL_PIXEL_TRANSFORM_2D_MATRIX_EXT          = 0x8338;
}

version (GL_EXT_pixel_transform_color_table)
{
}
else
{
}

version (GL_EXT_shared_texture_palette)
{
}
else
{
	immutable GLenum GL_SHARED_TEXTURE_PALETTE_EXT = 0x81FB;
}

version (GL_EXT_separate_specular_color)
{
}
else
{
	immutable GLenum GL_LIGHT_MODEL_COLOR_CONTROL_EXT = 0x81F8;
	immutable GLenum GL_SINGLE_COLOR_EXT              = 0x81F9;
	immutable GLenum GL_SEPARATE_SPECULAR_COLOR_EXT   = 0x81FA;
}

version (GL_EXT_secondary_color)
{
}
else
{
	immutable GLenum GL_COLOR_SUM_EXT                     = 0x8458;
	immutable GLenum GL_CURRENT_SECONDARY_COLOR_EXT       = 0x8459;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_SIZE_EXT    = 0x845A;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_TYPE_EXT    = 0x845B;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_STRIDE_EXT  = 0x845C;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_POINTER_EXT = 0x845D;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_EXT         = 0x845E;
}

version (GL_EXT_texture_perturb_normal)
{
}
else
{
	immutable GLenum GL_PERTURB_EXT        = 0x85AE;
	immutable GLenum GL_TEXTURE_NORMAL_EXT = 0x85AF;
}

version (GL_EXT_multi_draw_arrays)
{
}
else
{
}

version (GL_EXT_fog_coord)
{
}
else
{
	immutable GLenum GL_FOG_COORDINATE_SOURCE_EXT        = 0x8450;
	immutable GLenum GL_FOG_COORDINATE_EXT               = 0x8451;
	immutable GLenum GL_FRAGMENT_DEPTH_EXT               = 0x8452;
	immutable GLenum GL_CURRENT_FOG_COORDINATE_EXT       = 0x8453;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_TYPE_EXT    = 0x8454;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_STRIDE_EXT  = 0x8455;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_POINTER_EXT = 0x8456;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_EXT         = 0x8457;
}

version (GL_REND_screen_coordinates)
{
}
else
{
	immutable GLenum GL_SCREEN_COORDINATES_REND = 0x8490;
	immutable GLenum GL_INVERTED_SCREEN_W_REND  = 0x8491;
}

version (GL_EXT_coordinate_frame)
{
}
else
{
	immutable GLenum GL_TANGENT_ARRAY_EXT          = 0x8439;
	immutable GLenum GL_BINORMAL_ARRAY_EXT         = 0x843A;
	immutable GLenum GL_CURRENT_TANGENT_EXT        = 0x843B;
	immutable GLenum GL_CURRENT_BINORMAL_EXT       = 0x843C;
	immutable GLenum GL_TANGENT_ARRAY_TYPE_EXT     = 0x843E;
	immutable GLenum GL_TANGENT_ARRAY_STRIDE_EXT   = 0x843F;
	immutable GLenum GL_BINORMAL_ARRAY_TYPE_EXT    = 0x8440;
	immutable GLenum GL_BINORMAL_ARRAY_STRIDE_EXT  = 0x8441;
	immutable GLenum GL_TANGENT_ARRAY_POINTER_EXT  = 0x8442;
	immutable GLenum GL_BINORMAL_ARRAY_POINTER_EXT = 0x8443;
	immutable GLenum GL_MAP1_TANGENT_EXT           = 0x8444;
	immutable GLenum GL_MAP2_TANGENT_EXT           = 0x8445;
	immutable GLenum GL_MAP1_BINORMAL_EXT          = 0x8446;
	immutable GLenum GL_MAP2_BINORMAL_EXT          = 0x8447;
}

version (GL_EXT_texture_env_combine)
{
}
else
{
	immutable GLenum GL_COMBINE_EXT        = 0x8570;
	immutable GLenum GL_COMBINE_RGB_EXT    = 0x8571;
	immutable GLenum GL_COMBINE_ALPHA_EXT  = 0x8572;
	immutable GLenum GL_RGB_SCALE_EXT      = 0x8573;
	immutable GLenum GL_ADD_SIGNED_EXT     = 0x8574;
	immutable GLenum GL_INTERPOLATE_EXT    = 0x8575;
	immutable GLenum GL_CONSTANT_EXT       = 0x8576;
	immutable GLenum GL_PRIMARY_COLOR_EXT  = 0x8577;
	immutable GLenum GL_PREVIOUS_EXT       = 0x8578;
	immutable GLenum GL_SOURCE0_RGB_EXT    = 0x8580;
	immutable GLenum GL_SOURCE1_RGB_EXT    = 0x8581;
	immutable GLenum GL_SOURCE2_RGB_EXT    = 0x8582;
	immutable GLenum GL_SOURCE0_ALPHA_EXT  = 0x8588;
	immutable GLenum GL_SOURCE1_ALPHA_EXT  = 0x8589;
	immutable GLenum GL_SOURCE2_ALPHA_EXT  = 0x858A;
	immutable GLenum GL_OPERAND0_RGB_EXT   = 0x8590;
	immutable GLenum GL_OPERAND1_RGB_EXT   = 0x8591;
	immutable GLenum GL_OPERAND2_RGB_EXT   = 0x8592;
	immutable GLenum GL_OPERAND0_ALPHA_EXT = 0x8598;
	immutable GLenum GL_OPERAND1_ALPHA_EXT = 0x8599;
	immutable GLenum GL_OPERAND2_ALPHA_EXT = 0x859A;
}

version (GL_APPLE_specular_vector)
{
}
else
{
	immutable GLenum GL_LIGHT_MODEL_SPECULAR_VECTOR_APPLE = 0x85B0;
}

version (GL_APPLE_transform_hint)
{
}
else
{
	immutable GLenum GL_TRANSFORM_HINT_APPLE = 0x85B1;
}

version (GL_SGIX_fog_scale)
{
}
else
{
	immutable GLenum GL_FOG_SCALE_SGIX       = 0x81FC;
	immutable GLenum GL_FOG_SCALE_VALUE_SGIX = 0x81FD;
}

version (GL_SUNX_constant_data)
{
}
else
{
	immutable GLenum GL_UNPACK_CONSTANT_DATA_SUNX  = 0x81D5;
	immutable GLenum GL_TEXTURE_CONSTANT_DATA_SUNX = 0x81D6;
}

version (GL_SUN_global_alpha)
{
}
else
{
	immutable GLenum GL_GLOBAL_ALPHA_SUN        = 0x81D9;
	immutable GLenum GL_GLOBAL_ALPHA_FACTOR_SUN = 0x81DA;
}

version (GL_SUN_triangle_list)
{
}
else
{
	immutable GLenum GL_RESTART_SUN                        = 0x0001;
	immutable GLenum GL_REPLACE_MIDDLE_SUN                 = 0x0002;
	immutable GLenum GL_REPLACE_OLDEST_SUN                 = 0x0003;
	immutable GLenum GL_TRIANGLE_LIST_SUN                  = 0x81D7;
	immutable GLenum GL_REPLACEMENT_CODE_SUN               = 0x81D8;
	immutable GLenum GL_REPLACEMENT_CODE_ARRAY_SUN         = 0x85C0;
	immutable GLenum GL_REPLACEMENT_CODE_ARRAY_TYPE_SUN    = 0x85C1;
	immutable GLenum GL_REPLACEMENT_CODE_ARRAY_STRIDE_SUN  = 0x85C2;
	immutable GLenum GL_REPLACEMENT_CODE_ARRAY_POINTER_SUN = 0x85C3;
	immutable GLenum GL_R1UI_V3F_SUN                       = 0x85C4;
	immutable GLenum GL_R1UI_C4UB_V3F_SUN                  = 0x85C5;
	immutable GLenum GL_R1UI_C3F_V3F_SUN                   = 0x85C6;
	immutable GLenum GL_R1UI_N3F_V3F_SUN                   = 0x85C7;
	immutable GLenum GL_R1UI_C4F_N3F_V3F_SUN               = 0x85C8;
	immutable GLenum GL_R1UI_T2F_V3F_SUN                   = 0x85C9;
	immutable GLenum GL_R1UI_T2F_N3F_V3F_SUN               = 0x85CA;
	immutable GLenum GL_R1UI_T2F_C4F_N3F_V3F_SUN           = 0x85CB;
}

version (GL_SUN_vertex)
{
}
else
{
}

version (GL_EXT_blend_func_separate)
{
}
else
{
	immutable GLenum GL_BLEND_DST_RGB_EXT   = 0x80C8;
	immutable GLenum GL_BLEND_SRC_RGB_EXT   = 0x80C9;
	immutable GLenum GL_BLEND_DST_ALPHA_EXT = 0x80CA;
	immutable GLenum GL_BLEND_SRC_ALPHA_EXT = 0x80CB;
}

version (GL_INGR_color_clamp)
{
}
else
{
	immutable GLenum GL_RED_MIN_CLAMP_INGR   = 0x8560;
	immutable GLenum GL_GREEN_MIN_CLAMP_INGR = 0x8561;
	immutable GLenum GL_BLUE_MIN_CLAMP_INGR  = 0x8562;
	immutable GLenum GL_ALPHA_MIN_CLAMP_INGR = 0x8563;
	immutable GLenum GL_RED_MAX_CLAMP_INGR   = 0x8564;
	immutable GLenum GL_GREEN_MAX_CLAMP_INGR = 0x8565;
	immutable GLenum GL_BLUE_MAX_CLAMP_INGR  = 0x8566;
	immutable GLenum GL_ALPHA_MAX_CLAMP_INGR = 0x8567;
}

version (GL_INGR_interlace_read)
{
}
else
{
	immutable GLenum GL_INTERLACE_READ_INGR = 0x8568;
}

version (GL_EXT_stencil_wrap)
{
}
else
{
	immutable GLenum GL_INCR_WRAP_EXT = 0x8507;
	immutable GLenum GL_DECR_WRAP_EXT = 0x8508;
}

version (GL_EXT_422_pixels)
{
}
else
{
	immutable GLenum GL_422_EXT             = 0x80CC;
	immutable GLenum GL_422_REV_EXT         = 0x80CD;
	immutable GLenum GL_422_AVERAGE_EXT     = 0x80CE;
	immutable GLenum GL_422_REV_AVERAGE_EXT = 0x80CF;
}

version (GL_NV_texgen_reflection)
{
}
else
{
	immutable GLenum GL_NORMAL_MAP_NV     = 0x8511;
	immutable GLenum GL_REFLECTION_MAP_NV = 0x8512;
}

version (GL_EXT_texture_cube_map)
{
}
else
{
	immutable GLenum GL_NORMAL_MAP_EXT                  = 0x8511;
	immutable GLenum GL_REFLECTION_MAP_EXT              = 0x8512;
	immutable GLenum GL_TEXTURE_CUBE_MAP_EXT            = 0x8513;
	immutable GLenum GL_TEXTURE_BINDING_CUBE_MAP_EXT    = 0x8514;
	immutable GLenum GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT = 0x8515;
	immutable GLenum GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT = 0x8516;
	immutable GLenum GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT = 0x8517;
	immutable GLenum GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT = 0x8518;
	immutable GLenum GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT = 0x8519;
	immutable GLenum GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT = 0x851A;
	immutable GLenum GL_PROXY_TEXTURE_CUBE_MAP_EXT      = 0x851B;
	immutable GLenum GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT   = 0x851C;
}

version (GL_SUN_convolution_border_modes)
{
}
else
{
	immutable GLenum GL_WRAP_BORDER_SUN = 0x81D4;
}

version (GL_EXT_texture_env_add)
{
}
else
{
}

version (GL_EXT_texture_lod_bias)
{
}
else
{
	immutable GLenum GL_MAX_TEXTURE_LOD_BIAS_EXT   = 0x84FD;
	immutable GLenum GL_TEXTURE_FILTER_CONTROL_EXT = 0x8500;
	immutable GLenum GL_TEXTURE_LOD_BIAS_EXT       = 0x8501;
}

version (GL_EXT_texture_filter_anisotropic)
{
}
else
{
	immutable GLenum GL_TEXTURE_MAX_ANISOTROPY_EXT     = 0x84FE;
	immutable GLenum GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT = 0x84FF;
}

version (GL_EXT_vertex_weighting)
{
}
else
{
	immutable GLenum GL_MODELVIEW0_STACK_DEPTH_EXT      = GL_MODELVIEW_STACK_DEPTH;
	immutable GLenum GL_MODELVIEW1_STACK_DEPTH_EXT      = 0x8502;
	immutable GLenum GL_MODELVIEW0_MATRIX_EXT           = GL_MODELVIEW_MATRIX;
	immutable GLenum GL_MODELVIEW1_MATRIX_EXT           = 0x8506;
	immutable GLenum GL_VERTEX_WEIGHTING_EXT            = 0x8509;
	immutable GLenum GL_MODELVIEW0_EXT                  = GL_MODELVIEW;
	immutable GLenum GL_MODELVIEW1_EXT                  = 0x850A;
	immutable GLenum GL_CURRENT_VERTEX_WEIGHT_EXT       = 0x850B;
	immutable GLenum GL_VERTEX_WEIGHT_ARRAY_EXT         = 0x850C;
	immutable GLenum GL_VERTEX_WEIGHT_ARRAY_SIZE_EXT    = 0x850D;
	immutable GLenum GL_VERTEX_WEIGHT_ARRAY_TYPE_EXT    = 0x850E;
	immutable GLenum GL_VERTEX_WEIGHT_ARRAY_STRIDE_EXT  = 0x850F;
	immutable GLenum GL_VERTEX_WEIGHT_ARRAY_POINTER_EXT = 0x8510;
}

version (GL_NV_light_max_exponent)
{
}
else
{
	immutable GLenum GL_MAX_SHININESS_NV     = 0x8504;
	immutable GLenum GL_MAX_SPOT_EXPONENT_NV = 0x8505;
}

version (GL_NV_vertex_array_range)
{
}
else
{
	immutable GLenum GL_VERTEX_ARRAY_RANGE_NV             = 0x851D;
	immutable GLenum GL_VERTEX_ARRAY_RANGE_LENGTH_NV      = 0x851E;
	immutable GLenum GL_VERTEX_ARRAY_RANGE_VALID_NV       = 0x851F;
	immutable GLenum GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV = 0x8520;
	immutable GLenum GL_VERTEX_ARRAY_RANGE_POINTER_NV     = 0x8521;
}

version (GL_NV_register_combiners)
{
}
else
{
	immutable GLenum GL_REGISTER_COMBINERS_NV          = 0x8522;
	immutable GLenum GL_VARIABLE_A_NV                  = 0x8523;
	immutable GLenum GL_VARIABLE_B_NV                  = 0x8524;
	immutable GLenum GL_VARIABLE_C_NV                  = 0x8525;
	immutable GLenum GL_VARIABLE_D_NV                  = 0x8526;
	immutable GLenum GL_VARIABLE_E_NV                  = 0x8527;
	immutable GLenum GL_VARIABLE_F_NV                  = 0x8528;
	immutable GLenum GL_VARIABLE_G_NV                  = 0x8529;
	immutable GLenum GL_CONSTANT_COLOR0_NV             = 0x852A;
	immutable GLenum GL_CONSTANT_COLOR1_NV             = 0x852B;
	immutable GLenum GL_PRIMARY_COLOR_NV               = 0x852C;
	immutable GLenum GL_SECONDARY_COLOR_NV             = 0x852D;
	immutable GLenum GL_SPARE0_NV                      = 0x852E;
	immutable GLenum GL_SPARE1_NV                      = 0x852F;
	immutable GLenum GL_DISCARD_NV                     = 0x8530;
	immutable GLenum GL_E_TIMES_F_NV                   = 0x8531;
	immutable GLenum GL_SPARE0_PLUS_SECONDARY_COLOR_NV = 0x8532;
	immutable GLenum GL_UNSIGNED_IDENTITY_NV           = 0x8536;
	immutable GLenum GL_UNSIGNED_INVERT_NV             = 0x8537;
	immutable GLenum GL_EXPAND_NORMAL_NV               = 0x8538;
	immutable GLenum GL_EXPAND_NEGATE_NV               = 0x8539;
	immutable GLenum GL_HALF_BIAS_NORMAL_NV            = 0x853A;
	immutable GLenum GL_HALF_BIAS_NEGATE_NV            = 0x853B;
	immutable GLenum GL_SIGNED_IDENTITY_NV             = 0x853C;
	immutable GLenum GL_SIGNED_NEGATE_NV               = 0x853D;
	immutable GLenum GL_SCALE_BY_TWO_NV                = 0x853E;
	immutable GLenum GL_SCALE_BY_FOUR_NV               = 0x853F;
	immutable GLenum GL_SCALE_BY_ONE_HALF_NV           = 0x8540;
	immutable GLenum GL_BIAS_BY_NEGATIVE_ONE_HALF_NV   = 0x8541;
	immutable GLenum GL_COMBINER_INPUT_NV              = 0x8542;
	immutable GLenum GL_COMBINER_MAPPING_NV            = 0x8543;
	immutable GLenum GL_COMBINER_COMPONENT_USAGE_NV    = 0x8544;
	immutable GLenum GL_COMBINER_AB_DOT_PRODUCT_NV     = 0x8545;
	immutable GLenum GL_COMBINER_CD_DOT_PRODUCT_NV     = 0x8546;
	immutable GLenum GL_COMBINER_MUX_SUM_NV            = 0x8547;
	immutable GLenum GL_COMBINER_SCALE_NV              = 0x8548;
	immutable GLenum GL_COMBINER_BIAS_NV               = 0x8549;
	immutable GLenum GL_COMBINER_AB_OUTPUT_NV          = 0x854A;
	immutable GLenum GL_COMBINER_CD_OUTPUT_NV          = 0x854B;
	immutable GLenum GL_COMBINER_SUM_OUTPUT_NV         = 0x854C;
	immutable GLenum GL_MAX_GENERAL_COMBINERS_NV       = 0x854D;
	immutable GLenum GL_NUM_GENERAL_COMBINERS_NV       = 0x854E;
	immutable GLenum GL_COLOR_SUM_CLAMP_NV             = 0x854F;
	immutable GLenum GL_COMBINER0_NV                   = 0x8550;
	immutable GLenum GL_COMBINER1_NV                   = 0x8551;
	immutable GLenum GL_COMBINER2_NV                   = 0x8552;
	immutable GLenum GL_COMBINER3_NV                   = 0x8553;
	immutable GLenum GL_COMBINER4_NV                   = 0x8554;
	immutable GLenum GL_COMBINER5_NV                   = 0x8555;
	immutable GLenum GL_COMBINER6_NV                   = 0x8556;
	immutable GLenum GL_COMBINER7_NV                   = 0x8557;
}

version (GL_NV_fog_distance)
{
}
else
{
	immutable GLenum GL_FOG_DISTANCE_MODE_NV  = 0x855A;
	immutable GLenum GL_EYE_RADIAL_NV         = 0x855B;
	immutable GLenum GL_EYE_PLANE_ABSOLUTE_NV = 0x855C;
}

version (GL_NV_texgen_emboss)
{
}
else
{
	immutable GLenum GL_EMBOSS_LIGHT_NV    = 0x855D;
	immutable GLenum GL_EMBOSS_CONSTANT_NV = 0x855E;
	immutable GLenum GL_EMBOSS_MAP_NV      = 0x855F;
}

version (GL_NV_blend_square)
{
}
else
{
}

version (GL_NV_texture_env_combine4)
{
}
else
{
	immutable GLenum GL_COMBINE4_NV       = 0x8503;
	immutable GLenum GL_SOURCE3_RGB_NV    = 0x8583;
	immutable GLenum GL_SOURCE3_ALPHA_NV  = 0x858B;
	immutable GLenum GL_OPERAND3_RGB_NV   = 0x8593;
	immutable GLenum GL_OPERAND3_ALPHA_NV = 0x859B;
}

version (GL_MESA_resize_buffers)
{
}
else
{
}

version (GL_MESA_window_pos)
{
}
else
{
}

version (GL_EXT_texture_compression_s3tc)
{
}
else
{
	immutable GLenum GL_COMPRESSED_RGB_S3TC_DXT1_EXT  = 0x83F0;
	immutable GLenum GL_COMPRESSED_RGBA_S3TC_DXT1_EXT = 0x83F1;
	immutable GLenum GL_COMPRESSED_RGBA_S3TC_DXT3_EXT = 0x83F2;
	immutable GLenum GL_COMPRESSED_RGBA_S3TC_DXT5_EXT = 0x83F3;
}

version (GL_IBM_cull_vertex)
{
}
else
{
	immutable GLenum GL_CULL_VERTEX_IBM = 103050;
}

version (GL_IBM_multimode_draw_arrays)
{
}
else
{
}

version (GL_IBM_vertex_array_lists)
{
}
else
{
	immutable GLenum GL_VERTEX_ARRAY_LIST_IBM                 = 103070;
	immutable GLenum GL_NORMAL_ARRAY_LIST_IBM                 = 103071;
	immutable GLenum GL_COLOR_ARRAY_LIST_IBM                  = 103072;
	immutable GLenum GL_INDEX_ARRAY_LIST_IBM                  = 103073;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_LIST_IBM          = 103074;
	immutable GLenum GL_EDGE_FLAG_ARRAY_LIST_IBM              = 103075;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_LIST_IBM         = 103076;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_LIST_IBM        = 103077;
	immutable GLenum GL_VERTEX_ARRAY_LIST_STRIDE_IBM          = 103080;
	immutable GLenum GL_NORMAL_ARRAY_LIST_STRIDE_IBM          = 103081;
	immutable GLenum GL_COLOR_ARRAY_LIST_STRIDE_IBM           = 103082;
	immutable GLenum GL_INDEX_ARRAY_LIST_STRIDE_IBM           = 103083;
	immutable GLenum GL_TEXTURE_COORD_ARRAY_LIST_STRIDE_IBM   = 103084;
	immutable GLenum GL_EDGE_FLAG_ARRAY_LIST_STRIDE_IBM       = 103085;
	immutable GLenum GL_FOG_COORDINATE_ARRAY_LIST_STRIDE_IBM  = 103086;
	immutable GLenum GL_SECONDARY_COLOR_ARRAY_LIST_STRIDE_IBM = 103087;
}

version (GL_SGIX_subsample)
{
}
else
{
	immutable GLenum GL_PACK_SUBSAMPLE_RATE_SGIX   = 0x85A0;
	immutable GLenum GL_UNPACK_SUBSAMPLE_RATE_SGIX = 0x85A1;
	immutable GLenum GL_PIXEL_SUBSAMPLE_4444_SGIX  = 0x85A2;
	immutable GLenum GL_PIXEL_SUBSAMPLE_2424_SGIX  = 0x85A3;
	immutable GLenum GL_PIXEL_SUBSAMPLE_4242_SGIX  = 0x85A4;
}

version (GL_SGIX_ycrcb_subsample)
{
}
else
{
}

version (GL_SGIX_ycrcba)
{
}
else
{
	immutable GLenum GL_YCRCB_SGIX  = 0x8318;
	immutable GLenum GL_YCRCBA_SGIX = 0x8319;
}

version (GL_SGI_depth_pass_instrument)
{
}
else
{
	immutable GLenum GL_DEPTH_PASS_INSTRUMENT_SGIX          = 0x8310;
	immutable GLenum GL_DEPTH_PASS_INSTRUMENT_COUNTERS_SGIX = 0x8311;
	immutable GLenum GL_DEPTH_PASS_INSTRUMENT_MAX_SGIX      = 0x8312;
}

version (GL_3DFX_texture_compression_FXT1)
{
}
else
{
	immutable GLenum GL_COMPRESSED_RGB_FXT1_3DFX  = 0x86B0;
	immutable GLenum GL_COMPRESSED_RGBA_FXT1_3DFX = 0x86B1;
}

version (GL_3DFX_multisample)
{
}
else
{
	immutable GLbitfield GL_MULTISAMPLE_BIT_3DFX = 0x20000000;
	immutable GLenum GL_MULTISAMPLE_3DFX     = 0x86B2;
	immutable GLenum GL_SAMPLE_BUFFERS_3DFX  = 0x86B3;
	immutable GLenum GL_SAMPLES_3DFX         = 0x86B4;
}

version (GL_3DFX_tbuffer)
{
}
else
{
}

version (GL_EXT_multisample)
{
}
else
{
	immutable GLbitfield GL_MULTISAMPLE_BIT_EXT = 0x20000000;
	immutable GLenum GL_MULTISAMPLE_EXT          = 0x809D;
	immutable GLenum GL_SAMPLE_ALPHA_TO_MASK_EXT = 0x809E;
	immutable GLenum GL_SAMPLE_ALPHA_TO_ONE_EXT  = 0x809F;
	immutable GLenum GL_SAMPLE_MASK_EXT          = 0x80A0;
	immutable GLenum GL_1PASS_EXT                = 0x80A1;
	immutable GLenum GL_2PASS_0_EXT              = 0x80A2;
	immutable GLenum GL_2PASS_1_EXT              = 0x80A3;
	immutable GLenum GL_4PASS_0_EXT              = 0x80A4;
	immutable GLenum GL_4PASS_1_EXT              = 0x80A5;
	immutable GLenum GL_4PASS_2_EXT              = 0x80A6;
	immutable GLenum GL_4PASS_3_EXT              = 0x80A7;
	immutable GLenum GL_SAMPLE_BUFFERS_EXT       = 0x80A8;
	immutable GLenum GL_SAMPLES_EXT              = 0x80A9;
	immutable GLenum GL_SAMPLE_MASK_VALUE_EXT    = 0x80AA;
	immutable GLenum GL_SAMPLE_MASK_INVERT_EXT   = 0x80AB;
	immutable GLenum GL_SAMPLE_PATTERN_EXT       = 0x80AC;
}

version (GL_SGIX_vertex_preclip)
{
}
else
{
	immutable GLenum GL_VERTEX_PRECLIP_SGIX      = 0x83EE;
	immutable GLenum GL_VERTEX_PRECLIP_HINT_SGIX = 0x83EF;
}

version (GL_SGIX_convolution_accuracy)
{
}
else
{
	immutable GLenum GL_CONVOLUTION_HINT_SGIX = 0x8316;
}

version (GL_SGIX_resample)
{
}
else
{
	immutable GLenum GL_PACK_RESAMPLE_SGIX      = 0x842C;
	immutable GLenum GL_UNPACK_RESAMPLE_SGIX    = 0x842D;
	immutable GLenum GL_RESAMPLE_REPLICATE_SGIX = 0x842E;
	immutable GLenum GL_RESAMPLE_ZERO_FILL_SGIX = 0x842F;
	immutable GLenum GL_RESAMPLE_DECIMATE_SGIX  = 0x8430;
}

version (GL_SGIS_point_line_texgen)
{
}
else
{
	immutable GLenum GL_EYE_DISTANCE_TO_POINT_SGIS    = 0x81F0;
	immutable GLenum GL_OBJECT_DISTANCE_TO_POINT_SGIS = 0x81F1;
	immutable GLenum GL_EYE_DISTANCE_TO_LINE_SGIS     = 0x81F2;
	immutable GLenum GL_OBJECT_DISTANCE_TO_LINE_SGIS  = 0x81F3;
	immutable GLenum GL_EYE_POINT_SGIS                = 0x81F4;
	immutable GLenum GL_OBJECT_POINT_SGIS             = 0x81F5;
	immutable GLenum GL_EYE_LINE_SGIS                 = 0x81F6;
	immutable GLenum GL_OBJECT_LINE_SGIS              = 0x81F7;
}

version (GL_SGIS_texture_color_mask)
{
}
else
{
	immutable GLenum GL_TEXTURE_COLOR_WRITEMASK_SGIS = 0x81EF;
}

version (GL_EXT_texture_env_dot3)
{
}
else
{
	immutable GLenum GL_DOT3_RGB_EXT  = 0x8740;
	immutable GLenum GL_DOT3_RGBA_EXT = 0x8741;
}

version (GL_ATI_texture_mirror_once)
{
}
else
{
	immutable GLenum GL_MIRROR_CLAMP_ATI         = 0x8742;
	immutable GLenum GL_MIRROR_CLAMP_TO_EDGE_ATI = 0x8743;
}

version (GL_NV_fence)
{
}
else
{
	immutable GLenum GL_ALL_COMPLETED_NV   = 0x84F2;
	immutable GLenum GL_FENCE_STATUS_NV    = 0x84F3;
	immutable GLenum GL_FENCE_CONDITION_NV = 0x84F4;
}

version (GL_IBM_texture_mirrored_repeat)
{
}
else
{
	immutable GLenum GL_MIRRORED_REPEAT_IBM = 0x8370;
}

version (GL_NV_evaluators)
{
}
else
{
	immutable GLenum GL_EVAL_2D_NV                      = 0x86C0;
	immutable GLenum GL_EVAL_TRIANGULAR_2D_NV           = 0x86C1;
	immutable GLenum GL_MAP_TESSELLATION_NV             = 0x86C2;
	immutable GLenum GL_MAP_ATTRIB_U_ORDER_NV           = 0x86C3;
	immutable GLenum GL_MAP_ATTRIB_V_ORDER_NV           = 0x86C4;
	immutable GLenum GL_EVAL_FRACTIONAL_TESSELLATION_NV = 0x86C5;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB0_NV          = 0x86C6;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB1_NV          = 0x86C7;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB2_NV          = 0x86C8;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB3_NV          = 0x86C9;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB4_NV          = 0x86CA;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB5_NV          = 0x86CB;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB6_NV          = 0x86CC;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB7_NV          = 0x86CD;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB8_NV          = 0x86CE;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB9_NV          = 0x86CF;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB10_NV         = 0x86D0;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB11_NV         = 0x86D1;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB12_NV         = 0x86D2;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB13_NV         = 0x86D3;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB14_NV         = 0x86D4;
	immutable GLenum GL_EVAL_VERTEX_ATTRIB15_NV         = 0x86D5;
	immutable GLenum GL_MAX_MAP_TESSELLATION_NV         = 0x86D6;
	immutable GLenum GL_MAX_RATIONAL_EVAL_ORDER_NV      = 0x86D7;
}

version (GL_NV_packed_depth_stencil)
{
}
else
{
	immutable GLenum GL_DEPTH_STENCIL_NV     = 0x84F9;
	immutable GLenum GL_UNSIGNED_INT_24_8_NV = 0x84FA;
}

version (GL_NV_register_combiners2)
{
}
else
{
	immutable GLenum GL_PER_STAGE_CONSTANTS_NV = 0x8535;
}

version (GL_NV_texture_compression_vtc)
{
}
else
{
}

version (GL_NV_texture_rectangle)
{
}
else
{
	immutable GLenum GL_TEXTURE_RECTANGLE_NV          = 0x84F5;
	immutable GLenum GL_TEXTURE_BINDING_RECTANGLE_NV  = 0x84F6;
	immutable GLenum GL_PROXY_TEXTURE_RECTANGLE_NV    = 0x84F7;
	immutable GLenum GL_MAX_RECTANGLE_TEXTURE_SIZE_NV = 0x84F8;
}

version (GL_NV_texture_shader)
{
}
else
{
	immutable GLenum GL_OFFSET_TEXTURE_RECTANGLE_NV               = 0x864C;
	immutable GLenum GL_OFFSET_TEXTURE_RECTANGLE_SCALE_NV         = 0x864D;
	immutable GLenum GL_DOT_PRODUCT_TEXTURE_RECTANGLE_NV          = 0x864E;
	immutable GLenum GL_RGBA_UNSIGNED_DOT_PRODUCT_MAPPING_NV      = 0x86D9;
	immutable GLenum GL_UNSIGNED_INT_S8_S8_8_8_NV                 = 0x86DA;
	immutable GLenum GL_UNSIGNED_INT_8_8_S8_S8_REV_NV             = 0x86DB;
	immutable GLenum GL_DSDT_MAG_INTENSITY_NV                     = 0x86DC;
	immutable GLenum GL_SHADER_CONSISTENT_NV                      = 0x86DD;
	immutable GLenum GL_TEXTURE_SHADER_NV                         = 0x86DE;
	immutable GLenum GL_SHADER_OPERATION_NV                       = 0x86DF;
	immutable GLenum GL_CULL_MODES_NV                             = 0x86E0;
	immutable GLenum GL_OFFSET_TEXTURE_MATRIX_NV                  = 0x86E1;
	immutable GLenum GL_OFFSET_TEXTURE_SCALE_NV                   = 0x86E2;
	immutable GLenum GL_OFFSET_TEXTURE_BIAS_NV                    = 0x86E3;
	immutable GLenum GL_OFFSET_TEXTURE_2D_MATRIX_NV               = GL_OFFSET_TEXTURE_MATRIX_NV;
	immutable GLenum GL_OFFSET_TEXTURE_2D_SCALE_NV                = GL_OFFSET_TEXTURE_SCALE_NV;
	immutable GLenum GL_OFFSET_TEXTURE_2D_BIAS_NV                 = GL_OFFSET_TEXTURE_BIAS_NV;
	immutable GLenum GL_PREVIOUS_TEXTURE_INPUT_NV                 = 0x86E4;
	immutable GLenum GL_CONST_EYE_NV                              = 0x86E5;
	immutable GLenum GL_PASS_THROUGH_NV                           = 0x86E6;
	immutable GLenum GL_CULL_FRAGMENT_NV                          = 0x86E7;
	immutable GLenum GL_OFFSET_TEXTURE_2D_NV                      = 0x86E8;
	immutable GLenum GL_DEPENDENT_AR_TEXTURE_2D_NV                = 0x86E9;
	immutable GLenum GL_DEPENDENT_GB_TEXTURE_2D_NV                = 0x86EA;
	immutable GLenum GL_DOT_PRODUCT_NV                            = 0x86EC;
	immutable GLenum GL_DOT_PRODUCT_DEPTH_REPLACE_NV              = 0x86ED;
	immutable GLenum GL_DOT_PRODUCT_TEXTURE_2D_NV                 = 0x86EE;
	immutable GLenum GL_DOT_PRODUCT_TEXTURE_CUBE_MAP_NV           = 0x86F0;
	immutable GLenum GL_DOT_PRODUCT_DIFFUSE_CUBE_MAP_NV           = 0x86F1;
	immutable GLenum GL_DOT_PRODUCT_REFLECT_CUBE_MAP_NV           = 0x86F2;
	immutable GLenum GL_DOT_PRODUCT_CONST_EYE_REFLECT_CUBE_MAP_NV = 0x86F3;
	immutable GLenum GL_HILO_NV                                   = 0x86F4;
	immutable GLenum GL_DSDT_NV                                   = 0x86F5;
	immutable GLenum GL_DSDT_MAG_NV                               = 0x86F6;
	immutable GLenum GL_DSDT_MAG_VIB_NV                           = 0x86F7;
	immutable GLenum GL_HILO16_NV                                 = 0x86F8;
	immutable GLenum GL_SIGNED_HILO_NV                            = 0x86F9;
	immutable GLenum GL_SIGNED_HILO16_NV                          = 0x86FA;
	immutable GLenum GL_SIGNED_RGBA_NV                            = 0x86FB;
	immutable GLenum GL_SIGNED_RGBA8_NV                           = 0x86FC;
	immutable GLenum GL_SIGNED_RGB_NV                             = 0x86FE;
	immutable GLenum GL_SIGNED_RGB8_NV                            = 0x86FF;
	immutable GLenum GL_SIGNED_LUMINANCE_NV                       = 0x8701;
	immutable GLenum GL_SIGNED_LUMINANCE8_NV                      = 0x8702;
	immutable GLenum GL_SIGNED_LUMINANCE_ALPHA_NV                 = 0x8703;
	immutable GLenum GL_SIGNED_LUMINANCE8_ALPHA8_NV               = 0x8704;
	immutable GLenum GL_SIGNED_ALPHA_NV                           = 0x8705;
	immutable GLenum GL_SIGNED_ALPHA8_NV                          = 0x8706;
	immutable GLenum GL_SIGNED_INTENSITY_NV                       = 0x8707;
	immutable GLenum GL_SIGNED_INTENSITY8_NV                      = 0x8708;
	immutable GLenum GL_DSDT8_NV                                  = 0x8709;
	immutable GLenum GL_DSDT8_MAG8_NV                             = 0x870A;
	immutable GLenum GL_DSDT8_MAG8_INTENSITY8_NV                  = 0x870B;
	immutable GLenum GL_SIGNED_RGB_UNSIGNED_ALPHA_NV              = 0x870C;
	immutable GLenum GL_SIGNED_RGB8_UNSIGNED_ALPHA8_NV            = 0x870D;
	immutable GLenum GL_HI_SCALE_NV                               = 0x870E;
	immutable GLenum GL_LO_SCALE_NV                               = 0x870F;
	immutable GLenum GL_DS_SCALE_NV                               = 0x8710;
	immutable GLenum GL_DT_SCALE_NV                               = 0x8711;
	immutable GLenum GL_MAGNITUDE_SCALE_NV                        = 0x8712;
	immutable GLenum GL_VIBRANCE_SCALE_NV                         = 0x8713;
	immutable GLenum GL_HI_BIAS_NV                                = 0x8714;
	immutable GLenum GL_LO_BIAS_NV                                = 0x8715;
	immutable GLenum GL_DS_BIAS_NV                                = 0x8716;
	immutable GLenum GL_DT_BIAS_NV                                = 0x8717;
	immutable GLenum GL_MAGNITUDE_BIAS_NV                         = 0x8718;
	immutable GLenum GL_VIBRANCE_BIAS_NV                          = 0x8719;
	immutable GLenum GL_TEXTURE_BORDER_VALUES_NV                  = 0x871A;
	immutable GLenum GL_TEXTURE_HI_SIZE_NV                        = 0x871B;
	immutable GLenum GL_TEXTURE_LO_SIZE_NV                        = 0x871C;
	immutable GLenum GL_TEXTURE_DS_SIZE_NV                        = 0x871D;
	immutable GLenum GL_TEXTURE_DT_SIZE_NV                        = 0x871E;
	immutable GLenum GL_TEXTURE_MAG_SIZE_NV                       = 0x871F;
}

version (GL_NV_texture_shader2)
{
}
else
{
	immutable GLenum GL_DOT_PRODUCT_TEXTURE_3D_NV = 0x86EF;
}

version (GL_NV_vertex_array_range2)
{
}
else
{
	immutable GLenum GL_VERTEX_ARRAY_RANGE_WITHOUT_FLUSH_NV = 0x8533;
}

version (GL_NV_vertex_program)
{
}
else
{
	immutable GLenum GL_VERTEX_PROGRAM_NV               = 0x8620;
	immutable GLenum GL_VERTEX_STATE_PROGRAM_NV         = 0x8621;
	immutable GLenum GL_ATTRIB_ARRAY_SIZE_NV            = 0x8623;
	immutable GLenum GL_ATTRIB_ARRAY_STRIDE_NV          = 0x8624;
	immutable GLenum GL_ATTRIB_ARRAY_TYPE_NV            = 0x8625;
	immutable GLenum GL_CURRENT_ATTRIB_NV               = 0x8626;
	immutable GLenum GL_PROGRAM_LENGTH_NV               = 0x8627;
	immutable GLenum GL_PROGRAM_STRING_NV               = 0x8628;
	immutable GLenum GL_MODELVIEW_PROJECTION_NV         = 0x8629;
	immutable GLenum GL_IDENTITY_NV                     = 0x862A;
	immutable GLenum GL_INVERSE_NV                      = 0x862B;
	immutable GLenum GL_TRANSPOSE_NV                    = 0x862C;
	immutable GLenum GL_INVERSE_TRANSPOSE_NV            = 0x862D;
	immutable GLenum GL_MAX_TRACK_MATRIX_STACK_DEPTH_NV = 0x862E;
	immutable GLenum GL_MAX_TRACK_MATRICES_NV           = 0x862F;
	immutable GLenum GL_MATRIX0_NV                      = 0x8630;
	immutable GLenum GL_MATRIX1_NV                      = 0x8631;
	immutable GLenum GL_MATRIX2_NV                      = 0x8632;
	immutable GLenum GL_MATRIX3_NV                      = 0x8633;
	immutable GLenum GL_MATRIX4_NV                      = 0x8634;
	immutable GLenum GL_MATRIX5_NV                      = 0x8635;
	immutable GLenum GL_MATRIX6_NV                      = 0x8636;
	immutable GLenum GL_MATRIX7_NV                      = 0x8637;
	immutable GLenum GL_CURRENT_MATRIX_STACK_DEPTH_NV   = 0x8640;
	immutable GLenum GL_CURRENT_MATRIX_NV               = 0x8641;
	immutable GLenum GL_VERTEX_PROGRAM_POINT_SIZE_NV    = 0x8642;
	immutable GLenum GL_VERTEX_PROGRAM_TWO_SIDE_NV      = 0x8643;
	immutable GLenum GL_PROGRAM_PARAMETER_NV            = 0x8644;
	immutable GLenum GL_ATTRIB_ARRAY_POINTER_NV         = 0x8645;
	immutable GLenum GL_PROGRAM_TARGET_NV               = 0x8646;
	immutable GLenum GL_PROGRAM_RESIDENT_NV             = 0x8647;
	immutable GLenum GL_TRACK_MATRIX_NV                 = 0x8648;
	immutable GLenum GL_TRACK_MATRIX_TRANSFORM_NV       = 0x8649;
	immutable GLenum GL_VERTEX_PROGRAM_BINDING_NV       = 0x864A;
	immutable GLenum GL_PROGRAM_ERROR_POSITION_NV       = 0x864B;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY0_NV         = 0x8650;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY1_NV         = 0x8651;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY2_NV         = 0x8652;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY3_NV         = 0x8653;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY4_NV         = 0x8654;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY5_NV         = 0x8655;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY6_NV         = 0x8656;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY7_NV         = 0x8657;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY8_NV         = 0x8658;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY9_NV         = 0x8659;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY10_NV        = 0x865A;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY11_NV        = 0x865B;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY12_NV        = 0x865C;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY13_NV        = 0x865D;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY14_NV        = 0x865E;
	immutable GLenum GL_VERTEX_ATTRIB_ARRAY15_NV        = 0x865F;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB0_4_NV        = 0x8660;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB1_4_NV        = 0x8661;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB2_4_NV        = 0x8662;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB3_4_NV        = 0x8663;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB4_4_NV        = 0x8664;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB5_4_NV        = 0x8665;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB6_4_NV        = 0x8666;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB7_4_NV        = 0x8667;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB8_4_NV        = 0x8668;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB9_4_NV        = 0x8669;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB10_4_NV       = 0x866A;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB11_4_NV       = 0x866B;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB12_4_NV       = 0x866C;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB13_4_NV       = 0x866D;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB14_4_NV       = 0x866E;
	immutable GLenum GL_MAP1_VERTEX_ATTRIB15_4_NV       = 0x866F;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB0_4_NV        = 0x8670;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB1_4_NV        = 0x8671;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB2_4_NV        = 0x8672;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB3_4_NV        = 0x8673;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB4_4_NV        = 0x8674;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB5_4_NV        = 0x8675;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB6_4_NV        = 0x8676;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB7_4_NV        = 0x8677;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB8_4_NV        = 0x8678;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB9_4_NV        = 0x8679;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB10_4_NV       = 0x867A;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB11_4_NV       = 0x867B;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB12_4_NV       = 0x867C;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB13_4_NV       = 0x867D;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB14_4_NV       = 0x867E;
	immutable GLenum GL_MAP2_VERTEX_ATTRIB15_4_NV       = 0x867F;
}

version (GL_SGIX_texture_coordinate_clamp)
{
}
else
{
	immutable GLenum GL_TEXTURE_MAX_CLAMP_S_SGIX = 0x8369;
	immutable GLenum GL_TEXTURE_MAX_CLAMP_T_SGIX = 0x836A;
	immutable GLenum GL_TEXTURE_MAX_CLAMP_R_SGIX = 0x836B;
}

version (GL_SGIX_scalebias_hint)
{
}
else
{
	immutable GLenum GL_SCALEBIAS_HINT_SGIX = 0x8322;
}

version (GL_OML_interlace)
{
}
else
{
	immutable GLenum GL_INTERLACE_OML      = 0x8980;
	immutable GLenum GL_INTERLACE_READ_OML = 0x8981;
}

version (GL_OML_subsample)
{
}
else
{
	immutable GLenum GL_FORMAT_SUBSAMPLE_24_24_OML   = 0x8982;
	immutable GLenum GL_FORMAT_SUBSAMPLE_244_244_OML = 0x8983;
}

version (GL_OML_resample)
{
}
else
{
	immutable GLenum GL_PACK_RESAMPLE_OML      = 0x8984;
	immutable GLenum GL_UNPACK_RESAMPLE_OML    = 0x8985;
	immutable GLenum GL_RESAMPLE_REPLICATE_OML = 0x8986;
	immutable GLenum GL_RESAMPLE_ZERO_FILL_OML = 0x8987;
	immutable GLenum GL_RESAMPLE_AVERAGE_OML   = 0x8988;
	immutable GLenum GL_RESAMPLE_DECIMATE_OML  = 0x8989;
}

version (GL_NV_copy_depth_to_color)
{
}
else
{
	immutable GLenum GL_DEPTH_STENCIL_TO_RGBA_NV = 0x886E;
	immutable GLenum GL_DEPTH_STENCIL_TO_BGRA_NV = 0x886F;
}

version (GL_ATI_envmap_bumpmap)
{
}
else
{
	immutable GLenum GL_BUMP_ROT_MATRIX_ATI      = 0x8775;
	immutable GLenum GL_BUMP_ROT_MATRIX_SIZE_ATI = 0x8776;
	immutable GLenum GL_BUMP_NUM_TEX_UNITS_ATI   = 0x8777;
	immutable GLenum GL_BUMP_TEX_UNITS_ATI       = 0x8778;
	immutable GLenum GL_DUDV_ATI                 = 0x8779;
	immutable GLenum GL_DU8DV8_ATI               = 0x877A;
	immutable GLenum GL_BUMP_ENVMAP_ATI          = 0x877B;
	immutable GLenum GL_BUMP_TARGET_ATI          = 0x877C;
}

version (GL_ATI_fragment_shader)
{
}
else
{
	immutable GLbitfield GL_RED_BIT_ATI      = 0x00000001;
	immutable GLbitfield GL_GREEN_BIT_ATI    = 0x00000002;
	immutable GLbitfield GL_BLUE_BIT_ATI     = 0x00000004;
	immutable GLbitfield GL_2X_BIT_ATI       = 0x00000001;
	immutable GLbitfield GL_4X_BIT_ATI       = 0x00000002;
	immutable GLbitfield GL_8X_BIT_ATI       = 0x00000004;
	immutable GLbitfield GL_HALF_BIT_ATI     = 0x00000008;
	immutable GLbitfield GL_QUARTER_BIT_ATI  = 0x00000010;
	immutable GLbitfield GL_EIGHTH_BIT_ATI   = 0x00000020;
	immutable GLbitfield GL_SATURATE_BIT_ATI = 0x00000040;
	immutable GLbitfield GL_COMP_BIT_ATI     = 0x00000002;
	immutable GLbitfield GL_NEGATE_BIT_ATI   = 0x00000004;
	immutable GLbitfield GL_BIAS_BIT_ATI     = 0x00000008;
	immutable GLenum GL_FRAGMENT_SHADER_ATI                   = 0x8920;
	immutable GLenum GL_REG_0_ATI                             = 0x8921;
	immutable GLenum GL_REG_1_ATI                             = 0x8922;
	immutable GLenum GL_REG_2_ATI                             = 0x8923;
	immutable GLenum GL_REG_3_ATI                             = 0x8924;
	immutable GLenum GL_REG_4_ATI                             = 0x8925;
	immutable GLenum GL_REG_5_ATI                             = 0x8926;
	immutable GLenum GL_REG_6_ATI                             = 0x8927;
	immutable GLenum GL_REG_7_ATI                             = 0x8928;
	immutable GLenum GL_REG_8_ATI                             = 0x8929;
	immutable GLenum GL_REG_9_ATI                             = 0x892A;
	immutable GLenum GL_REG_10_ATI                            = 0x892B;
	immutable GLenum GL_REG_11_ATI                            = 0x892C;
	immutable GLenum GL_REG_12_ATI                            = 0x892D;
	immutable GLenum GL_REG_13_ATI                            = 0x892E;
	immutable GLenum GL_REG_14_ATI                            = 0x892F;
	immutable GLenum GL_REG_15_ATI                            = 0x8930;
	immutable GLenum GL_REG_16_ATI                            = 0x8931;
	immutable GLenum GL_REG_17_ATI                            = 0x8932;
	immutable GLenum GL_REG_18_ATI                            = 0x8933;
	immutable GLenum GL_REG_19_ATI                            = 0x8934;
	immutable GLenum GL_REG_20_ATI                            = 0x8935;
	immutable GLenum GL_REG_21_ATI                            = 0x8936;
	immutable GLenum GL_REG_22_ATI                            = 0x8937;
	immutable GLenum GL_REG_23_ATI                            = 0x8938;
	immutable GLenum GL_REG_24_ATI                            = 0x8939;
	immutable GLenum GL_REG_25_ATI                            = 0x893A;
	immutable GLenum GL_REG_26_ATI                            = 0x893B;
	immutable GLenum GL_REG_27_ATI                            = 0x893C;
	immutable GLenum GL_REG_28_ATI                            = 0x893D;
	immutable GLenum GL_REG_29_ATI                            = 0x893E;
	immutable GLenum GL_REG_30_ATI                            = 0x893F;
	immutable GLenum GL_REG_31_ATI                            = 0x8940;
	immutable GLenum GL_CON_0_ATI                             = 0x8941;
	immutable GLenum GL_CON_1_ATI                             = 0x8942;
	immutable GLenum GL_CON_2_ATI                             = 0x8943;
	immutable GLenum GL_CON_3_ATI                             = 0x8944;
	immutable GLenum GL_CON_4_ATI                             = 0x8945;
	immutable GLenum GL_CON_5_ATI                             = 0x8946;
	immutable GLenum GL_CON_6_ATI                             = 0x8947;
	immutable GLenum GL_CON_7_ATI                             = 0x8948;
	immutable GLenum GL_CON_8_ATI                             = 0x8949;
	immutable GLenum GL_CON_9_ATI                             = 0x894A;
	immutable GLenum GL_CON_10_ATI                            = 0x894B;
	immutable GLenum GL_CON_11_ATI                            = 0x894C;
	immutable GLenum GL_CON_12_ATI                            = 0x894D;
	immutable GLenum GL_CON_13_ATI                            = 0x894E;
	immutable GLenum GL_CON_14_ATI                            = 0x894F;
	immutable GLenum GL_CON_15_ATI                            = 0x8950;
	immutable GLenum GL_CON_16_ATI                            = 0x8951;
	immutable GLenum GL_CON_17_ATI                            = 0x8952;
	immutable GLenum GL_CON_18_ATI                            = 0x8953;
	immutable GLenum GL_CON_19_ATI                            = 0x8954;
	immutable GLenum GL_CON_20_ATI                            = 0x8955;
	immutable GLenum GL_CON_21_ATI                            = 0x8956;
	immutable GLenum GL_CON_22_ATI                            = 0x8957;
	immutable GLenum GL_CON_23_ATI                            = 0x8958;
	immutable GLenum GL_CON_24_ATI                            = 0x8959;
	immutable GLenum GL_CON_25_ATI                            = 0x895A;
	immutable GLenum GL_CON_26_ATI                            = 0x895B;
	immutable GLenum GL_CON_27_ATI                            = 0x895C;
	immutable GLenum GL_CON_28_ATI                            = 0x895D;
	immutable GLenum GL_CON_29_ATI                            = 0x895E;
	immutable GLenum GL_CON_30_ATI                            = 0x895F;
	immutable GLenum GL_CON_31_ATI                            = 0x8960;
	immutable GLenum GL_MOV_ATI                               = 0x8961;
	immutable GLenum GL_ADD_ATI                               = 0x8963;
	immutable GLenum GL_MUL_ATI                               = 0x8964;
	immutable GLenum GL_SUB_ATI                               = 0x8965;
	immutable GLenum GL_DOT3_ATI                              = 0x8966;
	immutable GLenum GL_DOT4_ATI                              = 0x8967;
	immutable GLenum GL_MAD_ATI                               = 0x8968;
	immutable GLenum GL_LERP_ATI                              = 0x8969;
	immutable GLenum GL_CND_ATI                               = 0x896A;
	immutable GLenum GL_CND0_ATI                              = 0x896B;
	immutable GLenum GL_DOT2_ADD_ATI                          = 0x896C;
	immutable GLenum GL_SECONDARY_INTERPOLATOR_ATI            = 0x896D;
	immutable GLenum GL_NUM_FRAGMENT_REGISTERS_ATI            = 0x896E;
	immutable GLenum GL_NUM_FRAGMENT_CONSTANTS_ATI            = 0x896F;
	immutable GLenum GL_NUM_PASSES_ATI                        = 0x8970;
	immutable GLenum GL_NUM_INSTRUCTIONS_PER_PASS_ATI         = 0x8971;
	immutable GLenum GL_NUM_INSTRUCTIONS_TOTAL_ATI            = 0x8972;
	immutable GLenum GL_NUM_INPUT_INTERPOLATOR_COMPONENTS_ATI = 0x8973;
	immutable GLenum GL_NUM_LOOPBACK_COMPONENTS_ATI           = 0x8974;
	immutable GLenum GL_COLOR_ALPHA_PAIRING_ATI               = 0x8975;
	immutable GLenum GL_SWIZZLE_STR_ATI                       = 0x8976;
	immutable GLenum GL_SWIZZLE_STQ_ATI                       = 0x8977;
	immutable GLenum GL_SWIZZLE_STR_DR_ATI                    = 0x8978;
	immutable GLenum GL_SWIZZLE_STQ_DQ_ATI                    = 0x8979;
	immutable GLenum GL_SWIZZLE_STRQ_ATI                      = 0x897A;
	immutable GLenum GL_SWIZZLE_STRQ_DQ_ATI                   = 0x897B;
}

version (GL_ATI_pn_triangles)
{
}
else
{
	immutable GLenum GL_PN_TRIANGLES_ATI                       = 0x87F0;
	immutable GLenum GL_MAX_PN_TRIANGLES_TESSELATION_LEVEL_ATI = 0x87F1;
	immutable GLenum GL_PN_TRIANGLES_POINT_MODE_ATI            = 0x87F2;
	immutable GLenum GL_PN_TRIANGLES_NORMAL_MODE_ATI           = 0x87F3;
	immutable GLenum GL_PN_TRIANGLES_TESSELATION_LEVEL_ATI     = 0x87F4;
	immutable GLenum GL_PN_TRIANGLES_POINT_MODE_LINEAR_ATI     = 0x87F5;
	immutable GLenum GL_PN_TRIANGLES_POINT_MODE_CUBIC_ATI      = 0x87F6;
	immutable GLenum GL_PN_TRIANGLES_NORMAL_MODE_LINEAR_ATI    = 0x87F7;
	immutable GLenum GL_PN_TRIANGLES_NORMAL_MODE_QUADRATIC_ATI = 0x87F8;
}

version (GL_ATI_vertex_array_object)
{
}
else
{
	immutable GLenum GL_STATIC_ATI              = 0x8760;
	immutable GLenum GL_DYNAMIC_ATI             = 0x8761;
	immutable GLenum GL_PRESERVE_ATI            = 0x8762;
	immutable GLenum GL_DISCARD_ATI             = 0x8763;
	immutable GLenum GL_OBJECT_BUFFER_SIZE_ATI  = 0x8764;
	immutable GLenum GL_OBJECT_BUFFER_USAGE_ATI = 0x8765;
	immutable GLenum GL_ARRAY_OBJECT_BUFFER_ATI = 0x8766;
	immutable GLenum GL_ARRAY_OBJECT_OFFSET_ATI = 0x8767;
}

version (GL_EXT_vertex_shader)
{
}
else
{
	immutable GLenum GL_VERTEX_SHADER_EXT                               = 0x8780;
	immutable GLenum GL_VERTEX_SHADER_BINDING_EXT                       = 0x8781;
	immutable GLenum GL_OP_INDEX_EXT                                    = 0x8782;
	immutable GLenum GL_OP_NEGATE_EXT                                   = 0x8783;
	immutable GLenum GL_OP_DOT3_EXT                                     = 0x8784;
	immutable GLenum GL_OP_DOT4_EXT                                     = 0x8785;
	immutable GLenum GL_OP_MUL_EXT                                      = 0x8786;
	immutable GLenum GL_OP_ADD_EXT                                      = 0x8787;
	immutable GLenum GL_OP_MADD_EXT                                     = 0x8788;
	immutable GLenum GL_OP_FRAC_EXT                                     = 0x8789;
	immutable GLenum GL_OP_MAX_EXT                                      = 0x878A;
	immutable GLenum GL_OP_MIN_EXT                                      = 0x878B;
	immutable GLenum GL_OP_SET_GE_EXT                                   = 0x878C;
	immutable GLenum GL_OP_SET_LT_EXT                                   = 0x878D;
	immutable GLenum GL_OP_CLAMP_EXT                                    = 0x878E;
	immutable GLenum GL_OP_FLOOR_EXT                                    = 0x878F;
	immutable GLenum GL_OP_ROUND_EXT                                    = 0x8790;
	immutable GLenum GL_OP_EXP_BASE_2_EXT                               = 0x8791;
	immutable GLenum GL_OP_LOG_BASE_2_EXT                               = 0x8792;
	immutable GLenum GL_OP_POWER_EXT                                    = 0x8793;
	immutable GLenum GL_OP_RECIP_EXT                                    = 0x8794;
	immutable GLenum GL_OP_RECIP_SQRT_EXT                               = 0x8795;
	immutable GLenum GL_OP_SUB_EXT                                      = 0x8796;
	immutable GLenum GL_OP_CROSS_PRODUCT_EXT                            = 0x8797;
	immutable GLenum GL_OP_MULTIPLY_MATRIX_EXT                          = 0x8798;
	immutable GLenum GL_OP_MOV_EXT                                      = 0x8799;
	immutable GLenum GL_OUTPUT_VERTEX_EXT                               = 0x879A;
	immutable GLenum GL_OUTPUT_COLOR0_EXT                               = 0x879B;
	immutable GLenum GL_OUTPUT_COLOR1_EXT                               = 0x879C;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD0_EXT                       = 0x879D;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD1_EXT                       = 0x879E;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD2_EXT                       = 0x879F;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD3_EXT                       = 0x87A0;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD4_EXT                       = 0x87A1;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD5_EXT                       = 0x87A2;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD6_EXT                       = 0x87A3;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD7_EXT                       = 0x87A4;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD8_EXT                       = 0x87A5;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD9_EXT                       = 0x87A6;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD10_EXT                      = 0x87A7;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD11_EXT                      = 0x87A8;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD12_EXT                      = 0x87A9;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD13_EXT                      = 0x87AA;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD14_EXT                      = 0x87AB;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD15_EXT                      = 0x87AC;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD16_EXT                      = 0x87AD;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD17_EXT                      = 0x87AE;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD18_EXT                      = 0x87AF;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD19_EXT                      = 0x87B0;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD20_EXT                      = 0x87B1;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD21_EXT                      = 0x87B2;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD22_EXT                      = 0x87B3;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD23_EXT                      = 0x87B4;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD24_EXT                      = 0x87B5;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD25_EXT                      = 0x87B6;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD26_EXT                      = 0x87B7;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD27_EXT                      = 0x87B8;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD28_EXT                      = 0x87B9;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD29_EXT                      = 0x87BA;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD30_EXT                      = 0x87BB;
	immutable GLenum GL_OUTPUT_TEXTURE_COORD31_EXT                      = 0x87BC;
	immutable GLenum GL_OUTPUT_FOG_EXT                                  = 0x87BD;
	immutable GLenum GL_SCALAR_EXT                                      = 0x87BE;
	immutable GLenum GL_VECTOR_EXT                                      = 0x87BF;
	immutable GLenum GL_MATRIX_EXT                                      = 0x87C0;
	immutable GLenum GL_VARIANT_EXT                                     = 0x87C1;
	immutable GLenum GL_INVARIANT_EXT                                   = 0x87C2;
	immutable GLenum GL_LOCAL_CONSTANT_EXT                              = 0x87C3;
	immutable GLenum GL_LOCAL_EXT                                       = 0x87C4;
	immutable GLenum GL_MAX_VERTEX_SHADER_INSTRUCTIONS_EXT              = 0x87C5;
	immutable GLenum GL_MAX_VERTEX_SHADER_VARIANTS_EXT                  = 0x87C6;
	immutable GLenum GL_MAX_VERTEX_SHADER_INVARIANTS_EXT                = 0x87C7;
	immutable GLenum GL_MAX_VERTEX_SHADER_LOCAL_CONSTANTS_EXT           = 0x87C8;
	immutable GLenum GL_MAX_VERTEX_SHADER_LOCALS_EXT                    = 0x87C9;
	immutable GLenum GL_MAX_OPTIMIZED_VERTEX_SHADER_INSTRUCTIONS_EXT    = 0x87CA;
	immutable GLenum GL_MAX_OPTIMIZED_VERTEX_SHADER_VARIANTS_EXT        = 0x87CB;
	immutable GLenum GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCAL_CONSTANTS_EXT = 0x87CC;
	immutable GLenum GL_MAX_OPTIMIZED_VERTEX_SHADER_INVARIANTS_EXT      = 0x87CD;
	immutable GLenum GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCALS_EXT          = 0x87CE;
	immutable GLenum GL_VERTEX_SHADER_INSTRUCTIONS_EXT                  = 0x87CF;
	immutable GLenum GL_VERTEX_SHADER_VARIANTS_EXT                      = 0x87D0;
	immutable GLenum GL_VERTEX_SHADER_INVARIANTS_EXT                    = 0x87D1;
	immutable GLenum GL_VERTEX_SHADER_LOCAL_CONSTANTS_EXT               = 0x87D2;
	immutable GLenum GL_VERTEX_SHADER_LOCALS_EXT                        = 0x87D3;
	immutable GLenum GL_VERTEX_SHADER_OPTIMIZED_EXT                     = 0x87D4;
	immutable GLenum GL_X_EXT                                           = 0x87D5;
	immutable GLenum GL_Y_EXT                                           = 0x87D6;
	immutable GLenum GL_Z_EXT                                           = 0x87D7;
	immutable GLenum GL_W_EXT                                           = 0x87D8;
	immutable GLenum GL_NEGATIVE_X_EXT                                  = 0x87D9;
	immutable GLenum GL_NEGATIVE_Y_EXT                                  = 0x87DA;
	immutable GLenum GL_NEGATIVE_Z_EXT                                  = 0x87DB;
	immutable GLenum GL_NEGATIVE_W_EXT                                  = 0x87DC;
	immutable GLenum GL_ZERO_EXT                                        = 0x87DD;
	immutable GLenum GL_ONE_EXT                                         = 0x87DE;
	immutable GLenum GL_NEGATIVE_ONE_EXT                                = 0x87DF;
	immutable GLenum GL_NORMALIZED_RANGE_EXT                            = 0x87E0;
	immutable GLenum GL_FULL_RANGE_EXT                                  = 0x87E1;
	immutable GLenum GL_CURRENT_VERTEX_EXT                              = 0x87E2;
	immutable GLenum GL_MVP_MATRIX_EXT                                  = 0x87E3;
	immutable GLenum GL_VARIANT_VALUE_EXT                               = 0x87E4;
	immutable GLenum GL_VARIANT_DATATYPE_EXT                            = 0x87E5;
	immutable GLenum GL_VARIANT_ARRAY_STRIDE_EXT                        = 0x87E6;
	immutable GLenum GL_VARIANT_ARRAY_TYPE_EXT                          = 0x87E7;
	immutable GLenum GL_VARIANT_ARRAY_EXT                               = 0x87E8;
	immutable GLenum GL_VARIANT_ARRAY_POINTER_EXT                       = 0x87E9;
	immutable GLenum GL_INVARIANT_VALUE_EXT                             = 0x87EA;
	immutable GLenum GL_INVARIANT_DATATYPE_EXT                          = 0x87EB;
	immutable GLenum GL_LOCAL_CONSTANT_VALUE_EXT                        = 0x87EC;
	immutable GLenum GL_LOCAL_CONSTANT_DATATYPE_EXT                     = 0x87ED;
}

version (GL_ATI_vertex_streams)
{
}
else
{
	immutable GLenum GL_MAX_VERTEX_STREAMS_ATI = 0x876B;
	immutable GLenum GL_VERTEX_STREAM0_ATI     = 0x876C;
	immutable GLenum GL_VERTEX_STREAM1_ATI     = 0x876D;
	immutable GLenum GL_VERTEX_STREAM2_ATI     = 0x876E;
	immutable GLenum GL_VERTEX_STREAM3_ATI     = 0x876F;
	immutable GLenum GL_VERTEX_STREAM4_ATI     = 0x8770;
	immutable GLenum GL_VERTEX_STREAM5_ATI     = 0x8771;
	immutable GLenum GL_VERTEX_STREAM6_ATI     = 0x8772;
	immutable GLenum GL_VERTEX_STREAM7_ATI     = 0x8773;
	immutable GLenum GL_VERTEX_SOURCE_ATI      = 0x8774;
}

version (GL_ATI_element_array)
{
}
else
{
	immutable GLenum GL_ELEMENT_ARRAY_ATI         = 0x8768;
	immutable GLenum GL_ELEMENT_ARRAY_TYPE_ATI    = 0x8769;
	immutable GLenum GL_ELEMENT_ARRAY_POINTER_ATI = 0x876A;
}

version (GL_SUN_mesh_array)
{
}
else
{
	immutable GLenum GL_QUAD_MESH_SUN     = 0x8614;
	immutable GLenum GL_TRIANGLE_MESH_SUN = 0x8615;
}

version (GL_SUN_slice_accum)
{
}
else
{
	immutable GLenum GL_SLICE_ACCUM_SUN = 0x85CC;
}

version (GL_NV_multisample_filter_hint)
{
}
else
{
	immutable GLenum GL_MULTISAMPLE_FILTER_HINT_NV = 0x8534;
}

version (GL_NV_depth_clamp)
{
}
else
{
	immutable GLenum GL_DEPTH_CLAMP_NV = 0x864F;
}

version (GL_NV_occlusion_query)
{
}
else
{
	immutable GLenum GL_PIXEL_COUNTER_BITS_NV         = 0x8864;
	immutable GLenum GL_CURRENT_OCCLUSION_QUERY_ID_NV = 0x8865;
	immutable GLenum GL_PIXEL_COUNT_NV                = 0x8866;
	immutable GLenum GL_PIXEL_COUNT_AVAILABLE_NV      = 0x8867;
}

version (GL_NV_point_sprite)
{
}
else
{
	immutable GLenum GL_POINT_SPRITE_NV        = 0x8861;
	immutable GLenum GL_COORD_REPLACE_NV       = 0x8862;
	immutable GLenum GL_POINT_SPRITE_R_MODE_NV = 0x8863;
}

version (GL_NV_texture_shader3)
{
}
else
{
	immutable GLenum GL_OFFSET_PROJECTIVE_TEXTURE_2D_NV              = 0x8850;
	immutable GLenum GL_OFFSET_PROJECTIVE_TEXTURE_2D_SCALE_NV        = 0x8851;
	immutable GLenum GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_NV       = 0x8852;
	immutable GLenum GL_OFFSET_PROJECTIVE_TEXTURE_RECTANGLE_SCALE_NV = 0x8853;
	immutable GLenum GL_OFFSET_HILO_TEXTURE_2D_NV                    = 0x8854;
	immutable GLenum GL_OFFSET_HILO_TEXTURE_RECTANGLE_NV             = 0x8855;
	immutable GLenum GL_OFFSET_HILO_PROJECTIVE_TEXTURE_2D_NV         = 0x8856;
	immutable GLenum GL_OFFSET_HILO_PROJECTIVE_TEXTURE_RECTANGLE_NV  = 0x8857;
	immutable GLenum GL_DEPENDENT_HILO_TEXTURE_2D_NV                 = 0x8858;
	immutable GLenum GL_DEPENDENT_RGB_TEXTURE_3D_NV                  = 0x8859;
	immutable GLenum GL_DEPENDENT_RGB_TEXTURE_CUBE_MAP_NV            = 0x885A;
	immutable GLenum GL_DOT_PRODUCT_PASS_THROUGH_NV                  = 0x885B;
	immutable GLenum GL_DOT_PRODUCT_TEXTURE_1D_NV                    = 0x885C;
	immutable GLenum GL_DOT_PRODUCT_AFFINE_DEPTH_REPLACE_NV          = 0x885D;
	immutable GLenum GL_HILO8_NV                                     = 0x885E;
	immutable GLenum GL_SIGNED_HILO8_NV                              = 0x885F;
	immutable GLenum GL_FORCE_BLUE_TO_ONE_NV                         = 0x8860;
}

version (GL_NV_vertex_program1_1)
{
}
else
{
}

version (GL_EXT_shadow_funcs)
{
}
else
{
}

version (GL_EXT_stencil_two_side)
{
}
else
{
	immutable GLenum GL_STENCIL_TEST_TWO_SIDE_EXT = 0x8910;
	immutable GLenum GL_ACTIVE_STENCIL_FACE_EXT   = 0x8911;
}

version (GL_ATI_text_fragment_shader)
{
}
else
{
	immutable GLenum GL_TEXT_FRAGMENT_SHADER_ATI = 0x8200;
}

version (GL_APPLE_client_storage)
{
}
else
{
	immutable GLenum GL_UNPACK_CLIENT_STORAGE_APPLE = 0x85B2;
}

version (GL_APPLE_element_array)
{
}
else
{
	immutable GLenum GL_ELEMENT_ARRAY_APPLE         = 0x8768;
	immutable GLenum GL_ELEMENT_ARRAY_TYPE_APPLE    = 0x8769;
	immutable GLenum GL_ELEMENT_ARRAY_POINTER_APPLE = 0x876A;
}

version (GL_APPLE_fence)
{
}
else
{
	immutable GLenum GL_DRAW_PIXELS_APPLE = 0x8A0A;
	immutable GLenum GL_FENCE_APPLE       = 0x8A0B;
}

version (GL_APPLE_vertex_array_object)
{
}
else
{
	immutable GLenum GL_VERTEX_ARRAY_BINDING_APPLE = 0x85B5;
}

version (GL_APPLE_vertex_array_range)
{
}
else
{
	immutable GLenum GL_VERTEX_ARRAY_RANGE_APPLE         = 0x851D;
	immutable GLenum GL_VERTEX_ARRAY_RANGE_LENGTH_APPLE  = 0x851E;
	immutable GLenum GL_VERTEX_ARRAY_STORAGE_HINT_APPLE  = 0x851F;
	immutable GLenum GL_VERTEX_ARRAY_RANGE_POINTER_APPLE = 0x8521;
	immutable GLenum GL_STORAGE_CACHED_APPLE             = 0x85BE;
	immutable GLenum GL_STORAGE_SHARED_APPLE             = 0x85BF;
}

version (GL_APPLE_ycbcr_422)
{
}
else
{
	immutable GLenum GL_YCBCR_422_APPLE              = 0x85B9;
	immutable GLenum GL_UNSIGNED_SHORT_8_8_APPLE     = 0x85BA;
	immutable GLenum GL_UNSIGNED_SHORT_8_8_REV_APPLE = 0x85BB;
}

version (GL_S3_s3tc)
{
}
else
{
	immutable GLenum GL_RGB_S3TC   = 0x83A0;
	immutable GLenum GL_RGB4_S3TC  = 0x83A1;
	immutable GLenum GL_RGBA_S3TC  = 0x83A2;
	immutable GLenum GL_RGBA4_S3TC = 0x83A3;
}

version (GL_ATI_draw_buffers)
{
}
else
{
	immutable GLenum GL_MAX_DRAW_BUFFERS_ATI = 0x8824;
	immutable GLenum GL_DRAW_BUFFER0_ATI     = 0x8825;
	immutable GLenum GL_DRAW_BUFFER1_ATI     = 0x8826;
	immutable GLenum GL_DRAW_BUFFER2_ATI     = 0x8827;
	immutable GLenum GL_DRAW_BUFFER3_ATI     = 0x8828;
	immutable GLenum GL_DRAW_BUFFER4_ATI     = 0x8829;
	immutable GLenum GL_DRAW_BUFFER5_ATI     = 0x882A;
	immutable GLenum GL_DRAW_BUFFER6_ATI     = 0x882B;
	immutable GLenum GL_DRAW_BUFFER7_ATI     = 0x882C;
	immutable GLenum GL_DRAW_BUFFER8_ATI     = 0x882D;
	immutable GLenum GL_DRAW_BUFFER9_ATI     = 0x882E;
	immutable GLenum GL_DRAW_BUFFER10_ATI    = 0x882F;
	immutable GLenum GL_DRAW_BUFFER11_ATI    = 0x8830;
	immutable GLenum GL_DRAW_BUFFER12_ATI    = 0x8831;
	immutable GLenum GL_DRAW_BUFFER13_ATI    = 0x8832;
	immutable GLenum GL_DRAW_BUFFER14_ATI    = 0x8833;
	immutable GLenum GL_DRAW_BUFFER15_ATI    = 0x8834;
}

version (GL_ATI_pixel_format_float)
{
}
else
{
	immutable GLenum GL_TYPE_RGBA_FLOAT_ATI             = 0x8820;
	immutable GLenum GL_COLOR_CLEAR_UNCLAMPED_VALUE_ATI = 0x8835;
}

version (GL_ATI_texture_env_combine3)
{
}
else
{
	immutable GLenum GL_MODULATE_ADD_ATI        = 0x8744;
	immutable GLenum GL_MODULATE_SIGNED_ADD_ATI = 0x8745;
	immutable GLenum GL_MODULATE_SUBTRACT_ATI   = 0x8746;
}

version (GL_ATI_texture_float)
{
}
else
{
	immutable GLenum GL_RGBA_FLOAT32_ATI            = 0x8814;
	immutable GLenum GL_RGB_FLOAT32_ATI             = 0x8815;
	immutable GLenum GL_ALPHA_FLOAT32_ATI           = 0x8816;
	immutable GLenum GL_INTENSITY_FLOAT32_ATI       = 0x8817;
	immutable GLenum GL_LUMINANCE_FLOAT32_ATI       = 0x8818;
	immutable GLenum GL_LUMINANCE_ALPHA_FLOAT32_ATI = 0x8819;
	immutable GLenum GL_RGBA_FLOAT16_ATI            = 0x881A;
	immutable GLenum GL_RGB_FLOAT16_ATI             = 0x881B;
	immutable GLenum GL_ALPHA_FLOAT16_ATI           = 0x881C;
	immutable GLenum GL_INTENSITY_FLOAT16_ATI       = 0x881D;
	immutable GLenum GL_LUMINANCE_FLOAT16_ATI       = 0x881E;
	immutable GLenum GL_LUMINANCE_ALPHA_FLOAT16_ATI = 0x881F;
}

version (GL_NV_float_buffer)
{
}
else
{
	immutable GLenum GL_FLOAT_R_NV                  = 0x8880;
	immutable GLenum GL_FLOAT_RG_NV                 = 0x8881;
	immutable GLenum GL_FLOAT_RGB_NV                = 0x8882;
	immutable GLenum GL_FLOAT_RGBA_NV               = 0x8883;
	immutable GLenum GL_FLOAT_R16_NV                = 0x8884;
	immutable GLenum GL_FLOAT_R32_NV                = 0x8885;
	immutable GLenum GL_FLOAT_RG16_NV               = 0x8886;
	immutable GLenum GL_FLOAT_RG32_NV               = 0x8887;
	immutable GLenum GL_FLOAT_RGB16_NV              = 0x8888;
	immutable GLenum GL_FLOAT_RGB32_NV              = 0x8889;
	immutable GLenum GL_FLOAT_RGBA16_NV             = 0x888A;
	immutable GLenum GL_FLOAT_RGBA32_NV             = 0x888B;
	immutable GLenum GL_TEXTURE_FLOAT_COMPONENTS_NV = 0x888C;
	immutable GLenum GL_FLOAT_CLEAR_COLOR_VALUE_NV  = 0x888D;
	immutable GLenum GL_FLOAT_RGBA_MODE_NV          = 0x888E;
}

version (GL_NV_fragment_program)
{
}
else
{
	immutable GLenum GL_MAX_FRAGMENT_PROGRAM_LOCAL_PARAMETERS_NV = 0x8868;
	immutable GLenum GL_FRAGMENT_PROGRAM_NV                      = 0x8870;
	immutable GLenum GL_MAX_TEXTURE_COORDS_NV                    = 0x8871;
	immutable GLenum GL_MAX_TEXTURE_IMAGE_UNITS_NV               = 0x8872;
	immutable GLenum GL_FRAGMENT_PROGRAM_BINDING_NV              = 0x8873;
	immutable GLenum GL_PROGRAM_ERROR_STRING_NV                  = 0x8874;
}

version (GL_NV_half_float)
{
}
else
{
	immutable GLenum GL_HALF_FLOAT_NV = 0x140B;
}

version (GL_NV_pixel_data_range)
{
}
else
{
	immutable GLenum GL_WRITE_PIXEL_DATA_RANGE_NV         = 0x8878;
	immutable GLenum GL_READ_PIXEL_DATA_RANGE_NV          = 0x8879;
	immutable GLenum GL_WRITE_PIXEL_DATA_RANGE_LENGTH_NV  = 0x887A;
	immutable GLenum GL_READ_PIXEL_DATA_RANGE_LENGTH_NV   = 0x887B;
	immutable GLenum GL_WRITE_PIXEL_DATA_RANGE_POINTER_NV = 0x887C;
	immutable GLenum GL_READ_PIXEL_DATA_RANGE_POINTER_NV  = 0x887D;
}

version (GL_NV_primitive_restart)
{
}
else
{
	immutable GLenum GL_PRIMITIVE_RESTART_NV       = 0x8558;
	immutable GLenum GL_PRIMITIVE_RESTART_INDEX_NV = 0x8559;
}

version (GL_NV_texture_expand_normal)
{
}
else
{
	immutable GLenum GL_TEXTURE_UNSIGNED_REMAP_MODE_NV = 0x888F;
}

version (GL_NV_vertex_program2)
{
}
else
{
}

version (GL_ATI_map_object_buffer)
{
}
else
{
}

version (GL_ATI_separate_stencil)
{
}
else
{
	immutable GLenum GL_STENCIL_BACK_FUNC_ATI            = 0x8800;
	immutable GLenum GL_STENCIL_BACK_FAIL_ATI            = 0x8801;
	immutable GLenum GL_STENCIL_BACK_PASS_DEPTH_FAIL_ATI = 0x8802;
	immutable GLenum GL_STENCIL_BACK_PASS_DEPTH_PASS_ATI = 0x8803;
}

version (GL_ATI_vertex_attrib_array_object)
{
}
else
{
}

version (GL_OES_read_format)
{
}
else
{
	immutable GLenum GL_IMPLEMENTATION_COLOR_READ_TYPE_OES   = 0x8B9A;
	immutable GLenum GL_IMPLEMENTATION_COLOR_READ_FORMAT_OES = 0x8B9B;
}

version (GL_EXT_depth_bounds_test)
{
}
else
{
	immutable GLenum GL_DEPTH_BOUNDS_TEST_EXT = 0x8890;
	immutable GLenum GL_DEPTH_BOUNDS_EXT      = 0x8891;
}

version (GL_EXT_texture_mirror_clamp)
{
}
else
{
	immutable GLenum GL_MIRROR_CLAMP_EXT           = 0x8742;
	immutable GLenum GL_MIRROR_CLAMP_TO_EDGE_EXT   = 0x8743;
	immutable GLenum GL_MIRROR_CLAMP_TO_BORDER_EXT = 0x8912;
}

version (GL_EXT_blend_equation_separate)
{
}
else
{
	immutable GLenum GL_BLEND_EQUATION_RGB_EXT   = GL_BLEND_EQUATION;
	immutable GLenum GL_BLEND_EQUATION_ALPHA_EXT = 0x883D;
}

version (GL_MESA_pack_invert)
{
}
else
{
	immutable GLenum GL_PACK_INVERT_MESA = 0x8758;
}

version (GL_MESA_ycbcr_texture)
{
}
else
{
	immutable GLenum GL_UNSIGNED_SHORT_8_8_MESA     = 0x85BA;
	immutable GLenum GL_UNSIGNED_SHORT_8_8_REV_MESA = 0x85BB;
	immutable GLenum GL_YCBCR_MESA                  = 0x8757;
}

version (GL_EXT_pixel_buffer_object)
{
}
else
{
	immutable GLenum GL_PIXEL_PACK_BUFFER_EXT           = 0x88EB;
	immutable GLenum GL_PIXEL_UNPACK_BUFFER_EXT         = 0x88EC;
	immutable GLenum GL_PIXEL_PACK_BUFFER_BINDING_EXT   = 0x88ED;
	immutable GLenum GL_PIXEL_UNPACK_BUFFER_BINDING_EXT = 0x88EF;
}

version (GL_NV_fragment_program_option)
{
}
else
{
}

version (GL_NV_fragment_program2)
{
}
else
{
	immutable GLenum GL_MAX_PROGRAM_EXEC_INSTRUCTIONS_NV = 0x88F4;
	immutable GLenum GL_MAX_PROGRAM_CALL_DEPTH_NV        = 0x88F5;
	immutable GLenum GL_MAX_PROGRAM_IF_DEPTH_NV          = 0x88F6;
	immutable GLenum GL_MAX_PROGRAM_LOOP_DEPTH_NV        = 0x88F7;
	immutable GLenum GL_MAX_PROGRAM_LOOP_COUNT_NV        = 0x88F8;
}

version (GL_NV_vertex_program2_option)
{
}
else
{
}

version (GL_NV_vertex_program3)
{
}
else
{
}

version (GL_EXT_framebuffer_object)
{
}
else
{
	immutable GLenum GL_INVALID_FRAMEBUFFER_OPERATION_EXT                = 0x0506;
	immutable GLenum GL_MAX_RENDERBUFFER_SIZE_EXT                        = 0x84E8;
	immutable GLenum GL_FRAMEBUFFER_BINDING_EXT                          = 0x8CA6;
	immutable GLenum GL_RENDERBUFFER_BINDING_EXT                         = 0x8CA7;
	immutable GLenum GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT           = 0x8CD0;
	immutable GLenum GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT           = 0x8CD1;
	immutable GLenum GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT         = 0x8CD2;
	immutable GLenum GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT = 0x8CD3;
	immutable GLenum GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT    = 0x8CD4;
	immutable GLenum GL_FRAMEBUFFER_COMPLETE_EXT                         = 0x8CD5;
	immutable GLenum GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT            = 0x8CD6;
	immutable GLenum GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT    = 0x8CD7;
	immutable GLenum GL_FRAMEBUFFER_INCOMPLETE_DUPLICATE_ATTACHMENT_EXT  = 0x8CD8;
	immutable GLenum GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT            = 0x8CD9;
	immutable GLenum GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT               = 0x8CDA;
	immutable GLenum GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT           = 0x8CDB;
	immutable GLenum GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT           = 0x8CDC;
	immutable GLenum GL_FRAMEBUFFER_UNSUPPORTED_EXT                      = 0x8CDD;
	immutable GLenum GL_MAX_COLOR_ATTACHMENTS_EXT                        = 0x8CDF;
	immutable GLenum GL_COLOR_ATTACHMENT0_EXT                            = 0x8CE0;
	immutable GLenum GL_COLOR_ATTACHMENT1_EXT                            = 0x8CE1;
	immutable GLenum GL_COLOR_ATTACHMENT2_EXT                            = 0x8CE2;
	immutable GLenum GL_COLOR_ATTACHMENT3_EXT                            = 0x8CE3;
	immutable GLenum GL_COLOR_ATTACHMENT4_EXT                            = 0x8CE4;
	immutable GLenum GL_COLOR_ATTACHMENT5_EXT                            = 0x8CE5;
	immutable GLenum GL_COLOR_ATTACHMENT6_EXT                            = 0x8CE6;
	immutable GLenum GL_COLOR_ATTACHMENT7_EXT                            = 0x8CE7;
	immutable GLenum GL_COLOR_ATTACHMENT8_EXT                            = 0x8CE8;
	immutable GLenum GL_COLOR_ATTACHMENT9_EXT                            = 0x8CE9;
	immutable GLenum GL_COLOR_ATTACHMENT10_EXT                           = 0x8CEA;
	immutable GLenum GL_COLOR_ATTACHMENT11_EXT                           = 0x8CEB;
	immutable GLenum GL_COLOR_ATTACHMENT12_EXT                           = 0x8CEC;
	immutable GLenum GL_COLOR_ATTACHMENT13_EXT                           = 0x8CED;
	immutable GLenum GL_COLOR_ATTACHMENT14_EXT                           = 0x8CEE;
	immutable GLenum GL_COLOR_ATTACHMENT15_EXT                           = 0x8CEF;
	immutable GLenum GL_DEPTH_ATTACHMENT_EXT                             = 0x8D00;
	immutable GLenum GL_STENCIL_ATTACHMENT_EXT                           = 0x8D20;
	immutable GLenum GL_FRAMEBUFFER_EXT                                  = 0x8D40;
	immutable GLenum GL_RENDERBUFFER_EXT                                 = 0x8D41;
	immutable GLenum GL_RENDERBUFFER_WIDTH_EXT                           = 0x8D42;
	immutable GLenum GL_RENDERBUFFER_HEIGHT_EXT                          = 0x8D43;
	immutable GLenum GL_RENDERBUFFER_INTERNAL_FORMAT_EXT                 = 0x8D44;
	immutable GLenum GL_STENCIL_INDEX1_EXT                               = 0x8D46;
	immutable GLenum GL_STENCIL_INDEX4_EXT                               = 0x8D47;
	immutable GLenum GL_STENCIL_INDEX8_EXT                               = 0x8D48;
	immutable GLenum GL_STENCIL_INDEX16_EXT                              = 0x8D49;
	immutable GLenum GL_RENDERBUFFER_RED_SIZE_EXT                        = 0x8D50;
	immutable GLenum GL_RENDERBUFFER_GREEN_SIZE_EXT                      = 0x8D51;
	immutable GLenum GL_RENDERBUFFER_BLUE_SIZE_EXT                       = 0x8D52;
	immutable GLenum GL_RENDERBUFFER_ALPHA_SIZE_EXT                      = 0x8D53;
	immutable GLenum GL_RENDERBUFFER_DEPTH_SIZE_EXT                      = 0x8D54;
	immutable GLenum GL_RENDERBUFFER_STENCIL_SIZE_EXT                    = 0x8D55;
}

version (GL_GREMEDY_string_marker)
{
}
else
{
}


version (GL_VERSION_2_0)
{
}
else
{
	alias char GLchar;
}

version (GL_VERSION_1_5)
{
}
else
{
	alias ptrdiff_t GLintptr;
	alias ptrdiff_t GLsizeiptr;
}

version (GL_ARB_vertex_buffer_object)
{
}
else
{
	alias ptrdiff_t GLintptrARB;
	alias ptrdiff_t GLsizeiptrARB;
}

version (GL_ARB_shader_objects)
{
}
else
{
	alias char GLcharARB;
	alias uint GLhandleARB;
}

version (GL_ARB_half_float_pixel)
{
}
else
{
	alias ushort GLhalfARB;
}

version (GL_NV_half_float)
{
}
else
{
	alias ushort GLhalfNV;
}

version (GL_VERSION_1_2)
{
}
else
{
	extern (C)
	{
		void glBlendColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
		void glBlendEquation(GLenum mode);
		void glDrawRangeElements(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const(GLvoid)* indices);
		void glColorTable(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const(GLvoid)* table);
		void glColorTableParameterfv(GLenum target, GLenum pname, const(GLfloat)* params);
		void glColorTableParameteriv(GLenum target, GLenum pname, const(GLint)* params);
		void glCopyColorTable(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
		void glGetColorTable(GLenum target, GLenum format, GLenum type, GLvoid* table);
		void glGetColorTableParameterfv(GLenum target, GLenum pname, GLfloat* params);
		void glGetColorTableParameteriv(GLenum target, GLenum pname, GLint* params);
		void glColorSubTable(GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const(GLvoid)* data);
		void glCopyColorSubTable(GLenum target, GLsizei start, GLint x, GLint y, GLsizei width);
		void glConvolutionFilter1D(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const(GLvoid)* image);
		void glConvolutionFilter2D(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const(GLvoid)* image);
		void glConvolutionParameterf(GLenum target, GLenum pname, GLfloat params);
		void glConvolutionParameterfv(GLenum target, GLenum pname, const(GLfloat)* params);
		void glConvolutionParameteri(GLenum target, GLenum pname, GLint params);
		void glConvolutionParameteriv(GLenum target, GLenum pname, const(GLint)* params);
		void glCopyConvolutionFilter1D(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
		void glCopyConvolutionFilter2D(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height);
		void glGetConvolutionFilter(GLenum target, GLenum format, GLenum type, GLvoid* image);
		void glGetConvolutionParameterfv(GLenum target, GLenum pname, GLfloat* params);
		void glGetConvolutionParameteriv(GLenum target, GLenum pname, GLint* params);
		void glGetSeparableFilter(GLenum target, GLenum format, GLenum type, GLvoid* row, GLvoid* column, GLvoid* span);
		void glSeparableFilter2D(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const(GLvoid)* row, const(GLvoid)* column);
		void glGetHistogram(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid* values);
		void glGetHistogramParameterfv(GLenum target, GLenum pname, GLfloat* params);
		void glGetHistogramParameteriv(GLenum target, GLenum pname, GLint* params);
		void glGetMinmax(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid* values);
		void glGetMinmaxParameterfv(GLenum target, GLenum pname, GLfloat* params);
		void glGetMinmaxParameteriv(GLenum target, GLenum pname, GLint* params);
		void glHistogram(GLenum target, GLsizei width, GLenum internalformat, GLboolean sink);
		void glMinmax(GLenum target, GLenum internalformat, GLboolean sink);
		void glResetHistogram(GLenum target);
		void glResetMinmax(GLenum target);
		void glTexImage3D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const(GLvoid)* pixels);
		void glTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const(GLvoid)* pixels);
		void glCopyTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);

		alias void function(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha) PFNGLBLENDCOLORPROC;
		alias void function(GLenum mode) PFNGLBLENDEQUATIONPROC;
		alias void function(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const(GLvoid)* indices) PFNGLDRAWRANGEELEMENTSPROC;
		alias void function(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const(GLvoid)* table) PFNGLCOLORTABLEPROC;
		alias void function(GLenum target, GLenum pname, const(GLfloat)* params) PFNGLCOLORTABLEPARAMETERFVPROC;
		alias void function(GLenum target, GLenum pname, const(GLint)* params) PFNGLCOLORTABLEPARAMETERIVPROC;
		alias void function(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width) PFNGLCOPYCOLORTABLEPROC;
		alias void function(GLenum target, GLenum format, GLenum type, GLvoid* table) PFNGLGETCOLORTABLEPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETCOLORTABLEPARAMETERFVPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETCOLORTABLEPARAMETERIVPROC;
		alias void function(GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const(GLvoid)* data) PFNGLCOLORSUBTABLEPROC;
		alias void function(GLenum target, GLsizei start, GLint x, GLint y, GLsizei width) PFNGLCOPYCOLORSUBTABLEPROC;
		alias void function(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const(GLvoid)* image) PFNGLCONVOLUTIONFILTER1DPROC;
		alias void function(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const(GLvoid)* image) PFNGLCONVOLUTIONFILTER2DPROC;
		alias void function(GLenum target, GLenum pname, GLfloat params) PFNGLCONVOLUTIONPARAMETERFPROC;
		alias void function(GLenum target, GLenum pname, const(GLfloat)* params) PFNGLCONVOLUTIONPARAMETERFVPROC;
		alias void function(GLenum target, GLenum pname, GLint params) PFNGLCONVOLUTIONPARAMETERIPROC;
		alias void function(GLenum target, GLenum pname, const(GLint)* params) PFNGLCONVOLUTIONPARAMETERIVPROC;
		alias void function(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width) PFNGLCOPYCONVOLUTIONFILTER1DPROC;
		alias void function(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height) PFNGLCOPYCONVOLUTIONFILTER2DPROC;
		alias void function(GLenum target, GLenum format, GLenum type, GLvoid* image) PFNGLGETCONVOLUTIONFILTERPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETCONVOLUTIONPARAMETERFVPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETCONVOLUTIONPARAMETERIVPROC;
		alias void function(GLenum target, GLenum format, GLenum type, GLvoid* row, GLvoid* column, GLvoid* span) PFNGLGETSEPARABLEFILTERPROC;
		alias void function(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const(GLvoid)* row, const(GLvoid)* column) PFNGLSEPARABLEFILTER2DPROC;
		alias void function(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid* values) PFNGLGETHISTOGRAMPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETHISTOGRAMPARAMETERFVPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETHISTOGRAMPARAMETERIVPROC;
		alias void function(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid* values) PFNGLGETMINMAXPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETMINMAXPARAMETERFVPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETMINMAXPARAMETERIVPROC;
		alias void function(GLenum target, GLsizei width, GLenum internalformat, GLboolean sink) PFNGLHISTOGRAMPROC;
		alias void function(GLenum target, GLenum internalformat, GLboolean sink) PFNGLMINMAXPROC;
		alias void function(GLenum target) PFNGLRESETHISTOGRAMPROC;
		alias void function(GLenum target) PFNGLRESETMINMAXPROC;
		alias void function(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const(GLvoid)* pixels) PFNGLTEXIMAGE3DPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const(GLvoid)* pixels) PFNGLTEXSUBIMAGE3DPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height) PFNGLCOPYTEXSUBIMAGE3DPROC;
	}
}

version (GL_VERSION_1_3)
{
}
else
{
	extern (C)
	{
		void glActiveTexture(GLenum texture);
		void glClientActiveTexture(GLenum texture);
		void glMultiTexCoord1d(GLenum target, GLdouble s);
		void glMultiTexCoord1dv(GLenum target, const(GLdouble)* v);
		void glMultiTexCoord1f(GLenum target, GLfloat s);
		void glMultiTexCoord1fv(GLenum target, const(GLfloat)* v);
		void glMultiTexCoord1i(GLenum target, GLint s);
		void glMultiTexCoord1iv(GLenum target, const(GLint)* v);
		void glMultiTexCoord1s(GLenum target, GLshort s);
		void glMultiTexCoord1sv(GLenum target, const(GLshort)* v);
		void glMultiTexCoord2d(GLenum target, GLdouble s, GLdouble t);
		void glMultiTexCoord2dv(GLenum target, const(GLdouble)* v);
		void glMultiTexCoord2f(GLenum target, GLfloat s, GLfloat t);
		void glMultiTexCoord2fv(GLenum target, const(GLfloat)* v);
		void glMultiTexCoord2i(GLenum target, GLint s, GLint t);
		void glMultiTexCoord2iv(GLenum target, const(GLint)* v);
		void glMultiTexCoord2s(GLenum target, GLshort s, GLshort t);
		void glMultiTexCoord2sv(GLenum target, const(GLshort)* v);
		void glMultiTexCoord3d(GLenum target, GLdouble s, GLdouble t, GLdouble r);
		void glMultiTexCoord3dv(GLenum target, const(GLdouble)* v);
		void glMultiTexCoord3f(GLenum target, GLfloat s, GLfloat t, GLfloat r);
		void glMultiTexCoord3fv(GLenum target, const(GLfloat)* v);
		void glMultiTexCoord3i(GLenum target, GLint s, GLint t, GLint r);
		void glMultiTexCoord3iv(GLenum target, const(GLint)* v);
		void glMultiTexCoord3s(GLenum target, GLshort s, GLshort t, GLshort r);
		void glMultiTexCoord3sv(GLenum target, const(GLshort)* v);
		void glMultiTexCoord4d(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
		void glMultiTexCoord4dv(GLenum target, const(GLdouble)* v);
		void glMultiTexCoord4f(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
		void glMultiTexCoord4fv(GLenum target, const(GLfloat)* v);
		void glMultiTexCoord4i(GLenum target, GLint s, GLint t, GLint r, GLint q);
		void glMultiTexCoord4iv(GLenum target, const(GLint)* v);
		void glMultiTexCoord4s(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
		void glMultiTexCoord4sv(GLenum target, const(GLshort)* v);
		void glLoadTransposeMatrixf(const(GLfloat)* m);
		void glLoadTransposeMatrixd(const(GLdouble)* m);
		void glMultTransposeMatrixf(const(GLfloat)* m);
		void glMultTransposeMatrixd(const(GLdouble)* m);
		void glSampleCoverage(GLclampf value, GLboolean invert);
		void glCompressedTexImage3D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const(GLvoid)* data);
		void glCompressedTexImage2D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const(GLvoid)* data);
		void glCompressedTexImage1D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const(GLvoid)* data);
		void glCompressedTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const(GLvoid)* data);
		void glCompressedTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const(GLvoid)* data);
		void glCompressedTexSubImage1D(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const(GLvoid)* data);
		void glGetCompressedTexImage(GLenum target, GLint level, GLvoid* img);

		alias void function(GLenum texture) PFNGLACTIVETEXTUREPROC;
		alias void function(GLenum texture) PFNGLCLIENTACTIVETEXTUREPROC;
		alias void function(GLenum target, GLdouble s) PFNGLMULTITEXCOORD1DPROC;
		alias void function(GLenum target, const(GLdouble)* v) PFNGLMULTITEXCOORD1DVPROC;
		alias void function(GLenum target, GLfloat s) PFNGLMULTITEXCOORD1FPROC;
		alias void function(GLenum target, const(GLfloat)* v) PFNGLMULTITEXCOORD1FVPROC;
		alias void function(GLenum target, GLint s) PFNGLMULTITEXCOORD1IPROC;
		alias void function(GLenum target, const(GLint)* v) PFNGLMULTITEXCOORD1IVPROC;
		alias void function(GLenum target, GLshort s) PFNGLMULTITEXCOORD1SPROC;
		alias void function(GLenum target, const(GLshort)* v) PFNGLMULTITEXCOORD1SVPROC;
		alias void function(GLenum target, GLdouble s, GLdouble t) PFNGLMULTITEXCOORD2DPROC;
		alias void function(GLenum target, const(GLdouble)* v) PFNGLMULTITEXCOORD2DVPROC;
		alias void function(GLenum target, GLfloat s, GLfloat t) PFNGLMULTITEXCOORD2FPROC;
		alias void function(GLenum target, const(GLfloat)* v) PFNGLMULTITEXCOORD2FVPROC;
		alias void function(GLenum target, GLint s, GLint t) PFNGLMULTITEXCOORD2IPROC;
		alias void function(GLenum target, const(GLint)* v) PFNGLMULTITEXCOORD2IVPROC;
		alias void function(GLenum target, GLshort s, GLshort t) PFNGLMULTITEXCOORD2SPROC;
		alias void function(GLenum target, const(GLshort)* v) PFNGLMULTITEXCOORD2SVPROC;
		alias void function(GLenum target, GLdouble s, GLdouble t, GLdouble r) PFNGLMULTITEXCOORD3DPROC;
		alias void function(GLenum target, const(GLdouble)* v) PFNGLMULTITEXCOORD3DVPROC;
		alias void function(GLenum target, GLfloat s, GLfloat t, GLfloat r) PFNGLMULTITEXCOORD3FPROC;
		alias void function(GLenum target, const(GLfloat)* v) PFNGLMULTITEXCOORD3FVPROC;
		alias void function(GLenum target, GLint s, GLint t, GLint r) PFNGLMULTITEXCOORD3IPROC;
		alias void function(GLenum target, const(GLint)* v) PFNGLMULTITEXCOORD3IVPROC;
		alias void function(GLenum target, GLshort s, GLshort t, GLshort r) PFNGLMULTITEXCOORD3SPROC;
		alias void function(GLenum target, const(GLshort)* v) PFNGLMULTITEXCOORD3SVPROC;
		alias void function(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q) PFNGLMULTITEXCOORD4DPROC;
		alias void function(GLenum target, const(GLdouble)* v) PFNGLMULTITEXCOORD4DVPROC;
		alias void function(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q) PFNGLMULTITEXCOORD4FPROC;
		alias void function(GLenum target, const(GLfloat)* v) PFNGLMULTITEXCOORD4FVPROC;
		alias void function(GLenum target, GLint s, GLint t, GLint r, GLint q) PFNGLMULTITEXCOORD4IPROC;
		alias void function(GLenum target, const(GLint)* v) PFNGLMULTITEXCOORD4IVPROC;
		alias void function(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q) PFNGLMULTITEXCOORD4SPROC;
		alias void function(GLenum target, const(GLshort)* v) PFNGLMULTITEXCOORD4SVPROC;
		alias void function(const(GLfloat)* m) PFNGLLOADTRANSPOSEMATRIXFPROC;
		alias void function(const(GLdouble)* m) PFNGLLOADTRANSPOSEMATRIXDPROC;
		alias void function(const(GLfloat)* m) PFNGLMULTTRANSPOSEMATRIXFPROC;
		alias void function(const(GLdouble)* m) PFNGLMULTTRANSPOSEMATRIXDPROC;
		alias void function(GLclampf value, GLboolean invert) PFNGLSAMPLECOVERAGEPROC;
		alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXIMAGE3DPROC;
		alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXIMAGE2DPROC;
		alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXIMAGE1DPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC;
		alias void function(GLenum target, GLint level, GLvoid* img) PFNGLGETCOMPRESSEDTEXIMAGEPROC;
	}
}

version (GL_VERSION_1_4)
{
}
else
{
	extern (C)
	{
		void glBlendFuncSeparate(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
		void glFogCoordf(GLfloat coord);
		void glFogCoordfv(const(GLfloat)* coord);
		void glFogCoordd(GLdouble coord);
		void glFogCoorddv(const(GLdouble)* coord);
		void glFogCoordPointer(GLenum type, GLsizei stride, const(GLvoid)* pointer);
		void glMultiDrawArrays(GLenum mode, GLint* first, GLsizei* count, GLsizei primcount);
		void glMultiDrawElements(GLenum mode, const(GLsizei)* count, GLenum type, const(GLvoid*)* indices, GLsizei primcount);
		void glPointParameterf(GLenum pname, GLfloat param);
		void glPointParameterfv(GLenum pname, const(GLfloat)* params);
		void glPointParameteri(GLenum pname, GLint param);
		void glPointParameteriv(GLenum pname, const(GLint)* params);
		void glSecondaryColor3b(GLbyte red, GLbyte green, GLbyte blue);
		void glSecondaryColor3bv(const(GLbyte)* v);
		void glSecondaryColor3d(GLdouble red, GLdouble green, GLdouble blue);
		void glSecondaryColor3dv(const(GLdouble)* v);
		void glSecondaryColor3f(GLfloat red, GLfloat green, GLfloat blue);
		void glSecondaryColor3fv(const(GLfloat)* v);
		void glSecondaryColor3i(GLint red, GLint green, GLint blue);
		void glSecondaryColor3iv(const(GLint)* v);
		void glSecondaryColor3s(GLshort red, GLshort green, GLshort blue);
		void glSecondaryColor3sv(const(GLshort)* v);
		void glSecondaryColor3ub(GLubyte red, GLubyte green, GLubyte blue);
		void glSecondaryColor3ubv(const(GLubyte)* v);
		void glSecondaryColor3ui(GLuint red, GLuint green, GLuint blue);
		void glSecondaryColor3uiv(const(GLuint)* v);
		void glSecondaryColor3us(GLushort red, GLushort green, GLushort blue);
		void glSecondaryColor3usv(const(GLushort)* v);
		void glSecondaryColorPointer(GLint size, GLenum type, GLsizei stride, const(GLvoid)* pointer);
		void glWindowPos2d(GLdouble x, GLdouble y);
		void glWindowPos2dv(const(GLdouble)* v);
		void glWindowPos2f(GLfloat x, GLfloat y);
		void glWindowPos2fv(const(GLfloat)* v);
		void glWindowPos2i(GLint x, GLint y);
		void glWindowPos2iv(const(GLint)* v);
		void glWindowPos2s(GLshort x, GLshort y);
		void glWindowPos2sv(const(GLshort)* v);
		void glWindowPos3d(GLdouble x, GLdouble y, GLdouble z);
		void glWindowPos3dv(const(GLdouble)* v);
		void glWindowPos3f(GLfloat x, GLfloat y, GLfloat z);
		void glWindowPos3fv(const(GLfloat)* v);
		void glWindowPos3i(GLint x, GLint y, GLint z);
		void glWindowPos3iv(const(GLint)* v);
		void glWindowPos3s(GLshort x, GLshort y, GLshort z);
		void glWindowPos3sv(const(GLshort)* v);

		alias void function(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha) PFNGLBLENDFUNCSEPARATEPROC;
		alias void function(GLfloat coord) PFNGLFOGCOORDFPROC;
		alias void function(const(GLfloat)* coord) PFNGLFOGCOORDFVPROC;
		alias void function(GLdouble coord) PFNGLFOGCOORDDPROC;
		alias void function(const(GLdouble)* coord) PFNGLFOGCOORDDVPROC;
		alias void function(GLenum type, GLsizei stride, const(GLvoid)* pointer) PFNGLFOGCOORDPOINTERPROC;
		alias void function(GLenum mode, GLint* first, GLsizei* count, GLsizei primcount) PFNGLMULTIDRAWARRAYSPROC;
		alias void function(GLenum mode, const(GLsizei)* count, GLenum type, const(GLvoid*)* indices, GLsizei primcount) PFNGLMULTIDRAWELEMENTSPROC;
		alias void function(GLenum pname, GLfloat param) PFNGLPOINTPARAMETERFPROC;
		alias void function(GLenum pname, const(GLfloat)* params) PFNGLPOINTPARAMETERFVPROC;
		alias void function(GLenum pname, GLint param) PFNGLPOINTPARAMETERIPROC;
		alias void function(GLenum pname, const(GLint)* params) PFNGLPOINTPARAMETERIVPROC;
		alias void function(GLbyte red, GLbyte green, GLbyte blue) PFNGLSECONDARYCOLOR3BPROC;
		alias void function(const(GLbyte)* v) PFNGLSECONDARYCOLOR3BVPROC;
		alias void function(GLdouble red, GLdouble green, GLdouble blue) PFNGLSECONDARYCOLOR3DPROC;
		alias void function(const(GLdouble)* v) PFNGLSECONDARYCOLOR3DVPROC;
		alias void function(GLfloat red, GLfloat green, GLfloat blue) PFNGLSECONDARYCOLOR3FPROC;
		alias void function(const(GLfloat)* v) PFNGLSECONDARYCOLOR3FVPROC;
		alias void function(GLint red, GLint green, GLint blue) PFNGLSECONDARYCOLOR3IPROC;
		alias void function(const(GLint)* v) PFNGLSECONDARYCOLOR3IVPROC;
		alias void function(GLshort red, GLshort green, GLshort blue) PFNGLSECONDARYCOLOR3SPROC;
		alias void function(const(GLshort)* v) PFNGLSECONDARYCOLOR3SVPROC;
		alias void function(GLubyte red, GLubyte green, GLubyte blue) PFNGLSECONDARYCOLOR3UBPROC;
		alias void function(const(GLubyte)* v) PFNGLSECONDARYCOLOR3UBVPROC;
		alias void function(GLuint red, GLuint green, GLuint blue) PFNGLSECONDARYCOLOR3UIPROC;
		alias void function(const(GLuint)* v) PFNGLSECONDARYCOLOR3UIVPROC;
		alias void function(GLushort red, GLushort green, GLushort blue) PFNGLSECONDARYCOLOR3USPROC;
		alias void function(const(GLushort)* v) PFNGLSECONDARYCOLOR3USVPROC;
		alias void function(GLint size, GLenum type, GLsizei stride, const(GLvoid)* pointer) PFNGLSECONDARYCOLORPOINTERPROC;
		alias void function(GLdouble x, GLdouble y) PFNGLWINDOWPOS2DPROC;
		alias void function(const(GLdouble)* v) PFNGLWINDOWPOS2DVPROC;
		alias void function(GLfloat x, GLfloat y) PFNGLWINDOWPOS2FPROC;
		alias void function(const(GLfloat)* v) PFNGLWINDOWPOS2FVPROC;
		alias void function(GLint x, GLint y) PFNGLWINDOWPOS2IPROC;
		alias void function(const(GLint)* v) PFNGLWINDOWPOS2IVPROC;
		alias void function(GLshort x, GLshort y) PFNGLWINDOWPOS2SPROC;
		alias void function(const(GLshort)* v) PFNGLWINDOWPOS2SVPROC;
		alias void function(GLdouble x, GLdouble y, GLdouble z) PFNGLWINDOWPOS3DPROC;
		alias void function(const(GLdouble)* v) PFNGLWINDOWPOS3DVPROC;
		alias void function(GLfloat x, GLfloat y, GLfloat z) PFNGLWINDOWPOS3FPROC;
		alias void function(const(GLfloat)* v) PFNGLWINDOWPOS3FVPROC;
		alias void function(GLint x, GLint y, GLint z) PFNGLWINDOWPOS3IPROC;
		alias void function(const(GLint)* v) PFNGLWINDOWPOS3IVPROC;
		alias void function(GLshort x, GLshort y, GLshort z) PFNGLWINDOWPOS3SPROC;
		alias void function(const(GLshort)* v) PFNGLWINDOWPOS3SVPROC;
	}
}

version (GL_VERSION_1_5)
{
}
else
{
	extern (C)
	{
		void glGenQueries(GLsizei n, GLuint* ids);
		void glDeleteQueries(GLsizei n, const(GLuint)* ids);
		GLboolean glIsQuery(GLuint id);
		void glBeginQuery(GLenum target, GLuint id);
		void glEndQuery(GLenum target);
		void glGetQueryiv(GLenum target, GLenum pname, GLint* params);
		void glGetQueryObjectiv(GLuint id, GLenum pname, GLint* params);
		void glGetQueryObjectuiv(GLuint id, GLenum pname, GLuint* params);
		void glBindBuffer(GLenum target, GLuint buffer);
		void glDeleteBuffers(GLsizei n, const(GLuint)* buffers);
		void glGenBuffers(GLsizei n, GLuint* buffers);
		GLboolean glIsBuffer(GLuint buffer);
		void glBufferData(GLenum target, GLsizeiptr size, const(GLvoid)* data, GLenum usage);
		void glBufferSubData(GLenum target, GLintptr offset, GLsizeiptr size, const(GLvoid)* data);
		void glGetBufferSubData(GLenum target, GLintptr offset, GLsizeiptr size, GLvoid* data);
		GLvoid* glMapBuffer(GLenum target, GLenum access);
		GLboolean glUnmapBuffer(GLenum target);
		void glGetBufferParameteriv(GLenum target, GLenum pname, GLint* params);
		void glGetBufferPointerv(GLenum target, GLenum pname, GLvoid** params);

		alias void function(GLsizei n, GLuint* ids) PFNGLGENQUERIESPROC;
		alias void function(GLsizei n, const(GLuint)* ids) PFNGLDELETEQUERIESPROC;
		alias GLboolean function(GLuint id) PFNGLISQUERYPROC;
		alias void function(GLenum target, GLuint id) PFNGLBEGINQUERYPROC;
		alias void function(GLenum target) PFNGLENDQUERYPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETQUERYIVPROC;
		alias void function(GLuint id, GLenum pname, GLint* params) PFNGLGETQUERYOBJECTIVPROC;
		alias void function(GLuint id, GLenum pname, GLuint* params) PFNGLGETQUERYOBJECTUIVPROC;
		alias void function(GLenum target, GLuint buffer) PFNGLBINDBUFFERPROC;
		alias void function(GLsizei n, const(GLuint)* buffers) PFNGLDELETEBUFFERSPROC;
		alias void function(GLsizei n, GLuint* buffers) PFNGLGENBUFFERSPROC;
		alias GLboolean function(GLuint buffer) PFNGLISBUFFERPROC;
		alias void function(GLenum target, GLsizeiptr size, const(GLvoid)* data, GLenum usage) PFNGLBUFFERDATAPROC;
		alias void function(GLenum target, GLintptr offset, GLsizeiptr size, const(GLvoid)* data) PFNGLBUFFERSUBDATAPROC;
		alias void function(GLenum target, GLintptr offset, GLsizeiptr size, GLvoid* data) PFNGLGETBUFFERSUBDATAPROC;
		alias GLvoid* function(GLenum target, GLenum access) PFNGLMAPBUFFERPROC;
		alias GLboolean function(GLenum target) PFNGLUNMAPBUFFERPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETBUFFERPARAMETERIVPROC;
		alias void function(GLenum target, GLenum pname, GLvoid** params) PFNGLGETBUFFERPOINTERVPROC;
	}
}

version (GL_VERSION_2_0)
{
}
else
{
	extern (C)
	{
		void glBlendEquationSeparate(GLenum modeRGB, GLenum modeAlpha);
		void glDrawBuffers(GLsizei n, const(GLenum)* bufs);
		void glStencilOpSeparate(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);
		void glStencilFuncSeparate(GLenum frontfunc, GLenum backfunc, GLint reference, GLuint mask);
		void glStencilMaskSeparate(GLenum face, GLuint mask);
		void glAttachShader(GLuint program, GLuint shader);
		void glBindAttribLocation(GLuint program, GLuint index, const(GLchar)* name);
		void glCompileShader(GLuint shader);
		GLuint glCreateProgram();
		GLuint glCreateShader(GLenum type);
		void glDeleteProgram(GLuint program);
		void glDeleteShader(GLuint shader);
		void glDetachShader(GLuint program, GLuint shader);
		void glDisableVertexAttribArray(GLuint index);
		void glEnableVertexAttribArray(GLuint index);
		void glGetActiveAttrib(GLuint program, GLuint index, GLsizei bufSize, GLsizei* length, GLint* size, GLenum* type, GLchar* name);
		void glGetActiveUniform(GLuint program, GLuint index, GLsizei bufSize, GLsizei* length, GLint* size, GLenum* type, GLchar* name);
		void glGetAttachedShaders(GLuint program, GLsizei maxCount, GLsizei* count, GLuint* obj);
		GLint glGetAttribLocation(GLuint program, const(GLchar)* name);
		void glGetProgramiv(GLuint program, GLenum pname, GLint* params);
		void glGetProgramInfoLog(GLuint program, GLsizei bufSize, GLsizei* length, GLchar* infoLog);
		void glGetShaderiv(GLuint shader, GLenum pname, GLint* params);
		void glGetShaderInfoLog(GLuint shader, GLsizei bufSize, GLsizei* length, GLchar* infoLog);
		void glGetShaderSource(GLuint shader, GLsizei bufSize, GLsizei* length, GLchar* source);
		GLint glGetUniformLocation(GLuint program, const(GLchar)* name);
		void glGetUniformfv(GLuint program, GLint location, GLfloat* params);
		void glGetUniformiv(GLuint program, GLint location, GLint* params);
		void glGetVertexAttribdv(GLuint index, GLenum pname, GLdouble* params);
		void glGetVertexAttribfv(GLuint index, GLenum pname, GLfloat* params);
		void glGetVertexAttribiv(GLuint index, GLenum pname, GLint* params);
		void glGetVertexAttribPointerv(GLuint index, GLenum pname, GLvoid** pointer);
		GLboolean glIsProgram(GLuint program);
		GLboolean glIsShader(GLuint shader);
		void glLinkProgram(GLuint program);
		void glShaderSource(GLuint shader, GLsizei count, const(GLchar*)* string, const(GLint)* length);
		void glUseProgram(GLuint program);
		void glUniform1f(GLint location, GLfloat v0);
		void glUniform2f(GLint location, GLfloat v0, GLfloat v1);
		void glUniform3f(GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
		void glUniform4f(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
		void glUniform1i(GLint location, GLint v0);
		void glUniform2i(GLint location, GLint v0, GLint v1);
		void glUniform3i(GLint location, GLint v0, GLint v1, GLint v2);
		void glUniform4i(GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
		void glUniform1fv(GLint location, GLsizei count, const(GLfloat)* value);
		void glUniform2fv(GLint location, GLsizei count, const(GLfloat)* value);
		void glUniform3fv(GLint location, GLsizei count, const(GLfloat)* value);
		void glUniform4fv(GLint location, GLsizei count, const(GLfloat)* value);
		void glUniform1iv(GLint location, GLsizei count, const(GLint)* value);
		void glUniform2iv(GLint location, GLsizei count, const(GLint)* value);
		void glUniform3iv(GLint location, GLsizei count, const(GLint)* value);
		void glUniform4iv(GLint location, GLsizei count, const(GLint)* value);
		void glUniformMatrix2fv(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value);
		void glUniformMatrix3fv(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value);
		void glUniformMatrix4fv(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value);
		void glValidateProgram(GLuint program);
		void glVertexAttrib1d(GLuint index, GLdouble x);
		void glVertexAttrib1dv(GLuint index, const(GLdouble)* v);
		void glVertexAttrib1f(GLuint index, GLfloat x);
		void glVertexAttrib1fv(GLuint index, const(GLfloat)* v);
		void glVertexAttrib1s(GLuint index, GLshort x);
		void glVertexAttrib1sv(GLuint index, const(GLshort)* v);
		void glVertexAttrib2d(GLuint index, GLdouble x, GLdouble y);
		void glVertexAttrib2dv(GLuint index, const(GLdouble)* v);
		void glVertexAttrib2f(GLuint index, GLfloat x, GLfloat y);
		void glVertexAttrib2fv(GLuint index, const(GLfloat)* v);
		void glVertexAttrib2s(GLuint index, GLshort x, GLshort y);
		void glVertexAttrib2sv(GLuint index, const(GLshort)* v);
		void glVertexAttrib3d(GLuint index, GLdouble x, GLdouble y, GLdouble z);
		void glVertexAttrib3dv(GLuint index, const(GLdouble)* v);
		void glVertexAttrib3f(GLuint index, GLfloat x, GLfloat y, GLfloat z);
		void glVertexAttrib3fv(GLuint index, const(GLfloat)* v);
		void glVertexAttrib3s(GLuint index, GLshort x, GLshort y, GLshort z);
		void glVertexAttrib3sv(GLuint index, const(GLshort)* v);
		void glVertexAttrib4Nbv(GLuint index, const(GLbyte)* v);
		void glVertexAttrib4Niv(GLuint index, const(GLint)* v);
		void glVertexAttrib4Nsv(GLuint index, const(GLshort)* v);
		void glVertexAttrib4Nub(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
		void glVertexAttrib4Nubv(GLuint index, const(GLubyte)* v);
		void glVertexAttrib4Nuiv(GLuint index, const(GLuint)* v);
		void glVertexAttrib4Nusv(GLuint index, const(GLushort)* v);
		void glVertexAttrib4bv(GLuint index, const(GLbyte)* v);
		void glVertexAttrib4d(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		void glVertexAttrib4dv(GLuint index, const(GLdouble)* v);
		void glVertexAttrib4f(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glVertexAttrib4fv(GLuint index, const(GLfloat)* v);
		void glVertexAttrib4iv(GLuint index, const(GLint)* v);
		void glVertexAttrib4s(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
		void glVertexAttrib4sv(GLuint index, const(GLshort)* v);
		void glVertexAttrib4ubv(GLuint index, const(GLubyte)* v);
		void glVertexAttrib4uiv(GLuint index, const(GLuint)* v);
		void glVertexAttrib4usv(GLuint index, const(GLushort)* v);
		void glVertexAttribPointer(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const(GLvoid)* pointer);

		alias void function(GLenum modeRGB, GLenum modeAlpha) PFNGLBLENDEQUATIONSEPARATEPROC;
		alias void function(GLsizei n, const(GLenum)* bufs) PFNGLDRAWBUFFERSPROC;
		alias void function(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass) PFNGLSTENCILOPSEPARATEPROC;
		alias void function(GLenum frontfunc, GLenum backfunc, GLint reference, GLuint mask) PFNGLSTENCILFUNCSEPARATEPROC;
		alias void function(GLenum face, GLuint mask) PFNGLSTENCILMASKSEPARATEPROC;
		alias void function(GLuint program, GLuint shader) PFNGLATTACHSHADERPROC;
		alias void function(GLuint program, GLuint index, const(GLchar)* name) PFNGLBINDATTRIBLOCATIONPROC;
		alias void function(GLuint shader) PFNGLCOMPILESHADERPROC;
		alias GLuint function() PFNGLCREATEPROGRAMPROC;
		alias GLuint function(GLenum type) PFNGLCREATESHADERPROC;
		alias void function(GLuint program) PFNGLDELETEPROGRAMPROC;
		alias void function(GLuint shader) PFNGLDELETESHADERPROC;
		alias void function(GLuint program, GLuint shader) PFNGLDETACHSHADERPROC;
		alias void function(GLuint index) PFNGLDISABLEVERTEXATTRIBARRAYPROC;
		alias void function(GLuint index) PFNGLENABLEVERTEXATTRIBARRAYPROC;
		alias void function(GLuint program, GLuint index, GLsizei bufSize, GLsizei* length, GLint* size, GLenum* type, GLchar* name) PFNGLGETACTIVEATTRIBPROC;
		alias void function(GLuint program, GLuint index, GLsizei bufSize, GLsizei* length, GLint* size, GLenum* type, GLchar* name) PFNGLGETACTIVEUNIFORMPROC;
		alias void function(GLuint program, GLsizei maxCount, GLsizei* count, GLuint* obj) PFNGLGETATTACHEDSHADERSPROC;
		alias GLint function(GLuint program, const(GLchar)* name) PFNGLGETATTRIBLOCATIONPROC;
		alias void function(GLuint program, GLenum pname, GLint* params) PFNGLGETPROGRAMIVPROC;
		alias void function(GLuint program, GLsizei bufSize, GLsizei* length, GLchar* infoLog) PFNGLGETPROGRAMINFOLOGPROC;
		alias void function(GLuint shader, GLenum pname, GLint* params) PFNGLGETSHADERIVPROC;
		alias void function(GLuint shader, GLsizei bufSize, GLsizei* length, GLchar* infoLog) PFNGLGETSHADERINFOLOGPROC;
		alias void function(GLuint shader, GLsizei bufSize, GLsizei* length, GLchar* source) PFNGLGETSHADERSOURCEPROC;
		alias GLint function(GLuint program, const(GLchar)* name) PFNGLGETUNIFORMLOCATIONPROC;
		alias void function(GLuint program, GLint location, GLfloat* params) PFNGLGETUNIFORMFVPROC;
		alias void function(GLuint program, GLint location, GLint* params) PFNGLGETUNIFORMIVPROC;
		alias void function(GLuint index, GLenum pname, GLdouble* params) PFNGLGETVERTEXATTRIBDVPROC;
		alias void function(GLuint index, GLenum pname, GLfloat* params) PFNGLGETVERTEXATTRIBFVPROC;
		alias void function(GLuint index, GLenum pname, GLint* params) PFNGLGETVERTEXATTRIBIVPROC;
		alias void function(GLuint index, GLenum pname, GLvoid** pointer) PFNGLGETVERTEXATTRIBPOINTERVPROC;
		alias GLboolean function(GLuint program) PFNGLISPROGRAMPROC;
		alias GLboolean function(GLuint shader) PFNGLISSHADERPROC;
		alias void function(GLuint program) PFNGLLINKPROGRAMPROC;
		alias void function(GLuint shader, GLsizei count, const(GLchar*)* string, const(GLint)* length) PFNGLSHADERSOURCEPROC;
		alias void function(GLuint program) PFNGLUSEPROGRAMPROC;
		alias void function(GLint location, GLfloat v0) PFNGLUNIFORM1FPROC;
		alias void function(GLint location, GLfloat v0, GLfloat v1) PFNGLUNIFORM2FPROC;
		alias void function(GLint location, GLfloat v0, GLfloat v1, GLfloat v2) PFNGLUNIFORM3FPROC;
		alias void function(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3) PFNGLUNIFORM4FPROC;
		alias void function(GLint location, GLint v0) PFNGLUNIFORM1IPROC;
		alias void function(GLint location, GLint v0, GLint v1) PFNGLUNIFORM2IPROC;
		alias void function(GLint location, GLint v0, GLint v1, GLint v2) PFNGLUNIFORM3IPROC;
		alias void function(GLint location, GLint v0, GLint v1, GLint v2, GLint v3) PFNGLUNIFORM4IPROC;
		alias void function(GLint location, GLsizei count, const(GLfloat)* value) PFNGLUNIFORM1FVPROC;
		alias void function(GLint location, GLsizei count, const(GLfloat)* value) PFNGLUNIFORM2FVPROC;
		alias void function(GLint location, GLsizei count, const(GLfloat)* value) PFNGLUNIFORM3FVPROC;
		alias void function(GLint location, GLsizei count, const(GLfloat)* value) PFNGLUNIFORM4FVPROC;
		alias void function(GLint location, GLsizei count, const(GLint)* value) PFNGLUNIFORM1IVPROC;
		alias void function(GLint location, GLsizei count, const(GLint)* value) PFNGLUNIFORM2IVPROC;
		alias void function(GLint location, GLsizei count, const(GLint)* value) PFNGLUNIFORM3IVPROC;
		alias void function(GLint location, GLsizei count, const(GLint)* value) PFNGLUNIFORM4IVPROC;
		alias void function(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value) PFNGLUNIFORMMATRIX2FVPROC;
		alias void function(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value) PFNGLUNIFORMMATRIX3FVPROC;
		alias void function(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value) PFNGLUNIFORMMATRIX4FVPROC;
		alias void function(GLuint program) PFNGLVALIDATEPROGRAMPROC;
		alias void function(GLuint index, GLdouble x) PFNGLVERTEXATTRIB1DPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB1DVPROC;
		alias void function(GLuint index, GLfloat x) PFNGLVERTEXATTRIB1FPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB1FVPROC;
		alias void function(GLuint index, GLshort x) PFNGLVERTEXATTRIB1SPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB1SVPROC;
		alias void function(GLuint index, GLdouble x, GLdouble y) PFNGLVERTEXATTRIB2DPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB2DVPROC;
		alias void function(GLuint index, GLfloat x, GLfloat y) PFNGLVERTEXATTRIB2FPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB2FVPROC;
		alias void function(GLuint index, GLshort x, GLshort y) PFNGLVERTEXATTRIB2SPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB2SVPROC;
		alias void function(GLuint index, GLdouble x, GLdouble y, GLdouble z) PFNGLVERTEXATTRIB3DPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB3DVPROC;
		alias void function(GLuint index, GLfloat x, GLfloat y, GLfloat z) PFNGLVERTEXATTRIB3FPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB3FVPROC;
		alias void function(GLuint index, GLshort x, GLshort y, GLshort z) PFNGLVERTEXATTRIB3SPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB3SVPROC;
		alias void function(GLuint index, const(GLbyte)* v) PFNGLVERTEXATTRIB4NBVPROC;
		alias void function(GLuint index, const(GLint)* v) PFNGLVERTEXATTRIB4NIVPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB4NSVPROC;
		alias void function(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w) PFNGLVERTEXATTRIB4NUBPROC;
		alias void function(GLuint index, const(GLubyte)* v) PFNGLVERTEXATTRIB4NUBVPROC;
		alias void function(GLuint index, const(GLuint)* v) PFNGLVERTEXATTRIB4NUIVPROC;
		alias void function(GLuint index, const(GLushort)* v) PFNGLVERTEXATTRIB4NUSVPROC;
		alias void function(GLuint index, const(GLbyte)* v) PFNGLVERTEXATTRIB4BVPROC;
		alias void function(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w) PFNGLVERTEXATTRIB4DPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB4DVPROC;
		alias void function(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLVERTEXATTRIB4FPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB4FVPROC;
		alias void function(GLuint index, const(GLint)* v) PFNGLVERTEXATTRIB4IVPROC;
		alias void function(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w) PFNGLVERTEXATTRIB4SPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB4SVPROC;
		alias void function(GLuint index, const(GLubyte)* v) PFNGLVERTEXATTRIB4UBVPROC;
		alias void function(GLuint index, const(GLuint)* v) PFNGLVERTEXATTRIB4UIVPROC;
		alias void function(GLuint index, const(GLushort)* v) PFNGLVERTEXATTRIB4USVPROC;
		alias void function(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const(GLvoid)* pointer) PFNGLVERTEXATTRIBPOINTERPROC;
	}
}

version (GL_ARB_multitexture)
{
}
else
{
	extern (C)
	{
		void glActiveTextureARB(GLenum texture);
		void glClientActiveTextureARB(GLenum texture);
		void glMultiTexCoord1dARB(GLenum target, GLdouble s);
		void glMultiTexCoord1dvARB(GLenum target, const(GLdouble)* v);
		void glMultiTexCoord1fARB(GLenum target, GLfloat s);
		void glMultiTexCoord1fvARB(GLenum target, const(GLfloat)* v);
		void glMultiTexCoord1iARB(GLenum target, GLint s);
		void glMultiTexCoord1ivARB(GLenum target, const(GLint)* v);
		void glMultiTexCoord1sARB(GLenum target, GLshort s);
		void glMultiTexCoord1svARB(GLenum target, const(GLshort)* v);
		void glMultiTexCoord2dARB(GLenum target, GLdouble s, GLdouble t);
		void glMultiTexCoord2dvARB(GLenum target, const(GLdouble)* v);
		void glMultiTexCoord2fARB(GLenum target, GLfloat s, GLfloat t);
		void glMultiTexCoord2fvARB(GLenum target, const(GLfloat)* v);
		void glMultiTexCoord2iARB(GLenum target, GLint s, GLint t);
		void glMultiTexCoord2ivARB(GLenum target, const(GLint)* v);
		void glMultiTexCoord2sARB(GLenum target, GLshort s, GLshort t);
		void glMultiTexCoord2svARB(GLenum target, const(GLshort)* v);
		void glMultiTexCoord3dARB(GLenum target, GLdouble s, GLdouble t, GLdouble r);
		void glMultiTexCoord3dvARB(GLenum target, const(GLdouble)* v);
		void glMultiTexCoord3fARB(GLenum target, GLfloat s, GLfloat t, GLfloat r);
		void glMultiTexCoord3fvARB(GLenum target, const(GLfloat)* v);
		void glMultiTexCoord3iARB(GLenum target, GLint s, GLint t, GLint r);
		void glMultiTexCoord3ivARB(GLenum target, const(GLint)* v);
		void glMultiTexCoord3sARB(GLenum target, GLshort s, GLshort t, GLshort r);
		void glMultiTexCoord3svARB(GLenum target, const(GLshort)* v);
		void glMultiTexCoord4dARB(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
		void glMultiTexCoord4dvARB(GLenum target, const(GLdouble)* v);
		void glMultiTexCoord4fARB(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
		void glMultiTexCoord4fvARB(GLenum target, const(GLfloat)* v);
		void glMultiTexCoord4iARB(GLenum target, GLint s, GLint t, GLint r, GLint q);
		void glMultiTexCoord4ivARB(GLenum target, const(GLint)* v);
		void glMultiTexCoord4sARB(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
		void glMultiTexCoord4svARB(GLenum target, const(GLshort)* v);

		alias void function(GLenum texture) PFNGLACTIVETEXTUREARBPROC;
		alias void function(GLenum texture) PFNGLCLIENTACTIVETEXTUREARBPROC;
		alias void function(GLenum target, GLdouble s) PFNGLMULTITEXCOORD1DARBPROC;
		alias void function(GLenum target, const(GLdouble)* v) PFNGLMULTITEXCOORD1DVARBPROC;
		alias void function(GLenum target, GLfloat s) PFNGLMULTITEXCOORD1FARBPROC;
		alias void function(GLenum target, const(GLfloat)* v) PFNGLMULTITEXCOORD1FVARBPROC;
		alias void function(GLenum target, GLint s) PFNGLMULTITEXCOORD1IARBPROC;
		alias void function(GLenum target, const(GLint)* v) PFNGLMULTITEXCOORD1IVARBPROC;
		alias void function(GLenum target, GLshort s) PFNGLMULTITEXCOORD1SARBPROC;
		alias void function(GLenum target, const(GLshort)* v) PFNGLMULTITEXCOORD1SVARBPROC;
		alias void function(GLenum target, GLdouble s, GLdouble t) PFNGLMULTITEXCOORD2DARBPROC;
		alias void function(GLenum target, const(GLdouble)* v) PFNGLMULTITEXCOORD2DVARBPROC;
		alias void function(GLenum target, GLfloat s, GLfloat t) PFNGLMULTITEXCOORD2FARBPROC;
		alias void function(GLenum target, const(GLfloat)* v) PFNGLMULTITEXCOORD2FVARBPROC;
		alias void function(GLenum target, GLint s, GLint t) PFNGLMULTITEXCOORD2IARBPROC;
		alias void function(GLenum target, const(GLint)* v) PFNGLMULTITEXCOORD2IVARBPROC;
		alias void function(GLenum target, GLshort s, GLshort t) PFNGLMULTITEXCOORD2SARBPROC;
		alias void function(GLenum target, const(GLshort)* v) PFNGLMULTITEXCOORD2SVARBPROC;
		alias void function(GLenum target, GLdouble s, GLdouble t, GLdouble r) PFNGLMULTITEXCOORD3DARBPROC;
		alias void function(GLenum target, const(GLdouble)* v) PFNGLMULTITEXCOORD3DVARBPROC;
		alias void function(GLenum target, GLfloat s, GLfloat t, GLfloat r) PFNGLMULTITEXCOORD3FARBPROC;
		alias void function(GLenum target, const(GLfloat)* v) PFNGLMULTITEXCOORD3FVARBPROC;
		alias void function(GLenum target, GLint s, GLint t, GLint r) PFNGLMULTITEXCOORD3IARBPROC;
		alias void function(GLenum target, const(GLint)* v) PFNGLMULTITEXCOORD3IVARBPROC;
		alias void function(GLenum target, GLshort s, GLshort t, GLshort r) PFNGLMULTITEXCOORD3SARBPROC;
		alias void function(GLenum target, const(GLshort)* v) PFNGLMULTITEXCOORD3SVARBPROC;
		alias void function(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q) PFNGLMULTITEXCOORD4DARBPROC;
		alias void function(GLenum target, const(GLdouble)* v) PFNGLMULTITEXCOORD4DVARBPROC;
		alias void function(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q) PFNGLMULTITEXCOORD4FARBPROC;
		alias void function(GLenum target, const(GLfloat)* v) PFNGLMULTITEXCOORD4FVARBPROC;
		alias void function(GLenum target, GLint s, GLint t, GLint r, GLint q) PFNGLMULTITEXCOORD4IARBPROC;
		alias void function(GLenum target, const(GLint)* v) PFNGLMULTITEXCOORD4IVARBPROC;
		alias void function(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q) PFNGLMULTITEXCOORD4SARBPROC;
		alias void function(GLenum target, const(GLshort)* v) PFNGLMULTITEXCOORD4SVARBPROC;
	}
}

version (GL_ARB_transpose_matrix)
{
}
else
{
	extern (C)
	{
		void glLoadTransposeMatrixfARB(const(GLfloat)* m);
		void glLoadTransposeMatrixdARB(const(GLdouble)* m);
		void glMultTransposeMatrixfARB(const(GLfloat)* m);
		void glMultTransposeMatrixdARB(const(GLdouble)* m);

		alias void function(const(GLfloat)* m) PFNGLLOADTRANSPOSEMATRIXFARBPROC;
		alias void function(const(GLdouble)* m) PFNGLLOADTRANSPOSEMATRIXDARBPROC;
		alias void function(const(GLfloat)* m) PFNGLMULTTRANSPOSEMATRIXFARBPROC;
		alias void function(const(GLdouble)* m) PFNGLMULTTRANSPOSEMATRIXDARBPROC;
	}
}

version (GL_ARB_multisample)
{
}
else
{
	extern (C)
	{
		void glSampleCoverageARB(GLclampf value, GLboolean invert);

		alias void function(GLclampf value, GLboolean invert) PFNGLSAMPLECOVERAGEARBPROC;
	}
}

version (GL_ARB_texture_env_add)
{
}
else
{
}

version (GL_ARB_texture_cube_map)
{
}
else
{
}

version (GL_ARB_texture_compression)
{
}
else
{
	extern (C)
	{
		void glCompressedTexImage3DARB(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const(GLvoid)* data);
		void glCompressedTexImage2DARB(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const(GLvoid)* data);
		void glCompressedTexImage1DARB(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const(GLvoid)* data);
		void glCompressedTexSubImage3DARB(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const(GLvoid)* data);
		void glCompressedTexSubImage2DARB(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const(GLvoid)* data);
		void glCompressedTexSubImage1DARB(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const(GLvoid)* data);
		void glGetCompressedTexImageARB(GLenum target, GLint level, GLvoid* img);

		alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXIMAGE3DARBPROC;
		alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXIMAGE2DARBPROC;
		alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXIMAGE1DARBPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const(GLvoid)* data) PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC;
		alias void function(GLenum target, GLint level, GLvoid* img) PFNGLGETCOMPRESSEDTEXIMAGEARBPROC;
	}
}

version (GL_ARB_texture_border_clamp)
{
}
else
{
}

version (GL_ARB_point_parameters)
{
}
else
{
	extern (C)
	{
		void glPointParameterfARB(GLenum pname, GLfloat param);
		void glPointParameterfvARB(GLenum pname, const(GLfloat)* params);

		alias void function(GLenum pname, GLfloat param) PFNGLPOINTPARAMETERFARBPROC;
		alias void function(GLenum pname, const(GLfloat)* params) PFNGLPOINTPARAMETERFVARBPROC;
	}
}

version (GL_ARB_vertex_blend)
{
}
else
{
	extern (C)
	{
		void glWeightbvARB(GLint size, const(GLbyte)* weights);
		void glWeightsvARB(GLint size, const(GLshort)* weights);
		void glWeightivARB(GLint size, const(GLint)* weights);
		void glWeightfvARB(GLint size, const(GLfloat)* weights);
		void glWeightdvARB(GLint size, const(GLdouble)* weights);
		void glWeightubvARB(GLint size, const(GLubyte)* weights);
		void glWeightusvARB(GLint size, const(GLushort)* weights);
		void glWeightuivARB(GLint size, const(GLuint)* weights);
		void glWeightPointerARB(GLint size, GLenum type, GLsizei stride, const(GLvoid)* pointer);
		void glVertexBlendARB(GLint count);

		alias void function(GLint size, const(GLbyte)* weights) PFNGLWEIGHTBVARBPROC;
		alias void function(GLint size, const(GLshort)* weights) PFNGLWEIGHTSVARBPROC;
		alias void function(GLint size, const(GLint)* weights) PFNGLWEIGHTIVARBPROC;
		alias void function(GLint size, const(GLfloat)* weights) PFNGLWEIGHTFVARBPROC;
		alias void function(GLint size, const(GLdouble)* weights) PFNGLWEIGHTDVARBPROC;
		alias void function(GLint size, const(GLubyte)* weights) PFNGLWEIGHTUBVARBPROC;
		alias void function(GLint size, const(GLushort)* weights) PFNGLWEIGHTUSVARBPROC;
		alias void function(GLint size, const(GLuint)* weights) PFNGLWEIGHTUIVARBPROC;
		alias void function(GLint size, GLenum type, GLsizei stride, const(GLvoid)* pointer) PFNGLWEIGHTPOINTERARBPROC;
		alias void function(GLint count) PFNGLVERTEXBLENDARBPROC;
	}
}

version (GL_ARB_matrix_palette)
{
}
else
{
	extern (C)
	{
		void glCurrentPaletteMatrixARB(GLint index);
		void glMatrixIndexubvARB(GLint size, const(GLubyte)* indices);
		void glMatrixIndexusvARB(GLint size, const(GLushort)* indices);
		void glMatrixIndexuivARB(GLint size, const(GLuint)* indices);
		void glMatrixIndexPointerARB(GLint size, GLenum type, GLsizei stride, const(GLvoid)* pointer);

		alias void function(GLint index) PFNGLCURRENTPALETTEMATRIXARBPROC;
		alias void function(GLint size, const(GLubyte)* indices) PFNGLMATRIXINDEXUBVARBPROC;
		alias void function(GLint size, const(GLushort)* indices) PFNGLMATRIXINDEXUSVARBPROC;
		alias void function(GLint size, const(GLuint)* indices) PFNGLMATRIXINDEXUIVARBPROC;
		alias void function(GLint size, GLenum type, GLsizei stride, const(GLvoid)* pointer) PFNGLMATRIXINDEXPOINTERARBPROC;
	}
}

version (GL_ARB_texture_env_combine)
{
}
else
{
}

version (GL_ARB_texture_env_crossbar)
{
}
else
{
}

version (GL_ARB_texture_env_dot3)
{
}
else
{
}

version (GL_ARB_texture_mirrored_repeat)
{
}
else
{
}

version (GL_ARB_depth_texture)
{
}
else
{
}

version (GL_ARB_shadow)
{
}
else
{
}

version (GL_ARB_shadow_ambient)
{
}
else
{
}

version (GL_ARB_window_pos)
{
}
else
{
	extern (C)
	{
		void glWindowPos2dARB(GLdouble x, GLdouble y);
		void glWindowPos2dvARB(const(GLdouble)* v);
		void glWindowPos2fARB(GLfloat x, GLfloat y);
		void glWindowPos2fvARB(const(GLfloat)* v);
		void glWindowPos2iARB(GLint x, GLint y);
		void glWindowPos2ivARB(const(GLint)* v);
		void glWindowPos2sARB(GLshort x, GLshort y);
		void glWindowPos2svARB(const(GLshort)* v);
		void glWindowPos3dARB(GLdouble x, GLdouble y, GLdouble z);
		void glWindowPos3dvARB(const(GLdouble)* v);
		void glWindowPos3fARB(GLfloat x, GLfloat y, GLfloat z);
		void glWindowPos3fvARB(const(GLfloat)* v);
		void glWindowPos3iARB(GLint x, GLint y, GLint z);
		void glWindowPos3ivARB(const(GLint)* v);
		void glWindowPos3sARB(GLshort x, GLshort y, GLshort z);
		void glWindowPos3svARB(const(GLshort)* v);

		alias void function(GLdouble x, GLdouble y) PFNGLWINDOWPOS2DARBPROC;
		alias void function(const(GLdouble)* v) PFNGLWINDOWPOS2DVARBPROC;
		alias void function(GLfloat x, GLfloat y) PFNGLWINDOWPOS2FARBPROC;
		alias void function(const(GLfloat)* v) PFNGLWINDOWPOS2FVARBPROC;
		alias void function(GLint x, GLint y) PFNGLWINDOWPOS2IARBPROC;
		alias void function(const(GLint)* v) PFNGLWINDOWPOS2IVARBPROC;
		alias void function(GLshort x, GLshort y) PFNGLWINDOWPOS2SARBPROC;
		alias void function(const(GLshort)* v) PFNGLWINDOWPOS2SVARBPROC;
		alias void function(GLdouble x, GLdouble y, GLdouble z) PFNGLWINDOWPOS3DARBPROC;
		alias void function(const(GLdouble)* v) PFNGLWINDOWPOS3DVARBPROC;
		alias void function(GLfloat x, GLfloat y, GLfloat z) PFNGLWINDOWPOS3FARBPROC;
		alias void function(const(GLfloat)* v) PFNGLWINDOWPOS3FVARBPROC;
		alias void function(GLint x, GLint y, GLint z) PFNGLWINDOWPOS3IARBPROC;
		alias void function(const(GLint)* v) PFNGLWINDOWPOS3IVARBPROC;
		alias void function(GLshort x, GLshort y, GLshort z) PFNGLWINDOWPOS3SARBPROC;
		alias void function(const(GLshort)* v) PFNGLWINDOWPOS3SVARBPROC;
	}
}

version (GL_ARB_vertex_program)
{
}
else
{
	extern (C)
	{
		void glVertexAttrib1dARB(GLuint index, GLdouble x);
		void glVertexAttrib1dvARB(GLuint index, const(GLdouble)* v);
		void glVertexAttrib1fARB(GLuint index, GLfloat x);
		void glVertexAttrib1fvARB(GLuint index, const(GLfloat)* v);
		void glVertexAttrib1sARB(GLuint index, GLshort x);
		void glVertexAttrib1svARB(GLuint index, const(GLshort)* v);
		void glVertexAttrib2dARB(GLuint index, GLdouble x, GLdouble y);
		void glVertexAttrib2dvARB(GLuint index, const(GLdouble)* v);
		void glVertexAttrib2fARB(GLuint index, GLfloat x, GLfloat y);
		void glVertexAttrib2fvARB(GLuint index, const(GLfloat)* v);
		void glVertexAttrib2sARB(GLuint index, GLshort x, GLshort y);
		void glVertexAttrib2svARB(GLuint index, const(GLshort)* v);
		void glVertexAttrib3dARB(GLuint index, GLdouble x, GLdouble y, GLdouble z);
		void glVertexAttrib3dvARB(GLuint index, const(GLdouble)* v);
		void glVertexAttrib3fARB(GLuint index, GLfloat x, GLfloat y, GLfloat z);
		void glVertexAttrib3fvARB(GLuint index, const(GLfloat)* v);
		void glVertexAttrib3sARB(GLuint index, GLshort x, GLshort y, GLshort z);
		void glVertexAttrib3svARB(GLuint index, const(GLshort)* v);
		void glVertexAttrib4NbvARB(GLuint index, const(GLbyte)* v);
		void glVertexAttrib4NivARB(GLuint index, const(GLint)* v);
		void glVertexAttrib4NsvARB(GLuint index, const(GLshort)* v);
		void glVertexAttrib4NubARB(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
		void glVertexAttrib4NubvARB(GLuint index, const(GLubyte)* v);
		void glVertexAttrib4NuivARB(GLuint index, const(GLuint)* v);
		void glVertexAttrib4NusvARB(GLuint index, const(GLushort)* v);
		void glVertexAttrib4bvARB(GLuint index, const(GLbyte)* v);
		void glVertexAttrib4dARB(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		void glVertexAttrib4dvARB(GLuint index, const(GLdouble)* v);
		void glVertexAttrib4fARB(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glVertexAttrib4fvARB(GLuint index, const(GLfloat)* v);
		void glVertexAttrib4ivARB(GLuint index, const(GLint)* v);
		void glVertexAttrib4sARB(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
		void glVertexAttrib4svARB(GLuint index, const(GLshort)* v);
		void glVertexAttrib4ubvARB(GLuint index, const(GLubyte)* v);
		void glVertexAttrib4uivARB(GLuint index, const(GLuint)* v);
		void glVertexAttrib4usvARB(GLuint index, const(GLushort)* v);
		void glVertexAttribPointerARB(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const(GLvoid)* pointer);
		void glEnableVertexAttribArrayARB(GLuint index);
		void glDisableVertexAttribArrayARB(GLuint index);
		void glProgramStringARB(GLenum target, GLenum format, GLsizei len, const(GLvoid)* string);
		void glBindProgramARB(GLenum target, GLuint program);
		void glDeleteProgramsARB(GLsizei n, const(GLuint)* programs);
		void glGenProgramsARB(GLsizei n, GLuint* programs);
		void glProgramEnvParameter4dARB(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		void glProgramEnvParameter4dvARB(GLenum target, GLuint index, const(GLdouble)* params);
		void glProgramEnvParameter4fARB(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glProgramEnvParameter4fvARB(GLenum target, GLuint index, const(GLfloat)* params);
		void glProgramLocalParameter4dARB(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		void glProgramLocalParameter4dvARB(GLenum target, GLuint index, const(GLdouble)* params);
		void glProgramLocalParameter4fARB(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glProgramLocalParameter4fvARB(GLenum target, GLuint index, const(GLfloat)* params);
		void glGetProgramEnvParameterdvARB(GLenum target, GLuint index, GLdouble* params);
		void glGetProgramEnvParameterfvARB(GLenum target, GLuint index, GLfloat* params);
		void glGetProgramLocalParameterdvARB(GLenum target, GLuint index, GLdouble* params);
		void glGetProgramLocalParameterfvARB(GLenum target, GLuint index, GLfloat* params);
		void glGetProgramivARB(GLenum target, GLenum pname, GLint* params);
		void glGetProgramStringARB(GLenum target, GLenum pname, GLvoid* string);
		void glGetVertexAttribdvARB(GLuint index, GLenum pname, GLdouble* params);
		void glGetVertexAttribfvARB(GLuint index, GLenum pname, GLfloat* params);
		void glGetVertexAttribivARB(GLuint index, GLenum pname, GLint* params);
		void glGetVertexAttribPointervARB(GLuint index, GLenum pname, GLvoid** pointer);
		GLboolean glIsProgramARB(GLuint program);

		alias void function(GLuint index, GLdouble x) PFNGLVERTEXATTRIB1DARBPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB1DVARBPROC;
		alias void function(GLuint index, GLfloat x) PFNGLVERTEXATTRIB1FARBPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB1FVARBPROC;
		alias void function(GLuint index, GLshort x) PFNGLVERTEXATTRIB1SARBPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB1SVARBPROC;
		alias void function(GLuint index, GLdouble x, GLdouble y) PFNGLVERTEXATTRIB2DARBPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB2DVARBPROC;
		alias void function(GLuint index, GLfloat x, GLfloat y) PFNGLVERTEXATTRIB2FARBPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB2FVARBPROC;
		alias void function(GLuint index, GLshort x, GLshort y) PFNGLVERTEXATTRIB2SARBPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB2SVARBPROC;
		alias void function(GLuint index, GLdouble x, GLdouble y, GLdouble z) PFNGLVERTEXATTRIB3DARBPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB3DVARBPROC;
		alias void function(GLuint index, GLfloat x, GLfloat y, GLfloat z) PFNGLVERTEXATTRIB3FARBPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB3FVARBPROC;
		alias void function(GLuint index, GLshort x, GLshort y, GLshort z) PFNGLVERTEXATTRIB3SARBPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB3SVARBPROC;
		alias void function(GLuint index, const(GLbyte)* v) PFNGLVERTEXATTRIB4NBVARBPROC;
		alias void function(GLuint index, const(GLint)* v) PFNGLVERTEXATTRIB4NIVARBPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB4NSVARBPROC;
		alias void function(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w) PFNGLVERTEXATTRIB4NUBARBPROC;
		alias void function(GLuint index, const(GLubyte)* v) PFNGLVERTEXATTRIB4NUBVARBPROC;
		alias void function(GLuint index, const(GLuint)* v) PFNGLVERTEXATTRIB4NUIVARBPROC;
		alias void function(GLuint index, const(GLushort)* v) PFNGLVERTEXATTRIB4NUSVARBPROC;
		alias void function(GLuint index, const(GLbyte)* v) PFNGLVERTEXATTRIB4BVARBPROC;
		alias void function(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w) PFNGLVERTEXATTRIB4DARBPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB4DVARBPROC;
		alias void function(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLVERTEXATTRIB4FARBPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB4FVARBPROC;
		alias void function(GLuint index, const(GLint)* v) PFNGLVERTEXATTRIB4IVARBPROC;
		alias void function(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w) PFNGLVERTEXATTRIB4SARBPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB4SVARBPROC;
		alias void function(GLuint index, const(GLubyte)* v) PFNGLVERTEXATTRIB4UBVARBPROC;
		alias void function(GLuint index, const(GLuint)* v) PFNGLVERTEXATTRIB4UIVARBPROC;
		alias void function(GLuint index, const(GLushort)* v) PFNGLVERTEXATTRIB4USVARBPROC;
		alias void function(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const(GLvoid)* pointer) PFNGLVERTEXATTRIBPOINTERARBPROC;
		alias void function(GLuint index) PFNGLENABLEVERTEXATTRIBARRAYARBPROC;
		alias void function(GLuint index) PFNGLDISABLEVERTEXATTRIBARRAYARBPROC;
		alias void function(GLenum target, GLenum format, GLsizei len, const(GLvoid)* string) PFNGLPROGRAMSTRINGARBPROC;
		alias void function(GLenum target, GLuint program) PFNGLBINDPROGRAMARBPROC;
		alias void function(GLsizei n, const(GLuint)* programs) PFNGLDELETEPROGRAMSARBPROC;
		alias void function(GLsizei n, GLuint* programs) PFNGLGENPROGRAMSARBPROC;
		alias void function(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w) PFNGLPROGRAMENVPARAMETER4DARBPROC;
		alias void function(GLenum target, GLuint index, const(GLdouble)* params) PFNGLPROGRAMENVPARAMETER4DVARBPROC;
		alias void function(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLPROGRAMENVPARAMETER4FARBPROC;
		alias void function(GLenum target, GLuint index, const(GLfloat)* params) PFNGLPROGRAMENVPARAMETER4FVARBPROC;
		alias void function(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w) PFNGLPROGRAMLOCALPARAMETER4DARBPROC;
		alias void function(GLenum target, GLuint index, const(GLdouble)* params) PFNGLPROGRAMLOCALPARAMETER4DVARBPROC;
		alias void function(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLPROGRAMLOCALPARAMETER4FARBPROC;
		alias void function(GLenum target, GLuint index, const(GLfloat)* params) PFNGLPROGRAMLOCALPARAMETER4FVARBPROC;
		alias void function(GLenum target, GLuint index, GLdouble* params) PFNGLGETPROGRAMENVPARAMETERDVARBPROC;
		alias void function(GLenum target, GLuint index, GLfloat* params) PFNGLGETPROGRAMENVPARAMETERFVARBPROC;
		alias void function(GLenum target, GLuint index, GLdouble* params) PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC;
		alias void function(GLenum target, GLuint index, GLfloat* params) PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETPROGRAMIVARBPROC;
		alias void function(GLenum target, GLenum pname, GLvoid* string) PFNGLGETPROGRAMSTRINGARBPROC;
		alias void function(GLuint index, GLenum pname, GLdouble* params) PFNGLGETVERTEXATTRIBDVARBPROC;
		alias void function(GLuint index, GLenum pname, GLfloat* params) PFNGLGETVERTEXATTRIBFVARBPROC;
		alias void function(GLuint index, GLenum pname, GLint* params) PFNGLGETVERTEXATTRIBIVARBPROC;
		alias void function(GLuint index, GLenum pname, GLvoid** pointer) PFNGLGETVERTEXATTRIBPOINTERVARBPROC;
		alias GLboolean function(GLuint program) PFNGLISPROGRAMARBPROC;
	}
}

version (GL_ARB_fragment_program)
{
}
else
{
}

version (GL_ARB_vertex_buffer_object)
{
}
else
{
	extern (C)
	{
		void glBindBufferARB(GLenum target, GLuint buffer);
		void glDeleteBuffersARB(GLsizei n, const(GLuint)* buffers);
		void glGenBuffersARB(GLsizei n, GLuint* buffers);
		GLboolean glIsBufferARB(GLuint buffer);
		void glBufferDataARB(GLenum target, GLsizeiptrARB size, const(GLvoid)* data, GLenum usage);
		void glBufferSubDataARB(GLenum target, GLintptrARB offset, GLsizeiptrARB size, const(GLvoid)* data);
		void glGetBufferSubDataARB(GLenum target, GLintptrARB offset, GLsizeiptrARB size, GLvoid* data);
		GLvoid* glMapBufferARB(GLenum target, GLenum access);
		GLboolean glUnmapBufferARB(GLenum target);
		void glGetBufferParameterivARB(GLenum target, GLenum pname, GLint* params);
		void glGetBufferPointervARB(GLenum target, GLenum pname, GLvoid** params);

		alias void function(GLenum target, GLuint buffer) PFNGLBINDBUFFERARBPROC;
		alias void function(GLsizei n, const(GLuint)* buffers) PFNGLDELETEBUFFERSARBPROC;
		alias void function(GLsizei n, GLuint* buffers) PFNGLGENBUFFERSARBPROC;
		alias GLboolean function(GLuint buffer) PFNGLISBUFFERARBPROC;
		alias void function(GLenum target, GLsizeiptrARB size, const(GLvoid)* data, GLenum usage) PFNGLBUFFERDATAARBPROC;
		alias void function(GLenum target, GLintptrARB offset, GLsizeiptrARB size, const(GLvoid)* data) PFNGLBUFFERSUBDATAARBPROC;
		alias void function(GLenum target, GLintptrARB offset, GLsizeiptrARB size, GLvoid* data) PFNGLGETBUFFERSUBDATAARBPROC;
		alias GLvoid* function(GLenum target, GLenum access) PFNGLMAPBUFFERARBPROC;
		alias GLboolean function(GLenum target) PFNGLUNMAPBUFFERARBPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETBUFFERPARAMETERIVARBPROC;
		alias void function(GLenum target, GLenum pname, GLvoid** params) PFNGLGETBUFFERPOINTERVARBPROC;
	}
}

version (GL_ARB_occlusion_query)
{
}
else
{
	extern (C)
	{
		void glGenQueriesARB(GLsizei n, GLuint* ids);
		void glDeleteQueriesARB(GLsizei n, const(GLuint)* ids);
		GLboolean glIsQueryARB(GLuint id);
		void glBeginQueryARB(GLenum target, GLuint id);
		void glEndQueryARB(GLenum target);
		void glGetQueryivARB(GLenum target, GLenum pname, GLint* params);
		void glGetQueryObjectivARB(GLuint id, GLenum pname, GLint* params);
		void glGetQueryObjectuivARB(GLuint id, GLenum pname, GLuint* params);

		alias void function(GLsizei n, GLuint* ids) PFNGLGENQUERIESARBPROC;
		alias void function(GLsizei n, const(GLuint)* ids) PFNGLDELETEQUERIESARBPROC;
		alias GLboolean function(GLuint id) PFNGLISQUERYARBPROC;
		alias void function(GLenum target, GLuint id) PFNGLBEGINQUERYARBPROC;
		alias void function(GLenum target) PFNGLENDQUERYARBPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETQUERYIVARBPROC;
		alias void function(GLuint id, GLenum pname, GLint* params) PFNGLGETQUERYOBJECTIVARBPROC;
		alias void function(GLuint id, GLenum pname, GLuint* params) PFNGLGETQUERYOBJECTUIVARBPROC;
	}
}

version (GL_ARB_shader_objects)
{
}
else
{
	extern (C)
	{
		void glDeleteObjectARB(GLhandleARB obj);
		GLhandleARB glGetHandleARB(GLenum pname);
		void glDetachObjectARB(GLhandleARB containerObj, GLhandleARB attachedObj);
		GLhandleARB glCreateShaderObjectARB(GLenum shaderType);
		void glShaderSourceARB(GLhandleARB shaderObj, GLsizei count, const(GLcharARB*)* string, const(GLint)* length);
		void glCompileShaderARB(GLhandleARB shaderObj);
		GLhandleARB glCreateProgramObjectARB();
		void glAttachObjectARB(GLhandleARB containerObj, GLhandleARB obj);
		void glLinkProgramARB(GLhandleARB programObj);
		void glUseProgramObjectARB(GLhandleARB programObj);
		void glValidateProgramARB(GLhandleARB programObj);
		void glUniform1fARB(GLint location, GLfloat v0);
		void glUniform2fARB(GLint location, GLfloat v0, GLfloat v1);
		void glUniform3fARB(GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
		void glUniform4fARB(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
		void glUniform1iARB(GLint location, GLint v0);
		void glUniform2iARB(GLint location, GLint v0, GLint v1);
		void glUniform3iARB(GLint location, GLint v0, GLint v1, GLint v2);
		void glUniform4iARB(GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
		void glUniform1fvARB(GLint location, GLsizei count, const(GLfloat)* value);
		void glUniform2fvARB(GLint location, GLsizei count, const(GLfloat)* value);
		void glUniform3fvARB(GLint location, GLsizei count, const(GLfloat)* value);
		void glUniform4fvARB(GLint location, GLsizei count, const(GLfloat)* value);
		void glUniform1ivARB(GLint location, GLsizei count, const(GLint)* value);
		void glUniform2ivARB(GLint location, GLsizei count, const(GLint)* value);
		void glUniform3ivARB(GLint location, GLsizei count, const(GLint)* value);
		void glUniform4ivARB(GLint location, GLsizei count, const(GLint)* value);
		void glUniformMatrix2fvARB(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value);
		void glUniformMatrix3fvARB(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value);
		void glUniformMatrix4fvARB(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value);
		void glGetObjectParameterfvARB(GLhandleARB obj, GLenum pname, GLfloat* params);
		void glGetObjectParameterivARB(GLhandleARB obj, GLenum pname, GLint* params);
		void glGetInfoLogARB(GLhandleARB obj, GLsizei maxLength, GLsizei* length, GLcharARB* infoLog);
		void glGetAttachedObjectsARB(GLhandleARB containerObj, GLsizei maxCount, GLsizei* count, GLhandleARB* obj);
		GLint glGetUniformLocationARB(GLhandleARB programObj, const(GLcharARB)* name);
		void glGetActiveUniformARB(GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei* length, GLint* size, GLenum* type, GLcharARB* name);
		void glGetUniformfvARB(GLhandleARB programObj, GLint location, GLfloat* params);
		void glGetUniformivARB(GLhandleARB programObj, GLint location, GLint* params);
		void glGetShaderSourceARB(GLhandleARB obj, GLsizei maxLength, GLsizei* length, GLcharARB* source);

		alias void function(GLhandleARB obj) PFNGLDELETEOBJECTARBPROC;
		alias GLhandleARB function(GLenum pname) PFNGLGETHANDLEARBPROC;
		alias void function(GLhandleARB containerObj, GLhandleARB attachedObj) PFNGLDETACHOBJECTARBPROC;
		alias GLhandleARB function(GLenum shaderType) PFNGLCREATESHADEROBJECTARBPROC;
		alias void function(GLhandleARB shaderObj, GLsizei count, const(GLcharARB*)* string, const(GLint)* length) PFNGLSHADERSOURCEARBPROC;
		alias void function(GLhandleARB shaderObj) PFNGLCOMPILESHADERARBPROC;
		alias GLhandleARB function() PFNGLCREATEPROGRAMOBJECTARBPROC;
		alias void function(GLhandleARB containerObj, GLhandleARB obj) PFNGLATTACHOBJECTARBPROC;
		alias void function(GLhandleARB programObj) PFNGLLINKPROGRAMARBPROC;
		alias void function(GLhandleARB programObj) PFNGLUSEPROGRAMOBJECTARBPROC;
		alias void function(GLhandleARB programObj) PFNGLVALIDATEPROGRAMARBPROC;
		alias void function(GLint location, GLfloat v0) PFNGLUNIFORM1FARBPROC;
		alias void function(GLint location, GLfloat v0, GLfloat v1) PFNGLUNIFORM2FARBPROC;
		alias void function(GLint location, GLfloat v0, GLfloat v1, GLfloat v2) PFNGLUNIFORM3FARBPROC;
		alias void function(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3) PFNGLUNIFORM4FARBPROC;
		alias void function(GLint location, GLint v0) PFNGLUNIFORM1IARBPROC;
		alias void function(GLint location, GLint v0, GLint v1) PFNGLUNIFORM2IARBPROC;
		alias void function(GLint location, GLint v0, GLint v1, GLint v2) PFNGLUNIFORM3IARBPROC;
		alias void function(GLint location, GLint v0, GLint v1, GLint v2, GLint v3) PFNGLUNIFORM4IARBPROC;
		alias void function(GLint location, GLsizei count, const(GLfloat)* value) PFNGLUNIFORM1FVARBPROC;
		alias void function(GLint location, GLsizei count, const(GLfloat)* value) PFNGLUNIFORM2FVARBPROC;
		alias void function(GLint location, GLsizei count, const(GLfloat)* value) PFNGLUNIFORM3FVARBPROC;
		alias void function(GLint location, GLsizei count, const(GLfloat)* value) PFNGLUNIFORM4FVARBPROC;
		alias void function(GLint location, GLsizei count, const(GLint)* value) PFNGLUNIFORM1IVARBPROC;
		alias void function(GLint location, GLsizei count, const(GLint)* value) PFNGLUNIFORM2IVARBPROC;
		alias void function(GLint location, GLsizei count, const(GLint)* value) PFNGLUNIFORM3IVARBPROC;
		alias void function(GLint location, GLsizei count, const(GLint)* value) PFNGLUNIFORM4IVARBPROC;
		alias void function(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value) PFNGLUNIFORMMATRIX2FVARBPROC;
		alias void function(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value) PFNGLUNIFORMMATRIX3FVARBPROC;
		alias void function(GLint location, GLsizei count, GLboolean transpose, const(GLfloat)* value) PFNGLUNIFORMMATRIX4FVARBPROC;
		alias void function(GLhandleARB obj, GLenum pname, GLfloat* params) PFNGLGETOBJECTPARAMETERFVARBPROC;
		alias void function(GLhandleARB obj, GLenum pname, GLint* params) PFNGLGETOBJECTPARAMETERIVARBPROC;
		alias void function(GLhandleARB obj, GLsizei maxLength, GLsizei* length, GLcharARB* infoLog) PFNGLGETINFOLOGARBPROC;
		alias void function(GLhandleARB containerObj, GLsizei maxCount, GLsizei* count, GLhandleARB* obj) PFNGLGETATTACHEDOBJECTSARBPROC;
		alias GLint function(GLhandleARB programObj, const(GLcharARB)* name) PFNGLGETUNIFORMLOCATIONARBPROC;
		alias void function(GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei* length, GLint* size, GLenum* type, GLcharARB* name) PFNGLGETACTIVEUNIFORMARBPROC;
		alias void function(GLhandleARB programObj, GLint location, GLfloat* params) PFNGLGETUNIFORMFVARBPROC;
		alias void function(GLhandleARB programObj, GLint location, GLint* params) PFNGLGETUNIFORMIVARBPROC;
		alias void function(GLhandleARB obj, GLsizei maxLength, GLsizei* length, GLcharARB* source) PFNGLGETSHADERSOURCEARBPROC;
	}
}

version (GL_ARB_vertex_shader)
{
}
else
{
	extern (C)
	{
		void glBindAttribLocationARB(GLhandleARB programObj, GLuint index, const(GLcharARB)* name);
		void glGetActiveAttribARB(GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei* length, GLint* size, GLenum* type, GLcharARB* name);
		GLint glGetAttribLocationARB(GLhandleARB programObj, const(GLcharARB)* name);

		alias void function(GLhandleARB programObj, GLuint index, const(GLcharARB)* name) PFNGLBINDATTRIBLOCATIONARBPROC;
		alias void function(GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei* length, GLint* size, GLenum* type, GLcharARB* name) PFNGLGETACTIVEATTRIBARBPROC;
		alias GLint function(GLhandleARB programObj, const(GLcharARB)* name) PFNGLGETATTRIBLOCATIONARBPROC;
	}
}

version (GL_ARB_fragment_shader)
{
}
else
{
}

version (GL_ARB_shading_language_100)
{
}
else
{
}

version (GL_ARB_texture_non_power_of_two)
{
}
else
{
}

version (GL_ARB_point_sprite)
{
}
else
{
}

version (GL_ARB_fragment_program_shadow)
{
}
else
{
}

version (GL_ARB_draw_buffers)
{
}
else
{
	extern (C)
	{
		void glDrawBuffersARB(GLsizei n, const(GLenum)* bufs);

		alias void function(GLsizei n, const(GLenum)* bufs) PFNGLDRAWBUFFERSARBPROC;
	}
}

version (GL_ARB_texture_rectangle)
{
}
else
{
}

version (GL_ARB_color_buffer_float)
{
}
else
{
	extern (C)
	{
		void glClampColorARB(GLenum target, GLenum clamp);

		alias void function(GLenum target, GLenum clamp) PFNGLCLAMPCOLORARBPROC;
	}
}

version (GL_ARB_half_float_pixel)
{
}
else
{
}

version (GL_ARB_texture_float)
{
}
else
{
}

version (GL_ARB_pixel_buffer_object)
{
}
else
{
}

version (GL_EXT_abgr)
{
}
else
{
}

version (GL_EXT_blend_color)
{
}
else
{
	extern (C)
	{
		void glBlendColorEXT(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);

		alias void function(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha) PFNGLBLENDCOLOREXTPROC;
	}
}

version (GL_EXT_polygon_offset)
{
}
else
{
	extern (C)
	{
		void glPolygonOffsetEXT(GLfloat factor, GLfloat bias);

		alias void function(GLfloat factor, GLfloat bias) PFNGLPOLYGONOFFSETEXTPROC;
	}
}

version (GL_EXT_texture)
{
}
else
{
}

version (GL_EXT_texture3D)
{
}
else
{
	extern (C)
	{
		void glTexImage3DEXT(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const(GLvoid)* pixels);
		void glTexSubImage3DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const(GLvoid)* pixels);

		alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const(GLvoid)* pixels) PFNGLTEXIMAGE3DEXTPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const(GLvoid)* pixels) PFNGLTEXSUBIMAGE3DEXTPROC;
	}
}

version (GL_SGIS_texture_filter4)
{
}
else
{
	extern (C)
	{
		void glGetTexFilterFuncSGIS(GLenum target, GLenum filter, GLfloat* weights);
		void glTexFilterFuncSGIS(GLenum target, GLenum filter, GLsizei n, const(GLfloat)* weights);

		alias void function(GLenum target, GLenum filter, GLfloat* weights) PFNGLGETTEXFILTERFUNCSGISPROC;
		alias void function(GLenum target, GLenum filter, GLsizei n, const(GLfloat)* weights) PFNGLTEXFILTERFUNCSGISPROC;
	}
}

version (GL_EXT_subtexture)
{
}
else
{
	extern (C)
	{
		void glTexSubImage1DEXT(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const(GLvoid)* pixels);
		void glTexSubImage2DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const(GLvoid)* pixels);

		alias void function(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const(GLvoid)* pixels) PFNGLTEXSUBIMAGE1DEXTPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const(GLvoid)* pixels) PFNGLTEXSUBIMAGE2DEXTPROC;
	}
}

version (GL_EXT_copy_texture)
{
}
else
{
	extern (C)
	{
		void glCopyTexImage1DEXT(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border);
		void glCopyTexImage2DEXT(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border);
		void glCopyTexSubImage1DEXT(GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width);
		void glCopyTexSubImage2DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
		void glCopyTexSubImage3DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);

		alias void function(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border) PFNGLCOPYTEXIMAGE1DEXTPROC;
		alias void function(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border) PFNGLCOPYTEXIMAGE2DEXTPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width) PFNGLCOPYTEXSUBIMAGE1DEXTPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height) PFNGLCOPYTEXSUBIMAGE2DEXTPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height) PFNGLCOPYTEXSUBIMAGE3DEXTPROC;
	}
}

version (GL_EXT_histogram)
{
}
else
{
	extern (C)
	{
		void glGetHistogramEXT(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid* values);
		void glGetHistogramParameterfvEXT(GLenum target, GLenum pname, GLfloat* params);
		void glGetHistogramParameterivEXT(GLenum target, GLenum pname, GLint* params);
		void glGetMinmaxEXT(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid* values);
		void glGetMinmaxParameterfvEXT(GLenum target, GLenum pname, GLfloat* params);
		void glGetMinmaxParameterivEXT(GLenum target, GLenum pname, GLint* params);
		void glHistogramEXT(GLenum target, GLsizei width, GLenum internalformat, GLboolean sink);
		void glMinmaxEXT(GLenum target, GLenum internalformat, GLboolean sink);
		void glResetHistogramEXT(GLenum target);
		void glResetMinmaxEXT(GLenum target);

		alias void function(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid* values) PFNGLGETHISTOGRAMEXTPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETHISTOGRAMPARAMETERFVEXTPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETHISTOGRAMPARAMETERIVEXTPROC;
		alias void function(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid* values) PFNGLGETMINMAXEXTPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETMINMAXPARAMETERFVEXTPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETMINMAXPARAMETERIVEXTPROC;
		alias void function(GLenum target, GLsizei width, GLenum internalformat, GLboolean sink) PFNGLHISTOGRAMEXTPROC;
		alias void function(GLenum target, GLenum internalformat, GLboolean sink) PFNGLMINMAXEXTPROC;
		alias void function(GLenum target) PFNGLRESETHISTOGRAMEXTPROC;
		alias void function(GLenum target) PFNGLRESETMINMAXEXTPROC;
	}
}

version (GL_EXT_convolution)
{
}
else
{
	extern (C)
	{
		void glConvolutionFilter1DEXT(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const(GLvoid)* image);
		void glConvolutionFilter2DEXT(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const(GLvoid)* image);
		void glConvolutionParameterfEXT(GLenum target, GLenum pname, GLfloat params);
		void glConvolutionParameterfvEXT(GLenum target, GLenum pname, const(GLfloat)* params);
		void glConvolutionParameteriEXT(GLenum target, GLenum pname, GLint params);
		void glConvolutionParameterivEXT(GLenum target, GLenum pname, const(GLint)* params);
		void glCopyConvolutionFilter1DEXT(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
		void glCopyConvolutionFilter2DEXT(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height);
		void glGetConvolutionFilterEXT(GLenum target, GLenum format, GLenum type, GLvoid* image);
		void glGetConvolutionParameterfvEXT(GLenum target, GLenum pname, GLfloat* params);
		void glGetConvolutionParameterivEXT(GLenum target, GLenum pname, GLint* params);
		void glGetSeparableFilterEXT(GLenum target, GLenum format, GLenum type, GLvoid* row, GLvoid* column, GLvoid* span);
		void glSeparableFilter2DEXT(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const(GLvoid)* row, const(GLvoid)* column);

		alias void function(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const(GLvoid)* image) PFNGLCONVOLUTIONFILTER1DEXTPROC;
		alias void function(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const(GLvoid)* image) PFNGLCONVOLUTIONFILTER2DEXTPROC;
		alias void function(GLenum target, GLenum pname, GLfloat params) PFNGLCONVOLUTIONPARAMETERFEXTPROC;
		alias void function(GLenum target, GLenum pname, const(GLfloat)* params) PFNGLCONVOLUTIONPARAMETERFVEXTPROC;
		alias void function(GLenum target, GLenum pname, GLint params) PFNGLCONVOLUTIONPARAMETERIEXTPROC;
		alias void function(GLenum target, GLenum pname, const(GLint)* params) PFNGLCONVOLUTIONPARAMETERIVEXTPROC;
		alias void function(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width) PFNGLCOPYCONVOLUTIONFILTER1DEXTPROC;
		alias void function(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height) PFNGLCOPYCONVOLUTIONFILTER2DEXTPROC;
		alias void function(GLenum target, GLenum format, GLenum type, GLvoid* image) PFNGLGETCONVOLUTIONFILTEREXTPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETCONVOLUTIONPARAMETERFVEXTPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETCONVOLUTIONPARAMETERIVEXTPROC;
		alias void function(GLenum target, GLenum format, GLenum type, GLvoid* row, GLvoid* column, GLvoid* span) PFNGLGETSEPARABLEFILTEREXTPROC;
		alias void function(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const(GLvoid)* row, const(GLvoid)* column) PFNGLSEPARABLEFILTER2DEXTPROC;
	}
}

version (GL_EXT_color_matrix)
{
}
else
{
}

version (GL_SGI_color_table)
{
}
else
{
	extern (C)
	{
		void glColorTableSGI(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const(GLvoid)* table);
		void glColorTableParameterfvSGI(GLenum target, GLenum pname, const(GLfloat)* params);
		void glColorTableParameterivSGI(GLenum target, GLenum pname, const(GLint)* params);
		void glCopyColorTableSGI(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
		void glGetColorTableSGI(GLenum target, GLenum format, GLenum type, GLvoid* table);
		void glGetColorTableParameterfvSGI(GLenum target, GLenum pname, GLfloat* params);
		void glGetColorTableParameterivSGI(GLenum target, GLenum pname, GLint* params);

		alias void function(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const(GLvoid)* table) PFNGLCOLORTABLESGIPROC;
		alias void function(GLenum target, GLenum pname, const(GLfloat)* params) PFNGLCOLORTABLEPARAMETERFVSGIPROC;
		alias void function(GLenum target, GLenum pname, const(GLint)* params) PFNGLCOLORTABLEPARAMETERIVSGIPROC;
		alias void function(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width) PFNGLCOPYCOLORTABLESGIPROC;
		alias void function(GLenum target, GLenum format, GLenum type, GLvoid* table) PFNGLGETCOLORTABLESGIPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETCOLORTABLEPARAMETERFVSGIPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETCOLORTABLEPARAMETERIVSGIPROC;
	}
}

version (GL_SGIX_pixel_texture)
{
}
else
{
	extern (C)
	{
		void glPixelTexGenSGIX(GLenum mode);

		alias void function(GLenum mode) PFNGLPIXELTEXGENSGIXPROC;
	}
}

version (GL_SGIS_pixel_texture)
{
}
else
{
	extern (C)
	{
		void glPixelTexGenParameteriSGIS(GLenum pname, GLint param);
		void glPixelTexGenParameterivSGIS(GLenum pname, const(GLint)* params);
		void glPixelTexGenParameterfSGIS(GLenum pname, GLfloat param);
		void glPixelTexGenParameterfvSGIS(GLenum pname, const(GLfloat)* params);
		void glGetPixelTexGenParameterivSGIS(GLenum pname, GLint* params);
		void glGetPixelTexGenParameterfvSGIS(GLenum pname, GLfloat* params);

		alias void function(GLenum pname, GLint param) PFNGLPIXELTEXGENPARAMETERISGISPROC;
		alias void function(GLenum pname, const(GLint)* params) PFNGLPIXELTEXGENPARAMETERIVSGISPROC;
		alias void function(GLenum pname, GLfloat param) PFNGLPIXELTEXGENPARAMETERFSGISPROC;
		alias void function(GLenum pname, const(GLfloat)* params) PFNGLPIXELTEXGENPARAMETERFVSGISPROC;
		alias void function(GLenum pname, GLint* params) PFNGLGETPIXELTEXGENPARAMETERIVSGISPROC;
		alias void function(GLenum pname, GLfloat* params) PFNGLGETPIXELTEXGENPARAMETERFVSGISPROC;
	}
}

version (GL_SGIS_texture4D)
{
}
else
{
	extern (C)
	{
		void glTexImage4DSGIS(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLint border, GLenum format, GLenum type, const(GLvoid)* pixels);
		void glTexSubImage4DSGIS(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint woffset, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLenum format, GLenum type, const(GLvoid)* pixels);

		alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLint border, GLenum format, GLenum type, const(GLvoid)* pixels) PFNGLTEXIMAGE4DSGISPROC;
		alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint woffset, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLenum format, GLenum type, const(GLvoid)* pixels) PFNGLTEXSUBIMAGE4DSGISPROC;
	}
}

version (GL_SGI_texture_color_table)
{
}
else
{
}

version (GL_EXT_cmyka)
{
}
else
{
}

version (GL_EXT_texture_object)
{
}
else
{
	extern (C)
	{
		GLboolean glAreTexturesResidentEXT(GLsizei n, const(GLuint)* textures, GLboolean* residences);
		void glBindTextureEXT(GLenum target, GLuint texture);
		void glDeleteTexturesEXT(GLsizei n, const(GLuint)* textures);
		void glGenTexturesEXT(GLsizei n, GLuint* textures);
		GLboolean glIsTextureEXT(GLuint texture);
		void glPrioritizeTexturesEXT(GLsizei n, const(GLuint)* textures, const(GLclampf)* priorities);

		alias GLboolean function(GLsizei n, const(GLuint)* textures, GLboolean* residences) PFNGLARETEXTURESRESIDENTEXTPROC;
		alias void function(GLenum target, GLuint texture) PFNGLBINDTEXTUREEXTPROC;
		alias void function(GLsizei n, const(GLuint)* textures) PFNGLDELETETEXTURESEXTPROC;
		alias void function(GLsizei n, GLuint* textures) PFNGLGENTEXTURESEXTPROC;
		alias GLboolean function(GLuint texture) PFNGLISTEXTUREEXTPROC;
		alias void function(GLsizei n, const(GLuint)* textures, const(GLclampf)* priorities) PFNGLPRIORITIZETEXTURESEXTPROC;
	}
}

version (GL_SGIS_detail_texture)
{
}
else
{
	extern (C)
	{
		void glDetailTexFuncSGIS(GLenum target, GLsizei n, const(GLfloat)* points);
		void glGetDetailTexFuncSGIS(GLenum target, GLfloat* points);

		alias void function(GLenum target, GLsizei n, const(GLfloat)* points) PFNGLDETAILTEXFUNCSGISPROC;
		alias void function(GLenum target, GLfloat* points) PFNGLGETDETAILTEXFUNCSGISPROC;
	}
}

version (GL_SGIS_sharpen_texture)
{
}
else
{
	extern (C)
	{
		void glSharpenTexFuncSGIS(GLenum target, GLsizei n, const(GLfloat)* points);
		void glGetSharpenTexFuncSGIS(GLenum target, GLfloat* points);

		alias void function(GLenum target, GLsizei n, const(GLfloat)* points) PFNGLSHARPENTEXFUNCSGISPROC;
		alias void function(GLenum target, GLfloat* points) PFNGLGETSHARPENTEXFUNCSGISPROC;
	}
}

version (GL_EXT_packed_pixels)
{
}
else
{
}

version (GL_SGIS_texture_lod)
{
}
else
{
}

version (GL_SGIS_multisample)
{
}
else
{
	extern (C)
	{
		void glSampleMaskSGIS(GLclampf value, GLboolean invert);
		void glSamplePatternSGIS(GLenum pattern);

		alias void function(GLclampf value, GLboolean invert) PFNGLSAMPLEMASKSGISPROC;
		alias void function(GLenum pattern) PFNGLSAMPLEPATTERNSGISPROC;
	}
}

version (GL_EXT_rescale_normal)
{
}
else
{
}

version (GL_EXT_vertex_array)
{
}
else
{
	extern (C)
	{
		void glArrayElementEXT(GLint i);
		void glColorPointerEXT(GLint size, GLenum type, GLsizei stride, GLsizei count, const(GLvoid)* pointer);
		void glDrawArraysEXT(GLenum mode, GLint first, GLsizei count);
		void glEdgeFlagPointerEXT(GLsizei stride, GLsizei count, const(GLboolean)* pointer);
		void glGetPointervEXT(GLenum pname, GLvoid** params);
		void glIndexPointerEXT(GLenum type, GLsizei stride, GLsizei count, const(GLvoid)* pointer);
		void glNormalPointerEXT(GLenum type, GLsizei stride, GLsizei count, const(GLvoid)* pointer);
		void glTexCoordPointerEXT(GLint size, GLenum type, GLsizei stride, GLsizei count, const(GLvoid)* pointer);
		void glVertexPointerEXT(GLint size, GLenum type, GLsizei stride, GLsizei count, const(GLvoid)* pointer);

		alias void function(GLint i) PFNGLARRAYELEMENTEXTPROC;
		alias void function(GLint size, GLenum type, GLsizei stride, GLsizei count, const(GLvoid)* pointer) PFNGLCOLORPOINTEREXTPROC;
		alias void function(GLenum mode, GLint first, GLsizei count) PFNGLDRAWARRAYSEXTPROC;
		alias void function(GLsizei stride, GLsizei count, const(GLboolean)* pointer) PFNGLEDGEFLAGPOINTEREXTPROC;
		alias void function(GLenum pname, GLvoid** params) PFNGLGETPOINTERVEXTPROC;
		alias void function(GLenum type, GLsizei stride, GLsizei count, const(GLvoid)* pointer) PFNGLINDEXPOINTEREXTPROC;
		alias void function(GLenum type, GLsizei stride, GLsizei count, const(GLvoid)* pointer) PFNGLNORMALPOINTEREXTPROC;
		alias void function(GLint size, GLenum type, GLsizei stride, GLsizei count, const(GLvoid)* pointer) PFNGLTEXCOORDPOINTEREXTPROC;
		alias void function(GLint size, GLenum type, GLsizei stride, GLsizei count, const(GLvoid)* pointer) PFNGLVERTEXPOINTEREXTPROC;
	}
}

version (GL_EXT_misc_attribute)
{
}
else
{
}

version (GL_SGIS_generate_mipmap)
{
}
else
{
}

version (GL_SGIX_clipmap)
{
}
else
{
}

version (GL_SGIX_shadow)
{
}
else
{
}

version (GL_SGIS_texture_edge_clamp)
{
}
else
{
}

version (GL_SGIS_texture_border_clamp)
{
}
else
{
}

version (GL_EXT_blend_minmax)
{
}
else
{
	extern (C)
	{
		void glBlendEquationEXT(GLenum mode);

		alias void function(GLenum mode) PFNGLBLENDEQUATIONEXTPROC;
	}
}

version (GL_EXT_blend_subtract)
{
}
else
{
}

version (GL_EXT_blend_logic_op)
{
}
else
{
}

version (GL_SGIX_interlace)
{
}
else
{
}

version (GL_SGIX_pixel_tiles)
{
}
else
{
}

version (GL_SGIX_texture_select)
{
}
else
{
}

version (GL_SGIX_sprite)
{
}
else
{
	extern (C)
	{
		void glSpriteParameterfSGIX(GLenum pname, GLfloat param);
		void glSpriteParameterfvSGIX(GLenum pname, const(GLfloat)* params);
		void glSpriteParameteriSGIX(GLenum pname, GLint param);
		void glSpriteParameterivSGIX(GLenum pname, const(GLint)* params);

		alias void function(GLenum pname, GLfloat param) PFNGLSPRITEPARAMETERFSGIXPROC;
		alias void function(GLenum pname, const(GLfloat)* params) PFNGLSPRITEPARAMETERFVSGIXPROC;
		alias void function(GLenum pname, GLint param) PFNGLSPRITEPARAMETERISGIXPROC;
		alias void function(GLenum pname, const(GLint)* params) PFNGLSPRITEPARAMETERIVSGIXPROC;
	}
}

version (GL_SGIX_texture_multi_buffer)
{
}
else
{
}

version (GL_EXT_point_parameters)
{
}
else
{
	extern (C)
	{
		void glPointParameterfEXT(GLenum pname, GLfloat param);
		void glPointParameterfvEXT(GLenum pname, const(GLfloat)* params);

		alias void function(GLenum pname, GLfloat param) PFNGLPOINTPARAMETERFEXTPROC;
		alias void function(GLenum pname, const(GLfloat)* params) PFNGLPOINTPARAMETERFVEXTPROC;
	}
}

version (GL_SGIS_point_parameters)
{
}
else
{
	extern (C)
	{
		void glPointParameterfSGIS(GLenum pname, GLfloat param);
		void glPointParameterfvSGIS(GLenum pname, const(GLfloat)* params);

		alias void function(GLenum pname, GLfloat param) PFNGLPOINTPARAMETERFSGISPROC;
		alias void function(GLenum pname, const(GLfloat)* params) PFNGLPOINTPARAMETERFVSGISPROC;
	}
}

version (GL_SGIX_instruments)
{
}
else
{
	extern (C)
	{
		GLint glGetInstrumentsSGIX();
		void glInstrumentsBufferSGIX(GLsizei size, GLint* buffer);
		GLint glPollInstrumentsSGIX(GLint* marker_p);
		void glReadInstrumentsSGIX(GLint marker);
		void glStartInstrumentsSGIX();
		void glStopInstrumentsSGIX(GLint marker);

		alias GLint function() PFNGLGETINSTRUMENTSSGIXPROC;
		alias void function(GLsizei size, GLint* buffer) PFNGLINSTRUMENTSBUFFERSGIXPROC;
		alias GLint function(GLint* marker_p) PFNGLPOLLINSTRUMENTSSGIXPROC;
		alias void function(GLint marker) PFNGLREADINSTRUMENTSSGIXPROC;
		alias void function() PFNGLSTARTINSTRUMENTSSGIXPROC;
		alias void function(GLint marker) PFNGLSTOPINSTRUMENTSSGIXPROC;
	}
}

version (GL_SGIX_texture_scale_bias)
{
}
else
{
}

version (GL_SGIX_framezoom)
{
}
else
{
	extern (C)
	{
		void glFrameZoomSGIX(GLint factor);

		alias void function(GLint factor) PFNGLFRAMEZOOMSGIXPROC;
	}
}

version (GL_SGIX_tag_sample_buffer)
{
}
else
{
	extern (C)
	{
		void glTagSampleBufferSGIX();

		alias void function() PFNGLTAGSAMPLEBUFFERSGIXPROC;
	}
}

version (GL_SGIX_polynomial_ffd)
{
}
else
{
	extern (C)
	{
		void glDeformationMap3dSGIX(GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, GLdouble w1, GLdouble w2, GLint wstride, GLint worder, const(GLdouble)* points);
		void glDeformationMap3fSGIX(GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, GLfloat w1, GLfloat w2, GLint wstride, GLint worder, const(GLfloat)* points);
		void glDeformSGIX(GLbitfield mask);
		void glLoadIdentityDeformationMapSGIX(GLbitfield mask);

		alias void function(GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, GLdouble w1, GLdouble w2, GLint wstride, GLint worder, const(GLdouble)* points) PFNGLDEFORMATIONMAP3DSGIXPROC;
		alias void function(GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, GLfloat w1, GLfloat w2, GLint wstride, GLint worder, const(GLfloat)* points) PFNGLDEFORMATIONMAP3FSGIXPROC;
		alias void function(GLbitfield mask) PFNGLDEFORMSGIXPROC;
		alias void function(GLbitfield mask) PFNGLLOADIDENTITYDEFORMATIONMAPSGIXPROC;
	}
}

version (GL_SGIX_reference_plane)
{
}
else
{
	extern (C)
	{
		void glReferencePlaneSGIX(const(GLdouble)* equation);

		alias void function(const(GLdouble)* equation) PFNGLREFERENCEPLANESGIXPROC;
	}
}

version (GL_SGIX_flush_raster)
{
}
else
{
	extern (C)
	{
		void glFlushRasterSGIX();

		alias void function() PFNGLFLUSHRASTERSGIXPROC;
	}
}

version (GL_SGIX_depth_texture)
{
}
else
{
}

version (GL_SGIS_fog_function)
{
}
else
{
	extern (C)
	{
		void glFogFuncSGIS(GLsizei n, const(GLfloat)* points);
		void glGetFogFuncSGIS(GLfloat* points);

		alias void function(GLsizei n, const(GLfloat)* points) PFNGLFOGFUNCSGISPROC;
		alias void function(GLfloat* points) PFNGLGETFOGFUNCSGISPROC;
	}
}

version (GL_SGIX_fog_offset)
{
}
else
{
}

version (GL_HP_image_transform)
{
}
else
{
	extern (C)
	{
		void glImageTransformParameteriHP(GLenum target, GLenum pname, GLint param);
		void glImageTransformParameterfHP(GLenum target, GLenum pname, GLfloat param);
		void glImageTransformParameterivHP(GLenum target, GLenum pname, const(GLint)* params);
		void glImageTransformParameterfvHP(GLenum target, GLenum pname, const(GLfloat)* params);
		void glGetImageTransformParameterivHP(GLenum target, GLenum pname, GLint* params);
		void glGetImageTransformParameterfvHP(GLenum target, GLenum pname, GLfloat* params);

		alias void function(GLenum target, GLenum pname, GLint param) PFNGLIMAGETRANSFORMPARAMETERIHPPROC;
		alias void function(GLenum target, GLenum pname, GLfloat param) PFNGLIMAGETRANSFORMPARAMETERFHPPROC;
		alias void function(GLenum target, GLenum pname, const(GLint)* params) PFNGLIMAGETRANSFORMPARAMETERIVHPPROC;
		alias void function(GLenum target, GLenum pname, const(GLfloat)* params) PFNGLIMAGETRANSFORMPARAMETERFVHPPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETIMAGETRANSFORMPARAMETERIVHPPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETIMAGETRANSFORMPARAMETERFVHPPROC;
	}
}

version (GL_HP_convolution_border_modes)
{
}
else
{
}

version (GL_SGIX_texture_add_env)
{
}
else
{
}

version (GL_EXT_color_subtable)
{
}
else
{
	extern (C)
	{
		void glColorSubTableEXT(GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const(GLvoid)* data);
		void glCopyColorSubTableEXT(GLenum target, GLsizei start, GLint x, GLint y, GLsizei width);

		alias void function(GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const(GLvoid)* data) PFNGLCOLORSUBTABLEEXTPROC;
		alias void function(GLenum target, GLsizei start, GLint x, GLint y, GLsizei width) PFNGLCOPYCOLORSUBTABLEEXTPROC;
	}
}

version (GL_PGI_vertex_hints)
{
}
else
{
}

version (GL_PGI_misc_hints)
{
}
else
{
	extern (C)
	{
		void glHintPGI(GLenum target, GLint mode);

		alias void function(GLenum target, GLint mode) PFNGLHINTPGIPROC;
	}
}

version (GL_EXT_paletted_texture)
{
}
else
{
	extern (C)
	{
		void glColorTableEXT(GLenum target, GLenum internalFormat, GLsizei width, GLenum format, GLenum type, const(GLvoid)* table);
		void glGetColorTableEXT(GLenum target, GLenum format, GLenum type, GLvoid* data);
		void glGetColorTableParameterivEXT(GLenum target, GLenum pname, GLint* params);
		void glGetColorTableParameterfvEXT(GLenum target, GLenum pname, GLfloat* params);

		alias void function(GLenum target, GLenum internalFormat, GLsizei width, GLenum format, GLenum type, const(GLvoid)* table) PFNGLCOLORTABLEEXTPROC;
		alias void function(GLenum target, GLenum format, GLenum type, GLvoid* data) PFNGLGETCOLORTABLEEXTPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETCOLORTABLEPARAMETERIVEXTPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETCOLORTABLEPARAMETERFVEXTPROC;
	}
}

version (GL_EXT_clip_volume_hint)
{
}
else
{
}

version (GL_SGIX_list_priority)
{
}
else
{
	extern (C)
	{
		void glGetListParameterfvSGIX(GLuint list, GLenum pname, GLfloat* params);
		void glGetListParameterivSGIX(GLuint list, GLenum pname, GLint* params);
		void glListParameterfSGIX(GLuint list, GLenum pname, GLfloat param);
		void glListParameterfvSGIX(GLuint list, GLenum pname, const(GLfloat)* params);
		void glListParameteriSGIX(GLuint list, GLenum pname, GLint param);
		void glListParameterivSGIX(GLuint list, GLenum pname, const(GLint)* params);

		alias void function(GLuint list, GLenum pname, GLfloat* params) PFNGLGETLISTPARAMETERFVSGIXPROC;
		alias void function(GLuint list, GLenum pname, GLint* params) PFNGLGETLISTPARAMETERIVSGIXPROC;
		alias void function(GLuint list, GLenum pname, GLfloat param) PFNGLLISTPARAMETERFSGIXPROC;
		alias void function(GLuint list, GLenum pname, const(GLfloat)* params) PFNGLLISTPARAMETERFVSGIXPROC;
		alias void function(GLuint list, GLenum pname, GLint param) PFNGLLISTPARAMETERISGIXPROC;
		alias void function(GLuint list, GLenum pname, const(GLint)* params) PFNGLLISTPARAMETERIVSGIXPROC;
	}
}

version (GL_SGIX_ir_instrument1)
{
}
else
{
}

version (GL_SGIX_calligraphic_fragment)
{
}
else
{
}

version (GL_SGIX_texture_lod_bias)
{
}
else
{
}

version (GL_SGIX_shadow_ambient)
{
}
else
{
}

version (GL_EXT_index_texture)
{
}
else
{
}

version (GL_EXT_index_material)
{
}
else
{
	extern (C)
	{
		void glIndexMaterialEXT(GLenum face, GLenum mode);

		alias void function(GLenum face, GLenum mode) PFNGLINDEXMATERIALEXTPROC;
	}
}

version (GL_EXT_index_func)
{
}
else
{
	extern (C)
	{
		void glIndexFuncEXT(GLenum func, GLclampf reference);

		alias void function(GLenum func, GLclampf reference) PFNGLINDEXFUNCEXTPROC;
	}
}

version (GL_EXT_index_array_formats)
{
}
else
{
}

version (GL_EXT_compiled_vertex_array)
{
}
else
{
	extern (C)
	{
		void glLockArraysEXT(GLint first, GLsizei count);
		void glUnlockArraysEXT();

		alias void function(GLint first, GLsizei count) PFNGLLOCKARRAYSEXTPROC;
		alias void function() PFNGLUNLOCKARRAYSEXTPROC;
	}
}

version (GL_EXT_cull_vertex)
{
}
else
{
	extern (C)
	{
		void glCullParameterdvEXT(GLenum pname, GLdouble* params);
		void glCullParameterfvEXT(GLenum pname, GLfloat* params);

		alias void function(GLenum pname, GLdouble* params) PFNGLCULLPARAMETERDVEXTPROC;
		alias void function(GLenum pname, GLfloat* params) PFNGLCULLPARAMETERFVEXTPROC;
	}
}

version (GL_SGIX_ycrcb)
{
}
else
{
}

version (GL_SGIX_fragment_lighting)
{
}
else
{
	extern (C)
	{
		void glFragmentColorMaterialSGIX(GLenum face, GLenum mode);
		void glFragmentLightfSGIX(GLenum light, GLenum pname, GLfloat param);
		void glFragmentLightfvSGIX(GLenum light, GLenum pname, const(GLfloat)* params);
		void glFragmentLightiSGIX(GLenum light, GLenum pname, GLint param);
		void glFragmentLightivSGIX(GLenum light, GLenum pname, const(GLint)* params);
		void glFragmentLightModelfSGIX(GLenum pname, GLfloat param);
		void glFragmentLightModelfvSGIX(GLenum pname, const(GLfloat)* params);
		void glFragmentLightModeliSGIX(GLenum pname, GLint param);
		void glFragmentLightModelivSGIX(GLenum pname, const(GLint)* params);
		void glFragmentMaterialfSGIX(GLenum face, GLenum pname, GLfloat param);
		void glFragmentMaterialfvSGIX(GLenum face, GLenum pname, const(GLfloat)* params);
		void glFragmentMaterialiSGIX(GLenum face, GLenum pname, GLint param);
		void glFragmentMaterialivSGIX(GLenum face, GLenum pname, const(GLint)* params);
		void glGetFragmentLightfvSGIX(GLenum light, GLenum pname, GLfloat* params);
		void glGetFragmentLightivSGIX(GLenum light, GLenum pname, GLint* params);
		void glGetFragmentMaterialfvSGIX(GLenum face, GLenum pname, GLfloat* params);
		void glGetFragmentMaterialivSGIX(GLenum face, GLenum pname, GLint* params);
		void glLightEnviSGIX(GLenum pname, GLint param);

		alias void function(GLenum face, GLenum mode) PFNGLFRAGMENTCOLORMATERIALSGIXPROC;
		alias void function(GLenum light, GLenum pname, GLfloat param) PFNGLFRAGMENTLIGHTFSGIXPROC;
		alias void function(GLenum light, GLenum pname, const(GLfloat)* params) PFNGLFRAGMENTLIGHTFVSGIXPROC;
		alias void function(GLenum light, GLenum pname, GLint param) PFNGLFRAGMENTLIGHTISGIXPROC;
		alias void function(GLenum light, GLenum pname, const(GLint)* params) PFNGLFRAGMENTLIGHTIVSGIXPROC;
		alias void function(GLenum pname, GLfloat param) PFNGLFRAGMENTLIGHTMODELFSGIXPROC;
		alias void function(GLenum pname, const(GLfloat)* params) PFNGLFRAGMENTLIGHTMODELFVSGIXPROC;
		alias void function(GLenum pname, GLint param) PFNGLFRAGMENTLIGHTMODELISGIXPROC;
		alias void function(GLenum pname, const(GLint)* params) PFNGLFRAGMENTLIGHTMODELIVSGIXPROC;
		alias void function(GLenum face, GLenum pname, GLfloat param) PFNGLFRAGMENTMATERIALFSGIXPROC;
		alias void function(GLenum face, GLenum pname, const(GLfloat)* params) PFNGLFRAGMENTMATERIALFVSGIXPROC;
		alias void function(GLenum face, GLenum pname, GLint param) PFNGLFRAGMENTMATERIALISGIXPROC;
		alias void function(GLenum face, GLenum pname, const(GLint)* params) PFNGLFRAGMENTMATERIALIVSGIXPROC;
		alias void function(GLenum light, GLenum pname, GLfloat* params) PFNGLGETFRAGMENTLIGHTFVSGIXPROC;
		alias void function(GLenum light, GLenum pname, GLint* params) PFNGLGETFRAGMENTLIGHTIVSGIXPROC;
		alias void function(GLenum face, GLenum pname, GLfloat* params) PFNGLGETFRAGMENTMATERIALFVSGIXPROC;
		alias void function(GLenum face, GLenum pname, GLint* params) PFNGLGETFRAGMENTMATERIALIVSGIXPROC;
		alias void function(GLenum pname, GLint param) PFNGLLIGHTENVISGIXPROC;
	}
}

version (GL_IBM_rasterpos_clip)
{
}
else
{
}

version (GL_HP_texture_lighting)
{
}
else
{
}

version (GL_EXT_draw_range_elements)
{
}
else
{
	extern (C)
	{
		void glDrawRangeElementsEXT(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const(GLvoid)* indices);

		alias void function(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const(GLvoid)* indices) PFNGLDRAWRANGEELEMENTSEXTPROC;
	}
}

version (GL_WIN_phong_shading)
{
}
else
{
}

version (GL_WIN_specular_fog)
{
}
else
{
}

version (GL_EXT_light_texture)
{
}
else
{
	extern (C)
	{
		void glApplyTextureEXT(GLenum mode);
		void glTextureLightEXT(GLenum pname);
		void glTextureMaterialEXT(GLenum face, GLenum mode);

		alias void function(GLenum mode) PFNGLAPPLYTEXTUREEXTPROC;
		alias void function(GLenum pname) PFNGLTEXTURELIGHTEXTPROC;
		alias void function(GLenum face, GLenum mode) PFNGLTEXTUREMATERIALEXTPROC;
	}
}

version (GL_SGIX_blend_alpha_minmax)
{
}
else
{
}

version (GL_EXT_bgra)
{
}
else
{
}

version (GL_SGIX_async)
{
}
else
{
	extern (C)
	{
		void glAsyncMarkerSGIX(GLuint marker);
		GLint glFinishAsyncSGIX(GLuint* markerp);
		GLint glPollAsyncSGIX(GLuint* markerp);
		GLuint glGenAsyncMarkersSGIX(GLsizei range);
		void glDeleteAsyncMarkersSGIX(GLuint marker, GLsizei range);
		GLboolean glIsAsyncMarkerSGIX(GLuint marker);

		alias void function(GLuint marker) PFNGLASYNCMARKERSGIXPROC;
		alias GLint function(GLuint* markerp) PFNGLFINISHASYNCSGIXPROC;
		alias GLint function(GLuint* markerp) PFNGLPOLLASYNCSGIXPROC;
		alias GLuint function(GLsizei range) PFNGLGENASYNCMARKERSSGIXPROC;
		alias void function(GLuint marker, GLsizei range) PFNGLDELETEASYNCMARKERSSGIXPROC;
		alias GLboolean function(GLuint marker) PFNGLISASYNCMARKERSGIXPROC;
	}
}

version (GL_SGIX_async_pixel)
{
}
else
{
}

version (GL_SGIX_async_histogram)
{
}
else
{
}

version (GL_INTEL_parallel_arrays)
{
}
else
{
	extern (C)
	{
		void glVertexPointervINTEL(GLint size, GLenum type, const(GLvoid*)* pointer);
		void glNormalPointervINTEL(GLenum type, const(GLvoid*)* pointer);
		void glColorPointervINTEL(GLint size, GLenum type, const(GLvoid*)* pointer);
		void glTexCoordPointervINTEL(GLint size, GLenum type, const(GLvoid*)* pointer);

		alias void function(GLint size, GLenum type, const(GLvoid*)* pointer) PFNGLVERTEXPOINTERVINTELPROC;
		alias void function(GLenum type, const(GLvoid*)* pointer) PFNGLNORMALPOINTERVINTELPROC;
		alias void function(GLint size, GLenum type, const(GLvoid*)* pointer) PFNGLCOLORPOINTERVINTELPROC;
		alias void function(GLint size, GLenum type, const(GLvoid*)* pointer) PFNGLTEXCOORDPOINTERVINTELPROC;
	}
}

version (GL_HP_occlusion_test)
{
}
else
{
}

version (GL_EXT_pixel_transform)
{
}
else
{
	extern (C)
	{
		void glPixelTransformParameteriEXT(GLenum target, GLenum pname, GLint param);
		void glPixelTransformParameterfEXT(GLenum target, GLenum pname, GLfloat param);
		void glPixelTransformParameterivEXT(GLenum target, GLenum pname, const(GLint)* params);
		void glPixelTransformParameterfvEXT(GLenum target, GLenum pname, const(GLfloat)* params);

		alias void function(GLenum target, GLenum pname, GLint param) PFNGLPIXELTRANSFORMPARAMETERIEXTPROC;
		alias void function(GLenum target, GLenum pname, GLfloat param) PFNGLPIXELTRANSFORMPARAMETERFEXTPROC;
		alias void function(GLenum target, GLenum pname, const(GLint)* params) PFNGLPIXELTRANSFORMPARAMETERIVEXTPROC;
		alias void function(GLenum target, GLenum pname, const(GLfloat)* params) PFNGLPIXELTRANSFORMPARAMETERFVEXTPROC;
	}
}

version (GL_EXT_pixel_transform_color_table)
{
}
else
{
}

version (GL_EXT_shared_texture_palette)
{
}
else
{
}

version (GL_EXT_separate_specular_color)
{
}
else
{
}

version (GL_EXT_secondary_color)
{
}
else
{
	extern (C)
	{
		void glSecondaryColor3bEXT(GLbyte red, GLbyte green, GLbyte blue);
		void glSecondaryColor3bvEXT(const(GLbyte)* v);
		void glSecondaryColor3dEXT(GLdouble red, GLdouble green, GLdouble blue);
		void glSecondaryColor3dvEXT(const(GLdouble)* v);
		void glSecondaryColor3fEXT(GLfloat red, GLfloat green, GLfloat blue);
		void glSecondaryColor3fvEXT(const(GLfloat)* v);
		void glSecondaryColor3iEXT(GLint red, GLint green, GLint blue);
		void glSecondaryColor3ivEXT(const(GLint)* v);
		void glSecondaryColor3sEXT(GLshort red, GLshort green, GLshort blue);
		void glSecondaryColor3svEXT(const(GLshort)* v);
		void glSecondaryColor3ubEXT(GLubyte red, GLubyte green, GLubyte blue);
		void glSecondaryColor3ubvEXT(const(GLubyte)* v);
		void glSecondaryColor3uiEXT(GLuint red, GLuint green, GLuint blue);
		void glSecondaryColor3uivEXT(const(GLuint)* v);
		void glSecondaryColor3usEXT(GLushort red, GLushort green, GLushort blue);
		void glSecondaryColor3usvEXT(const(GLushort)* v);
		void glSecondaryColorPointerEXT(GLint size, GLenum type, GLsizei stride, const(GLvoid)* pointer);

		alias void function(GLbyte red, GLbyte green, GLbyte blue) PFNGLSECONDARYCOLOR3BEXTPROC;
		alias void function(const(GLbyte)* v) PFNGLSECONDARYCOLOR3BVEXTPROC;
		alias void function(GLdouble red, GLdouble green, GLdouble blue) PFNGLSECONDARYCOLOR3DEXTPROC;
		alias void function(const(GLdouble)* v) PFNGLSECONDARYCOLOR3DVEXTPROC;
		alias void function(GLfloat red, GLfloat green, GLfloat blue) PFNGLSECONDARYCOLOR3FEXTPROC;
		alias void function(const(GLfloat)* v) PFNGLSECONDARYCOLOR3FVEXTPROC;
		alias void function(GLint red, GLint green, GLint blue) PFNGLSECONDARYCOLOR3IEXTPROC;
		alias void function(const(GLint)* v) PFNGLSECONDARYCOLOR3IVEXTPROC;
		alias void function(GLshort red, GLshort green, GLshort blue) PFNGLSECONDARYCOLOR3SEXTPROC;
		alias void function(const(GLshort)* v) PFNGLSECONDARYCOLOR3SVEXTPROC;
		alias void function(GLubyte red, GLubyte green, GLubyte blue) PFNGLSECONDARYCOLOR3UBEXTPROC;
		alias void function(const(GLubyte)* v) PFNGLSECONDARYCOLOR3UBVEXTPROC;
		alias void function(GLuint red, GLuint green, GLuint blue) PFNGLSECONDARYCOLOR3UIEXTPROC;
		alias void function(const(GLuint)* v) PFNGLSECONDARYCOLOR3UIVEXTPROC;
		alias void function(GLushort red, GLushort green, GLushort blue) PFNGLSECONDARYCOLOR3USEXTPROC;
		alias void function(const(GLushort)* v) PFNGLSECONDARYCOLOR3USVEXTPROC;
		alias void function(GLint size, GLenum type, GLsizei stride, const(GLvoid)* pointer) PFNGLSECONDARYCOLORPOINTEREXTPROC;
	}
}

version (GL_EXT_texture_perturb_normal)
{
}
else
{
	extern (C)
	{
		void glTextureNormalEXT(GLenum mode);

		alias void function(GLenum mode) PFNGLTEXTURENORMALEXTPROC;
	}
}

version (GL_EXT_multi_draw_arrays)
{
}
else
{
	extern (C)
	{
		void glMultiDrawArraysEXT(GLenum mode, GLint* first, GLsizei* count, GLsizei primcount);
		void glMultiDrawElementsEXT(GLenum mode, const(GLsizei)* count, GLenum type, const(GLvoid*)* indices, GLsizei primcount);

		alias void function(GLenum mode, GLint* first, GLsizei* count, GLsizei primcount) PFNGLMULTIDRAWARRAYSEXTPROC;
		alias void function(GLenum mode, const(GLsizei)* count, GLenum type, const(GLvoid*)* indices, GLsizei primcount) PFNGLMULTIDRAWELEMENTSEXTPROC;
	}
}

version (GL_EXT_fog_coord)
{
}
else
{
	extern (C)
	{
		void glFogCoordfEXT(GLfloat coord);
		void glFogCoordfvEXT(const(GLfloat)* coord);
		void glFogCoorddEXT(GLdouble coord);
		void glFogCoorddvEXT(const(GLdouble)* coord);
		void glFogCoordPointerEXT(GLenum type, GLsizei stride, const(GLvoid)* pointer);

		alias void function(GLfloat coord) PFNGLFOGCOORDFEXTPROC;
		alias void function(const(GLfloat)* coord) PFNGLFOGCOORDFVEXTPROC;
		alias void function(GLdouble coord) PFNGLFOGCOORDDEXTPROC;
		alias void function(const(GLdouble)* coord) PFNGLFOGCOORDDVEXTPROC;
		alias void function(GLenum type, GLsizei stride, const(GLvoid)* pointer) PFNGLFOGCOORDPOINTEREXTPROC;
	}
}

version (GL_REND_screen_coordinates)
{
}
else
{
}

version (GL_EXT_coordinate_frame)
{
}
else
{
	extern (C)
	{
		void glTangent3bEXT(GLbyte tx, GLbyte ty, GLbyte tz);
		void glTangent3bvEXT(const(GLbyte)* v);
		void glTangent3dEXT(GLdouble tx, GLdouble ty, GLdouble tz);
		void glTangent3dvEXT(const(GLdouble)* v);
		void glTangent3fEXT(GLfloat tx, GLfloat ty, GLfloat tz);
		void glTangent3fvEXT(const(GLfloat)* v);
		void glTangent3iEXT(GLint tx, GLint ty, GLint tz);
		void glTangent3ivEXT(const(GLint)* v);
		void glTangent3sEXT(GLshort tx, GLshort ty, GLshort tz);
		void glTangent3svEXT(const(GLshort)* v);
		void glBinormal3bEXT(GLbyte bx, GLbyte by, GLbyte bz);
		void glBinormal3bvEXT(const(GLbyte)* v);
		void glBinormal3dEXT(GLdouble bx, GLdouble by, GLdouble bz);
		void glBinormal3dvEXT(const(GLdouble)* v);
		void glBinormal3fEXT(GLfloat bx, GLfloat by, GLfloat bz);
		void glBinormal3fvEXT(const(GLfloat)* v);
		void glBinormal3iEXT(GLint bx, GLint by, GLint bz);
		void glBinormal3ivEXT(const(GLint)* v);
		void glBinormal3sEXT(GLshort bx, GLshort by, GLshort bz);
		void glBinormal3svEXT(const(GLshort)* v);
		void glTangentPointerEXT(GLenum type, GLsizei stride, const(GLvoid)* pointer);
		void glBinormalPointerEXT(GLenum type, GLsizei stride, const(GLvoid)* pointer);

		alias void function(GLbyte tx, GLbyte ty, GLbyte tz) PFNGLTANGENT3BEXTPROC;
		alias void function(const(GLbyte)* v) PFNGLTANGENT3BVEXTPROC;
		alias void function(GLdouble tx, GLdouble ty, GLdouble tz) PFNGLTANGENT3DEXTPROC;
		alias void function(const(GLdouble)* v) PFNGLTANGENT3DVEXTPROC;
		alias void function(GLfloat tx, GLfloat ty, GLfloat tz) PFNGLTANGENT3FEXTPROC;
		alias void function(const(GLfloat)* v) PFNGLTANGENT3FVEXTPROC;
		alias void function(GLint tx, GLint ty, GLint tz) PFNGLTANGENT3IEXTPROC;
		alias void function(const(GLint)* v) PFNGLTANGENT3IVEXTPROC;
		alias void function(GLshort tx, GLshort ty, GLshort tz) PFNGLTANGENT3SEXTPROC;
		alias void function(const(GLshort)* v) PFNGLTANGENT3SVEXTPROC;
		alias void function(GLbyte bx, GLbyte by, GLbyte bz) PFNGLBINORMAL3BEXTPROC;
		alias void function(const(GLbyte)* v) PFNGLBINORMAL3BVEXTPROC;
		alias void function(GLdouble bx, GLdouble by, GLdouble bz) PFNGLBINORMAL3DEXTPROC;
		alias void function(const(GLdouble)* v) PFNGLBINORMAL3DVEXTPROC;
		alias void function(GLfloat bx, GLfloat by, GLfloat bz) PFNGLBINORMAL3FEXTPROC;
		alias void function(const(GLfloat)* v) PFNGLBINORMAL3FVEXTPROC;
		alias void function(GLint bx, GLint by, GLint bz) PFNGLBINORMAL3IEXTPROC;
		alias void function(const(GLint)* v) PFNGLBINORMAL3IVEXTPROC;
		alias void function(GLshort bx, GLshort by, GLshort bz) PFNGLBINORMAL3SEXTPROC;
		alias void function(const(GLshort)* v) PFNGLBINORMAL3SVEXTPROC;
		alias void function(GLenum type, GLsizei stride, const(GLvoid)* pointer) PFNGLTANGENTPOINTEREXTPROC;
		alias void function(GLenum type, GLsizei stride, const(GLvoid)* pointer) PFNGLBINORMALPOINTEREXTPROC;
	}
}

version (GL_EXT_texture_env_combine)
{
}
else
{
}

version (GL_APPLE_specular_vector)
{
}
else
{
}

version (GL_APPLE_transform_hint)
{
}
else
{
}

version (GL_SGIX_fog_scale)
{
}
else
{
}

version (GL_SUNX_constant_data)
{
}
else
{
	extern (C)
	{
		void glFinishTextureSUNX();

		alias void function() PFNGLFINISHTEXTURESUNXPROC;
	}
}

version (GL_SUN_global_alpha)
{
}
else
{
	extern (C)
	{
		void glGlobalAlphaFactorbSUN(GLbyte factor);
		void glGlobalAlphaFactorsSUN(GLshort factor);
		void glGlobalAlphaFactoriSUN(GLint factor);
		void glGlobalAlphaFactorfSUN(GLfloat factor);
		void glGlobalAlphaFactordSUN(GLdouble factor);
		void glGlobalAlphaFactorubSUN(GLubyte factor);
		void glGlobalAlphaFactorusSUN(GLushort factor);
		void glGlobalAlphaFactoruiSUN(GLuint factor);

		alias void function(GLbyte factor) PFNGLGLOBALALPHAFACTORBSUNPROC;
		alias void function(GLshort factor) PFNGLGLOBALALPHAFACTORSSUNPROC;
		alias void function(GLint factor) PFNGLGLOBALALPHAFACTORISUNPROC;
		alias void function(GLfloat factor) PFNGLGLOBALALPHAFACTORFSUNPROC;
		alias void function(GLdouble factor) PFNGLGLOBALALPHAFACTORDSUNPROC;
		alias void function(GLubyte factor) PFNGLGLOBALALPHAFACTORUBSUNPROC;
		alias void function(GLushort factor) PFNGLGLOBALALPHAFACTORUSSUNPROC;
		alias void function(GLuint factor) PFNGLGLOBALALPHAFACTORUISUNPROC;
	}
}

version (GL_SUN_triangle_list)
{
}
else
{
	extern (C)
	{
		void glReplacementCodeuiSUN(GLuint code);
		void glReplacementCodeusSUN(GLushort code);
		void glReplacementCodeubSUN(GLubyte code);
		void glReplacementCodeuivSUN(const(GLuint)* code);
		void glReplacementCodeusvSUN(const(GLushort)* code);
		void glReplacementCodeubvSUN(const(GLubyte)* code);
		void glReplacementCodePointerSUN(GLenum type, GLsizei stride, const(GLvoid*)* pointer);

		alias void function(GLuint code) PFNGLREPLACEMENTCODEUISUNPROC;
		alias void function(GLushort code) PFNGLREPLACEMENTCODEUSSUNPROC;
		alias void function(GLubyte code) PFNGLREPLACEMENTCODEUBSUNPROC;
		alias void function(const(GLuint)* code) PFNGLREPLACEMENTCODEUIVSUNPROC;
		alias void function(const(GLushort)* code) PFNGLREPLACEMENTCODEUSVSUNPROC;
		alias void function(const(GLubyte)* code) PFNGLREPLACEMENTCODEUBVSUNPROC;
		alias void function(GLenum type, GLsizei stride, const(GLvoid*)* pointer) PFNGLREPLACEMENTCODEPOINTERSUNPROC;
	}
}

version (GL_SUN_vertex)
{
}
else
{
	extern (C)
	{
		void glColor4ubVertex2fSUN(GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y);
		void glColor4ubVertex2fvSUN(const(GLubyte)* c, const(GLfloat)* v);
		void glColor4ubVertex3fSUN(GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
		void glColor4ubVertex3fvSUN(const(GLubyte)* c, const(GLfloat)* v);
		void glColor3fVertex3fSUN(GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
		void glColor3fVertex3fvSUN(const(GLfloat)* c, const(GLfloat)* v);
		void glNormal3fVertex3fSUN(GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		void glNormal3fVertex3fvSUN(const(GLfloat)* n, const(GLfloat)* v);
		void glColor4fNormal3fVertex3fSUN(GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		void glColor4fNormal3fVertex3fvSUN(const(GLfloat)* c, const(GLfloat)* n, const(GLfloat)* v);
		void glTexCoord2fVertex3fSUN(GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z);
		void glTexCoord2fVertex3fvSUN(const(GLfloat)* tc, const(GLfloat)* v);
		void glTexCoord4fVertex4fSUN(GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glTexCoord4fVertex4fvSUN(const(GLfloat)* tc, const(GLfloat)* v);
		void glTexCoord2fColor4ubVertex3fSUN(GLfloat s, GLfloat t, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
		void glTexCoord2fColor4ubVertex3fvSUN(const(GLfloat)* tc, const(GLubyte)* c, const(GLfloat)* v);
		void glTexCoord2fColor3fVertex3fSUN(GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
		void glTexCoord2fColor3fVertex3fvSUN(const(GLfloat)* tc, const(GLfloat)* c, const(GLfloat)* v);
		void glTexCoord2fNormal3fVertex3fSUN(GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		void glTexCoord2fNormal3fVertex3fvSUN(const(GLfloat)* tc, const(GLfloat)* n, const(GLfloat)* v);
		void glTexCoord2fColor4fNormal3fVertex3fSUN(GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		void glTexCoord2fColor4fNormal3fVertex3fvSUN(const(GLfloat)* tc, const(GLfloat)* c, const(GLfloat)* n, const(GLfloat)* v);
		void glTexCoord4fColor4fNormal3fVertex4fSUN(GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glTexCoord4fColor4fNormal3fVertex4fvSUN(const(GLfloat)* tc, const(GLfloat)* c, const(GLfloat)* n, const(GLfloat)* v);
		void glReplacementCodeuiVertex3fSUN(GLuint rc, GLfloat x, GLfloat y, GLfloat z);
		void glReplacementCodeuiVertex3fvSUN(const(GLuint)* rc, const(GLfloat)* v);
		void glReplacementCodeuiColor4ubVertex3fSUN(GLuint rc, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
		void glReplacementCodeuiColor4ubVertex3fvSUN(const(GLuint)* rc, const(GLubyte)* c, const(GLfloat)* v);
		void glReplacementCodeuiColor3fVertex3fSUN(GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
		void glReplacementCodeuiColor3fVertex3fvSUN(const(GLuint)* rc, const(GLfloat)* c, const(GLfloat)* v);
		void glReplacementCodeuiNormal3fVertex3fSUN(GLuint rc, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		void glReplacementCodeuiNormal3fVertex3fvSUN(const(GLuint)* rc, const(GLfloat)* n, const(GLfloat)* v);
		void glReplacementCodeuiColor4fNormal3fVertex3fSUN(GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		void glReplacementCodeuiColor4fNormal3fVertex3fvSUN(const(GLuint)* rc, const(GLfloat)* c, const(GLfloat)* n, const(GLfloat)* v);
		void glReplacementCodeuiTexCoord2fVertex3fSUN(GLuint rc, GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z);
		void glReplacementCodeuiTexCoord2fVertex3fvSUN(const(GLuint)* rc, const(GLfloat)* tc, const(GLfloat)* v);
		void glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN(GLuint rc, GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		void glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(const(GLuint)* rc, const(GLfloat)* tc, const(GLfloat)* n, const(GLfloat)* v);
		void glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN(GLuint rc, GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		void glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(const(GLuint)* rc, const(GLfloat)* tc, const(GLfloat)* c, const(GLfloat)* n, const(GLfloat)* v);

		alias void function(GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y) PFNGLCOLOR4UBVERTEX2FSUNPROC;
		alias void function(const(GLubyte)* c, const(GLfloat)* v) PFNGLCOLOR4UBVERTEX2FVSUNPROC;
		alias void function(GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z) PFNGLCOLOR4UBVERTEX3FSUNPROC;
		alias void function(const(GLubyte)* c, const(GLfloat)* v) PFNGLCOLOR4UBVERTEX3FVSUNPROC;
		alias void function(GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z) PFNGLCOLOR3FVERTEX3FSUNPROC;
		alias void function(const(GLfloat)* c, const(GLfloat)* v) PFNGLCOLOR3FVERTEX3FVSUNPROC;
		alias void function(GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z) PFNGLNORMAL3FVERTEX3FSUNPROC;
		alias void function(const(GLfloat)* n, const(GLfloat)* v) PFNGLNORMAL3FVERTEX3FVSUNPROC;
		alias void function(GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z) PFNGLCOLOR4FNORMAL3FVERTEX3FSUNPROC;
		alias void function(const(GLfloat)* c, const(GLfloat)* n, const(GLfloat)* v) PFNGLCOLOR4FNORMAL3FVERTEX3FVSUNPROC;
		alias void function(GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z) PFNGLTEXCOORD2FVERTEX3FSUNPROC;
		alias void function(const(GLfloat)* tc, const(GLfloat)* v) PFNGLTEXCOORD2FVERTEX3FVSUNPROC;
		alias void function(GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLTEXCOORD4FVERTEX4FSUNPROC;
		alias void function(const(GLfloat)* tc, const(GLfloat)* v) PFNGLTEXCOORD4FVERTEX4FVSUNPROC;
		alias void function(GLfloat s, GLfloat t, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z) PFNGLTEXCOORD2FCOLOR4UBVERTEX3FSUNPROC;
		alias void function(const(GLfloat)* tc, const(GLubyte)* c, const(GLfloat)* v) PFNGLTEXCOORD2FCOLOR4UBVERTEX3FVSUNPROC;
		alias void function(GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z) PFNGLTEXCOORD2FCOLOR3FVERTEX3FSUNPROC;
		alias void function(const(GLfloat)* tc, const(GLfloat)* c, const(GLfloat)* v) PFNGLTEXCOORD2FCOLOR3FVERTEX3FVSUNPROC;
		alias void function(GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z) PFNGLTEXCOORD2FNORMAL3FVERTEX3FSUNPROC;
		alias void function(const(GLfloat)* tc, const(GLfloat)* n, const(GLfloat)* v) PFNGLTEXCOORD2FNORMAL3FVERTEX3FVSUNPROC;
		alias void function(GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z) PFNGLTEXCOORD2FCOLOR4FNORMAL3FVERTEX3FSUNPROC;
		alias void function(const(GLfloat)* tc, const(GLfloat)* c, const(GLfloat)* n, const(GLfloat)* v) PFNGLTEXCOORD2FCOLOR4FNORMAL3FVERTEX3FVSUNPROC;
		alias void function(GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLTEXCOORD4FCOLOR4FNORMAL3FVERTEX4FSUNPROC;
		alias void function(const(GLfloat)* tc, const(GLfloat)* c, const(GLfloat)* n, const(GLfloat)* v) PFNGLTEXCOORD4FCOLOR4FNORMAL3FVERTEX4FVSUNPROC;
		alias void function(GLuint rc, GLfloat x, GLfloat y, GLfloat z) PFNGLREPLACEMENTCODEUIVERTEX3FSUNPROC;
		alias void function(const(GLuint)* rc, const(GLfloat)* v) PFNGLREPLACEMENTCODEUIVERTEX3FVSUNPROC;
		alias void function(GLuint rc, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z) PFNGLREPLACEMENTCODEUICOLOR4UBVERTEX3FSUNPROC;
		alias void function(const(GLuint)* rc, const(GLubyte)* c, const(GLfloat)* v) PFNGLREPLACEMENTCODEUICOLOR4UBVERTEX3FVSUNPROC;
		alias void function(GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z) PFNGLREPLACEMENTCODEUICOLOR3FVERTEX3FSUNPROC;
		alias void function(const(GLuint)* rc, const(GLfloat)* c, const(GLfloat)* v) PFNGLREPLACEMENTCODEUICOLOR3FVERTEX3FVSUNPROC;
		alias void function(GLuint rc, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z) PFNGLREPLACEMENTCODEUINORMAL3FVERTEX3FSUNPROC;
		alias void function(const(GLuint)* rc, const(GLfloat)* n, const(GLfloat)* v) PFNGLREPLACEMENTCODEUINORMAL3FVERTEX3FVSUNPROC;
		alias void function(GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z) PFNGLREPLACEMENTCODEUICOLOR4FNORMAL3FVERTEX3FSUNPROC;
		alias void function(const(GLuint)* rc, const(GLfloat)* c, const(GLfloat)* n, const(GLfloat)* v) PFNGLREPLACEMENTCODEUICOLOR4FNORMAL3FVERTEX3FVSUNPROC;
		alias void function(GLuint rc, GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z) PFNGLREPLACEMENTCODEUITEXCOORD2FVERTEX3FSUNPROC;
		alias void function(const(GLuint)* rc, const(GLfloat)* tc, const(GLfloat)* v) PFNGLREPLACEMENTCODEUITEXCOORD2FVERTEX3FVSUNPROC;
		alias void function(GLuint rc, GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z) PFNGLREPLACEMENTCODEUITEXCOORD2FNORMAL3FVERTEX3FSUNPROC;
		alias void function(const(GLuint)* rc, const(GLfloat)* tc, const(GLfloat)* n, const(GLfloat)* v) PFNGLREPLACEMENTCODEUITEXCOORD2FNORMAL3FVERTEX3FVSUNPROC;
		alias void function(GLuint rc, GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z) PFNGLREPLACEMENTCODEUITEXCOORD2FCOLOR4FNORMAL3FVERTEX3FSUNPROC;
		alias void function(const(GLuint)* rc, const(GLfloat)* tc, const(GLfloat)* c, const(GLfloat)* n, const(GLfloat)* v) PFNGLREPLACEMENTCODEUITEXCOORD2FCOLOR4FNORMAL3FVERTEX3FVSUNPROC;
	}
}

version (GL_EXT_blend_func_separate)
{
}
else
{
	extern (C)
	{
		void glBlendFuncSeparateEXT(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);

		alias void function(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha) PFNGLBLENDFUNCSEPARATEEXTPROC;
	}
}

version (GL_INGR_blend_func_separate)
{
}
else
{
	extern (C)
	{
		void glBlendFuncSeparateINGR(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);

		alias void function(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha) PFNGLBLENDFUNCSEPARATEINGRPROC;
	}
}

version (GL_INGR_color_clamp)
{
}
else
{
}

version (GL_INGR_interlace_read)
{
}
else
{
}

version (GL_EXT_stencil_wrap)
{
}
else
{
}

version (GL_EXT_422_pixels)
{
}
else
{
}

version (GL_NV_texgen_reflection)
{
}
else
{
}

version (GL_SUN_convolution_border_modes)
{
}
else
{
}

version (GL_EXT_texture_env_add)
{
}
else
{
}

version (GL_EXT_texture_lod_bias)
{
}
else
{
}

version (GL_EXT_texture_filter_anisotropic)
{
}
else
{
}

version (GL_EXT_vertex_weighting)
{
}
else
{
	extern (C)
	{
		void glVertexWeightfEXT(GLfloat weight);
		void glVertexWeightfvEXT(const(GLfloat)* weight);
		void glVertexWeightPointerEXT(GLsizei size, GLenum type, GLsizei stride, const(GLvoid)* pointer);

		alias void function(GLfloat weight) PFNGLVERTEXWEIGHTFEXTPROC;
		alias void function(const(GLfloat)* weight) PFNGLVERTEXWEIGHTFVEXTPROC;
		alias void function(GLsizei size, GLenum type, GLsizei stride, const(GLvoid)* pointer) PFNGLVERTEXWEIGHTPOINTEREXTPROC;
	}
}

version (GL_NV_light_max_exponent)
{
}
else
{
}

version (GL_NV_vertex_array_range)
{
}
else
{
	extern (C)
	{
		void glFlushVertexArrayRangeNV();
		void glVertexArrayRangeNV(GLsizei length, const(GLvoid)* pointer);

		alias void function() PFNGLFLUSHVERTEXARRAYRANGENVPROC;
		alias void function(GLsizei length, const(GLvoid)* pointer) PFNGLVERTEXARRAYRANGENVPROC;
	}
}

version (GL_NV_register_combiners)
{
}
else
{
	extern (C)
	{
		void glCombinerParameterfvNV(GLenum pname, const(GLfloat)* params);
		void glCombinerParameterfNV(GLenum pname, GLfloat param);
		void glCombinerParameterivNV(GLenum pname, const(GLint)* params);
		void glCombinerParameteriNV(GLenum pname, GLint param);
		void glCombinerInputNV(GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage);
		void glCombinerOutputNV(GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum);
		void glFinalCombinerInputNV(GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage);
		void glGetCombinerInputParameterfvNV(GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat* params);
		void glGetCombinerInputParameterivNV(GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint* params);
		void glGetCombinerOutputParameterfvNV(GLenum stage, GLenum portion, GLenum pname, GLfloat* params);
		void glGetCombinerOutputParameterivNV(GLenum stage, GLenum portion, GLenum pname, GLint* params);
		void glGetFinalCombinerInputParameterfvNV(GLenum variable, GLenum pname, GLfloat* params);
		void glGetFinalCombinerInputParameterivNV(GLenum variable, GLenum pname, GLint* params);

		alias void function(GLenum pname, const(GLfloat)* params) PFNGLCOMBINERPARAMETERFVNVPROC;
		alias void function(GLenum pname, GLfloat param) PFNGLCOMBINERPARAMETERFNVPROC;
		alias void function(GLenum pname, const(GLint)* params) PFNGLCOMBINERPARAMETERIVNVPROC;
		alias void function(GLenum pname, GLint param) PFNGLCOMBINERPARAMETERINVPROC;
		alias void function(GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage) PFNGLCOMBINERINPUTNVPROC;
		alias void function(GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum) PFNGLCOMBINEROUTPUTNVPROC;
		alias void function(GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage) PFNGLFINALCOMBINERINPUTNVPROC;
		alias void function(GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat* params) PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC;
		alias void function(GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint* params) PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC;
		alias void function(GLenum stage, GLenum portion, GLenum pname, GLfloat* params) PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC;
		alias void function(GLenum stage, GLenum portion, GLenum pname, GLint* params) PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC;
		alias void function(GLenum variable, GLenum pname, GLfloat* params) PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC;
		alias void function(GLenum variable, GLenum pname, GLint* params) PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC;
	}
}

version (GL_NV_fog_distance)
{
}
else
{
}

version (GL_NV_texgen_emboss)
{
}
else
{
}

version (GL_NV_blend_square)
{
}
else
{
}

version (GL_NV_texture_env_combine4)
{
}
else
{
}

version (GL_MESA_resize_buffers)
{
}
else
{
	extern (C)
	{
		void glResizeBuffersMESA();

		alias void function() PFNGLRESIZEBUFFERSMESAPROC;
	}
}

version (GL_MESA_window_pos)
{
}
else
{
	extern (C)
	{
		void glWindowPos2dMESA(GLdouble x, GLdouble y);
		void glWindowPos2dvMESA(const(GLdouble)* v);
		void glWindowPos2fMESA(GLfloat x, GLfloat y);
		void glWindowPos2fvMESA(const(GLfloat)* v);
		void glWindowPos2iMESA(GLint x, GLint y);
		void glWindowPos2ivMESA(const(GLint)* v);
		void glWindowPos2sMESA(GLshort x, GLshort y);
		void glWindowPos2svMESA(const(GLshort)* v);
		void glWindowPos3dMESA(GLdouble x, GLdouble y, GLdouble z);
		void glWindowPos3dvMESA(const(GLdouble)* v);
		void glWindowPos3fMESA(GLfloat x, GLfloat y, GLfloat z);
		void glWindowPos3fvMESA(const(GLfloat)* v);
		void glWindowPos3iMESA(GLint x, GLint y, GLint z);
		void glWindowPos3ivMESA(const(GLint)* v);
		void glWindowPos3sMESA(GLshort x, GLshort y, GLshort z);
		void glWindowPos3svMESA(const(GLshort)* v);
		void glWindowPos4dMESA(GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		void glWindowPos4dvMESA(const(GLdouble)* v);
		void glWindowPos4fMESA(GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glWindowPos4fvMESA(const(GLfloat)* v);
		void glWindowPos4iMESA(GLint x, GLint y, GLint z, GLint w);
		void glWindowPos4ivMESA(const(GLint)* v);
		void glWindowPos4sMESA(GLshort x, GLshort y, GLshort z, GLshort w);
		void glWindowPos4svMESA(const(GLshort)* v);

		alias void function(GLdouble x, GLdouble y) PFNGLWINDOWPOS2DMESAPROC;
		alias void function(const(GLdouble)* v) PFNGLWINDOWPOS2DVMESAPROC;
		alias void function(GLfloat x, GLfloat y) PFNGLWINDOWPOS2FMESAPROC;
		alias void function(const(GLfloat)* v) PFNGLWINDOWPOS2FVMESAPROC;
		alias void function(GLint x, GLint y) PFNGLWINDOWPOS2IMESAPROC;
		alias void function(const(GLint)* v) PFNGLWINDOWPOS2IVMESAPROC;
		alias void function(GLshort x, GLshort y) PFNGLWINDOWPOS2SMESAPROC;
		alias void function(const(GLshort)* v) PFNGLWINDOWPOS2SVMESAPROC;
		alias void function(GLdouble x, GLdouble y, GLdouble z) PFNGLWINDOWPOS3DMESAPROC;
		alias void function(const(GLdouble)* v) PFNGLWINDOWPOS3DVMESAPROC;
		alias void function(GLfloat x, GLfloat y, GLfloat z) PFNGLWINDOWPOS3FMESAPROC;
		alias void function(const(GLfloat)* v) PFNGLWINDOWPOS3FVMESAPROC;
		alias void function(GLint x, GLint y, GLint z) PFNGLWINDOWPOS3IMESAPROC;
		alias void function(const(GLint)* v) PFNGLWINDOWPOS3IVMESAPROC;
		alias void function(GLshort x, GLshort y, GLshort z) PFNGLWINDOWPOS3SMESAPROC;
		alias void function(const(GLshort)* v) PFNGLWINDOWPOS3SVMESAPROC;
		alias void function(GLdouble x, GLdouble y, GLdouble z, GLdouble w) PFNGLWINDOWPOS4DMESAPROC;
		alias void function(const(GLdouble)* v) PFNGLWINDOWPOS4DVMESAPROC;
		alias void function(GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLWINDOWPOS4FMESAPROC;
		alias void function(const(GLfloat)* v) PFNGLWINDOWPOS4FVMESAPROC;
		alias void function(GLint x, GLint y, GLint z, GLint w) PFNGLWINDOWPOS4IMESAPROC;
		alias void function(const(GLint)* v) PFNGLWINDOWPOS4IVMESAPROC;
		alias void function(GLshort x, GLshort y, GLshort z, GLshort w) PFNGLWINDOWPOS4SMESAPROC;
		alias void function(const(GLshort)* v) PFNGLWINDOWPOS4SVMESAPROC;
	}
}

version (GL_IBM_cull_vertex)
{
}
else
{
}

version (GL_IBM_multimode_draw_arrays)
{
}
else
{
	extern (C)
	{
		void glMultiModeDrawArraysIBM(const(GLenum)* mode, const(GLint)* first, const(GLsizei)* count, GLsizei primcount, GLint modestride);
		void glMultiModeDrawElementsIBM(const(GLenum)* mode, const(GLsizei)* count, GLenum type, const(GLvoid)** indices, GLsizei primcount, GLint modestride);

		alias void function(const(GLenum)* mode, const(GLint)* first, const(GLsizei)* count, GLsizei primcount, GLint modestride) PFNGLMULTIMODEDRAWARRAYSIBMPROC;
		alias void function(const(GLenum)* mode, const(GLsizei)* count, GLenum type, const(GLvoid)** indices, GLsizei primcount, GLint modestride) PFNGLMULTIMODEDRAWELEMENTSIBMPROC;
	}
}

version (GL_IBM_vertex_array_lists)
{
}
else
{
	extern (C)
	{
		void glColorPointerListIBM(GLint size, GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride);
		void glSecondaryColorPointerListIBM(GLint size, GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride);
		void glEdgeFlagPointerListIBM(GLint stride, const(GLboolean*)* pointer, GLint ptrstride);
		void glFogCoordPointerListIBM(GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride);
		void glIndexPointerListIBM(GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride);
		void glNormalPointerListIBM(GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride);
		void glTexCoordPointerListIBM(GLint size, GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride);
		void glVertexPointerListIBM(GLint size, GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride);

		alias void function(GLint size, GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride) PFNGLCOLORPOINTERLISTIBMPROC;
		alias void function(GLint size, GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride) PFNGLSECONDARYCOLORPOINTERLISTIBMPROC;
		alias void function(GLint stride, const(GLboolean*)* pointer, GLint ptrstride) PFNGLEDGEFLAGPOINTERLISTIBMPROC;
		alias void function(GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride) PFNGLFOGCOORDPOINTERLISTIBMPROC;
		alias void function(GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride) PFNGLINDEXPOINTERLISTIBMPROC;
		alias void function(GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride) PFNGLNORMALPOINTERLISTIBMPROC;
		alias void function(GLint size, GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride) PFNGLTEXCOORDPOINTERLISTIBMPROC;
		alias void function(GLint size, GLenum type, GLint stride, const(GLvoid*)* pointer, GLint ptrstride) PFNGLVERTEXPOINTERLISTIBMPROC;
	}
}

version (GL_SGIX_subsample)
{
}
else
{
}

version (GL_SGIX_ycrcba)
{
}
else
{
}

version (GL_SGIX_ycrcb_subsample)
{
}
else
{
}

version (GL_SGIX_depth_pass_instrument)
{
}
else
{
}

version (GL_3DFX_texture_compression_FXT1)
{
}
else
{
}

version (GL_3DFX_multisample)
{
}
else
{
}

version (GL_3DFX_tbuffer)
{
}
else
{
	extern (C)
	{
		void glTbufferMask3DFX(GLuint mask);

		alias void function(GLuint mask) PFNGLTBUFFERMASK3DFXPROC;
	}
}

version (GL_EXT_multisample)
{
}
else
{
	extern (C)
	{
		void glSampleMaskEXT(GLclampf value, GLboolean invert);
		void glSamplePatternEXT(GLenum pattern);

		alias void function(GLclampf value, GLboolean invert) PFNGLSAMPLEMASKEXTPROC;
		alias void function(GLenum pattern) PFNGLSAMPLEPATTERNEXTPROC;
	}
}

version (GL_SGIX_vertex_preclip)
{
}
else
{
}

version (GL_SGIX_convolution_accuracy)
{
}
else
{
}

version (GL_SGIX_resample)
{
}
else
{
}

version (GL_SGIS_point_line_texgen)
{
}
else
{
}

version (GL_SGIS_texture_color_mask)
{
}
else
{
	extern (C)
	{
		void glTextureColorMaskSGIS(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);

		alias void function(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha) PFNGLTEXTURECOLORMASKSGISPROC;
	}
}

version (GL_SGIX_igloo_interface)
{
}
else
{
	extern (C)
	{
		void glIglooInterfaceSGIX(GLenum pname, const(GLvoid)* params);

		alias void function(GLenum pname, const(GLvoid)* params) PFNGLIGLOOINTERFACESGIXPROC;
	}
}

version (GL_EXT_texture_env_dot3)
{
}
else
{
}

version (GL_ATI_texture_mirror_once)
{
}
else
{
}

version (GL_NV_fence)
{
}
else
{
	extern (C)
	{
		void glDeleteFencesNV(GLsizei n, const(GLuint)* fences);
		void glGenFencesNV(GLsizei n, GLuint* fences);
		GLboolean glIsFenceNV(GLuint fence);
		GLboolean glTestFenceNV(GLuint fence);
		void glGetFenceivNV(GLuint fence, GLenum pname, GLint* params);
		void glFinishFenceNV(GLuint fence);
		void glSetFenceNV(GLuint fence, GLenum condition);

		alias void function(GLsizei n, const(GLuint)* fences) PFNGLDELETEFENCESNVPROC;
		alias void function(GLsizei n, GLuint* fences) PFNGLGENFENCESNVPROC;
		alias GLboolean function(GLuint fence) PFNGLISFENCENVPROC;
		alias GLboolean function(GLuint fence) PFNGLTESTFENCENVPROC;
		alias void function(GLuint fence, GLenum pname, GLint* params) PFNGLGETFENCEIVNVPROC;
		alias void function(GLuint fence) PFNGLFINISHFENCENVPROC;
		alias void function(GLuint fence, GLenum condition) PFNGLSETFENCENVPROC;
	}
}

version (GL_NV_evaluators)
{
}
else
{
	extern (C)
	{
		void glMapControlPointsNV(GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLint uorder, GLint vorder, GLboolean packed, const(GLvoid)* points);
		void glMapParameterivNV(GLenum target, GLenum pname, const(GLint)* params);
		void glMapParameterfvNV(GLenum target, GLenum pname, const(GLfloat)* params);
		void glGetMapControlPointsNV(GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLboolean packed, GLvoid* points);
		void glGetMapParameterivNV(GLenum target, GLenum pname, GLint* params);
		void glGetMapParameterfvNV(GLenum target, GLenum pname, GLfloat* params);
		void glGetMapAttribParameterivNV(GLenum target, GLuint index, GLenum pname, GLint* params);
		void glGetMapAttribParameterfvNV(GLenum target, GLuint index, GLenum pname, GLfloat* params);
		void glEvalMapsNV(GLenum target, GLenum mode);

		alias void function(GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLint uorder, GLint vorder, GLboolean packed, const(GLvoid)* points) PFNGLMAPCONTROLPOINTSNVPROC;
		alias void function(GLenum target, GLenum pname, const(GLint)* params) PFNGLMAPPARAMETERIVNVPROC;
		alias void function(GLenum target, GLenum pname, const(GLfloat)* params) PFNGLMAPPARAMETERFVNVPROC;
		alias void function(GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLboolean packed, GLvoid* points) PFNGLGETMAPCONTROLPOINTSNVPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETMAPPARAMETERIVNVPROC;
		alias void function(GLenum target, GLenum pname, GLfloat* params) PFNGLGETMAPPARAMETERFVNVPROC;
		alias void function(GLenum target, GLuint index, GLenum pname, GLint* params) PFNGLGETMAPATTRIBPARAMETERIVNVPROC;
		alias void function(GLenum target, GLuint index, GLenum pname, GLfloat* params) PFNGLGETMAPATTRIBPARAMETERFVNVPROC;
		alias void function(GLenum target, GLenum mode) PFNGLEVALMAPSNVPROC;
	}
}

version (GL_NV_packed_depth_stencil)
{
}
else
{
}

version (GL_NV_register_combiners2)
{
}
else
{
	extern (C)
	{
		void glCombinerStageParameterfvNV(GLenum stage, GLenum pname, const(GLfloat)* params);
		void glGetCombinerStageParameterfvNV(GLenum stage, GLenum pname, GLfloat* params);

		alias void function(GLenum stage, GLenum pname, const(GLfloat)* params) PFNGLCOMBINERSTAGEPARAMETERFVNVPROC;
		alias void function(GLenum stage, GLenum pname, GLfloat* params) PFNGLGETCOMBINERSTAGEPARAMETERFVNVPROC;
	}
}

version (GL_NV_texture_compression_vtc)
{
}
else
{
}

version (GL_NV_texture_rectangle)
{
}
else
{
}

version (GL_NV_texture_shader)
{
}
else
{
}

version (GL_NV_texture_shader2)
{
}
else
{
}

version (GL_NV_vertex_array_range2)
{
}
else
{
}

version (GL_NV_vertex_program)
{
}
else
{
	extern (C)
	{
		GLboolean glAreProgramsResidentNV(GLsizei n, const(GLuint)* programs, GLboolean* residences);
		void glBindProgramNV(GLenum target, GLuint id);
		void glDeleteProgramsNV(GLsizei n, const(GLuint)* programs);
		void glExecuteProgramNV(GLenum target, GLuint id, const(GLfloat)* params);
		void glGenProgramsNV(GLsizei n, GLuint* programs);
		void glGetProgramParameterdvNV(GLenum target, GLuint index, GLenum pname, GLdouble* params);
		void glGetProgramParameterfvNV(GLenum target, GLuint index, GLenum pname, GLfloat* params);
		void glGetProgramivNV(GLuint id, GLenum pname, GLint* params);
		void glGetProgramStringNV(GLuint id, GLenum pname, GLubyte* program);
		void glGetTrackMatrixivNV(GLenum target, GLuint address, GLenum pname, GLint* params);
		void glGetVertexAttribdvNV(GLuint index, GLenum pname, GLdouble* params);
		void glGetVertexAttribfvNV(GLuint index, GLenum pname, GLfloat* params);
		void glGetVertexAttribivNV(GLuint index, GLenum pname, GLint* params);
		void glGetVertexAttribPointervNV(GLuint index, GLenum pname, GLvoid** pointer);
		GLboolean glIsProgramNV(GLuint id);
		void glLoadProgramNV(GLenum target, GLuint id, GLsizei len, const(GLubyte)* program);
		void glProgramParameter4dNV(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		void glProgramParameter4dvNV(GLenum target, GLuint index, const(GLdouble)* v);
		void glProgramParameter4fNV(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glProgramParameter4fvNV(GLenum target, GLuint index, const(GLfloat)* v);
		void glProgramParameters4dvNV(GLenum target, GLuint index, GLuint count, const(GLdouble)* v);
		void glProgramParameters4fvNV(GLenum target, GLuint index, GLuint count, const(GLfloat)* v);
		void glRequestResidentProgramsNV(GLsizei n, const(GLuint)* programs);
		void glTrackMatrixNV(GLenum target, GLuint address, GLenum matrix, GLenum transform);
		void glVertexAttribPointerNV(GLuint index, GLint fsize, GLenum type, GLsizei stride, const(GLvoid)* pointer);
		void glVertexAttrib1dNV(GLuint index, GLdouble x);
		void glVertexAttrib1dvNV(GLuint index, const(GLdouble)* v);
		void glVertexAttrib1fNV(GLuint index, GLfloat x);
		void glVertexAttrib1fvNV(GLuint index, const(GLfloat)* v);
		void glVertexAttrib1sNV(GLuint index, GLshort x);
		void glVertexAttrib1svNV(GLuint index, const(GLshort)* v);
		void glVertexAttrib2dNV(GLuint index, GLdouble x, GLdouble y);
		void glVertexAttrib2dvNV(GLuint index, const(GLdouble)* v);
		void glVertexAttrib2fNV(GLuint index, GLfloat x, GLfloat y);
		void glVertexAttrib2fvNV(GLuint index, const(GLfloat)* v);
		void glVertexAttrib2sNV(GLuint index, GLshort x, GLshort y);
		void glVertexAttrib2svNV(GLuint index, const(GLshort)* v);
		void glVertexAttrib3dNV(GLuint index, GLdouble x, GLdouble y, GLdouble z);
		void glVertexAttrib3dvNV(GLuint index, const(GLdouble)* v);
		void glVertexAttrib3fNV(GLuint index, GLfloat x, GLfloat y, GLfloat z);
		void glVertexAttrib3fvNV(GLuint index, const(GLfloat)* v);
		void glVertexAttrib3sNV(GLuint index, GLshort x, GLshort y, GLshort z);
		void glVertexAttrib3svNV(GLuint index, const(GLshort)* v);
		void glVertexAttrib4dNV(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		void glVertexAttrib4dvNV(GLuint index, const(GLdouble)* v);
		void glVertexAttrib4fNV(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glVertexAttrib4fvNV(GLuint index, const(GLfloat)* v);
		void glVertexAttrib4sNV(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
		void glVertexAttrib4svNV(GLuint index, const(GLshort)* v);
		void glVertexAttrib4ubNV(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
		void glVertexAttrib4ubvNV(GLuint index, const(GLubyte)* v);
		void glVertexAttribs1dvNV(GLuint index, GLsizei count, const(GLdouble)* v);
		void glVertexAttribs1fvNV(GLuint index, GLsizei count, const(GLfloat)* v);
		void glVertexAttribs1svNV(GLuint index, GLsizei count, const(GLshort)* v);
		void glVertexAttribs2dvNV(GLuint index, GLsizei count, const(GLdouble)* v);
		void glVertexAttribs2fvNV(GLuint index, GLsizei count, const(GLfloat)* v);
		void glVertexAttribs2svNV(GLuint index, GLsizei count, const(GLshort)* v);
		void glVertexAttribs3dvNV(GLuint index, GLsizei count, const(GLdouble)* v);
		void glVertexAttribs3fvNV(GLuint index, GLsizei count, const(GLfloat)* v);
		void glVertexAttribs3svNV(GLuint index, GLsizei count, const(GLshort)* v);
		void glVertexAttribs4dvNV(GLuint index, GLsizei count, const(GLdouble)* v);
		void glVertexAttribs4fvNV(GLuint index, GLsizei count, const(GLfloat)* v);
		void glVertexAttribs4svNV(GLuint index, GLsizei count, const(GLshort)* v);
		void glVertexAttribs4ubvNV(GLuint index, GLsizei count, const(GLubyte)* v);

		alias GLboolean function(GLsizei n, const(GLuint)* programs, GLboolean* residences) PFNGLAREPROGRAMSRESIDENTNVPROC;
		alias void function(GLenum target, GLuint id) PFNGLBINDPROGRAMNVPROC;
		alias void function(GLsizei n, const(GLuint)* programs) PFNGLDELETEPROGRAMSNVPROC;
		alias void function(GLenum target, GLuint id, const(GLfloat)* params) PFNGLEXECUTEPROGRAMNVPROC;
		alias void function(GLsizei n, GLuint* programs) PFNGLGENPROGRAMSNVPROC;
		alias void function(GLenum target, GLuint index, GLenum pname, GLdouble* params) PFNGLGETPROGRAMPARAMETERDVNVPROC;
		alias void function(GLenum target, GLuint index, GLenum pname, GLfloat* params) PFNGLGETPROGRAMPARAMETERFVNVPROC;
		alias void function(GLuint id, GLenum pname, GLint* params) PFNGLGETPROGRAMIVNVPROC;
		alias void function(GLuint id, GLenum pname, GLubyte* program) PFNGLGETPROGRAMSTRINGNVPROC;
		alias void function(GLenum target, GLuint address, GLenum pname, GLint* params) PFNGLGETTRACKMATRIXIVNVPROC;
		alias void function(GLuint index, GLenum pname, GLdouble* params) PFNGLGETVERTEXATTRIBDVNVPROC;
		alias void function(GLuint index, GLenum pname, GLfloat* params) PFNGLGETVERTEXATTRIBFVNVPROC;
		alias void function(GLuint index, GLenum pname, GLint* params) PFNGLGETVERTEXATTRIBIVNVPROC;
		alias void function(GLuint index, GLenum pname, GLvoid** pointer) PFNGLGETVERTEXATTRIBPOINTERVNVPROC;
		alias GLboolean function(GLuint id) PFNGLISPROGRAMNVPROC;
		alias void function(GLenum target, GLuint id, GLsizei len, const(GLubyte)* program) PFNGLLOADPROGRAMNVPROC;
		alias void function(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w) PFNGLPROGRAMPARAMETER4DNVPROC;
		alias void function(GLenum target, GLuint index, const(GLdouble)* v) PFNGLPROGRAMPARAMETER4DVNVPROC;
		alias void function(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLPROGRAMPARAMETER4FNVPROC;
		alias void function(GLenum target, GLuint index, const(GLfloat)* v) PFNGLPROGRAMPARAMETER4FVNVPROC;
		alias void function(GLenum target, GLuint index, GLuint count, const(GLdouble)* v) PFNGLPROGRAMPARAMETERS4DVNVPROC;
		alias void function(GLenum target, GLuint index, GLuint count, const(GLfloat)* v) PFNGLPROGRAMPARAMETERS4FVNVPROC;
		alias void function(GLsizei n, const(GLuint)* programs) PFNGLREQUESTRESIDENTPROGRAMSNVPROC;
		alias void function(GLenum target, GLuint address, GLenum matrix, GLenum transform) PFNGLTRACKMATRIXNVPROC;
		alias void function(GLuint index, GLint fsize, GLenum type, GLsizei stride, const(GLvoid)* pointer) PFNGLVERTEXATTRIBPOINTERNVPROC;
		alias void function(GLuint index, GLdouble x) PFNGLVERTEXATTRIB1DNVPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB1DVNVPROC;
		alias void function(GLuint index, GLfloat x) PFNGLVERTEXATTRIB1FNVPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB1FVNVPROC;
		alias void function(GLuint index, GLshort x) PFNGLVERTEXATTRIB1SNVPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB1SVNVPROC;
		alias void function(GLuint index, GLdouble x, GLdouble y) PFNGLVERTEXATTRIB2DNVPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB2DVNVPROC;
		alias void function(GLuint index, GLfloat x, GLfloat y) PFNGLVERTEXATTRIB2FNVPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB2FVNVPROC;
		alias void function(GLuint index, GLshort x, GLshort y) PFNGLVERTEXATTRIB2SNVPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB2SVNVPROC;
		alias void function(GLuint index, GLdouble x, GLdouble y, GLdouble z) PFNGLVERTEXATTRIB3DNVPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB3DVNVPROC;
		alias void function(GLuint index, GLfloat x, GLfloat y, GLfloat z) PFNGLVERTEXATTRIB3FNVPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB3FVNVPROC;
		alias void function(GLuint index, GLshort x, GLshort y, GLshort z) PFNGLVERTEXATTRIB3SNVPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB3SVNVPROC;
		alias void function(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w) PFNGLVERTEXATTRIB4DNVPROC;
		alias void function(GLuint index, const(GLdouble)* v) PFNGLVERTEXATTRIB4DVNVPROC;
		alias void function(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLVERTEXATTRIB4FNVPROC;
		alias void function(GLuint index, const(GLfloat)* v) PFNGLVERTEXATTRIB4FVNVPROC;
		alias void function(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w) PFNGLVERTEXATTRIB4SNVPROC;
		alias void function(GLuint index, const(GLshort)* v) PFNGLVERTEXATTRIB4SVNVPROC;
		alias void function(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w) PFNGLVERTEXATTRIB4UBNVPROC;
		alias void function(GLuint index, const(GLubyte)* v) PFNGLVERTEXATTRIB4UBVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLdouble)* v) PFNGLVERTEXATTRIBS1DVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLfloat)* v) PFNGLVERTEXATTRIBS1FVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLshort)* v) PFNGLVERTEXATTRIBS1SVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLdouble)* v) PFNGLVERTEXATTRIBS2DVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLfloat)* v) PFNGLVERTEXATTRIBS2FVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLshort)* v) PFNGLVERTEXATTRIBS2SVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLdouble)* v) PFNGLVERTEXATTRIBS3DVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLfloat)* v) PFNGLVERTEXATTRIBS3FVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLshort)* v) PFNGLVERTEXATTRIBS3SVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLdouble)* v) PFNGLVERTEXATTRIBS4DVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLfloat)* v) PFNGLVERTEXATTRIBS4FVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLshort)* v) PFNGLVERTEXATTRIBS4SVNVPROC;
		alias void function(GLuint index, GLsizei count, const(GLubyte)* v) PFNGLVERTEXATTRIBS4UBVNVPROC;
	}
}

version (GL_SGIX_texture_coordinate_clamp)
{
}
else
{
}

version (GL_SGIX_scalebias_hint)
{
}
else
{
}

version (GL_OML_interlace)
{
}
else
{
}

version (GL_OML_subsample)
{
}
else
{
}

version (GL_OML_resample)
{
}
else
{
}

version (GL_NV_copy_depth_to_color)
{
}
else
{
}

version (GL_ATI_envmap_bumpmap)
{
}
else
{
	extern (C)
	{
		void glTexBumpParameterivATI(GLenum pname, const(GLint)* param);
		void glTexBumpParameterfvATI(GLenum pname, const(GLfloat)* param);
		void glGetTexBumpParameterivATI(GLenum pname, GLint* param);
		void glGetTexBumpParameterfvATI(GLenum pname, GLfloat* param);

		alias void function(GLenum pname, const(GLint)* param) PFNGLTEXBUMPPARAMETERIVATIPROC;
		alias void function(GLenum pname, const(GLfloat)* param) PFNGLTEXBUMPPARAMETERFVATIPROC;
		alias void function(GLenum pname, GLint* param) PFNGLGETTEXBUMPPARAMETERIVATIPROC;
		alias void function(GLenum pname, GLfloat* param) PFNGLGETTEXBUMPPARAMETERFVATIPROC;
	}
}

version (GL_ATI_fragment_shader)
{
}
else
{
	extern (C)
	{
		GLuint glGenFragmentShadersATI(GLuint range);
		void glBindFragmentShaderATI(GLuint id);
		void glDeleteFragmentShaderATI(GLuint id);
		void glBeginFragmentShaderATI();
		void glEndFragmentShaderATI();
		void glPassTexCoordATI(GLuint dst, GLuint coord, GLenum swizzle);
		void glSampleMapATI(GLuint dst, GLuint interp, GLenum swizzle);
		void glColorFragmentOp1ATI(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod);
		void glColorFragmentOp2ATI(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod);
		void glColorFragmentOp3ATI(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod);
		void glAlphaFragmentOp1ATI(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod);
		void glAlphaFragmentOp2ATI(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod);
		void glAlphaFragmentOp3ATI(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod);
		void glSetFragmentShaderConstantATI(GLuint dst, const(GLfloat)* value);

		alias GLuint function(GLuint range) PFNGLGENFRAGMENTSHADERSATIPROC;
		alias void function(GLuint id) PFNGLBINDFRAGMENTSHADERATIPROC;
		alias void function(GLuint id) PFNGLDELETEFRAGMENTSHADERATIPROC;
		alias void function() PFNGLBEGINFRAGMENTSHADERATIPROC;
		alias void function() PFNGLENDFRAGMENTSHADERATIPROC;
		alias void function(GLuint dst, GLuint coord, GLenum swizzle) PFNGLPASSTEXCOORDATIPROC;
		alias void function(GLuint dst, GLuint interp, GLenum swizzle) PFNGLSAMPLEMAPATIPROC;
		alias void function(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod) PFNGLCOLORFRAGMENTOP1ATIPROC;
		alias void function(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod) PFNGLCOLORFRAGMENTOP2ATIPROC;
		alias void function(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod) PFNGLCOLORFRAGMENTOP3ATIPROC;
		alias void function(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod) PFNGLALPHAFRAGMENTOP1ATIPROC;
		alias void function(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod) PFNGLALPHAFRAGMENTOP2ATIPROC;
		alias void function(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod) PFNGLALPHAFRAGMENTOP3ATIPROC;
		alias void function(GLuint dst, const(GLfloat)* value) PFNGLSETFRAGMENTSHADERCONSTANTATIPROC;
	}
}

version (GL_ATI_pn_triangles)
{
}
else
{
	extern (C)
	{
		void glPNTrianglesiATI(GLenum pname, GLint param);
		void glPNTrianglesfATI(GLenum pname, GLfloat param);

		alias void function(GLenum pname, GLint param) PFNGLPNTRIANGLESIATIPROC;
		alias void function(GLenum pname, GLfloat param) PFNGLPNTRIANGLESFATIPROC;
	}
}

version (GL_ATI_vertex_array_object)
{
}
else
{
	extern (C)
	{
		GLuint glNewObjectBufferATI(GLsizei size, const(GLvoid)* pointer, GLenum usage);
		GLboolean glIsObjectBufferATI(GLuint buffer);
		void glUpdateObjectBufferATI(GLuint buffer, GLuint offset, GLsizei size, const(GLvoid)* pointer, GLenum preserve);
		void glGetObjectBufferfvATI(GLuint buffer, GLenum pname, GLfloat* params);
		void glGetObjectBufferivATI(GLuint buffer, GLenum pname, GLint* params);
		void glFreeObjectBufferATI(GLuint buffer);
		void glArrayObjectATI(GLenum array, GLint size, GLenum type, GLsizei stride, GLuint buffer, GLuint offset);
		void glGetArrayObjectfvATI(GLenum array, GLenum pname, GLfloat* params);
		void glGetArrayObjectivATI(GLenum array, GLenum pname, GLint* params);
		void glVariantArrayObjectATI(GLuint id, GLenum type, GLsizei stride, GLuint buffer, GLuint offset);
		void glGetVariantArrayObjectfvATI(GLuint id, GLenum pname, GLfloat* params);
		void glGetVariantArrayObjectivATI(GLuint id, GLenum pname, GLint* params);

		alias GLuint function(GLsizei size, const(GLvoid)* pointer, GLenum usage) PFNGLNEWOBJECTBUFFERATIPROC;
		alias GLboolean function(GLuint buffer) PFNGLISOBJECTBUFFERATIPROC;
		alias void function(GLuint buffer, GLuint offset, GLsizei size, const(GLvoid)* pointer, GLenum preserve) PFNGLUPDATEOBJECTBUFFERATIPROC;
		alias void function(GLuint buffer, GLenum pname, GLfloat* params) PFNGLGETOBJECTBUFFERFVATIPROC;
		alias void function(GLuint buffer, GLenum pname, GLint* params) PFNGLGETOBJECTBUFFERIVATIPROC;
		alias void function(GLuint buffer) PFNGLFREEOBJECTBUFFERATIPROC;
		alias void function(GLenum array, GLint size, GLenum type, GLsizei stride, GLuint buffer, GLuint offset) PFNGLARRAYOBJECTATIPROC;
		alias void function(GLenum array, GLenum pname, GLfloat* params) PFNGLGETARRAYOBJECTFVATIPROC;
		alias void function(GLenum array, GLenum pname, GLint* params) PFNGLGETARRAYOBJECTIVATIPROC;
		alias void function(GLuint id, GLenum type, GLsizei stride, GLuint buffer, GLuint offset) PFNGLVARIANTARRAYOBJECTATIPROC;
		alias void function(GLuint id, GLenum pname, GLfloat* params) PFNGLGETVARIANTARRAYOBJECTFVATIPROC;
		alias void function(GLuint id, GLenum pname, GLint* params) PFNGLGETVARIANTARRAYOBJECTIVATIPROC;
	}
}

version (GL_EXT_vertex_shader)
{
}
else
{
	extern (C)
	{
		void glBeginVertexShaderEXT();
		void glEndVertexShaderEXT();
		void glBindVertexShaderEXT(GLuint id);
		GLuint glGenVertexShadersEXT(GLuint range);
		void glDeleteVertexShaderEXT(GLuint id);
		void glShaderOp1EXT(GLenum op, GLuint res, GLuint arg1);
		void glShaderOp2EXT(GLenum op, GLuint res, GLuint arg1, GLuint arg2);
		void glShaderOp3EXT(GLenum op, GLuint res, GLuint arg1, GLuint arg2, GLuint arg3);
		void glSwizzleEXT(GLuint res, GLuint input, GLenum outX, GLenum outY, GLenum outZ, GLenum outW);
		void glWriteMaskEXT(GLuint res, GLuint input, GLenum outX, GLenum outY, GLenum outZ, GLenum outW);
		void glInsertComponentEXT(GLuint res, GLuint src, GLuint num);
		void glExtractComponentEXT(GLuint res, GLuint src, GLuint num);
		GLuint glGenSymbolsEXT(GLenum datatype, GLenum storagetype, GLenum range, GLuint components);
		void glSetInvariantEXT(GLuint id, GLenum type, const(GLvoid)* addr);
		void glSetLocalConstantEXT(GLuint id, GLenum type, const(GLvoid)* addr);
		void glVariantbvEXT(GLuint id, const(GLbyte)* addr);
		void glVariantsvEXT(GLuint id, const(GLshort)* addr);
		void glVariantivEXT(GLuint id, const(GLint)* addr);
		void glVariantfvEXT(GLuint id, const(GLfloat)* addr);
		void glVariantdvEXT(GLuint id, const(GLdouble)* addr);
		void glVariantubvEXT(GLuint id, const(GLubyte)* addr);
		void glVariantusvEXT(GLuint id, const(GLushort)* addr);
		void glVariantuivEXT(GLuint id, const(GLuint)* addr);
		void glVariantPointerEXT(GLuint id, GLenum type, GLuint stride, const(GLvoid)* addr);
		void glEnableVariantClientStateEXT(GLuint id);
		void glDisableVariantClientStateEXT(GLuint id);
		GLuint glBindLightParameterEXT(GLenum light, GLenum value);
		GLuint glBindMaterialParameterEXT(GLenum face, GLenum value);
		GLuint glBindTexGenParameterEXT(GLenum unit, GLenum coord, GLenum value);
		GLuint glBindTextureUnitParameterEXT(GLenum unit, GLenum value);
		GLuint glBindParameterEXT(GLenum value);
		GLboolean glIsVariantEnabledEXT(GLuint id, GLenum cap);
		void glGetVariantBooleanvEXT(GLuint id, GLenum value, GLboolean* data);
		void glGetVariantIntegervEXT(GLuint id, GLenum value, GLint* data);
		void glGetVariantFloatvEXT(GLuint id, GLenum value, GLfloat* data);
		void glGetVariantPointervEXT(GLuint id, GLenum value, GLvoid** data);
		void glGetInvariantBooleanvEXT(GLuint id, GLenum value, GLboolean* data);
		void glGetInvariantIntegervEXT(GLuint id, GLenum value, GLint* data);
		void glGetInvariantFloatvEXT(GLuint id, GLenum value, GLfloat* data);
		void glGetLocalConstantBooleanvEXT(GLuint id, GLenum value, GLboolean* data);
		void glGetLocalConstantIntegervEXT(GLuint id, GLenum value, GLint* data);
		void glGetLocalConstantFloatvEXT(GLuint id, GLenum value, GLfloat* data);

		alias void function() PFNGLBEGINVERTEXSHADEREXTPROC;
		alias void function() PFNGLENDVERTEXSHADEREXTPROC;
		alias void function(GLuint id) PFNGLBINDVERTEXSHADEREXTPROC;
		alias GLuint function(GLuint range) PFNGLGENVERTEXSHADERSEXTPROC;
		alias void function(GLuint id) PFNGLDELETEVERTEXSHADEREXTPROC;
		alias void function(GLenum op, GLuint res, GLuint arg1) PFNGLSHADEROP1EXTPROC;
		alias void function(GLenum op, GLuint res, GLuint arg1, GLuint arg2) PFNGLSHADEROP2EXTPROC;
		alias void function(GLenum op, GLuint res, GLuint arg1, GLuint arg2, GLuint arg3) PFNGLSHADEROP3EXTPROC;
		alias void function(GLuint res, GLuint input, GLenum outX, GLenum outY, GLenum outZ, GLenum outW) PFNGLSWIZZLEEXTPROC;
		alias void function(GLuint res, GLuint input, GLenum outX, GLenum outY, GLenum outZ, GLenum outW) PFNGLWRITEMASKEXTPROC;
		alias void function(GLuint res, GLuint src, GLuint num) PFNGLINSERTCOMPONENTEXTPROC;
		alias void function(GLuint res, GLuint src, GLuint num) PFNGLEXTRACTCOMPONENTEXTPROC;
		alias GLuint function(GLenum datatype, GLenum storagetype, GLenum range, GLuint components) PFNGLGENSYMBOLSEXTPROC;
		alias void function(GLuint id, GLenum type, const(GLvoid)* addr) PFNGLSETINVARIANTEXTPROC;
		alias void function(GLuint id, GLenum type, const(GLvoid)* addr) PFNGLSETLOCALCONSTANTEXTPROC;
		alias void function(GLuint id, const(GLbyte)* addr) PFNGLVARIANTBVEXTPROC;
		alias void function(GLuint id, const(GLshort)* addr) PFNGLVARIANTSVEXTPROC;
		alias void function(GLuint id, const(GLint)* addr) PFNGLVARIANTIVEXTPROC;
		alias void function(GLuint id, const(GLfloat)* addr) PFNGLVARIANTFVEXTPROC;
		alias void function(GLuint id, const(GLdouble)* addr) PFNGLVARIANTDVEXTPROC;
		alias void function(GLuint id, const(GLubyte)* addr) PFNGLVARIANTUBVEXTPROC;
		alias void function(GLuint id, const(GLushort)* addr) PFNGLVARIANTUSVEXTPROC;
		alias void function(GLuint id, const(GLuint)* addr) PFNGLVARIANTUIVEXTPROC;
		alias void function(GLuint id, GLenum type, GLuint stride, const(GLvoid)* addr) PFNGLVARIANTPOINTEREXTPROC;
		alias void function(GLuint id) PFNGLENABLEVARIANTCLIENTSTATEEXTPROC;
		alias void function(GLuint id) PFNGLDISABLEVARIANTCLIENTSTATEEXTPROC;
		alias GLuint function(GLenum light, GLenum value) PFNGLBINDLIGHTPARAMETEREXTPROC;
		alias GLuint function(GLenum face, GLenum value) PFNGLBINDMATERIALPARAMETEREXTPROC;
		alias GLuint function(GLenum unit, GLenum coord, GLenum value) PFNGLBINDTEXGENPARAMETEREXTPROC;
		alias GLuint function(GLenum unit, GLenum value) PFNGLBINDTEXTUREUNITPARAMETEREXTPROC;
		alias GLuint function(GLenum value) PFNGLBINDPARAMETEREXTPROC;
		alias GLboolean function(GLuint id, GLenum cap) PFNGLISVARIANTENABLEDEXTPROC;
		alias void function(GLuint id, GLenum value, GLboolean* data) PFNGLGETVARIANTBOOLEANVEXTPROC;
		alias void function(GLuint id, GLenum value, GLint* data) PFNGLGETVARIANTINTEGERVEXTPROC;
		alias void function(GLuint id, GLenum value, GLfloat* data) PFNGLGETVARIANTFLOATVEXTPROC;
		alias void function(GLuint id, GLenum value, GLvoid** data) PFNGLGETVARIANTPOINTERVEXTPROC;
		alias void function(GLuint id, GLenum value, GLboolean* data) PFNGLGETINVARIANTBOOLEANVEXTPROC;
		alias void function(GLuint id, GLenum value, GLint* data) PFNGLGETINVARIANTINTEGERVEXTPROC;
		alias void function(GLuint id, GLenum value, GLfloat* data) PFNGLGETINVARIANTFLOATVEXTPROC;
		alias void function(GLuint id, GLenum value, GLboolean* data) PFNGLGETLOCALCONSTANTBOOLEANVEXTPROC;
		alias void function(GLuint id, GLenum value, GLint* data) PFNGLGETLOCALCONSTANTINTEGERVEXTPROC;
		alias void function(GLuint id, GLenum value, GLfloat* data) PFNGLGETLOCALCONSTANTFLOATVEXTPROC;
	}
}

version (GL_ATI_vertex_streams)
{
}
else
{
	extern (C)
	{
		void glVertexStream1sATI(GLenum stream, GLshort x);
		void glVertexStream1svATI(GLenum stream, const(GLshort)* coords);
		void glVertexStream1iATI(GLenum stream, GLint x);
		void glVertexStream1ivATI(GLenum stream, const(GLint)* coords);
		void glVertexStream1fATI(GLenum stream, GLfloat x);
		void glVertexStream1fvATI(GLenum stream, const(GLfloat)* coords);
		void glVertexStream1dATI(GLenum stream, GLdouble x);
		void glVertexStream1dvATI(GLenum stream, const(GLdouble)* coords);
		void glVertexStream2sATI(GLenum stream, GLshort x, GLshort y);
		void glVertexStream2svATI(GLenum stream, const(GLshort)* coords);
		void glVertexStream2iATI(GLenum stream, GLint x, GLint y);
		void glVertexStream2ivATI(GLenum stream, const(GLint)* coords);
		void glVertexStream2fATI(GLenum stream, GLfloat x, GLfloat y);
		void glVertexStream2fvATI(GLenum stream, const(GLfloat)* coords);
		void glVertexStream2dATI(GLenum stream, GLdouble x, GLdouble y);
		void glVertexStream2dvATI(GLenum stream, const(GLdouble)* coords);
		void glVertexStream3sATI(GLenum stream, GLshort x, GLshort y, GLshort z);
		void glVertexStream3svATI(GLenum stream, const(GLshort)* coords);
		void glVertexStream3iATI(GLenum stream, GLint x, GLint y, GLint z);
		void glVertexStream3ivATI(GLenum stream, const(GLint)* coords);
		void glVertexStream3fATI(GLenum stream, GLfloat x, GLfloat y, GLfloat z);
		void glVertexStream3fvATI(GLenum stream, const(GLfloat)* coords);
		void glVertexStream3dATI(GLenum stream, GLdouble x, GLdouble y, GLdouble z);
		void glVertexStream3dvATI(GLenum stream, const(GLdouble)* coords);
		void glVertexStream4sATI(GLenum stream, GLshort x, GLshort y, GLshort z, GLshort w);
		void glVertexStream4svATI(GLenum stream, const(GLshort)* coords);
		void glVertexStream4iATI(GLenum stream, GLint x, GLint y, GLint z, GLint w);
		void glVertexStream4ivATI(GLenum stream, const(GLint)* coords);
		void glVertexStream4fATI(GLenum stream, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glVertexStream4fvATI(GLenum stream, const(GLfloat)* coords);
		void glVertexStream4dATI(GLenum stream, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		void glVertexStream4dvATI(GLenum stream, const(GLdouble)* coords);
		void glNormalStream3bATI(GLenum stream, GLbyte nx, GLbyte ny, GLbyte nz);
		void glNormalStream3bvATI(GLenum stream, const(GLbyte)* coords);
		void glNormalStream3sATI(GLenum stream, GLshort nx, GLshort ny, GLshort nz);
		void glNormalStream3svATI(GLenum stream, const(GLshort)* coords);
		void glNormalStream3iATI(GLenum stream, GLint nx, GLint ny, GLint nz);
		void glNormalStream3ivATI(GLenum stream, const(GLint)* coords);
		void glNormalStream3fATI(GLenum stream, GLfloat nx, GLfloat ny, GLfloat nz);
		void glNormalStream3fvATI(GLenum stream, const(GLfloat)* coords);
		void glNormalStream3dATI(GLenum stream, GLdouble nx, GLdouble ny, GLdouble nz);
		void glNormalStream3dvATI(GLenum stream, const(GLdouble)* coords);
		void glClientActiveVertexStreamATI(GLenum stream);
		void glVertexBlendEnviATI(GLenum pname, GLint param);
		void glVertexBlendEnvfATI(GLenum pname, GLfloat param);

		alias void function(GLenum stream, GLshort x) PFNGLVERTEXSTREAM1SATIPROC;
		alias void function(GLenum stream, const(GLshort)* coords) PFNGLVERTEXSTREAM1SVATIPROC;
		alias void function(GLenum stream, GLint x) PFNGLVERTEXSTREAM1IATIPROC;
		alias void function(GLenum stream, const(GLint)* coords) PFNGLVERTEXSTREAM1IVATIPROC;
		alias void function(GLenum stream, GLfloat x) PFNGLVERTEXSTREAM1FATIPROC;
		alias void function(GLenum stream, const(GLfloat)* coords) PFNGLVERTEXSTREAM1FVATIPROC;
		alias void function(GLenum stream, GLdouble x) PFNGLVERTEXSTREAM1DATIPROC;
		alias void function(GLenum stream, const(GLdouble)* coords) PFNGLVERTEXSTREAM1DVATIPROC;
		alias void function(GLenum stream, GLshort x, GLshort y) PFNGLVERTEXSTREAM2SATIPROC;
		alias void function(GLenum stream, const(GLshort)* coords) PFNGLVERTEXSTREAM2SVATIPROC;
		alias void function(GLenum stream, GLint x, GLint y) PFNGLVERTEXSTREAM2IATIPROC;
		alias void function(GLenum stream, const(GLint)* coords) PFNGLVERTEXSTREAM2IVATIPROC;
		alias void function(GLenum stream, GLfloat x, GLfloat y) PFNGLVERTEXSTREAM2FATIPROC;
		alias void function(GLenum stream, const(GLfloat)* coords) PFNGLVERTEXSTREAM2FVATIPROC;
		alias void function(GLenum stream, GLdouble x, GLdouble y) PFNGLVERTEXSTREAM2DATIPROC;
		alias void function(GLenum stream, const(GLdouble)* coords) PFNGLVERTEXSTREAM2DVATIPROC;
		alias void function(GLenum stream, GLshort x, GLshort y, GLshort z) PFNGLVERTEXSTREAM3SATIPROC;
		alias void function(GLenum stream, const(GLshort)* coords) PFNGLVERTEXSTREAM3SVATIPROC;
		alias void function(GLenum stream, GLint x, GLint y, GLint z) PFNGLVERTEXSTREAM3IATIPROC;
		alias void function(GLenum stream, const(GLint)* coords) PFNGLVERTEXSTREAM3IVATIPROC;
		alias void function(GLenum stream, GLfloat x, GLfloat y, GLfloat z) PFNGLVERTEXSTREAM3FATIPROC;
		alias void function(GLenum stream, const(GLfloat)* coords) PFNGLVERTEXSTREAM3FVATIPROC;
		alias void function(GLenum stream, GLdouble x, GLdouble y, GLdouble z) PFNGLVERTEXSTREAM3DATIPROC;
		alias void function(GLenum stream, const(GLdouble)* coords) PFNGLVERTEXSTREAM3DVATIPROC;
		alias void function(GLenum stream, GLshort x, GLshort y, GLshort z, GLshort w) PFNGLVERTEXSTREAM4SATIPROC;
		alias void function(GLenum stream, const(GLshort)* coords) PFNGLVERTEXSTREAM4SVATIPROC;
		alias void function(GLenum stream, GLint x, GLint y, GLint z, GLint w) PFNGLVERTEXSTREAM4IATIPROC;
		alias void function(GLenum stream, const(GLint)* coords) PFNGLVERTEXSTREAM4IVATIPROC;
		alias void function(GLenum stream, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLVERTEXSTREAM4FATIPROC;
		alias void function(GLenum stream, const(GLfloat)* coords) PFNGLVERTEXSTREAM4FVATIPROC;
		alias void function(GLenum stream, GLdouble x, GLdouble y, GLdouble z, GLdouble w) PFNGLVERTEXSTREAM4DATIPROC;
		alias void function(GLenum stream, const(GLdouble)* coords) PFNGLVERTEXSTREAM4DVATIPROC;
		alias void function(GLenum stream, GLbyte nx, GLbyte ny, GLbyte nz) PFNGLNORMALSTREAM3BATIPROC;
		alias void function(GLenum stream, const(GLbyte)* coords) PFNGLNORMALSTREAM3BVATIPROC;
		alias void function(GLenum stream, GLshort nx, GLshort ny, GLshort nz) PFNGLNORMALSTREAM3SATIPROC;
		alias void function(GLenum stream, const(GLshort)* coords) PFNGLNORMALSTREAM3SVATIPROC;
		alias void function(GLenum stream, GLint nx, GLint ny, GLint nz) PFNGLNORMALSTREAM3IATIPROC;
		alias void function(GLenum stream, const(GLint)* coords) PFNGLNORMALSTREAM3IVATIPROC;
		alias void function(GLenum stream, GLfloat nx, GLfloat ny, GLfloat nz) PFNGLNORMALSTREAM3FATIPROC;
		alias void function(GLenum stream, const(GLfloat)* coords) PFNGLNORMALSTREAM3FVATIPROC;
		alias void function(GLenum stream, GLdouble nx, GLdouble ny, GLdouble nz) PFNGLNORMALSTREAM3DATIPROC;
		alias void function(GLenum stream, const(GLdouble)* coords) PFNGLNORMALSTREAM3DVATIPROC;
		alias void function(GLenum stream) PFNGLCLIENTACTIVEVERTEXSTREAMATIPROC;
		alias void function(GLenum pname, GLint param) PFNGLVERTEXBLENDENVIATIPROC;
		alias void function(GLenum pname, GLfloat param) PFNGLVERTEXBLENDENVFATIPROC;
	}
}

version (GL_ATI_element_array)
{
}
else
{
	extern (C)
	{
		void glElementPointerATI(GLenum type, const(GLvoid)* pointer);
		void glDrawElementArrayATI(GLenum mode, GLsizei count);
		void glDrawRangeElementArrayATI(GLenum mode, GLuint start, GLuint end, GLsizei count);

		alias void function(GLenum type, const(GLvoid)* pointer) PFNGLELEMENTPOINTERATIPROC;
		alias void function(GLenum mode, GLsizei count) PFNGLDRAWELEMENTARRAYATIPROC;
		alias void function(GLenum mode, GLuint start, GLuint end, GLsizei count) PFNGLDRAWRANGEELEMENTARRAYATIPROC;
	}
}

version (GL_SUN_mesh_array)
{
}
else
{
	extern (C)
	{
		void glDrawMeshArraysSUN(GLenum mode, GLint first, GLsizei count, GLsizei width);

		alias void function(GLenum mode, GLint first, GLsizei count, GLsizei width) PFNGLDRAWMESHARRAYSSUNPROC;
	}
}

version (GL_SUN_slice_accum)
{
}
else
{
}

version (GL_NV_multisample_filter_hint)
{
}
else
{
}

version (GL_NV_depth_clamp)
{
}
else
{
}

version (GL_NV_occlusion_query)
{
}
else
{
	extern (C)
	{
		void glGenOcclusionQueriesNV(GLsizei n, GLuint* ids);
		void glDeleteOcclusionQueriesNV(GLsizei n, const(GLuint)* ids);
		GLboolean glIsOcclusionQueryNV(GLuint id);
		void glBeginOcclusionQueryNV(GLuint id);
		void glEndOcclusionQueryNV();
		void glGetOcclusionQueryivNV(GLuint id, GLenum pname, GLint* params);
		void glGetOcclusionQueryuivNV(GLuint id, GLenum pname, GLuint* params);

		alias void function(GLsizei n, GLuint* ids) PFNGLGENOCCLUSIONQUERIESNVPROC;
		alias void function(GLsizei n, const(GLuint)* ids) PFNGLDELETEOCCLUSIONQUERIESNVPROC;
		alias GLboolean function(GLuint id) PFNGLISOCCLUSIONQUERYNVPROC;
		alias void function(GLuint id) PFNGLBEGINOCCLUSIONQUERYNVPROC;
		alias void function() PFNGLENDOCCLUSIONQUERYNVPROC;
		alias void function(GLuint id, GLenum pname, GLint* params) PFNGLGETOCCLUSIONQUERYIVNVPROC;
		alias void function(GLuint id, GLenum pname, GLuint* params) PFNGLGETOCCLUSIONQUERYUIVNVPROC;
	}
}

version (GL_NV_point_sprite)
{
}
else
{
	extern (C)
	{
		void glPointParameteriNV(GLenum pname, GLint param);
		void glPointParameterivNV(GLenum pname, const(GLint)* params);

		alias void function(GLenum pname, GLint param) PFNGLPOINTPARAMETERINVPROC;
		alias void function(GLenum pname, const(GLint)* params) PFNGLPOINTPARAMETERIVNVPROC;
	}
}

version (GL_NV_texture_shader3)
{
}
else
{
}

version (GL_NV_vertex_program1_1)
{
}
else
{
}

version (GL_EXT_shadow_funcs)
{
}
else
{
}

version (GL_EXT_stencil_two_side)
{
}
else
{
	extern (C)
	{
		void glActiveStencilFaceEXT(GLenum face);

		alias void function(GLenum face) PFNGLACTIVESTENCILFACEEXTPROC;
	}
}

version (GL_ATI_text_fragment_shader)
{
}
else
{
}

version (GL_APPLE_client_storage)
{
}
else
{
}

version (GL_APPLE_element_array)
{
}
else
{
	extern (C)
	{
		void glElementPointerAPPLE(GLenum type, const(GLvoid)* pointer);
		void glDrawElementArrayAPPLE(GLenum mode, GLint first, GLsizei count);
		void glDrawRangeElementArrayAPPLE(GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count);
		void glMultiDrawElementArrayAPPLE(GLenum mode, const(GLint)* first, const(GLsizei)* count, GLsizei primcount);
		void glMultiDrawRangeElementArrayAPPLE(GLenum mode, GLuint start, GLuint end, const(GLint)* first, const(GLsizei)* count, GLsizei primcount);

		alias void function(GLenum type, const(GLvoid)* pointer) PFNGLELEMENTPOINTERAPPLEPROC;
		alias void function(GLenum mode, GLint first, GLsizei count) PFNGLDRAWELEMENTARRAYAPPLEPROC;
		alias void function(GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count) PFNGLDRAWRANGEELEMENTARRAYAPPLEPROC;
		alias void function(GLenum mode, const(GLint)* first, const(GLsizei)* count, GLsizei primcount) PFNGLMULTIDRAWELEMENTARRAYAPPLEPROC;
		alias void function(GLenum mode, GLuint start, GLuint end, const(GLint)* first, const(GLsizei)* count, GLsizei primcount) PFNGLMULTIDRAWRANGEELEMENTARRAYAPPLEPROC;
	}
}

version (GL_APPLE_fence)
{
}
else
{
	extern (C)
	{
		void glGenFencesAPPLE(GLsizei n, GLuint* fences);
		void glDeleteFencesAPPLE(GLsizei n, const(GLuint)* fences);
		void glSetFenceAPPLE(GLuint fence);
		GLboolean glIsFenceAPPLE(GLuint fence);
		GLboolean glTestFenceAPPLE(GLuint fence);
		void glFinishFenceAPPLE(GLuint fence);
		GLboolean glTestObjectAPPLE(GLenum object, GLuint name);
		void glFinishObjectAPPLE(GLenum object, GLint name);

		alias void function(GLsizei n, GLuint* fences) PFNGLGENFENCESAPPLEPROC;
		alias void function(GLsizei n, const(GLuint)* fences) PFNGLDELETEFENCESAPPLEPROC;
		alias void function(GLuint fence) PFNGLSETFENCEAPPLEPROC;
		alias GLboolean function(GLuint fence) PFNGLISFENCEAPPLEPROC;
		alias GLboolean function(GLuint fence) PFNGLTESTFENCEAPPLEPROC;
		alias void function(GLuint fence) PFNGLFINISHFENCEAPPLEPROC;
		alias GLboolean function(GLenum object, GLuint name) PFNGLTESTOBJECTAPPLEPROC;
		alias void function(GLenum object, GLint name) PFNGLFINISHOBJECTAPPLEPROC;
	}
}

version (GL_APPLE_vertex_array_object)
{
}
else
{
	extern (C)
	{
		void glBindVertexArrayAPPLE(GLuint array);
		void glDeleteVertexArraysAPPLE(GLsizei n, const(GLuint)* arrays);
		void glGenVertexArraysAPPLE(GLsizei n, const(GLuint)* arrays);
		GLboolean glIsVertexArrayAPPLE(GLuint array);

		alias void function(GLuint array) PFNGLBINDVERTEXARRAYAPPLEPROC;
		alias void function(GLsizei n, const(GLuint)* arrays) PFNGLDELETEVERTEXARRAYSAPPLEPROC;
		alias void function(GLsizei n, const(GLuint)* arrays) PFNGLGENVERTEXARRAYSAPPLEPROC;
		alias GLboolean function(GLuint array) PFNGLISVERTEXARRAYAPPLEPROC;
	}
}

version (GL_APPLE_vertex_array_range)
{
}
else
{
	extern (C)
	{
		void glVertexArrayRangeAPPLE(GLsizei length, GLvoid* pointer);
		void glFlushVertexArrayRangeAPPLE(GLsizei length, GLvoid* pointer);
		void glVertexArrayParameteriAPPLE(GLenum pname, GLint param);

		alias void function(GLsizei length, GLvoid* pointer) PFNGLVERTEXARRAYRANGEAPPLEPROC;
		alias void function(GLsizei length, GLvoid* pointer) PFNGLFLUSHVERTEXARRAYRANGEAPPLEPROC;
		alias void function(GLenum pname, GLint param) PFNGLVERTEXARRAYPARAMETERIAPPLEPROC;
	}
}

version (GL_APPLE_ycbcr_422)
{
}
else
{
}

version (GL_S3_s3tc)
{
}
else
{
}

version (GL_ATI_draw_buffers)
{
}
else
{
	extern (C)
	{
		void glDrawBuffersATI(GLsizei n, const(GLenum)* bufs);

		alias void function(GLsizei n, const(GLenum)* bufs) PFNGLDRAWBUFFERSATIPROC;
	}
}

version (GL_ATI_pixel_format_float)
{
}
else
{
}

version (GL_ATI_texture_env_combine3)
{
}
else
{
}

version (GL_ATI_texture_float)
{
}
else
{
}

version (GL_NV_float_buffer)
{
}
else
{
}

version (GL_NV_fragment_program)
{
}
else
{
	extern (C)
	{
		void glProgramNamedParameter4fNV(GLuint id, GLsizei len, const(GLubyte)* name, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		void glProgramNamedParameter4dNV(GLuint id, GLsizei len, const(GLubyte)* name, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		void glProgramNamedParameter4fvNV(GLuint id, GLsizei len, const(GLubyte)* name, const(GLfloat)* v);
		void glProgramNamedParameter4dvNV(GLuint id, GLsizei len, const(GLubyte)* name, const(GLdouble)* v);
		void glGetProgramNamedParameterfvNV(GLuint id, GLsizei len, const(GLubyte)* name, GLfloat* params);
		void glGetProgramNamedParameterdvNV(GLuint id, GLsizei len, const(GLubyte)* name, GLdouble* params);

		alias void function(GLuint id, GLsizei len, const(GLubyte)* name, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLPROGRAMNAMEDPARAMETER4FNVPROC;
		alias void function(GLuint id, GLsizei len, const(GLubyte)* name, GLdouble x, GLdouble y, GLdouble z, GLdouble w) PFNGLPROGRAMNAMEDPARAMETER4DNVPROC;
		alias void function(GLuint id, GLsizei len, const(GLubyte)* name, const(GLfloat)* v) PFNGLPROGRAMNAMEDPARAMETER4FVNVPROC;
		alias void function(GLuint id, GLsizei len, const(GLubyte)* name, const(GLdouble)* v) PFNGLPROGRAMNAMEDPARAMETER4DVNVPROC;
		alias void function(GLuint id, GLsizei len, const(GLubyte)* name, GLfloat* params) PFNGLGETPROGRAMNAMEDPARAMETERFVNVPROC;
		alias void function(GLuint id, GLsizei len, const(GLubyte)* name, GLdouble* params) PFNGLGETPROGRAMNAMEDPARAMETERDVNVPROC;
	}
}

version (GL_NV_half_float)
{
}
else
{
	extern (C)
	{
		void glVertex2hNV(GLhalfNV x, GLhalfNV y);
		void glVertex2hvNV(const(GLhalfNV)* v);
		void glVertex3hNV(GLhalfNV x, GLhalfNV y, GLhalfNV z);
		void glVertex3hvNV(const(GLhalfNV)* v);
		void glVertex4hNV(GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w);
		void glVertex4hvNV(const(GLhalfNV)* v);
		void glNormal3hNV(GLhalfNV nx, GLhalfNV ny, GLhalfNV nz);
		void glNormal3hvNV(const(GLhalfNV)* v);
		void glColor3hNV(GLhalfNV red, GLhalfNV green, GLhalfNV blue);
		void glColor3hvNV(const(GLhalfNV)* v);
		void glColor4hNV(GLhalfNV red, GLhalfNV green, GLhalfNV blue, GLhalfNV alpha);
		void glColor4hvNV(const(GLhalfNV)* v);
		void glTexCoord1hNV(GLhalfNV s);
		void glTexCoord1hvNV(const(GLhalfNV)* v);
		void glTexCoord2hNV(GLhalfNV s, GLhalfNV t);
		void glTexCoord2hvNV(const(GLhalfNV)* v);
		void glTexCoord3hNV(GLhalfNV s, GLhalfNV t, GLhalfNV r);
		void glTexCoord3hvNV(const(GLhalfNV)* v);
		void glTexCoord4hNV(GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q);
		void glTexCoord4hvNV(const(GLhalfNV)* v);
		void glMultiTexCoord1hNV(GLenum target, GLhalfNV s);
		void glMultiTexCoord1hvNV(GLenum target, const(GLhalfNV)* v);
		void glMultiTexCoord2hNV(GLenum target, GLhalfNV s, GLhalfNV t);
		void glMultiTexCoord2hvNV(GLenum target, const(GLhalfNV)* v);
		void glMultiTexCoord3hNV(GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r);
		void glMultiTexCoord3hvNV(GLenum target, const(GLhalfNV)* v);
		void glMultiTexCoord4hNV(GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q);
		void glMultiTexCoord4hvNV(GLenum target, const(GLhalfNV)* v);
		void glFogCoordhNV(GLhalfNV fog);
		void glFogCoordhvNV(const(GLhalfNV)* fog);
		void glSecondaryColor3hNV(GLhalfNV red, GLhalfNV green, GLhalfNV blue);
		void glSecondaryColor3hvNV(const(GLhalfNV)* v);
		void glVertexWeighthNV(GLhalfNV weight);
		void glVertexWeighthvNV(const(GLhalfNV)* weight);
		void glVertexAttrib1hNV(GLuint index, GLhalfNV x);
		void glVertexAttrib1hvNV(GLuint index, const(GLhalfNV)* v);
		void glVertexAttrib2hNV(GLuint index, GLhalfNV x, GLhalfNV y);
		void glVertexAttrib2hvNV(GLuint index, const(GLhalfNV)* v);
		void glVertexAttrib3hNV(GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z);
		void glVertexAttrib3hvNV(GLuint index, const(GLhalfNV)* v);
		void glVertexAttrib4hNV(GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w);
		void glVertexAttrib4hvNV(GLuint index, const(GLhalfNV)* v);
		void glVertexAttribs1hvNV(GLuint index, GLsizei n, const(GLhalfNV)* v);
		void glVertexAttribs2hvNV(GLuint index, GLsizei n, const(GLhalfNV)* v);
		void glVertexAttribs3hvNV(GLuint index, GLsizei n, const(GLhalfNV)* v);
		void glVertexAttribs4hvNV(GLuint index, GLsizei n, const(GLhalfNV)* v);

		alias void function(GLhalfNV x, GLhalfNV y) PFNGLVERTEX2HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLVERTEX2HVNVPROC;
		alias void function(GLhalfNV x, GLhalfNV y, GLhalfNV z) PFNGLVERTEX3HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLVERTEX3HVNVPROC;
		alias void function(GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w) PFNGLVERTEX4HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLVERTEX4HVNVPROC;
		alias void function(GLhalfNV nx, GLhalfNV ny, GLhalfNV nz) PFNGLNORMAL3HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLNORMAL3HVNVPROC;
		alias void function(GLhalfNV red, GLhalfNV green, GLhalfNV blue) PFNGLCOLOR3HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLCOLOR3HVNVPROC;
		alias void function(GLhalfNV red, GLhalfNV green, GLhalfNV blue, GLhalfNV alpha) PFNGLCOLOR4HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLCOLOR4HVNVPROC;
		alias void function(GLhalfNV s) PFNGLTEXCOORD1HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLTEXCOORD1HVNVPROC;
		alias void function(GLhalfNV s, GLhalfNV t) PFNGLTEXCOORD2HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLTEXCOORD2HVNVPROC;
		alias void function(GLhalfNV s, GLhalfNV t, GLhalfNV r) PFNGLTEXCOORD3HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLTEXCOORD3HVNVPROC;
		alias void function(GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q) PFNGLTEXCOORD4HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLTEXCOORD4HVNVPROC;
		alias void function(GLenum target, GLhalfNV s) PFNGLMULTITEXCOORD1HNVPROC;
		alias void function(GLenum target, const(GLhalfNV)* v) PFNGLMULTITEXCOORD1HVNVPROC;
		alias void function(GLenum target, GLhalfNV s, GLhalfNV t) PFNGLMULTITEXCOORD2HNVPROC;
		alias void function(GLenum target, const(GLhalfNV)* v) PFNGLMULTITEXCOORD2HVNVPROC;
		alias void function(GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r) PFNGLMULTITEXCOORD3HNVPROC;
		alias void function(GLenum target, const(GLhalfNV)* v) PFNGLMULTITEXCOORD3HVNVPROC;
		alias void function(GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q) PFNGLMULTITEXCOORD4HNVPROC;
		alias void function(GLenum target, const(GLhalfNV)* v) PFNGLMULTITEXCOORD4HVNVPROC;
		alias void function(GLhalfNV fog) PFNGLFOGCOORDHNVPROC;
		alias void function(const(GLhalfNV)* fog) PFNGLFOGCOORDHVNVPROC;
		alias void function(GLhalfNV red, GLhalfNV green, GLhalfNV blue) PFNGLSECONDARYCOLOR3HNVPROC;
		alias void function(const(GLhalfNV)* v) PFNGLSECONDARYCOLOR3HVNVPROC;
		alias void function(GLhalfNV weight) PFNGLVERTEXWEIGHTHNVPROC;
		alias void function(const(GLhalfNV)* weight) PFNGLVERTEXWEIGHTHVNVPROC;
		alias void function(GLuint index, GLhalfNV x) PFNGLVERTEXATTRIB1HNVPROC;
		alias void function(GLuint index, const(GLhalfNV)* v) PFNGLVERTEXATTRIB1HVNVPROC;
		alias void function(GLuint index, GLhalfNV x, GLhalfNV y) PFNGLVERTEXATTRIB2HNVPROC;
		alias void function(GLuint index, const(GLhalfNV)* v) PFNGLVERTEXATTRIB2HVNVPROC;
		alias void function(GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z) PFNGLVERTEXATTRIB3HNVPROC;
		alias void function(GLuint index, const(GLhalfNV)* v) PFNGLVERTEXATTRIB3HVNVPROC;
		alias void function(GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w) PFNGLVERTEXATTRIB4HNVPROC;
		alias void function(GLuint index, const(GLhalfNV)* v) PFNGLVERTEXATTRIB4HVNVPROC;
		alias void function(GLuint index, GLsizei n, const(GLhalfNV)* v) PFNGLVERTEXATTRIBS1HVNVPROC;
		alias void function(GLuint index, GLsizei n, const(GLhalfNV)* v) PFNGLVERTEXATTRIBS2HVNVPROC;
		alias void function(GLuint index, GLsizei n, const(GLhalfNV)* v) PFNGLVERTEXATTRIBS3HVNVPROC;
		alias void function(GLuint index, GLsizei n, const(GLhalfNV)* v) PFNGLVERTEXATTRIBS4HVNVPROC;
	}
}

version (GL_NV_pixel_data_range)
{
}
else
{
	extern (C)
	{
		void glPixelDataRangeNV(GLenum target, GLsizei length, GLvoid* pointer);
		void glFlushPixelDataRangeNV(GLenum target);

		alias void function(GLenum target, GLsizei length, GLvoid* pointer) PFNGLPIXELDATARANGENVPROC;
		alias void function(GLenum target) PFNGLFLUSHPIXELDATARANGENVPROC;
	}
}

version (GL_NV_primitive_restart)
{
}
else
{
	extern (C)
	{
		void glPrimitiveRestartNV();
		void glPrimitiveRestartIndexNV(GLuint index);

		alias void function() PFNGLPRIMITIVERESTARTNVPROC;
		alias void function(GLuint index) PFNGLPRIMITIVERESTARTINDEXNVPROC;
	}
}

version (GL_NV_texture_expand_normal)
{
}
else
{
}

version (GL_NV_vertex_program2)
{
}
else
{
}

version (GL_ATI_map_object_buffer)
{
}
else
{
	extern (C)
	{
		GLvoid* glMapObjectBufferATI(GLuint buffer);
		void glUnmapObjectBufferATI(GLuint buffer);

		alias GLvoid* function(GLuint buffer) PFNGLMAPOBJECTBUFFERATIPROC;
		alias void function(GLuint buffer) PFNGLUNMAPOBJECTBUFFERATIPROC;
	}
}

version (GL_ATI_separate_stencil)
{
}
else
{
	extern (C)
	{
		void glStencilOpSeparateATI(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);
		void glStencilFuncSeparateATI(GLenum frontfunc, GLenum backfunc, GLint reference, GLuint mask);

		alias void function(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass) PFNGLSTENCILOPSEPARATEATIPROC;
		alias void function(GLenum frontfunc, GLenum backfunc, GLint reference, GLuint mask) PFNGLSTENCILFUNCSEPARATEATIPROC;
	}
}

version (GL_ATI_vertex_attrib_array_object)
{
}
else
{
	extern (C)
	{
		void glVertexAttribArrayObjectATI(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, GLuint buffer, GLuint offset);
		void glGetVertexAttribArrayObjectfvATI(GLuint index, GLenum pname, GLfloat* params);
		void glGetVertexAttribArrayObjectivATI(GLuint index, GLenum pname, GLint* params);

		alias void function(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, GLuint buffer, GLuint offset) PFNGLVERTEXATTRIBARRAYOBJECTATIPROC;
		alias void function(GLuint index, GLenum pname, GLfloat* params) PFNGLGETVERTEXATTRIBARRAYOBJECTFVATIPROC;
		alias void function(GLuint index, GLenum pname, GLint* params) PFNGLGETVERTEXATTRIBARRAYOBJECTIVATIPROC;
	}
}

version (GL_OES_read_format)
{
}
else
{
}

version (GL_EXT_depth_bounds_test)
{
}
else
{
	extern (C)
	{
		void glDepthBoundsEXT(GLclampd zmin, GLclampd zmax);

		alias void function(GLclampd zmin, GLclampd zmax) PFNGLDEPTHBOUNDSEXTPROC;
	}
}

version (GL_EXT_texture_mirror_clamp)
{
}
else
{
}

version (GL_EXT_blend_equation_separate)
{
}
else
{
	extern (C)
	{
		void glBlendEquationSeparateEXT(GLenum modeRGB, GLenum modeAlpha);

		alias void function(GLenum modeRGB, GLenum modeAlpha) PFNGLBLENDEQUATIONSEPARATEEXTPROC;
	}
}

version (GL_MESA_pack_invert)
{
}
else
{
}

version (GL_MESA_ycbcr_texture)
{
}
else
{
}

version (GL_EXT_pixel_buffer_object)
{
}
else
{
}

version (GL_NV_fragment_program_option)
{
}
else
{
}

version (GL_NV_fragment_program2)
{
}
else
{
}

version (GL_NV_vertex_program2_option)
{
}
else
{
}

version (GL_NV_vertex_program3)
{
}
else
{
}

version (GL_EXT_framebuffer_object)
{
}
else
{
	extern (C)
	{
		GLboolean glIsRenderbufferEXT(GLuint renderbuffer);
		void glBindRenderbufferEXT(GLenum target, GLuint renderbuffer);
		void glDeleteRenderbuffersEXT(GLsizei n, const(GLuint)* renderbuffers);
		void glGenRenderbuffersEXT(GLsizei n, GLuint* renderbuffers);
		void glRenderbufferStorageEXT(GLenum target, GLenum internalformat, GLsizei width, GLsizei height);
		void glGetRenderbufferParameterivEXT(GLenum target, GLenum pname, GLint* params);
		GLboolean glIsFramebufferEXT(GLuint framebuffer);
		void glBindFramebufferEXT(GLenum target, GLuint framebuffer);
		void glDeleteFramebuffersEXT(GLsizei n, const(GLuint)* framebuffers);
		void glGenFramebuffersEXT(GLsizei n, GLuint* framebuffers);
		GLenum glCheckFramebufferStatusEXT(GLenum target);
		void glFramebufferTexture1DEXT(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
		void glFramebufferTexture2DEXT(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level);
		void glFramebufferTexture3DEXT(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset);
		void glFramebufferRenderbufferEXT(GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer);
		void glGetFramebufferAttachmentParameterivEXT(GLenum target, GLenum attachment, GLenum pname, GLint* params);
		void glGenerateMipmapEXT(GLenum target);

		alias GLboolean function(GLuint renderbuffer) PFNGLISRENDERBUFFEREXTPROC;
		alias void function(GLenum target, GLuint renderbuffer) PFNGLBINDRENDERBUFFEREXTPROC;
		alias void function(GLsizei n, const(GLuint)* renderbuffers) PFNGLDELETERENDERBUFFERSEXTPROC;
		alias void function(GLsizei n, GLuint* renderbuffers) PFNGLGENRENDERBUFFERSEXTPROC;
		alias void function(GLenum target, GLenum internalformat, GLsizei width, GLsizei height) PFNGLRENDERBUFFERSTORAGEEXTPROC;
		alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC;
		alias GLboolean function(GLuint framebuffer) PFNGLISFRAMEBUFFEREXTPROC;
		alias void function(GLenum target, GLuint framebuffer) PFNGLBINDFRAMEBUFFEREXTPROC;
		alias void function(GLsizei n, const(GLuint)* framebuffers) PFNGLDELETEFRAMEBUFFERSEXTPROC;
		alias void function(GLsizei n, GLuint* framebuffers) PFNGLGENFRAMEBUFFERSEXTPROC;
		alias GLenum function(GLenum target) PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC;
		alias void function(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level) PFNGLFRAMEBUFFERTEXTURE1DEXTPROC;
		alias void function(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level) PFNGLFRAMEBUFFERTEXTURE2DEXTPROC;
		alias void function(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset) PFNGLFRAMEBUFFERTEXTURE3DEXTPROC;
		alias void function(GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer) PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC;
		alias void function(GLenum target, GLenum attachment, GLenum pname, GLint* params) PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC;
		alias void function(GLenum target) PFNGLGENERATEMIPMAPEXTPROC;
	}
}

version (GL_GREMEDY_string_marker)
{
}
else
{
	extern (C)
	{
		void glStringMarkerGREMEDY(GLsizei len, const(GLvoid)* string);

		alias void function(GLsizei len, const(GLvoid)* string) PFNGLSTRINGMARKERGREMEDYPROC;
	}
}


